<?php

// ======================================================================================
// ============= DPXMailer_sendmailToAdmins
// ======================================================================================
function DPXMailer_sendmailToAdmins($subject, $addmsg="")
{
    $link = "<a href='". $GLOBALS['settings']->mail->instanceurl ."'>". $GLOBALS['settings']->mail->instanceurl ."</a> ";
    $msg = "Service message from  ". DPXALIAS . "    $link <br><br><b> $subject </b> <br><br>";

    return  DPXMailer_send($GLOBALS['settings']->mail->serviceadmins, $subject, $msg . $addmsg);
}


// ======================================================================================
// ============= DPXMailer_sendmailToUser
// ======================================================================================
function DPXMailer_sendmailToUser($what, $msg, $useradress)
{
    return  DPXMailer_send($useradress, $what, $msg);
}


// ======================================================================================
// ============= DPXMailer_send
// ======================================================================================
function DPXMailer_send($to, $subject, $msg, $msgIsAlreadyFinished=false)
{
    $settings = &$GLOBALS['settings']->mail;
  
    $debug = $settings->debug;
    $simulate = $settings->simulate;
    
	// force debug mode when sending a testmail
    if( $subject == "testmail")
    {	
    	$debug=2;
    }
    
    require_once('PHPMailer/PHPMailerAutoload.php');
    
    if($to == "admins")
    {
       $to = $GLOBALS['settings']->mail->serviceadmins;
       $link = "<a href='". $GLOBALS['settings']->mail->instanceurl ."'>". $GLOBALS['settings']->mail->instanceurl ."</a> ";
       $msg = "Service message from System <b> ". DPXALIAS . "</b>    $link <br><br><b> $subject </b> <br><br>" . $msg;
    }



      
    $to = explode(',', $to );

    $mail=new PHPMailer();
    $mail->CharSet = 'UTF-8';

    $mail->IsSMTP();
    $mail->Host       = $settings->host;

    $mail->SMTPSecure = $settings->secure;
    $mail->Port       = $settings->port;

    $mail->SMTPAuth   = $settings->auth;

    $mail->Timeout  =   15;
    
    // needed because of php7
    $mail->SMTPOptions = array(
        'ssl' => array(
            'verify_peer' => false,
            'verify_peer_name' => false,
            'allow_self_signed' => true
        )
    );

    $mail->Username   = $settings->user ;
    $mail->Password   = $settings->pwd;

    $mail->SetFrom($settings->from_email, DPXALIAS . " service");
    $mail->AddReplyTo($settings->from_email, DPXALIAS . " service");


    $mail->SMTPDebug  = $debug;


    $mail->IsHTML(true);  
    $mail->Subject    = $subject;
    $mail->AltBody    = $msg;
    if(!$msgIsAlreadyFinished)
		$html = DPXMailer_renderHTML($subject, $msg);
	else
		$html = $msg;
		
    $mail->Body  = $html;

    foreach($to as $adress)
    {
    	$temp = trim($adress);
		if(filter_var($temp, FILTER_VALIDATE_EMAIL))
			$mail->AddAddress( $temp ) ;
    }

    //$mail->Priority = 1; 
    //$mail->AddAttachment($fileName);

    if($simulate)
    {
	// in simulation mode, instead of sending a true email, prepare an injection script for opening a popup with the email content
	// also dump the mail headers, for debugging
	// this must be injected into the parent page in the header section
        $mailinfo = "<br><br><br><br><br>===========================================================<br>";
        $mailinfo .=  '<pre>' . var_export($mail, true) . '</pre>';
        $mailinfoFormatted = preg_replace("/\r|\n/", "<br>", preg_replace("/\'/", "\"",  $mailinfo));
        
        $popup = "<script type='text/javascript'>   window.open('','','width=900, height=900').document.write('". preg_replace("/\r|\n/", "", preg_replace("/\'/", "\"", $html )) . $mailinfoFormatted ." ');  </script>";
        $out = $popup;
    }
    else
    {
        $out = $mail->send();
    }
    
    return $out;

}



// ======================================================================================
// ============= DPXMailer_renderHTML
// ======================================================================================
function DPXMailer_renderHTML($subject, $msg, $options = false)
{
	if($options===false)
		$options= (object)Array();

    $doc = (object)array();
    $doc->text = $msg;
    $doc->title = $subject;
    $doc->logotext = DPXALIAS;
    $doc->logoimg = "";
    $doc->linktoolbar = ""; 

    
    $doc->senderadress = "";
    
    $doc->serviceadmins = "";
		foreach( explode(',', $GLOBALS['settings']->mail->serviceadmins) as $e)
			{
				$doc->serviceadmins .= "<a href='mailto:$e'><b>$e</b></a><br>";
			};
    
    $doc->link = "none";
    $sep = " &nbsp;&nbsp;&nbsp;|&nbsp;&nbsp&nbsp;";
    $doc->footer = DPXALIAS . $sep . " <a href='". $GLOBALS['settings']->mail->instanceurl .   "'>". str_replace('http://', '', $GLOBALS['settings']->mail->instanceurl) . "</a> ";

  
  
  ////////////////////////////////////////////

  $logotext = "nora";
  $logocolor = "rgb(34, 102, 155)";
  $logosize = "30px";
  
  $bgColorMain = "#666666";
  $bgColorMain = "white";
  $bgColorInner = "white";
  $fontColorInner = "#222222";
  $fontColorTitle = "gray";
  
  $fontSizeMain = "15px";
  $fontSizeTitle = "20px";
  $fontSizeAdress = "12px";
  $fontSizeFooter = "10px";
  
  $borderColorInner = $logocolor;

  $widthInner = "100%";

  $out = "
    <!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
    <html xlns='http://www.w3.org/1999/xhtml' style='height:100%;'>
      <head>
	<title></title>
	 <meta http-equiv='Content-Type' content='text/html; charset=UTF-8' />
	  <title>$doc->title</title>
	<style>
	</style>
      </head>

    <body style=' height: 95%;'>";


  $out .="
  <table id='backgroundTable' width='100%' cellpadding='10' cellspacing='0' border='0'  bgcolor='$bgColorMain' style='font-family:arial; background:$bgColorMain; height:100%; vertical-align:top' >
    <tr>
      <td align='center' style=' vertical-align:top; '>
	<table class='mainContent' style='border:solid 0px $borderColorInner; border-collapse:collapse; background:$bgColorInner; width:$widthInner; height:100%'   cellpadding='0' cellspacing='0' border='0'  width='$widthInner'   bgcolor='$bgColorInner'>
	  
	  <!-- ================= HEAD LOGO 	================= -->
	  <tr>
	    <td align='center' style='height:100px; border-bottom:solid 1px $borderColorInner;'>
	      <table class='headTable'  cellpadding='0' cellspacing='0' width='100%' style='border-collapse:collapse;'>
		<tr>";
		    if($doc->logoimg!="")
		      $out .="<td style='text-align:right;'><img src='xxx' width='218' height='100' /> </td>";
		    else if($doc->logotext!=="")
		      $out .="<td style='text-align:right; padding:0px 40px; color:$logocolor;font-weight:bold;font-size:$logosize;font-style:italic'>$doc->logotext</td>";
		    $out .="
		</tr>
	      </table>
	    </td>
	  </tr>
	";
	
	  if($doc->linktoolbar !="")
	  $out .="
	  <!-- ================= MAIN LINKS ================= -->
	  <tr>
	    <td align='center' style='height:30px;'>
	      <table width='100%' cellpadding='4px' cellspacing='0px'  >
		<tr>
		</tr>
	      </table>
	    </td>
	  </tr>";

	   $out .="
	  <!-- ================= MESSAGE TITLE ================= -->

	  <tr>
	    <td style='font-size:$fontSizeTitle; color: $fontColorTitle; padding:15px; height:20px; vertical-align:top '>
	    
		$doc->title
	    
	    </td>
	  </tr>";

	  
	   $out .="
	  <!-- ================= CONTENTS ================= -->

	  <tr>
	    <td style='font-size:$fontSizeMain; color: $fontColorInner; padding:15px 30px; height:100%; vertical-align:top; '>
	    
		$doc->text
		
	    </td>
	  </tr>

	  ";
	  if(isset($options->addAdminAdress) && $options->addAdminAdress == true)	  
	  $out .="
	  <!-- ================= SERVICEADMINS ================= -->

	  <tr>
	    <td style='font-size:$fontSizeAdress; color: $fontColorInner; padding:15px 30px; vertical-align:top; '>
	    
	    If you have any questions, please contact the system Administrators:</br>
      
		$doc->serviceadmins 
		
	    </td>
	  </tr>";
	  
	  $out .="
	  <!-- ================= Adress ================= -->
	  
	  <tr>
	      <td class ='adressFooter' style='font-size:$fontSizeAdress; color: $fontColorInner; padding:15px; height:10px; '>
		$doc->senderadress
		</td>
	  </tr>
  
	  <!-- ================= Footer ================= -->
	  <tr>
	    <td align='center' style='padding:3px; font-size:$fontSizeFooter; color: $fontColorInner; height:50px; border-top:solid 1px $borderColorInner;'>
		
		$doc->footer
	    
	    </td>
	  </tr>

  	  
	  
	</table>  <!-- ende mainContent-->
    </td>
    </tr>
  </table>
";


 $out .= "    </body> </html> ";

  return $out;
}

// ======================================================================================
// ============= DPXMailer_renderHTML
// ======================================================================================
function DPXMailer_createTemplateMessage($json )
{

	if(!isset($json->subject))
		$json->subject = "No title";
		
	if(!isset($json->msg))
		$json->subject = "Your message here";

		
	if(!isset($json->template))
		$json->template = "";

	$options = (object)Array();
	$options->addAdminAdress = true;
		
	// ======================================================================================
	// invite a new user
	// ======================================================================================
	if($json->template == 'inviteUser')
	{
		if(isset($json->yaps))
			$yaps = (array)$json->yaps;
		else
			$yaps = Array('uid' => 'username', 'mail' => 'emailadress');
		
		// this would mean allow ONLY ldap
		$fullldap = false;

		$pwd = $fullldap?"YOUR LDAP PASSWORD":"choose in next step";

		$details  = "<br>";
		$ww = "100px";
		$details .= "<span style='display:inline-block;width:$ww'>username:</span> <b>" . $yaps['uid']. "</b><br>" ;
		$details .= "<span style='display:inline-block;width:$ww'>email   :</span>    <b>" . $yaps['mail']. "</b><br>" ;
		$details .= "<span style='display:inline-block;width:$ww'>password :</span>    <i>$pwd</i><br>" ;
		
		$name = isset($yaps['combinedname'])?("Dear ".$yaps['combinedname'].",<br></br>"):"";
		$msg  =  "$name You have been invited to '" . DPXALIAS . "', an Instance of the medical imaging platform NORA.<br><br>\n\n";
		$msg .=  "Your details:<br>";
		$msg .= $details;

		/* customized creation of account */
		
		if($fullldap)
		{
			/* LDAP AUTOSIGNUP */
			$msg .= "<br><br>Please log into <b>".DPXALIAS."</b> using your LDAP credentials:";
			$lnk = $GLOBALS['settings']->mail->instanceurl . "?username=$yaps[uid]";
			$msg .= "<br><br><a target='_blank' href='". $lnk . "'><b>". str_replace('http://', '', $lnk). "</b></a>";
			$msg .= "<br><br>Please bookmark that adress, or keep this email for your records.";
		}
		else
		{
			$msg .= "<br><br>To create your account, please click on the following link:";

			$fulllink = $GLOBALS['settings']->mail->instanceurl .  "?";
			if(isset($yaps[token]) && $yaps[token] != "")
				$token="&token=".$yaps[token];
			else
				$token="&xfvz=1";

			if(LDAPENABLED)
				$fulllink .= "ldap_username=$yaps[uid]$token";
			else
				$fulllink .= "signup=1&signup_username=$yaps[uid]&email=$yaps[mail]$token";
				
			$msg .= "<br><a target='_blank' href='$fulllink'><i>$fulllink</i></a>";
			$msg .= "<br><br><br>After that, you can always access the platform via the following adress:";
			$msg .= "<br><br><a target='_blank' href='". $GLOBALS['settings']->mail->instanceurl . "'><b>". str_replace('http://', '', $GLOBALS['settings']->mail->instanceurl). "</b></a>";
			$msg .= "<br><br>Please bookmark that address, or keep this email for your records.";
		}
		
		$msg = DPXMailer_renderHTML("Invitation to " . DPXALIAS , $msg, $options);
	
	}
	else
	{
		if(!isset($json->msg))
			$json->msg = "";

		$msg = DPXMailer_renderHTML($json->subject, $json->msg, $options);
	}

	return $msg;
	
}



?>