






/*
module.exports = 
function() {
    this.substRefVars = substRefVars;
    this.iterateOverArgs = iterateOverArgs;
    this.prepareFuns = prepareFuns;
}
*/
if (typeof module != "undefined")
{
	module.exports = {
		substRefVars:substRefVars,
		iterateOverArgs:iterateOverArgs,
		prepareFuns:prepareFuns
	}
}

function isReferenceArg(type)
{
	return (type == "FILE" | type == "OUT" | type == "PATHOUT" | type == "FORM" | type == "ATLAS")
}


function substRefVars(funs,obj,psidvars,runningSubmitCnt,parallel,simulate)
{
	  for (var f = 0; f < funs.length; f++)
	  {
		var thefun = funs[f];
		thefun.name = runningSubmitCnt + "/" + thefun.name;
		if (thefun.dep != "" && parallel != 'parallel')
			thefun.dep =  runningSubmitCnt + "/" + thefun.dep;

		var args = thefun.args;



		var res = iterateOverArgs(args,Object.keys(args),function (thearg)
		{
			if (isReferenceArg(thearg.type))
			{
				function attachSelectionToArgument(theval)
				{
					for (var k=0;k < psidvars.length;k++)
					{
						if (theval[0] == psidvars[k].funhandle) // get the matching selector var
						{
							if (theval[1].search("\\[selectedfolder\\]") != -1) // if FILE is subfolder of (some) selection
							{
								if (obj.type == 'subfolder')
								{
									thefun.psid = obj.piz + obj.sid;
								    return  obj.piz + obj.sid + " " + theval[1].replace("[selectedfolder]", obj.subfolder);
								}
								else if (obj.type == 'file')
								{
									thefun.psid = obj.piz + obj.sid;
								    return  obj.piz + obj.sid + " " + theval[1].replace("[selectedfolder]", obj.subfolder);
								}
								else
								{
									alertify.alert("Error: batch contains an open folder selection");
									return false;
								}
							}
							else if (theval[1].search("\\[selectedfile\\]") != -1) // if FILE is selection
							{
								if (obj.type == 'file')
								{
									thefun.psid = obj.piz + obj.sid;
								    return obj.piz + obj.sid + " " + obj.filename;
								}
								else
								{
									alertify.alert("Error: batch contains an open file selection");
									return false;
								}
							}
							else
							{
								var psidval = psidvars[k].args.val.val;
								if (psidval == "")
									psidval = "[selection]";
								if (psidval.search("\\[selection\\]") != -1 || psidval.search("\\[selectionpatient\\]") != -1 )
								{
									if (state.viewer.selectionMode[1] == "s" | state.viewer.selectionMode[1] == 'a')
									{
										if (obj == undefined)
										{
											alertify.alert("Error: you have to select some study");
											return false;
										}
										psidval = psidval.replace("[selectionpatient]",obj.piz);
										psidval = psidval.replace("[selection]",obj.piz+""+obj.sid) 
										theval = psidval + " " + theval[1];
										if (thefun.psid == undefined)
											thefun.psid = obj.piz+""+obj.sid;
									}
									else if (state.viewer.selectionMode[1] == "p")
									{
										if (obj == undefined)
										{
											alertify.alert("Error: you have to select some patient");
											return false;
										}
										var psid = obj.piz;
										if (obj.sid != undefined)
										    psid += obj.sid
										theval = psidval.replace("[selection]",psid) + " " + theval[1];
										if (thefun.psid == undefined)
											thefun.psid = psid;
									}
								}
								else
								{
									theval = psidval + " " + theval[1];
								}
								return theval.replace(/\n/g," ");
							}
						}
					}

					if (theval[0] == 'Patient' | theval[0] == 'Study')
					{
						if (typeof $ != "undefined")
						{
							var $errordiv = $("div[funref='"+thefun.name.substring(thefun.name.search('/')+1)+"']");
							if ($errordiv != undefined)
							{
								  $errordiv.addClass('error_blinker');
								  setTimeout(function() {$errordiv.removeClass('error_blinker'); } ,2000);
							}
							if (theval[0] == 'Patient')
								alertify.alert("Error: open patient selection while being in study mode");
							else
								alertify.alert("Error: open study selection while being in patient mode");
						}
						else
						{
							if (theval[0] == 'Patient')
								console.error("Error: open patient selection while being in study mode");
							else
								console.error("Error: open study selection while being in patient mode");
						}
						return false;
					}
					
					return theval[0] +  " " + theval[1];
				}

				if (thearg.val[0] instanceof Array)
				{
					for (var u = 0; u < thearg.val.length;u++)
					{
						var res = attachSelectionToArgument(thearg.val[u]);
						if (res == false)
							return false;
						thearg.val[u] = res;
					}
				}
				else
				{
					var res =attachSelectionToArgument(thearg.val);
					if (res == false)
						return false;
					thearg.val = res
				}

			}

		});

		if (res == false)
			return false;

		if (thefun.psid == undefined)
		{ 
			if (state.viewer.selectionMode[1] == "p")
				thefun.psid =  obj.piz;
			else
				thefun.psid =  obj.piz+""+obj.sid;
				
		}

		if (parallel == "sequential" && simulate == undefined)
		{
			console.log( obj.piz + obj.sid  + ") submitted fun:" + thefun.name + " dep:" + thefun.dep);
		}
	  }
}




function iterateOverArgs(Args,argnames,funtoapply)
{
	      for (var u = 0; u < argnames.length;u++ )
	      {
		      var res;
		      if (Args[argnames[u]].type == 'NODE')
			      res = iterateOverArgs(Args[argnames[u]],Args[argnames[u]].children,funtoapply);
		  else
		      res = funtoapply(Args[argnames[u]]);
		      if (res == false)
			      return false;    
	      }	
}


function makeSubstInJobs(funs,variables)
{

// make substitution in jobs
      function doSubst(thearg,thevar)
      {
          var  theval = thevar.args.val.val;
          var repref,repstr;
          if (theval instanceof Array)
          {
          	  theval[1] = theval[1].trim();
          	  repstr = v => v;
              repref = function (v)
              {
              	  if (v[1].search("\\[REFERENCE") > -1)
              	  {
                      var r = RegExp(/\[REFERENCE_[\w]+/).exec(v[1])
                      if (r[0].substring(1) == thevar.funhandle)
                      {
                      	  v[0] = theval[0]                      	
                          v[1] = theval[1];
                      }
              	  }
              	  else
              	  {
              	  	  var r = RegExp("\\[" + thevar.funhandle + "\\]","g");
              	  	  if (r.exec(v[1]))
              	  	  {              	  	  	  
                      	  v[0] = theval[0]                      	
              	          v[1] = v[1].replace(r,theval[1]);
              	  	  }
              	  }
              }            
          }
          else 
          {
              theval = theval.trim();
              repstr = (x) => x.replace(RegExp("\\[" + thevar.funhandle + "\\]","g"),theval);
              repref = function (v)
              {
              	  v[1] = v[1].replace(RegExp("\\[" + thevar.funhandle + "\\]","g"),theval);
              }
          }

	      if (thearg.type != 'NODE')
	      {
		      if (isReferenceArg(thearg.type))
		      {
			      if (thearg.val[0] instanceof Array)
			      {
				      for (var u = 0; u < thearg.val.length;u++)
					      if (thearg.val[u][0] != 'ATLAS')
						   repref(thearg.val[u])
			      }
			      else if (thearg.val[0] != 'ATLAS')
			  	      repref(thearg.val)
		      }
		      else
		      {
			      if (thearg.val instanceof Array)
			      {
				      for (var u = 0; u < thearg.val.length;u++)
					      thearg.val[u] = repstr(thearg.val[u]);
			      }
			      else
				      thearg.val = repstr(thearg.val)
		      }
	      }
      }


      for (var f = 0; f < funs.length; f++)
      {
 	      iterateOverArgs(funs[f].args,Object.keys(funs[f].args),function(thearg){
			      doSubst(thearg,{funhandle:"TITLE",args:{val:{val:funs[f].customName}}});
		   });
	      for (var i = 0; i< variables.length;i++)
	      {
		     if (variables[i].args.val.type == 'value' | variables[i].args.val.type == 'outref')
		      iterateOverArgs(funs[f].args,Object.keys(funs[f].args),function(thearg){
			      doSubst(thearg,variables[i]);
		      });
	      }
      }
}




function prepareFuns(allfuns,variables,psidvars,via_action_button,queue)
{
	  var funs = [];

	  // select funs (not variables) from funlist
	  var dep = "";
      var lastloop = undefined;
      var loopcnt =0
      var loop_iteratornames = [];	
      var thewrap = undefined 
	  for (var i=0;i <allfuns.length;i++)
	  {
		  if (!allfuns[i].banned && allfuns[i].type.search("variable") == -1 && allfuns[i].type != "separator" && allfuns[i].type != "wrap")
		  {
			  var tmp = JSON.parse(JSON.stringify(allfuns[i]));
			  tmp.dep = dep;
			  tmp.queue = queue;
			  funs.push(tmp);
			  dep = tmp.name;
			  loopcnt++;
			  if (lastloop != undefined)
			  {
			     if (allfuns[i].type == "loop")
			     {
			     	lastloop.cnt = loopcnt-1;
			     	lastloop = undefined;
			     }
			  }
 			  if (allfuns[i].type == "loop")
			  {
				  lastloop = tmp
				  loop_iteratornames.push(tmp.args.iteratorname.val)
				  loopcnt = 0;
			  }
		  }
		  if (allfuns[i].type == "wrap")
		      thewrap = allfuns[i];
		  if (allfuns[i].type == "separator" && lastloop != undefined)
 		  {
			 lastloop.cnt = loopcnt;
			 lastloop = undefined;
		  }
	  }
      if (lastloop != undefined)
          lastloop.cnt = loopcnt;

	  // make substitution in vars
	  for (var its = 0; its < 2; its++)
	  {
			  for (var j = 0; j< variables.length;j++)
				  for (var i = 0; i< variables.length;i++)
				    if (variables[j].args.val.type == 'value')
						  variables[j].args.val.val = variables[j].args.val.val.replace("["+variables[i].funhandle+"]",variables[i].args.val.val);						
	  }

	  if (via_action_button)
	  {
		  var tmp = variables;
		  variables = [];
		  for (var j = 0; j< tmp.length;j++)
		  {
			  if (tmp[j].funhandle != "selectedfile" && tmp[j].funhandle != "selectedfolder")
				  variables.push(tmp[j]);
		  }
	  }

    
      // remove looped vars
	  var tmp = variables;
	  variables = [];
	  for (var j = 0; j< tmp.length;j++)
	  {
	  	  var found = false;
	  	  for (var k = 0; k < loop_iteratornames.length;k++)
	  	  	 if (tmp[j].funhandle == loop_iteratornames[k])
	  	  	 {
	  	  	 	found = true;
	  	  	 	break;
	  	  	 }
	  	  if (!found)
	  	    variables.push(tmp[j])
	  	  else
	  	  {
	  	     alertify.error("variable " + tmp[j].funhandle + " overwritten by loop")
	  	  }  
	  	  
	  }


	  // check for undefined variables        
	  for (var j = 0; j< variables.length;j++)
	  {
		  if (variables[j].args.val.type == 'value')
		  {
			  var p  = variables[j].args.val.val.match(/\[\w+\]/);
			  if (p != null)
			  {
				  for (var k = 0; k < p.length; k++)
				  {
					  if (p[k] != "[selection]" && p[k] != "[selectedfolder]" && 
					      p[k] != "[selectedfile]" && p[k] != "[selectionpatient]" && p[k] != "[FILELOOPPSID]" 
					      )
					  {
						  alertify.alert("variable "+ p[k] +" undefined")	;
						  if (typeof DPXconf == "undefined")
							 return false;
					  }
				  }
			  }
		  }
	  }

	  

	  if (thewrap != undefined)
	  {
	  	  var parms = thewrap.args.parameters
	  	  for (var k = 0; k < parms.multi;k++)
	  	  {
	          variables.push({funhandle:parms.thename.val[k], 
	              args:{val:{type:"value",val:parms.thedefault.val[k]} }})
	  	  }
	  }


	  var templatefuns = JSON.parse(JSON.stringify(funs));

	  makeSubstInJobs(templatefuns,variables);


	  return templatefuns;
}




