<?php 
// ======================================================================================
// ============= INPUT: JSON from web-ajax, JSON from command line, or key/ values from command line
// ======================================================================================

// Message channels: 
// email
// platform
//    popup ( small on right side, standard)
//    modal_fullscreen ( fullscreen, for example for terms of agreement)



// from command line: 
if(sizeof($argv) > 1)
{
  //  $inputsummary .= var_dump($argv);
  //  echo $inputsummary;
 
  // this is a json
  if(substr($argv[1],0,1) == "{" )
  {
      $json = json_decode($argv[1], true);
      if($json==null)
      {
        echo("Error parsing input json:\n" + var_dump($argv[1]) . "\n" . json_last_error_msg() ."\n");
        exit(0);
      }
  }
  else // key / values
  {
    $json = array();
    for($k=1; $k<sizeof($argv)-1; $k+=2)
    {
      $json[substr( $argv[$k], 1, strlen($argv[$k]) )] =   $argv[$k+1];
    }
     $inputsummary = "=========== END OF INPUT   ===================\n";
     $inputsummary .= print_r($json);
     echo $inputsummary;
  }

  $ret = DPXnotify($json, true);
  echo($ret['msg']);
  
  if(!$ret['success'])
    exit(1);
  else
    exit(0);

}
// call from webinterface
else 
{
   echo json_encode( DPXnotify($_GET['json'], true) );
}

  

// ======================================================================================
// ============= MAIN function
// ======================================================================================
function DPXnotify($json, $fromCommandLine=false)
{
  
  require_once(dirname(__FILE__) . '/settings.php');
  require_once(dirname(__FILE__) . '/routes.php');

  // ***********  vars
  /*
    type: notification, warning, error, jobdone, ...
    title:
    content:
    
    from: username, "admin",  "service"
    to:   username/ mailinglist (like "admin") or email
    
    channel: email, platform


  */

  if( !isset($json['to'] ) )
  { 
    
  }

  if( !isset($json['from'] ) )
    { $json['from'] = 'system'; }
  
  if( !isset($json['type'] ) )
    { $json['type'] = 'popup'; }
  
  if( !isset($json['title'] ) )
    { $json['title'] = 'MessageTitle'; }
  
  if( !isset($json['content'] ) )
    { $json['content'] = 'MessageContent'; }
  
  if( !isset($json['thread'] ) )
    { $json['thread'] = ''; }
  
  if( !isset($json['project'] ) )
    { $json['project'] = ""; }
  
  if( !isset($json['channel'] ) )
    { $json['channel'] = 'platform'; }

  if( !isset($json['anonymize'] ) )
    { $json['anonymize'] = false; }

  
  // for job-realated messages
  if( !isset($json['submit_user'] ) )
    { $json['submit_user'] = 'Unknown Submit-user';}


  // ****************  predefined message types ***************
  if($json['type'] == 'jobdone' )
  {

      $pname     = json_decode( $json['PatientsName'], true );
      if($json['anonymize']==1)
      {
        $pname['FamilyName'] = substr($pname['FamilyName'], 0,1) . '***';
        $pname['GivenName'] = substr($pname['GivenName'], 0,1) . '***';
      }
      if($pname['GivenName'] != '[]')
      {
        $pname['FamilyName'] = $pname['FamilyName'] . ", " . $pname['GivenName'];
      }      

      $PatientID = ( $json['PatientID'] );
      $StudyID   = ( $json['StudyID'] );

      $json['title']   = "Job finished";
      $json['content'].= "<br>user: <b>" . $json['submit_user'] . "</b>";
      $json['content'].= "<br>project: <b>" . $json['project'] . "</b>";
      $json['content'].= "<br>patient: <b>" . $pname['FamilyName'] . "</b>";
      //if(!empty($pname['GivenName']))
      //    $json['content'] .=  ", " . $pname['GivenName'];
      
      $json['content'].= "<br><br>Please check your account to see the results.<br>";

      if(0)
      {
          $json['content'].= "<br><br>Check your account or click the following link to see the results:<br>";

          // ********** build share link ************
          $expandedNodes = (object) array( "x".$PatientID => 1,   (urlencode("x".$PatientID ."§" . $StudyID)) => 1 );
          $sharedLink = (object) array("project" => $json['project']
                                        ,"fireandforget" => true 
                                        ,"loginrequired" => true 
                                        , "expandedNodes" => $expandedNodes);

          $sharedLink = (json_encode($sharedLink));
          //$sub = ($_SERVER['PHP_SELF']); 
          $inner = "" . $GLOBALS['settings']->mail->instanceurl .  "?sharelink=" . ($sharedLink) ;
          //$inner = "" . $GLOBALS['settings']->mail->instanceurl .  "?project=" . $json['project']; 
          $link = "<a href='$inner'>$inner</a> ";


          //echo($link);
          //exit(1);

          $json['content'].= $link;
      }



      $dep = $json['dependency'];
      if($dep != "")
      {
        $pp =  resolve_Route(VARPATH . '/import/') . "/logs/$dep";
        if(file_exists($pp . ".log"))
        {
          $log = file_get_contents($pp.".log"  );       
          $err = file_get_contents($pp.".error"   );       
          $dep = "<hr INFORMATION ABOUT THE JOBS jobs<hr><div style='font-family:courier; font-size:12px'>";
          $dep .= str_replace("\n", "<br>", $log);
          $dep .= str_replace("\n", "<br>", $err) ;
          $dep .= "</div>";
          $json['content'].= "<br><br>" . $dep;
        }
      }
      //die( $json['content']);
  }







  $json_out = array("msg"=>"", 'success'=>false);

  // replace _SELF with the submitting user
  $json['to'] = str_replace("_SELF", $json['submit_user'], $json['to']);
  

  // "to" can be a list of users
  $toarray = explode( " ", $json['to']);


  //////////////////// email ///////////////////////////
  if( strpos("email", $json['channel']) !== false )
  {
    $toemails = array();
    $toadmins = "";
      
    require_once(dirname(__FILE__) . '/DPXMailer.php');
    require_once(dirname(__FILE__) . '/mydbconnection.php');
    $db = mydbconnection(ROOTDB);
    foreach($toarray as $t)
    {
      if( $t !== '_ADMINS' && $t !== '_SELF' && strpos("@", $t) == false  ) // entry is a username (not a group or an email)
      {
        $a = $db->query( "SELECT * from users where username LIKE '$t'" );
        if($a == false || ($row = $a->fetch_assoc()) == false )
        {
              $json_out['msg'] .= "Warning: No valid email found for `$t`.\n" ;
        }
        else
        {
           $to = $row['email'];
           if(!filter_var($to, FILTER_VALIDATE_EMAIL)) // invalid email found. do not send
              $json_out['msg'] .= "Warning: The email adress `" . $to . "` for user `$t` seems to be invalid.\n" ;
           else
             $toemails[] = $to;
        }

      }
      else if( $t == '_ADMINS' ) // the admin group
      {
        $toadmins = "admins";
      }

    }
    $db->close();
    
    if(sizeof($toemails) == 0 & $toadmins == "")
    {
      $json_out['msg'] .= "Error: No valid email adress entries found in database.";
      return $json_out;
    }

    $mail = &$GLOBALS['settings']->mail;
    $mail->debug = 2;
    $mail->simulate = false;
    //$to = $mail->testuser_email;
    //$to = "admins";

    $json_out['msg']   .= DPXMailer_send(implode(',', $toemails), $json['title'], $json['content']);
    if($toadmins != "")
    {
      $json_out['msg'] .= DPXMailer_send($toadmins, $json['title'], $json['content']);
    }
    
    $json_out['success'] = 1;
    
  }

  




  //////////////////// message on platform ///////////////////////////
  if( strpos("platform", $json['channel']) !== false )
  {
    require_once(dirname(__FILE__) . '/mydbconnection.php');
    $db = mydbconnection(ROOTDB);
    foreach($toarray as $t)
    {
       if( $t !== '_ADMINS' && $t !== '_SELF' && strpos("@", $t) == false  )
       {
          $json['content'] = $db->real_escape_string($json['content']);
          $ans = $db->query( "INSERT INTO notifications (username, fromuser, title, content, project, type) VALUES ('$t', '$json[from]', '$json[title]', '$json[content]',  '$json[project]',  '$json[type]');");
       }
       // send message to ALL users
       if($t === '*')
       {
           $a = $db->query( "SELECT * from users where username LIKE '%'" );
           while($row = $a->fetch_assoc())
           {
              $ans = $db->query( "INSERT INTO notifications (username, fromuser, title, content, project, type) VALUES ('$row[username]', '$json[from]', '$json[title]', '$json[content]',  '$json[project]',  '$json[type]');");
           }
       }
    }
    $db->close();
    $json_out['success'] = 1;
  }
  return $json_out;

}
   
?>