<?php

/***************************************************************************************
initialise
***************************************************************************************/

error_reporting(E_ALL);

//session_name('PHPSESSION2'); // Session must be set first, otherwise cookie params are not working
// $scriptPath =  substr ( $_SERVER['PHP_SELF'] , 0 , strrpos($_SERVER['PHP_SELF'] ,'/') ) . '/';
// session_set_cookie_params (0, $scriptPath);
// session_start();

header('Content-type: text/html; charset=utf-8');

require_once('session.php');
require_once('settings.php');
require_once('mydbconnection.php');

if(sizeof($_POST)>0) {$_GET = array_merge($_GET,$_POST);}


/***************************************************************************************
input arguments
***************************************************************************************/
$obj = false;
if(isset($_GET['json']))
{
  $obj = json_decode($_GET['json'], false);
  if($obj == false || $obj == null)
  {	
	echo "There was a severe error in the reading definition. Contact system admin.";
	var_dump(json_last_error_msg());
	echo $_GET['json'];
	die();
  }
}

/***************************************************************************************
output arguments
***************************************************************************************/
$out['msg'] = 'PHP script says: No action performed';
$out['success'] = false;



/***************************************************************************************
main logic
***************************************************************************************/
$rp = new ReadingProxy(null);
//var_dump($rp);

$command = $_GET['command'];

if(method_exists($rp, $command))
{
	$out = $rp->{$command}($obj);
}
else
{
	throw new Exception("Error, the command '" . $command . "'' does not exist.");
}


//var_dump($out);
echo json_encode($out);

die();



/***************************************************************************************
functions
***************************************************************************************/

class ReadingProxy
{
	private $readingresultstable = "readingresults";
	
	function __construct($klog) 
	{
		 
	}

	/******************************************************
	save case
	******************************************************/
	public function saveCaseResults($obj)
	{
		// can not save case without a patient id
		if(!isset($obj->patients_id))
		{
			// try to select next case, if desired
			//die(var_dump($obj));
			if(isset($obj->nextCaseID))
			{
				$out = $this->selectCase($obj) ;   // go to next case
				$out['msg'] = "" ;             
			}
			return $out;
		}

		// for backward compatibility (unique key was previously identified as negative iterator values in training mode)
		if($obj->rdef->currentmode=='mode_training')
				$obj->dbrow->iterator = -(abs($obj->dbrow->iterator)) ;

		$valueArray = (array)($obj->dbrow);
				
		$query =  ("REPLACE INTO " . $this->readingresultstable ." (" . implode(array_keys($valueArray), ',')  . ")" . " VALUES  ('" . implode(array_values($valueArray), "','")  . "') ");
		//var_dump($query);
		//return;

		$db =  mydbconnection($obj->project);
		if(!$db->query($query))
		{
			$out['success'] = false;
			$out['msg'] = "Warning. SQL error:\n". $db->error;
		}

		if(isset($obj->tagstoremove) | isset($obj->tagstoadd))
		{
			$selectionmode =  substr($obj->rdef->viewer->selectionMode,1);
			if($selectionmode=='s')
			{
				$TABLE = 'studies';
				$WCLAUSE = " patients_id LIKE '". $obj->patients_id . "' AND StudyID LIKE '" . $obj->studies_id . "' ";
				$TAGNAME = 'STAG';
			}
			else
			{
				$TABLE = 'patients';
				$WCLAUSE = " PIZ LIKE '". $obj->patients_id. "'";
				$TAGNAME = 'PTAG';
			}
			$tagquery = "";
			if(isset($obj->tagstoadd)) 
				foreach($obj->tagstoadd as $tag)
					$tagquery .=  ("UPDATE $TABLE SET $TAGNAME = CASE WHEN $TAGNAME > '' THEN CONCAT($TAGNAME, '$tag/')  ELSE '/$tag/' END WHERE $WCLAUSE AND $TAGNAME NOT LIKE '%/$tag/%';"  );
			if(isset($obj->tagstoremove))
				foreach($obj->tagstoremove as $tag)
					 $tagquery .= ("UPDATE $TABLE SET $TAGNAME = CASE WHEN LENGTH(REPLACE($TAGNAME, '/$tag/', '')) = 0 THEN REPLACE($TAGNAME, '/$tag/', '') ELSE  REPLACE($TAGNAME, '/$tag/', '/') END WHERE $WCLAUSE AND $TAGNAME LIKE '%/$tag/%';"  );
			
			if(strlen($tagquery)>0)
				$db->multi_query($tagquery);
		}


		// for development and debugging, we have a function to create random answers
		if(isset($obj->dbrow_randomlist))
		{
			//var_dump($obj->dbrow_randomlist);
			//echo("--------------");
			$arr = (array)($obj->dbrow_randomlist);
			//var_dump($arr);
			$keys = implode(array_keys((array)$arr[0]), ',');
			$varr = [];
			foreach($arr as &$temp)
			{
				// for backward compatibility (unique key was previously identified as negative iterator values in training mode)
				if($obj->rdef->currentmode=='mode_training')
						$temp->iterator = -(abs($temp->iterator)) ;

				$temp =  "('" . implode(array_values((array)$temp), "','")   . "')";
			}
			$query =  ("REPLACE INTO " . $this->readingresultstable ." (" . $keys  . ")" . " VALUES  " . implode(array_values($arr), ",")  . " ");
			if(!$db->query($query))
			{
				$out['success'] = false;
				$out['msg'] = "Warning. SQL error:\n". $db->error;
			}
		}
		
		
		$db->close(); 

		if(isset($obj->nextCaseID))
		{
			$out = $this->selectCase($obj) ;   // go to next case
			$out['msg'] = "" ;             
		}
		$out['msg'] = "" ;             

		return $out;
	}


    /******************************************************
    select a specific case, next/before a specific case, or next unrated case
    ******************************************************/
	public function selectCase($obj)
	{
		if(!isset($obj->nextCaseID))
		{
			die('no case id defined, aborting');
		}

		/******************************************************
		prepare all vars
		******************************************************/
		$project = $obj->project;
		$rdef = $obj->rdef;

		$isJointReading = isset($rdef->reading->jointreading) && $rdef->reading->jointreading;

		$ratedcondition = $this->createRatedCondition($obj,isset($obj->whoami)?$obj->whoami:null, $isJointReading);

		//$thestate = $_SESSION['state'][$project];
		// the following is somewhat strange... complicated... why??
		$thestate = $rdef;
 		$selectionmode =  substr($thestate->viewer->selectionMode,1);
 		
		
		$sortOrder = strtoupper($thestate->viewer->sortOrder);
		$sortOrder_ = strtoupper($thestate->viewer->sortOrder);
	
		$sortDirection = $thestate->viewer->sortDirection;
		$sortDirectionOriginal = $thestate->viewer->sortDirection;

		// base query for SQLCondition 
		$rtab =  $this->readingresultstable;
		
		$currentmode = $rdef->currentmode;
		$SQLCondition = getSQLCondition($rdef, $currentmode);

	    
	    // the following sorting might be valid
	    //$pHeader = array('PIZ'=> ['PIZ'], 'NAME'=> ['FamilyName','GivenName'], 'DATE' =>['StudyDate'],'UID'=>'StudyInstanceUID', 'PTAG' => ['PTag'], 'STAG' => ['STag']);
		//$pHeader = array('PIZ'=> 'PIZ', 'NAME'=> "FamilyName,', ',GivenName", 'DATE' =>'StudyDate', 'STUDYID'=>'StudyID', 'UID'=>'StudyInstanceUID', 'PTAG' => 'PTag', 'STAG' => 'STag');

		$pHeader = array('PIZ'=> 'PIZ', 'NAME'=> "FamilyName,', ',GivenName", 'DATE' =>'StudyDate', 'UID'=>'StudyInstanceUID', 'PTAG' => 'PTag', 'STAG' => 'STag');
		
		/* there is no study id sortorder, this does not work */
		/*
		if($selectionmode=='s')
			$pHeader['PIZ'] = 'StudyID';
		if($selectionmode=='p')
			$pHeader['PIZ'] = 'PIZ';
		*/

		// build a concatted key for sorting
		if (isset($pHeader[$sortOrder]))
		{
			$sortOrder = $pHeader[$sortOrder];
			
			//$fieldsForSorting = ["PIZ", 'NAME', 'STUDYID', 'DATE'];
			$fieldsForSorting = ["PIZ", 'NAME', 'DATE'];
			array_splice($fieldsForSorting, array_search($sortOrder_, $fieldsForSorting),1);
			array_unshift($fieldsForSorting, $sortOrder_);

// 			$sortOrderSQL = "CONCAT(" . $sortOrder;
			$fieldsForSorting2 = Array();
 			foreach($fieldsForSorting as $tt)
 					$fieldsForSorting2[] = $pHeader[$tt];

// 			$sortOrderSQL .= ")";
			$sortOrderSQL = 'CONCAT(' . implode($fieldsForSorting2, ',') . ")";

// 			if($sortOrder_ =='NAME')
// 				$sortOrderSQL = "concat(FamilyName,', ',GivenName, p.PIZ, s.StudyID, s.StudyDate) ";
// 			else
// 				$sortOrderSQL = 'CONCAT(' . implode(',', $pHeader[$sortOrder_]) .  ', p.PIZ, s.StudyID, s.StudyDate )';
			
// 			$getComparatorValue = function($row) use($sortOrder, $selectionmode)
// 			{ 
// 				$out = "";
// 				foreach($sortOrder as $s)
// 					$out .= $row[$s]; 

// 				$out .= $row['PIZ'];
				
// 				return $out; 
// 			};

			$getComparatorValue = function($row) use($fieldsForSorting, $pHeader)
			{ 
				
				$out = "";
				foreach($fieldsForSorting as $s)
				{
					$u = $pHeader[$s];
					if($s=='NAME')
						$out .= $row['FamilyName']. ', ' . $row['GivenName']; 
					else
						$out .= $row[$u]; 
				}
			
				return $out; 
			};
			
		}
		else
		{
			die("Error in reading definition, sort order ' $sortOrder   ' is undefined ");
		}


		if( isset($rdef->reading->$currentmode->randomize))
		{
			if($rdef->reading->$currentmode->randomize == "full")
			{
				$sortOrderSQL	= "RAND()";
			}
			elseif($rdef->reading->$currentmode->randomize == "idhash")
			{
				if($selectionmode=='s')
					$sortOrderSQL	= "MD5(StudyID)";
				else
					$sortOrderSQL	= "MD5(PIZ)";
			}

		}

			
		/******************************************************
		Build the query for study mode
		******************************************************/
		if($selectionmode=='s')
		{
			// join patients and studies
			//$basequery 	=	" FROM patients AS p LEFT JOIN studies AS s ON p.piz=s.patients_id "; 
			$basequery 	=	" FROM patients AS p INNER JOIN studies AS s ON p.piz=s.patients_id AND $SQLCondition"; 
			// join (all) metadata
			$basequery .=	" LEFT JOIN metacontent AS m ON CONCAT(s.patients_id, s.StudyID)=m.psid"; 
			// join previous reading results --> no, do this later
			//$basequery .=	" LEFT JOIN $rtab AS r ON CONCAT(r.patients_id,r.studies_id)=CONCAT(s.patients_id,s.StudyID)";
			
			// reading SQL cond
			//$basequery .=	" WHERE $SQLCondition";
			$basequery .=	" WHERE 1 ";
							
			// select the non - rated
			if($obj->nextCaseID == 'nextunrated')
			{
				//$basequery .= " AND (s.patients_id, s.StudyID) NOT IN ( SELECT patients_id, studies_id FROM $rtab WHERE $ratedcondition)"; 
				$basequery .= " AND CONCAT(s.patients_id, s.StudyID) NOT IN ( SELECT CONCAT(patients_id, studies_id) FROM $rtab WHERE $ratedcondition)"; 
			}
			// select specific case BEFORE or AFTER
			elseif($obj->nextCaseID == 'next' | $obj->nextCaseID == 'prev')
			{
				$operator  = $sortDirection=='ASC'?">":"<";
				if($obj->nextCaseID == 'prev')
				{
					$operator  = $sortDirection=='ASC'?"<":">";
					$sortDirection = $sortDirection=='ASC'?'DESC':'ASC';
				}
					
				if(!$isJointReading)
				{
					$basequery .= " AND  $sortOrderSQL $operator (SELECT MAX($sortOrderSQL) from patients AS p LEFT JOIN studies AS s ON p.piz=s.patients_id 
								AND s.patients_id LIKE '$obj->patients_id' AND s.StudyID LIKE '$obj->studies_id' )"; 
				}
				else
				{
					$basequery .= " AND  $sortOrderSQL $operator (SELECT MAX($sortOrderSQL) from patients AS p LEFT JOIN studies AS s ON p.piz=s.patients_id 
								AND s.patients_id LIKE '$obj->patients_id' AND s.StudyID LIKE '$obj->studies_id' )
								AND CONCAT(s.patients_id, s.StudyID) NOT IN (SELECT CONCAT(patients_id, studies_id) from $rtab WHERE formid LIKE '". $obj->rdef->formid. "' AND user NOT LIKE '$_SESSION[username]' AND duration = -1 ) 
								"; 
				}
			}
			elseif($obj->nextCaseID == 'first')
			{
				$basequery .= " AND CONCAT(s.patients_id, s.StudyID) IN ( SELECT CONCAT(patients_id, studies_id) FROM $rtab WHERE $ratedcondition) "; 
			}
			// select specific case (for reloading a case)
			elseif( is_object($obj->nextCaseID) )
			{
				$basequery .= " AND s.patients_id LIKE '". $obj->nextCaseID->patients_id . "' AND s.StudyID LIKE '" . $obj->nextCaseID->studies_id . "'" ;
				$basequery .= " AND CONCAT(s.patients_id, s.StudyID) NOT IN (SELECT CONCAT(patients_id, studies_id) from $rtab WHERE formid LIKE '". $obj->rdef->formid. "' AND user NOT LIKE '$_SESSION[username]' AND duration = -1 ) ";
			}
			// faster with AND in ON
			$allquery = "SELECT count(DISTINCT s.ID) as count FROM patients AS p INNER JOIN studies AS s ON p.piz=s.patients_id AND $SQLCondition";
			//$allquery = "SELECT count(DISTINCT s.ID) as count FROM patients AS p LEFT JOIN studies AS s ON p.piz=s.patients_id WHERE $SQLCondition";

		}


		/******************************************************
		Build the query for patient mode
		******************************************************/
		if($selectionmode=='p')
		{
			// join patients and studies
			$basequery 	=	" FROM patients AS p INNER JOIN studies AS s ON p.piz=s.patients_id"; 
			// join (all) metadata
			$basequery .=	" LEFT JOIN metacontent AS m ON p.PIZ=m.psid"; 
			// join previous reading results --> no, do this later
			//$basequery .=	" LEFT JOIN $rtab AS r ON CONCAT(r.patients_id,r.studies_id)=CONCAT(s.patients_id,s.StudyID)";
			
			// reading SQL cond
			$basequery .=	" WHERE $SQLCondition";
							
			if($obj->nextCaseID == 'nextunrated')
			{
				$basequery .=	" AND p.PIZ  NOT IN ( SELECT patients_id FROM $rtab WHERE $ratedcondition)"; 
			}
			elseif($obj->nextCaseID == 'next' | $obj->nextCaseID == 'prev')
			{
				$operator  = $sortDirection=='ASC'?">":"<";
				if($obj->nextCaseID == 'prev')
				{
					$operator  = $sortDirection=='ASC'?"<":">";
					$sortDirection = $sortDirection=='ASC'?'DESC':'ASC';
				}
					
				$basequery .=	" AND  $sortOrderSQL $operator (SELECT MAX($sortOrderSQL) from patients AS p LEFT JOIN studies AS s ON p.piz=s.patients_id 
								WHERE p.PIZ LIKE '$obj->patients_id' GROUP BY p.PIZ )"; 
			}
			elseif($obj->nextCaseID == 'first')
			{
				$basequery .= " AND p.PIZ IN ( SELECT patients_id FROM $rtab WHERE $ratedcondition) "; 
			}
			elseif(is_object($obj->nextCaseID) && isset($obj->nextCaseID->patients_id))
			{
				$basequery .=	" AND p.PIZ LIKE '" .$obj->nextCaseID->patients_id ."'"; 
			}

			// faster with AND in ON
			$allquery = "SELECT count(DISTINCT p.ID) as count FROM patients AS p INNER JOIN studies AS s ON p.piz=s.patients_id AND $SQLCondition ";
			//$allquery = "SELECT count(DISTINCT p.ID) as count FROM patients AS p LEFT JOIN studies AS s ON p.piz=s.patients_id WHERE $SQLCondition ";
			//$allquery = "SELECT count(*) as count FROM patients AS p WHERE $SQLCondition ";
		}		
		
 		// order by 
  		$basequery .=" ORDER BY $sortOrderSQL $sortDirection LIMIT 1";

  		//die($basequery);
		$aquery = "SELECT * $basequery";
  		
  		//var_dump($aquery);
		$db =  mydbconnection($project);	
		{
			/******************************************************
			select the desired case 
			******************************************************/		
			if( ($a=$db->query($aquery)) != false)
				$patientinfo = $a->fetch_assoc();
			else
				$patientinfo = array();


			// no case found => probably we are done. If allowPatientBrowsing, select first case
			if( $patientinfo == null && $rdef->reading->allowPatientBrowsing)
			{
				$obj->nextCaseID = "first";
				return $this->selectCase($obj);	
			}


			//var_dump($aquery);
			
			// for later convenience make sure we have the generic fields  patients_id and patients_id
			if(isset($patientinfo['PIZ']))
				$patientinfo['patients_id'] = $patientinfo['PIZ'];
			if($selectionmode=='s' && isset($patientinfo['StudyID']))
				$patientinfo['studies_id'] = $patientinfo['StudyID'];
				
				
			/******************************************************
			find the row number of the case
			******************************************************/		
			$vv =  $getComparatorValue($patientinfo);
			//echo $vv;
			if($selectionmode=='s')
			{
				$cquery = "SELECT count(*) as count  FROM patients AS p LEFT JOIN studies AS s ON p.piz=s.patients_id WHERE $SQLCondition AND $sortOrderSQL ".($sortDirectionOriginal=='ASC'?"<":">")." '$vv' ORDER BY $sortOrderSQL $sortDirection ";
			}
			else if($selectionmode=='p')
			{
				//find the row number of the case
				$cquery = "SELECT count(DISTINCT p.PIZ) as count  FROM patients as p LEFT JOIN studies AS s ON p.piz=s.patients_id WHERE $SQLCondition AND $sortOrderSQL ".($sortDirectionOriginal=='ASC'?"<":">")." '$vv' ORDER BY ($sortOrderSQL) $sortDirection ";
// 				$cquery = "SELECT count(*) as count  FROM patients as p LEFT JOIN studies AS s ON p.piz=s.patients_id WHERE $sortOrderSQL ".($sortDirectionOriginal=='ASC'?"<":">")." '$vv' ORDER BY MIN($sortOrderSQL) $sortDirection ";
			}

			if( ($a=$db->query($cquery)) != false)
			{
				$rownumber = $a->fetch_assoc();
				$rownumber = $rownumber['count'];
				//$rownumber = ($a['num_rows']);
			}
			else
			{
				$rownumber = -1;
			}
//die($cquery . "nnn ". $rownumber);
			/******************************************************
			previous results
			******************************************************/	
			// set at least the patient and study id, if no previous result is available
			$dbrow = (object)array();
			$dbrow->patients_id = $patientinfo['PIZ'];
			$dbrow->user = $_SESSION['username'];
			if($selectionmode=='s')
			{	
				$studies_id = $patientinfo['StudyID'];
				$dbrow->studies_id  = $patientinfo['StudyID'];
			}
			else if($selectionmode=='p')
			{
				$studies_id = "%";
				$dbrow->studies_id  = '';
			}
				
			//previous results for ALL other raters. For iterated readings, must consider other ratedcondition!!!
			//var_dump($rdef);
			if($rdef->showothers->when > 0)
			{
				$ratedcondition_any_user = $this->createRatedCondition_other_users($obj);
				$rquery = "SELECT * FROM $rtab WHERE patients_id LIKE '$dbrow->patients_id' AND studies_id LIKE '$studies_id' AND $ratedcondition_any_user";
			}
			else
			{
				$rquery = "SELECT * FROM $rtab WHERE patients_id LIKE '$dbrow->patients_id' AND studies_id LIKE '$studies_id' AND $ratedcondition";
			}

 			$dbrow_others=[];
			
			if( ($a=$db->query($rquery)) != false)
			{
				while( ($row = $a->fetch_assoc() )!==null)
				{
					if($row['user'] == $_SESSION['username'])
						$dbrow = (object)$row;
					// if this is a joint reading, every case should be rated by one user only, use this
					elseif( $isJointReading )
						$dbrow = (object)$row;

					// store all results
					$dbrow_others[] = $row;
				}
			}
			// reserve case by setting duration to -1
			// if( $rdef->jointreading && $obj->nextCaseID == 'nextunrated')
			if($isJointReading && !isset($dbrow->json) && isset($patientinfo['PIZ']))
			{
 			

				$valueArray = Array("user"=>$_SESSION['username'], "formid"=>$obj->rdef->formid, "duration" => -1, "patients_id" => $patientinfo['PIZ']
					,"studies_id" => $patientinfo['StudyID'] 
					,"iterator" => ($currentmode=='mode_serious'?1:-1)
					,"repetition" => 0
					);
		     	$query =  ("INSERT IGNORE INTO " . $this->readingresultstable ." (" . implode(array_keys($valueArray), ',')  . ")" . " VALUES  ('" . implode(array_values($valueArray), "','")  . "') ");
				
				if( ($dummy=$db->query($query)) == false)
					die($query);
			}

			/******************************************************
			overall progress
			******************************************************/		
			$progress = array();
			$a=$db->query($allquery);
			$a = $a->fetch_assoc(); 
			$progress['numcases_total'] = intval($a['count']);
			
			// most likely, "next" was hit after all cases are done
			// NO! also on restart training ... disable!
			/*
			if($rownumber == 0  && ($obj->nextCaseID == 'next' || $obj->nextCaseID == 'nextunrated') ) 
				$rownumber = $progress['numcases_total']+1;
			*/
			
			$a=$db->query("SELECT count(*) as count FROM $rtab WHERE $ratedcondition");
			$a = $a->fetch_assoc(); 
			$progress['numcases_rated'] = intval($a['count']);
		
		}
		
		$db->close();

		
		/******************************************************
		set the relevant case information (repetition etc)
		******************************************************/		
		$res = array();
		$res['patientinfo'] = $patientinfo;
		$res['progress'] 	= $progress;
		$res['dbrow'] 		= $dbrow;
		$res['dbrow_others'] 	= $dbrow_others;
		$res['rownum_in_ptable'] = $rownumber;
		
		//var_dump($res);

		
		$out[] = array();
		$out['msg'] = "" ;           
		$out['json'] =  $res;
		
	  	return $out;
					
		
	}
	

    /******************************************************
    get progress info (progress, remaining cases, etc)
    ******************************************************/
	public function getReadingProgress($obj)
	{
		
		function createProjectCountQuery($project, $currentmode, $rdef)
		{
			//$selectionmode =  substr($_SESSION['state'][$project]->viewer->selectionMode,1);
			$selectionmode = substr($rdef->viewer->selectionMode,1);
			$SQLCondition = getSQLCondition($rdef, $currentmode);
			if($selectionmode=='p')
				$query = "SELECT count(DISTINCT p.ID) as count FROM $project.patients AS p LEFT JOIN $project.studies AS s ON p.piz=s.patients_id WHERE $SQLCondition";
			else if($selectionmode=='s')
				$query = "SELECT count(DISTINCT s.ID) as count FROM $project.patients AS p LEFT JOIN $project.studies AS s ON p.piz=s.patients_id WHERE $SQLCondition";
			return $query;
		}

		function doTheCount($db, $row, &$rlist, $rtab, $rdef,  $mode)
		{
			/******************************************************
			reading table exists?
			******************************************************/
			$a = $db->query( "SHOW TABLES FROM $row[project] LIKE '$rtab'");
			if($a->fetch_assoc() == null ) 
			{	
				$rlist['stats'][$row['id']][$mode] = array("count" => "-1");	
			}
			else
			{
				/******************************************************
				count rated cases
				******************************************************/
				$rlist['stats'][$row['id']][$mode] = array("count" => "0");	
					$xxx = $mode=='mode_serious'?"iterator > 0":"iterator < 0";
				if( isset($rdef->reading->jointreading) && $rdef->reading->jointreading) 
					$userc = "%";
				else	
					$userc = $_SESSION["username"];

				$query = "SELECT  count(r.id) as count from $row[project].$rtab as r WHERE r.formid like '$row[id]'  AND user LIKE '$userc' AND $xxx AND duration > -1 GROUP BY r.formid";
				
				$a = $db->query( $query );
				if( ($xrow = $a->fetch_assoc()) !== null ) 
				{	
					$rlist['stats'][$row['id']][$mode] = $xrow;
				}	
			}
			/******************************************************
			count total num cases
			******************************************************/
			if( ($b=$db->query( createProjectCountQuery($row['project'], $mode, $rdef) )) != false)
			{
				$b = $b->fetch_assoc();
				if($b!== null)
					$rlist['stats'][$row['id']][$mode]['numcases_total'] = intval($b['count']);
				else
					$rlist['stats'][$row['id']][$mode]['numcases_total'] = 0;
			}
			return;
		}
		
		$db = mydbconnection(ROOTDB);
		

		$rlist = array('stats' => Array(), 'forms' => Array() );

		/******************************************************
		Loop over readings
	    ******************************************************/
	    if ($_SESSION['userinfo']['isadmin'] === '1')  
			$query = "SELECT j.* from json as j WHERE j.type LIKE 'form' AND j.TAG LIKE '%READING%'";
		else
			$query = "SELECT j.* from json as j join rights as r ON j.project=r.project WHERE j.type LIKE 'form' AND j.TAG LIKE '%READING%' AND (r.username='$_SESSION[username]' OR r.username='<ANY>')";
		
		if( ($a=$db->query( $query)) != false)
		{
			/******************************************************
			iterate over readings
			******************************************************/
			while( ($row = $a->fetch_assoc() )!==null)
			{
				// id key might be upper case
				$row = array_change_key_case($row);

				if(!isset($rlist['stats'][$row['id']]))
					$rlist['stats'][$row['id']] = array();
				if(!isset($rlist['forms'][$row['id']]))
					$rlist['forms'][$row['id']] = 	$row['json'];

				$rdef = json_decode($row['json'], false); 
				$rdef = $rdef->reading;
				unset($row['json']);
					
				doTheCount($db, $row, $rlist, $this->readingresultstable, $rdef,  'mode_training');
				doTheCount($db, $row, $rlist, $this->readingresultstable, $rdef,  'mode_serious');
			}

		}

		$res = array();

		$out[] = array();
		$out['msg'] = "" ;           
		$out['json'] =  $rlist;


		$db->close();
		return $out;
	}


	
	public function createRatedCondition($obj, $user='xxxnative', $isJointReading=false  )
	{
		if($user=='xxxnative' || $user==null)
			$user = $_SESSION['username'];
		
		if( $obj->rdef->currentmode=='mode_serious')
			$modecondition = "iterator > 0";
		else
			$modecondition = "iterator < 0";
		
		/* for joint reading condition, must 
			a) check if someone is currently working and some case / hase reserved it
			b) and select cases rated by ANY user */
			
		if( $isJointReading )
		{
			$ratedcondition = 	"formid LIKE '".$obj->rdef->formid."' AND $modecondition AND ( (user LIKE '%' AND duration > 0) OR (user NOT like '$user' AND duration = -1 )) ";	
		}
		else
		{
			$ratedcondition = 	"formid LIKE '".$obj->rdef->formid."'  AND user LIKE '$user' AND $modecondition ";	
		}
		return $ratedcondition;
	}
	
	public function createRatedCondition_other_users($obj)
	{
		$otherusers = $obj->rdef->showothers->users;
		$xxx = $obj->rdef->currentmode=='mode_serious'?"iterator > 0":"iterator < 0";
		$ratedcondition = 	"formid LIKE '".$obj->rdef->formid."'  AND (user like '$_SESSION[username]' OR user LIKE '$otherusers') AND $xxx ";	
		//$ratedcondition = 	"formid LIKE '".$obj->rdef->formid."'  AND user LIKE '%' AND mode like '".$obj->rdef->currentmode."'";	
		return $ratedcondition;
	}

    /******************************************************
    restart (training)
    ******************************************************/
	public function restartReading($obj)
	{

		/******************************************************
		prepare all vars
		******************************************************/
		$project = $obj->project;
		$rdef = $obj->rdef;
		
		$ratedcondition =  $this->createRatedCondition($obj, $obj->whoami, false); // joint reading flag must be false, otherwise will delete ALL user results
		
		$thestate = $_SESSION['state'][$project];

		// base query for SQLCondition 
		$rtab =  $this->readingresultstable;
		if(!isset($rdef->SQLCondition) || empty($rdef->SQLCondition))
			$rdef->SQLCondition = " 1 ";

			
		/******************************************************
		Build the query
		******************************************************/
		
		$query 	=	" DELETE FROM  $rtab WHERE $ratedcondition"; 
		$db =  mydbconnection($project);	
		
		if( ($a=$db->query($query)) != false)
			1;		
		else
	  		1;

		$db->close();


		$out = $this->selectCase($obj) ;   // go to next case
		$out['msg'] = "" ;	  	

		
		return $out;	
	}

	//createSummaryTable
	public function createSummaryTable($obj)
	{
		$formid = $obj->formid;
		//die("adyd". var_dump($obj) );
		$db =  mydbconnection($obj->project);
		$lim = "limit 30";
		$lim = "";
		//$query 	=	" SELECT * FROM $this->readingresultstable JOIN $obj->project.metacontent AS m ON CONCAT(patients_id,studies_id) = m.psid $lim"; 	
		$query 	=	" SELECT * FROM $this->readingresultstable WHERE formid like '$formid' ORDER BY user $lim"; 	
		
		if( ($a=$db->query($query)) != false)
		{
			$rows = array();
			$resultfields = array();
			$fieldstomremove = ["ID", "formid", 'modified', 'psid'];
			
			//var_dump($a);

			while( ($row = $a->fetch_assoc() )!==null)
			{
				$json = json_decode( $row['json'], true);
				unset($row['json']);

				foreach($row as $key => $val)
				{
				      if(!isset($resultfields[$key]))
					      $resultfields[$key] = 1;
				}
				
				if(!isset($json['formcontent']))
					continue;

				foreach($json['formcontent'] as $key => $val)
				{
					// collect all possible keys

					// must append subforms here differently!!!
					// if some rating has same name as dbrow, zb timestamp, will be overwritten ...
					$row[$key]	= str_replace(';', 'SEMICOLON', $val);	
					if(is_array($val))
					{	
						$ucount = -1;
						foreach($val as $ukey => $uval)
						{
							$xkey = $key."_".$ukey;
							//if(is_array($uval))
							if($ukey == 'markerset')
							{
								/*
								foreach($uval['points'] as $point)
								{
									var_dump($point);
								}
								*/
								$uval = sizeof($uval['points']);
								
							}

							$row[$xkey] = $uval;
							if(!isset($resultfields[$xkey]))
									$resultfields[$xkey] = 1;
						}
					}
					else
					{
						$row[$key]	= $val;	
						if(!isset($resultfields[$key]))
							$resultfields[$key] = 1;
					}
					
				}
				foreach($fieldstomremove as $rr)
					if(isset($row[$rr]))
						unset($row[$rr]);

				$rows[] = $row;
				
			}
			foreach($fieldstomremove as $rr)
				if(isset($resultfields[$rr]))
					unset($resultfields[$rr]);
			
			$resultfields = array_keys($resultfields);

            array_unshift($resultfields,'PSID');
			$csv = "";
			foreach( $rows as &$row)
			{
				$csv .= "\n";
				$trow = [];
				foreach($resultfields as $num => $key )
				{
					if ($key == 'PSID')
						$row[$key] = $row['patients_id'] . $row['studies_id'];
						
					if(!isset($row[$key]))			// fill missing fields
						$row[$key] = "NA";
					
					if(!is_array($row[$key]))
						$trow[] = $row[$key] ;
				}

				//echo "=========";
				$csv .= implode(';', $trow);

			}
			
			/********** prepend header ************/
			if(sizeof($rows) > 0)
			{
				$keylist = array_keys($rows[0]);
				$header = implode(';', $resultfields );
				//$header = str_replace('kellnere_', '', $header);
				$csv =  $header .  $csv;
			}
			

			//die($csv);
			$out = array();
			$out['msg'] = "" ;	  	
			$out['json'] = array("csv"=> $csv );	  	


		}
		else
		{
			$out = array();
			$out['msg'] = "Database Error" ;	  	
		}
		$db->close();
		

		
		return $out;	

	}


}

///////// helper funs

function getSQLCondition($rdef, $currentmode)
{
	$SQLCondition = $rdef->reading->$currentmode->SQLCondition;

	// for joint / shared reading, can define user specific ranges
	if(isset($rdef->reading->users ))
	{
		$theuser = $_SESSION['username'];
		$u = $rdef->reading->users;
		//die(var_dump($u->$theuser));
		if(isset( $u->$theuser ) && isset($u->$theuser->SQLCondition)  )
		{
			$SQLCondition .= (" AND " . $u->$theuser->SQLCondition);
		}
	}
	
	return $SQLCondition;
}






















/***************************************************************************************
***************************************************************************************
   OLD  FUNCTIONS
***************************************************************************************
****************************************************************************************/


function KReading_setMode($mode)
{

  unset($_SESSION['KReader_currentCaseInfo']);
  $_SESSION['KReading_mode'] = $mode;

  if($mode == "mode_normal")
    $_SESSION["KReading_tableName"] = INSTANCEPREFIX . 'readings.' . $_SESSION['currentReading'];
  else
    $_SESSION["KReading_tableName"] = INSTANCEPREFIX . 'readings.' . $_SESSION['currentReading'] . '_training';
}

function KReading_restartForThisUser()
{
  if( ! $_SESSION['KReader_readingDefinition']['allowRestartTraining'] |  $_SESSION['KReading_mode'] !== 'mode_training' )
  {
      $out['success'] = false;
      $out['msg'] = "Error: You are not allowd to restart.";

  }

  $db = KReading_mydbconnection();
    $query =  ("DELETE FROM ". $_SESSION["KReading_tableName"]  ." WHERE username = '$_SESSION[username]'");
    if($db->query($query))
    {
      $out = KReading_getCaseInfo(true);   // proceed to next case inside getCaseInfo
      $out['msg'] = "" ;
    }
    else
    {
      $out['success'] = false;
      $out['msg'] = "Warning. SQL error:\n". $db->error;

    }

  return ($out);
}

function KReading_unsetReadingSession()
{
  unset($_SESSION['KReader_readingDefinition']);
  unset($_SESSION['KReader_currentCaseInfo']);
  unset($_SESSION['currentReading']);
}

function KReading_mydbconnection()
{
  //return  mydbconnection('readings');
  $dbname = $_SESSION['readingInfo'][$_SESSION['currentReading']]['referenced_project'];
  return  mydbconnection( $dbname);
}

/***************************************************************************************
Save reading defintion to file
****************************************************************************************/
function KReading_saveReadingDefinition($obj)
{
  $filepath =  DPXROOT . '/var/readings/' . $_SESSION['currentReading'] . '.json';
  $msg = file_put_contents( $filepath, $obj->readingDefinition );
  if( $msg === false )
    $out['msg']  = "Error while writing the .json file: " . $filepath . var_dump($obj->readingDefinition) ;
  else
    $out['msg']  = " Saved  <br>". $filepath ;

  return $out;
}



/***************************************************************************************
Get reading defintion from file
****************************************************************************************/
function KReading_getReadingDefinition()
{
  $filepath =  DPXROOT . '/var/readings/' . $_SESSION['currentReading'] . '.json';
  if(!file_exists($filepath))
  {
    $out['success']  = false;
    $out['msg']  = 'Error: Definition file ' .$filepath  .  'not found on server.';
    $out['msg']  = var_dump($_SESSION['moduleInfo']);
    die(json_encode($out));
  }
  $out['json']  = file_get_contents($filepath);


  // ============= some default values, to be implemented as template
  $_SESSION['KReader_readingDefinition']['stage'] = 0  ;
  $_SESSION['KReader_readingDefinition']['PIZcondition']  = ' 1=1 ';
  $_SESSION['KReader_readingDefinition']['showPatientTable']  = 0;

  $_SESSION['KReader_readingDefinition']['numStages']  = 1;
  $_SESSION['KReader_readingDefinition']['numOfPatientsWithRepetitions']  = 1;
  $_SESSION['KReader_readingDefinition']['numRepetitionsForPatientsWithRepetitions']  = 1;

  // =============


  $struct =   json_decode($out['json'], true);

  if($_SESSION['KReading_mode'] == 'mode_training')
  {
     // training mode is available. extend normal settings with training mode
    if(isset($struct['mode_training']))
    {
      $struct['mode_normal'] =  array_replace_recursive( $struct['mode_normal'], $struct['mode_training']   );
    }
  }

  $struct  = array_merge($struct, $struct['mode_normal']);
  unset($struct['mode_training']);
  unset($struct['mode_normal']);

  // set the current Mode
  //$_SESSION['KReader_readingDefinition']['readingMode'] =  $_SESSION['KReading_mode'];
  $struct['readingMode'] = $_SESSION['KReading_mode'];
  // rebuild the structure with the corrected settings
  $out['json'] = json_encode($struct);



  foreach($struct as $tkey => $tval )
  {
    $_SESSION['KReader_readingDefinition'][$tkey] = $tval;
  }


  // if(isset(  $_SESSION['KReader_readingDefinition']['PIZcondition'] ))
  //     $_SESSION['KReader_readingDefinition']['PIZcondition']  = $_SESSION['KReader_readingDefinition']['PIZcondition'];



      // Specialty: make sure that num patients with repetitions can not be larger than num patients total
      $db = KReading_mydbconnection();
      $a = $db->query("SELECT count(*) as count FROM patients as p WHERE " . $_SESSION['KReader_readingDefinition']['PIZcondition'] );
      if(!$a) KReading_throw_sql_error($db);
      $row = $a->fetch_assoc();
      $nPatientsTot = $row['count'];
      $_SESSION['KReader_readingDefinition']['numOfPatientsWithRepetitions'] = min($nPatientsTot,   $_SESSION['KReader_readingDefinition']['numOfPatientsWithRepetitions']);
//var_dump($row);
  $out['success']  = true;
  $out['msg']  = '';
  return ($out);

}




function KScore_getRemainigCases()
{
  $db = KReading_mydbconnection();
  $rname = $_SESSION["KReading_tableName"];



// find all patients which have not been fully answered. Somewhat complicated, because might be that only some patients have repetitions.

  // these are the first X cases which might be repeated
  $pc1 = "( select * from (select PIZ from patients WHERE ".$_SESSION['KReader_readingDefinition']['PIZcondition']." LIMIT ". intval($_SESSION['KReader_readingDefinition']['numOfPatientsWithRepetitions']) . " ) as ttt)";
  // this is the rest
  $pc2 = "( select PIZ from patients WHERE ".$_SESSION['KReader_readingDefinition']['PIZcondition'] ." AND PIZ NOT IN $pc1 )";

  $a = $db->query("SELECT PIZ FROM patients as p WHERE ".$_SESSION['KReader_readingDefinition']['PIZcondition'] ."AND PIZ NOT IN
  ( SELECT PIZ from  $rname WHERE  stage = " . $_SESSION['KReader_readingDefinition']['stage'] . " AND username LIKE '$_SESSION[username]'
          AND (  (PIZ IN $pc1 AND repetition >= ".intval($_SESSION['KReader_readingDefinition']['numRepetitionsForPatientsWithRepetitions'])." ) OR (PIZ IN $pc2 AND repetition = 0 )) )"
  //      AND (  (PIZ IN $pc1 AND repetition >=3 ) OR (PIZ IN $pc2 AND repetition = 0 )) )"

 );

  if(!$a) KReading_throw_sql_error($db);
  $db->close();

  $pList = array();
  // collect all in strutured array
  while( $row = $a->fetch_assoc() )    {	     $pList[] = $row;      }
  // no patiens left, finished. Implemented in javascript now.
  // if(sizeof($pList)==0)
  // {
  //   $_SESSION['KReader_currentCaseInfo']['repetition'] = 0;
  //   $_SESSION['KReader_currentCaseInfo']['level'] =0;
  //
  //   $out['success'] = false;
  //   $out['msg'] = "";
  //   $out['hiddenmsg'] = "finished";
  //   die(json_encode($out));
  // }

//var_dump($pList);
  return $pList;

}


function KScore_proceedToNextCase()
{
      $pList = KScore_getRemainigCases();
      if(sizeof($pList) == 0 )
      {
        return false;
      }
      if(isset(    $_SESSION['KReader_readingDefinition']['randomize']))
      {
        if($_SESSION['KReader_readingDefinition']['randomize'])
        {
          shuffle($pList) ;   // randomise the array
        }
      }
      $newPIZ = $pList[0]['PIZ'];
      $_SESSION['KReader_currentCaseInfo']['PIZ'] = $newPIZ;

      $db = KReading_mydbconnection();
      //$a = $db->query("SELECT StudyID FROM studies WHERE patients_id LIKE '$newPIZ' ORDER BY StudyDate DESC LIMIT 1" );
      //$a = $db->query("SELECT * FROM files WHERE patients_id = '$newPIZ' ORDER BY Filename ASC" );
      $a = $db->query("SELECT * FROM files WHERE (studies_id IN
        (  select studyID from (SELECT studyID from studies where patients_id LIKE '$newPIZ' order by StudyDate ASC LIMIT 1 ) as x )
        AND patients_id LIKE '$newPIZ')
        OR patients_id LIKE '000'  ORDER BY Filename ASC
        ");

      if(!$a) KReading_throw_sql_error($db);
      $db->close();
      $files = array();
      while($row = $a->fetch_assoc())
      {
        $files[] = $row;
      }
      $_SESSION['KReader_currentCaseInfo']['files'] = json_encode($files);

  //  var_dump($files);
      // $out['success'] = true;
      // $out['msg'] = "Successfully selected the next case.";
     return true;
}

function KReading_throw_sql_error($db)
{
  $out['success'] = false;
  $out['msg'] = "Warning. SQL error:\n". $db->error;
  $db->close();
  die(json_encode($out));
}

function KReading_getCaseInfo($proceedToNext = false)
{
  $db = KReading_mydbconnection();
  //
  $_SESSION['KReader_currentCaseInfo']['username']   = $_SESSION['username'];
  $_SESSION['KReader_currentCaseInfo']['numberOfCases'] = 'not php_not_set';
  $_SESSION['KReader_currentCaseInfo']['currentCase']   = 'not php_not_set';
  $_SESSION['KReader_currentCaseInfo']['level']   = 'php_not_set';
  $_SESSION['KReader_currentCaseInfo']['gender_age']   = 'php_not_set';
  $_SESSION['KReader_currentCaseInfo']['stage']   = $_SESSION['KReader_readingDefinition']['stage'];


  $out['success']  = true;
  $out['msg']  = '';

  // // ========  the table does not exits yet.
  if( !($a = $db->query("SELECT count(*) as count  FROM " . $_SESSION["KReading_tableName"], true )   ) )
  {
    if(!$_SESSION['userinfo']['isadmin'])
    {
      $out['msg'] = "The results table does not exist. Please contact your system admin.";
      $out['success'] = false;
    }
    else
    {
      $out['caseInfo']  = json_encode($_SESSION['KReader_currentCaseInfo']);
    }
    return $out;
  }


   if( !isset($_SESSION['KReader_currentCaseInfo']['PIZ']) | $proceedToNext )
   {
     if( !KScore_proceedToNextCase() ) // no more cases left, quit
     {
       $_SESSION['KReader_currentCaseInfo']['PIZ'] = 'php_not_set';
       $_SESSION['KReader_currentCaseInfo']['numberOfCases'] = 0;
       $_SESSION['KReader_currentCaseInfo']['currentCase']   = 1;
       $out['caseInfo']  = json_encode($_SESSION['KReader_currentCaseInfo']);
       return $out;
     }
   }

   // check if number of cases has been exceeded.

   $PIZ = $_SESSION['KReader_currentCaseInfo']['PIZ'];
  //
  // ========= get Patient Information for current Patient
   $a = $db->query("SELECT *  FROM patients WHERE PIZ LIKE '$PIZ'");
   if(!$a) KReading_throw_sql_error($db);

   $row = $a->fetch_assoc();
   if($row['BirthDate']!=='')
   {
     $_SESSION['KReader_currentCaseInfo']['gender_age'] =  $row['Sex'] . ", " . (intval(date("Y")) - intval(substr($row['BirthDate'],0,4)) + 0*rand(-5,5) )  ." Years";
   }
   else
   {
     $_SESSION['KReader_currentCaseInfo']['gender_age'] = 'n/a';
   }


  // // ========= get the number of patiens --> number of cases.
    $a = $db->query("SELECT COUNT(*) as count FROM patients WHERE 1=1 AND " . $_SESSION['KReader_readingDefinition']['PIZcondition']);

    if(!$a) KReading_throw_sql_error($db);
    $row = $a->fetch_assoc();
    $_SESSION['KReader_currentCaseInfo']['numberOfCases'] = $row['count'] + $_SESSION['KReader_readingDefinition']['numOfPatientsWithRepetitions']*($_SESSION['KReader_readingDefinition']['numRepetitionsForPatientsWithRepetitions']);

    // // ========  get the number the current case
    $a = $db->query("SELECT count(*) as count  FROM ".$_SESSION["KReading_tableName"]." WHERE username = '$_SESSION[username]' GROUP BY stage");
    if($row = $a->fetch_assoc())
    {
      $_SESSION['KReader_currentCaseInfo']['currentCase']  = $row['count'] +1;
    }
    else
    {
       $_SESSION['KReader_currentCaseInfo']['currentCase'] = 1;
    }


  // // ======== for repetitions: get the number repetitions for the current case

   $a = $db->query("SELECT COUNT(*) as count from ".$_SESSION["KReading_tableName"]." WHERE PIZ = '$PIZ' AND username = '$_SESSION[username]' AND stage = '" . $_SESSION['KReader_readingDefinition']['stage'] ."'");
   if(!$a) KReading_throw_sql_error($db);
   if($row = $a->fetch_assoc())  $count = $row['count'];
   else $count = 0;

     $_SESSION['KReader_currentCaseInfo']['repetition'] = $count;

     // set the level for the current case with modulo  n cases . can also be changed.
     $_SESSION['KReader_currentCaseInfo']['level'] = (intval($row['ID'])+ $_SESSION['KReader_currentCaseInfo']['stage']) % $_SESSION['KReader_readingDefinition']['numStages']  ;



  //
  //   $out['savedRow'] = '';
  //
  //
  //   // =========== search value which was previously saved and save in savedRow. Check first if database exists.
  //   /*
  //   $a = $db->query("SELECT COUNT(*) as count FROM sqlite_master WHERE name = '$GLOBALS[tablename]' and type='table'");
  //   $row = $a->fetchArray(SQLITE3_ASSOC);
  //   if($row['count'] > 0 )
  //   {
  //       $a = $db->query("SELECT * FROM $GLOBALS[tablename] WHERE PIZ ='$_SESSION[PIZ]' AND username = '$_SESSION[username]'  ");  $row = $a->fetchArray(SQLITE3_ASSOC);
  //       $out['savedRow']   = $row;
  //   }*/
  //
  // // find the current case number
  // $a = $db->query("SELECT count(*) as count  FROM $_SESSION[currentReading][name] WHERE username = '$_SESSION[username]' GROUP BY stage");
  // if($row = $a->fetchArray())
  // {
  //   $_SESSION['currentReading']['currentCase']  = $row['count'] +1;
  // }
  // else
  // {
  //    $_SESSION['currentReading']['currentCase'] = 1;
  //    //$_SESSION['currentReading']['numberOfAnsweredPatients'] = 1;
  // }
  //
  // $out['msg'] = '';
  // if($_SESSION['currentReading']['currentCase'] > $_SESSION['currentReading']['numberOfCases'])
  // {
  //   $out['msg'] = 'finished';
  // }
  //
  // $out['html'] 	   = parseForm();
  // $out['success']  = true;
  //
  // return $out;
  //
  //

  $db->close();

  $out['caseInfo']  = json_encode($_SESSION['KReader_currentCaseInfo']);

  //$out['html'] =  KReading_renderFormHTML();   // this calls the specific function
  $out['success']  = true;
  $out['msg']  = '';
  return $out;
}


function KReading_submitResult($jsonString)
{
  $ddd = get_object_vars($jsonString);
  $valueArray	  = get_object_vars($ddd['valueArray']);
  //var_dump(implode(array_values($valueArray), "','"));  return;
  $db = KReading_mydbconnection();
  try
  {
    $query =  ("REPLACE INTO ". $_SESSION["KReading_tableName"] ." (" . implode(array_keys($valueArray), ',')  . ")" . " VALUES  ('" . implode(array_values($valueArray), "','")  . "') ");
    if($db->query($query))
    {
      //KScore_proceedToNextCase();
      $out = KReading_getCaseInfo(true);   // proced to next case inside getCaseInfo
      //$out['success'] = true;
      $out['msg'] = "" ;//"Saved sucessfully and proceeded to next case";
    }
    else
    {
      $out['success'] = false;
      $out['msg'] = "Warning. SQL error:\n". $db->error;

    }
  }
  catch(Exception $exception)
  {
      $out['success'] = false;
      $out['msg']  = $exception->getMessage();
  }
  $db->close();

 return $out;

}


function KReading_createResultsTable($jsonString)
{
  //var_dump($jsonString);
  $ddd = get_object_vars($jsonString);
  $tableDefintion = get_object_vars($ddd['tableDefintion']);

  $db = KReading_mydbconnection();
  $rname = $_SESSION["KReading_tableName"];
  $db->query("CREATE DATABASE IF NOT EXISTS readings");
  $db->query("DROP TABLE IF EXISTS $rname" );
  $a = $db->query("CREATE TABLE $rname (" . implode(array_values($tableDefintion), ',')  . ")");
  //var_dump( $ddd); return;
  if($a)
  {
    $out['success'] = true;
    $out['msg'] = '';
  }
  else
  {
    $out['success'] = false;
    $out['msg'] = "Warning. SQL error:\n". $db->error;
  }
  $db->close();

   //unset($_SESSION['KReader_currentCaseInfo']['PIZ']);
   unset($_SESSION['KReader_currentCaseInfo']);
   KReading_getReadingDefinition();

   return $out;
}




function KReading_renderResultsTableHTML()
{
    $html = '<div>';

    $db = KReading_mydbconnection();
    $a = mysqli_query($db, "SHOW FULL COLUMNS from " . $_SESSION["KReading_tableName"] );// or die(mysqli_error($db));;
    $keys = array();    while($row = $a->fetch_assoc())    {     	$keys[] = $row['Field'];           }
    //array_splice($keys,1,0,'case');


    $html .= "<table class='KReading_resultsTable'>";
    $html .= "<tr>";
	  foreach($keys as $tKey )
    {
      $html .= "<td>" . $tKey ."</td>";
    }
    $html .= "</tr>";


    if(isset($_GET['restrict_to_username']))
          $restrictionString = "AND username == '$_GET[restrict_to_username]'";
    else
         $restrictionString = "";

   //$a = $db->query("SELECT p.ID, p.PIZ  FROM patients as p JOIN ".$_SESSION["KReading_tableName"]." as s WHERE p.PIZ=s.PIZ $restrictionString ORDER BY username, p.id, s.stage");
   $a = $db->query("SELECT *  FROM ".$_SESSION["KReading_tableName"]." ORDER BY username, PIZ, stage");
//   $a = $db->query("SELECT p.ID, * FROM table_patient as p JOIN $GLOBALS[tablename] as s ON p.PIZ=s.PIZ $restrictionString ORDER BY username, s.rowid, s.stage");
  if(!$a) KReading_throw_sql_error($db);
   while($row = $a->fetch_assoc())
   {
      $html .= "<tr>";
      foreach($keys as $tKey )
      {
  	    $tStr = $row[$tKey];
  	   // if($tKey=='PIZ') $tStr = substr(crypt($tStr), 3, 5);
  	    $html .= "<td>" . $tStr . "</td>";
       }
      $html .= "</tr>";
     }


    $html .= "</table>";
    $html .= "</div>";

    $out['success'] = true;
    $out['html'] = $html;

     return $out;


}





if(isset($_GET['KReading_mode']))
{
  KReading_setMode($_GET['KReading_mode']);
  $out = KReading_getReadingDefinition();
}

?>


