

var tour =
{ name : "ROI painting in 3D",
  intro : "Hello, you will learn ROI drawing in 3D, you will create isosurfaces "+
     "and stuff like this, have fun! Don`t break anything this is just a beta version.",
  seq:
  [

   { 
     delay: 100,
     selector : '#patientTableWrap',
     text : "check out the patient table",
     where : "right",
     duration:5000,
  
   },

   
   { event : 'click',
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div.KViewPort_tool.KViewPort_tool_toggle3D',
     text : "press the 3D button"
   },
   { event : 'click',
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div:nth-child(8)',
     text : "and click the pencil", where: 'bottom' 
   },   
   { event : 'click',
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.roiTool_panel > div:nth-child(2) > a:nth-child(2)',
     text : "create a new roi here"
   },   
   {      
     text : "draw ROI by holding shift pressed",
     duration : 5000,
   }   ,
   {      
     text : "use shift/right mouse button to erase",
     duration : 5000,
   }   ,
   { event : 'click',
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div:nth-child(17)',
     text : "create an isosurface of the ROI"
   },   
    
 ]

}





var fibertour =
 { name : "Fiber Viewer 3D",
  intro : "Hello, you will interactively select fibers. You need webGL for doing this, otherwise 3D will not work.",
  seq:
  [
  

   { 
     delay: 100,
     text : "This is the 3D view, use the left/right mouse button to rotate/pan, or use mouse wheel+ctrl  to zoom.",
     duration:6000,
  
   },







   { 
     delay: 3000,
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div:nth-child(18) > div.KViewPort_tool.fibers.current',
     text : "currently the fibers are ready for selection.",
     where : "left",
     duration:3000,
  
   },
 
   {      
     text : "select a fiber subset by clicking somewhere while holding shift.",
     duration : 5000,
   },

   { 
     delay: 3000,     
     text : "you can you use the mouse wheel (while holding shift) to change the size of the selection ball.",
     duration : 5000,
   },


   { 
     delay: 5000,
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div:nth-child(18)',
     text : "this is the fiber bar, use it manipulate or change properties of the fibers",
     where : "bottom",
     duration:4000,
  
   },


   { 
     
     delay: 5000,
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div:nth-child(18) > div:nth-child(4)',
     text : "crop a selection you have made",
     where : "left",
     duration:5000,  
   },

   { 
     event: 'click',
     delay: 3000,
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div:nth-child(18) > div:nth-child(18)',
     text : "change color the color of the selection",
     where : "left",
     duration:4000,
   },


   { 
     event: 'click',
     delay: 4000,
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div:nth-child(18) > div:nth-child(8)',
     text : "show  fibers of the full tractogram",
     where : "left",
     duration:4000,
   },



   { 
     event: 'click',
     delay: 1000,
     selector : '#KViewPort_container_number0 > div.KViewPort_icontainer > div.KViewPort_topRow > div.KViewPort_toolbar > div:nth-child(18) > div:nth-child(7)',
     text : "here you can cut down the fiber view to a specific plane",
     where : "left",
     duration:4000,
   },





 ]
};








function createTourBubble(txt,anno,duration,where,width)
{
	
	var tipSize = 35;

	if (anno == undefined)
	{
		$("<div class='centerdummy'></div>").appendTo(document.body);
		anno = ".centerdummy";
		tipSize = 0;
	}

    where = where || 'left';
    duration = duration || 100000;
    if (!width)
    	width = "30%";

	$(anno).showBalloon({ html: true, contents: txt, classname: 'Ktourtips',

	 tipSize: tipSize,
	 position:where,
	 showDuration:600,
	 hideDuration:600,
	  css: {
		border: 'solid 2px green',
		padding: '10px',
		fontSize: '130%',
		"max-width": width,
		//fontWeight: 'bold',
		lineHeight: '2',
		backgroundColor: 'white',
		color: 'black',
		cursor: "default",
		"pointer-events":"none"
	  }

	 });
	 setTimeout(function() {
	   $(anno).hideBalloon(); 
     if (anno == '.centerdummy')
      	$(anno).remove();
	   },duration); 
    
	return;


}






function startTour(tour)
{

	var $div = $("<div id='KStartTour'>"
        + "<h2>" +  tour.name + "</h2>" +tour.intro + "</div>").appendTo($(document.body));
    var $button = $("<div class='modernbutton'>Start Tour</div>").appendTo($div)
    .click(function() {
    	$div.fadeOut(300);    	
		var $cancelTour = $("<div class='cancelTour'> cancel tour <i class='fa fa-close'> </i> </div>").appendTo($(document.body));
		var stop = function()
		{
			$(".Ktourtips").hide();
			$cancelTour.remove();
			doTour.stopTour();
		}
		$cancelTour.click(stop);
		doTour(tour.seq.slice(0));
    });
}

function doTour(tour)
{
   if (tour.length == 0)
   {	
   	  $(".cancelTour").remove()
   	  return;
   }
   var text = tour[0].text;
   var selector = tour[0].selector;
   var event = tour[0].event;
   var where = tour[0].where;
   var width = tour[0].width;
   var delay = tour[0].delay || 2000;
   var duration =  tour[0].duration || 2000;
   var $highlighter;

   if (event == undefined)
   {
   	  setTimeout(function () {
	       createTourBubble(text,selector,duration,where,width);
	       if (selector != undefined)
	       	  $highlighter = highlight(selector,duration);
	       setTimeout(function() {
		        if (selector != undefined)
	       	       $highlighter.del();
   		   		doTour(tour.splice(1)); },duration);
   	  },delay)

   	  doTour.stopTour = function() {
   	  	  if ($highlighter != undefined)
   	  	  	$highlighter.del();
   	  	  tour = [];
		  $(selector).hideBalloon();		  
      }
   }
   else if (event == 'click')
   {
   	  var response = function () {
   	  	  if ($(selector).length == 0)
   	  	  {
				console.warn("tour selector not found, trying again");
				setTimeout(response,delay);
   			    return;  	  	
   	  	  };


		  createTourBubble(text,selector,duration,where,width);
		  $highlighter = highlight(selector,60000);
		  doTour.stopTour = function() {
			  $(selector).off(event,fun);
			  $(selector).hideBalloon();
			  $highlighter.del();		
			  tour = [];	
		  }
		  var fun = function() {
			  $(selector).off(event,fun);
			  $(selector).hideBalloon();
			  $highlighter.del();
			  doTour(tour.splice(1));	  	  
		  }
		  $(selector).on(event,fun);
   	  }
   	  setTimeout(response,delay);

   }


   function highlight(sel,duration)
   {
		var $div = $(sel);
	
		var rect = $div[0].getBoundingClientRect();
		var docEl = document.documentElement;

		var rectTop = rect.top + window.pageYOffset - docEl.clientTop;
		var rectLeft = rect.left + window.pageXOffset - docEl.clientLeft;

		var $highlight = $("<div id=KHighlighter>  </div>");
		var margin = 1;
		$highlight.css('left',rect.left-margin);
		$highlight.css('top',rect.top-margin);
		$highlight.css('width',rect.width+2*margin);
		$highlight.css('height',rect.height+2*margin);
		$highlight.appendTo($(document.body));
		
		var togglecnt = 0;
		var freq = 300;
		var id = setInterval(function() {
			if (math.floor(togglecnt/10)%2 == 0)
			{
				if (togglecnt%2 == 0)
					$highlight.fadeIn(freq/2);
				else
					$highlight.fadeOut(freq/2);
			}
			else
				$highlight.hide();
			togglecnt++;


		},200);

		$highlight.del = function()
		{
			clearInterval(id);
			$highlight.fadeOut(1000);
			$highlight.remove();
		}
		setTimeout($highlight.del,duration);


		return $highlight;
		
		
   }


}



