
KWMQLPanel.panels = {};
KWMQLPanel.qryscripts = ['native','FreeSurfer'];
KWMQLPanel.scripts = new Array(KWMQLPanel.qryscripts.length)


KWMQLPanel.openPanel = function(fibers,atlas,state)
{
	 var wmql_id = atlas.fileID + "_" + fibers.fileID;
	 if (KWMQLPanel.panels[wmql_id] != undefined)
		KWMQLPanel.panels[wmql_id].toggle();
	 else
		KWMQLPanel.panels[wmql_id] = KWMQLPanel(fibers,atlas,wmql_id,function()
		{

			 if (state != undefined)
			 {
				KWMQLPanel.panels[wmql_id].imported = state.imported;
				KWMQLPanel.panels[wmql_id].parseImport(function(){
					KWMQLPanel.panels[wmql_id].$query_area.val(state.query);
					KWMQLPanel.panels[wmql_id].$query_area.trigger("keyup");
				});

			 }
		});

}


function KWMQLPanel(fibers,atlas,id,panelcallback)
{

    var panel = KPanel($(document.body), "Kpanel_"+id,
   "WMQL: " + fibers.filename.replace(".tck","").replace(".gz","") + "/" +  atlas.filename.replace(".nii","").replace(".gz",""));

	var tracts =  fibers;
    var $fileRow = $("<div class='roiTool_panel_flex_persistent'></div>").appendTo(panel.$container);
    panel.imported = new Array(KWMQLPanel.qryscripts.length).fill(false);
	var scripts = new Array(KWMQLPanel.qryscripts.length)

	panel.atlas = atlas;


    var native_script = "";
	for (var k in atlas.content.labels)
	{
		var name = atlas.content.labels[k].name;
		if (!isNaN(parseInt(name[0])))
			name = '_' + name;
		native_script +=name + "|=" +  atlas.content.labels[k].key + "\n";
	}

    native_script = native_script.replace(/[\-\.\(\)]/g,"_");
	panel.imported[0] = false;

    var $imports = $("<a class='KViewPort_tool'><span> Imports </span></a>").appendTooltip("importscripts").click(
		KContextMenu(function()
		{
  			var $menu = $("<ul class='menu_context'>");

			for (var k = 0;k <KWMQLPanel.qryscripts.length;k++)
			{
				var sel = "";
				if (panel.imported[k])
				  sel = 'check-';
				$menu.append($("<li  onchoice='vis_"+k+"' > "+KWMQLPanel.qryscripts[k]+"  <i  onchoice='vis_"+k+"' class='fa fa-"+sel+"square-o'></i> </li>") );
			}
			return  $menu;   
		}
		,function(str,ev)
		{
			  if (str == '' | str == undefined)
					return;
			  if (str.search("vis") != -1)
			  {
				  str = str.substring(4);
				  var pl = parseInt(str);
				  panel.imported[pl] = !panel.imported[pl];
				  parseImport(function(){});
				  
			  }
		},undefined,true) );

    function parseImport(cb)
    { 
    	 getQryScripts(1);

		 function getQryScripts(pl)
		 {
		 	if (pl >= panel.imported.length)
		 	{
		 		parse();
		 		return;
		 	}
  			if (panel.imported[pl])
 		    {
				 if (KWMQLPanel.scripts[pl] == undefined)
				 {
					getQueryFile("/KView/WMQL/"+KWMQLPanel.qryscripts[pl]+".qry",function(res)
					{
						KWMQLPanel.scripts[pl] = res;
						getQryScripts(pl+1)
					});
				 }
				 else
				   getQryScripts(pl+1)

			  }
			  else
			 	  getQryScripts(pl+1)
		 }

      	 function parse()
    	 {
		   var q = "";
		   if (panel.imported[0])
			  q += native_script + "\n ";
		   for (var k = 1; k < panel.imported.length;k++)
		   {
				if (panel.imported[k] && KWMQLPanel.scripts[k] != undefined)
					q += KWMQLPanel.scripts[k] + "\n ";
		   }				  	
		   worker.postMessage({message:'query',keepSymbols:true,query:q},[]);
		   $query_area.trigger("keyup");
		   cb();
    	}
    }
	panel.parseImport = parseImport;

    
    $fileRow.append($imports).append($("<i class='flexspacer'></i>"));

    var $atlaspanel = $("<a class='KViewPort_tool'><span> Atlas panel </span></a>").appendTooltip("atlaspanel")
    	.click(function() {
    		if (atlas.panel)
    			atlas.panel.toggle();
    		else
    		    atlas.panel = KAtlasPanel(atlas);
    	});
    $fileRow.append($atlaspanel).append($("<i class='flexspacer'></i>"));


    var $query = $("<div></div>").appendTo(panel.$container);
    var $query_area = $("<textarea spellcheck=false ></textarea>").appendTo(panel.$container);
    panel.$query_area = $query_area;
    var $error_area = $("<div></div").appendTo(panel.$container);
	$query_area.css("width","400px")
	$query_area.css("height","200px")
  	panel.$container.width($query_area.width()+10);


	function drawFibers(selection)
	{
		KViewer.iterateMedViewers(function(medV){
			for (var k = 0; k < medV.objects3D.length;k++)
			{
				if (medV.objects3D[k].fibers = fibers)
				{
					medV.objects3D[k].subsetToDisplay = selection;
					medV.objects3D[k].updateFibers();
				}

			}
		});
	}


	var worker ;
	var useWorker = true;


	if (useWorker)
	{
		panel.progressSpinner("building index");
		worker = new Worker('KView/WMQL/KWMQLworker.js');
		worker.postMessage = worker.webkitPostMessage || worker.postMessage;
		worker.addEventListener('message', function(e) {
			e = e.data;
			if (e.msg == 'index_progress')
			{
				panel.progressSpinner(e.detail);
				if (e.detail == undefined) // we are done
				{
					if (panelcallback)
						panelcallback();
				}
			}
			else if (e.msg == 'query_done')
			{
 			     panel.progressSpinner();
				 if (typeof e.selection === "string")
					 $error_area.text(e.selection);
				 else
				 {
				 	 $error_area.text("");
					 //if (atlas.panel)
					 //	atlas.panel.setPersistent(e.involved_Labels)
					 drawFibers(e.selection);
				 }
			}
		}, false);

		worker.kill = function()
		{
			worker.postMessage({message:'kill'},[]);
		}

		var deffield;
		if (KViewer.atlasTool.defField != undefined)
		{
			var t = KViewer.atlasTool.defField.content;
			deffield = {data:t.data,
						invedges: math.inv(t.edges),
						wid:t.wid,
						widhei:t.widhei,
						widheidep:t.widheidep,
						sizes:t.sizes};
		}

		worker.postMessage({message:'createIndex',
		tracts: KObject3DTool.packTractsForTransfer(tracts),
		atlas: {data:atlas.content.data,
				sizes:atlas.content.sizes,
				labels:atlas.content.labels,
				wid:atlas.content.wid,
				widhei:atlas.content.widhei,
				widheidep:atlas.content.widheidep,
				invedges: math.inv(atlas.content.edges)._data ,
				deffield:deffield}  }
				,[]);
//				,[tracts.content.buffer]);
	}
	else
	{
		var wmql_index = createWMQLindex(atlas.content,tracts.content);
		var index = wmql_index.index;
		var fiberQuery = FiberQuery(atlas,tracts,index);
	}

	var parent_close = panel.close
	panel.close = function()
	{
		if (useWorker)
			worker.kill();
		parent_close();
	}

	panel.getState = function()
	{
		return  { atlas_id:panel.atlas.fileID, 
		          tract_id:fibers.fileID  ,  
		          query:$query_area.val(),
		          imported:panel.imported    } 
	}



    var waiting_forupdate = -1;

  	$query_area.on("keyup",function()
  	{
  	   
  	   if (waiting_forupdate != -1)
  	   	   clearInterval(waiting_forupdate);
	   waiting_forupdate = setInterval(update,300);


  	   function update()
  	   {
//		   panel.progressSpinner("thinking");
  	   	   clearInterval(waiting_forupdate);
  	   	   waiting_forupdate=-1;
		   $error_area.text("thinking");	
		  
		   var q =  $query_area.val() + "\n endoffiledummy |=1 \n";
		   setTimeout(function(){
			   if (useWorker)
				  worker.postMessage({message:'query',query:q });
			   else
			   {
				   try
				   {
					  FiberQueryCurrent = fiberQuery;
					  console.log(".-----------------------");
					  var selection =  wmql.parse(q);

				   }
				   catch(err)
				   {
					  $error_area.text(err.message);
					  return
				   }

				   selection = processSelection(selection);
				   if (typeof selection == "string")
				   {
					  $error_area.text(selection);
					  return;
				   }
				   drawFibers(selection);
				   panel.progressSpinner();


			   }
		   },0);
  	   }
  	})


  
	return panel;

}




function getQueryFile(src,done)
{

    var xhr = new XMLHttpRequest();
    xhr.open('GET', myownurl().replace("index.php","") + src , true);
    xhr.onload = function()
    {
       done(this.responseText);        
    } 
    xhr.send();

}

   
