importScripts("WMQLparser.js");
importScripts("KWMQLquery.js");
importScripts("../../KMiscFuns.js");
importScripts("../../kmath.js");
importScripts("../../KTools/KObject3DTool.js");
importScripts("../../KTools/KAtlasTool.js");
importScripts("../../KView/KMedImageViewer.js");




self.addEventListener('message', function(e) {
	
	var execObj = e.data;
	if (e.data.message == 'createIndex')
	{

		var tracts = e.data.tracts;
	    KObject3DTool.unpackTracts(tracts);

	    self.index = createWMQLindex(e.data.atlas,tracts,e.data.atlas.deffield,function(str){
			self.postMessage({msg:'index_progress',detail:str});
	    });
	    self.fiberQuery = FiberQuery(e.data.atlas,tracts,self.index.index);
	    self.postMessage({msg:'index_progress',},[]);

	}

	if (e.data.message == 'query')
	{
	    FiberQueryCurrent = fiberQuery;
	    FiberQueryCurrent.involved_Labels = {};
	    try
	    {
			if (e.data.keepSymbols & e.data.query == "")
			{
				FiberQueryCurrent.symbol_table = {};
				return;
			}


            var selection = wmql.parse(e.data.query);

			if (e.data.keepSymbols)
			{
				FiberQueryCurrent.symbol_table = selection.symbols;
			}

            selection = processSelection(selection);
    		self.postMessage({msg:'query_done',selection:selection.tracts,involved_Labels:selection.labels},[]);
	    }
	    catch (err)
	    {
    		self.postMessage({msg:'query_done',selection:err.message },[]);
	    }
	}

	if (e.data.message == 'kill')
	{
		 self.close();
	}



}, false);

