<?php

/************************************************************
    Backup and restore the NORA database
************************************************************/
require_once(dirname(__FILE__) . '/settings.php');  // __FILE__ necessary for command line calls
require_once(dirname(__FILE__) . '/routes.php');
require_once(dirname(__FILE__) . '/miscfuns.php');


/************************************************************
Get the routes;
************************************************************/
if(isset($GLOBALS['settings']->db_routes))
{
	if(!isset($GLOBALS['hostname']));
		$GLOBALS['hostname'] = gethostname();
	
	$hostname = $GLOBALS['hostname'];  
	if (isset($GLOBALS['settings']->db_routes->$hostname))
		$dbspec = $GLOBALS['settings']->db_routes->$hostname;
	else
		$dbspec = $GLOBALS['settings']->db_routes->{'*'};
	
	$GLOBALS['dburl']  =  $dbspec->DBURL;
	$GLOBALS['dbport'] =  $dbspec->DBPORT;   
}

/************************************************************
Build the command
************************************************************/
if(!isset($GLOBALS['settings']->backup))
{
	die("No valid ->backup settings found in conf file. Aborting.");
}
	
if(!isset($_GET['command']))
	$_GET['command'] = 'backup';


if(isset($argv) && sizeof($argv) > 1)
{
  $GLOBALS['fromcommandline'] = true;
  $_GET = parseInputKeyValue($argv);
}
else
{
	 $GLOBALS['fromcommandline'] = false;
}


if($_GET['command'] == "restore")
{
#	var_dump($_GET);
	restore();
}
else
{
	backup();
}


/************************************************************
myecho
************************************************************/
function myecho($txt)
{
	if($GLOBALS['fromcommandline'])
		$txt = "\n" . $txt;
	else
		$txt = "<br>" . $txt;
		
	echo $txt;
	
	return $txt;
	
}

/************************************************************

************************************************************/
function backup()
{
	$verbose = 1;
	
	$backuppath = resolve_Route($GLOBALS['settings']->backup->sqlpath);
	
	#$cmd_base  = "mysqldump -h " . $GLOBALS['dburl'] . " -P " . $GLOBALS['dbport'] . " -u " . DBADMIN . " -p" . DBADMINPWD;
	$cmd_base  = "export MYSQL_PWD=".DBADMINPWD."; mysqldump -h " . $GLOBALS['dburl'] . " -P " . $GLOBALS['dbport'] . " -u " . DBADMIN;
	$dboptions1 = " --single-transaction=true --hex-blob";
	$dboptions2 = " --routines --triggers --events";

	
	/********************************************************
	export the defaults (schemata + PROTOTYPEPROJECT) 
	*********************************************************/
	if(isset($_GET['export-defaults']) && $_GET['export-defaults']==1 )
	{
		$DEFAULTPROJECTNAME = "DEFAULTPROJECT";
		$targetfolder = dirname(__FILE__)  ."/../docker/";
		//$targetfolder = "/tmp/";
		$cmdA = $cmd_base . $dboptions1 . $dboptions2 . " DPX --no-data " . " > ".$targetfolder."DPX.sql;";
		$cmdB = $cmd_base . $dboptions1 . $dboptions2 . " $DEFAULTPROJECTNAME --no-data  " . " > ".$targetfolder."$DEFAULTPROJECTNAME.sql;";
		
		// command to extract the default project row from the projects table.
		$cmdC = "$cmd_base DPX $dboptions1 --skip-add-drop-table --skip-triggers --no-create-info --tables projects --replace --where=\"name LIKE '$DEFAULTPROJECTNAME'\"";
		$cmdC 	.= " > ".$targetfolder.$DEFAULTPROJECTNAME."_ROW.sql;";
		
		$cmd = "$cmdA\n\n $cmdB\n\n $cmdC";
		$cmd = "$cmdA $cmdB $cmdC";
		$targetfile = $targetfolder."DPX.sql"; // only for checking Succesfully written
	}
	/********************************************************
	backup all tables or a single table
	*********************************************************/
	else
	{
		$acmd = $cmd_base . $dboptions1 . $dboptions2;
		$targetfile = $backuppath  ."/" . date("Ymd_Gis") ."_";
		if(!isset($_GET['database']))
			$_GET['database'] = "_all_";
			
		if($_GET['database'] == "_all_")
		{
            $cmd=$acmd;
			$cmd.= " --all-databases=true ";
			$targetfile .= "DB_ALL.sql.gz";
            
            if(isset($_GET['no-data']) && $_GET['no-data']==1 )
                $cmd.= " --no-data";
            
            $cmd.= "  | gzip >  $targetfile";
		}
		elseif(0==0)
		{
		/*
            // we need to implement ONLY noradatabases, not the system databases (otherwise no compatibility between sql version)
            export MYSQL_PWD=dpxuser
            DBASES=$(mysql -uroot -Bse 'show databases' | grep -v information_schema)
            DBASES=${DBASES//mysql/}
            DBASES=${DBASES//performance_schema/}
            DBASES=${DBASES//sys/}
            mysqldump -h localhost -P 3306 -u root --single-transaction=true --hex-blob --routines --triggers --events --add-drop-database --databases $DBASES  >  /tmp/aaa.sql

            // for sql > 5.7 node sql connector might have a a problem, this solves it
            node problem
            ALTER USER 'root'@'localhost' IDENTIFIED WITH mysql_native_password BY 'password';
            ALTER USER 'root' IDENTIFIED WITH mysql_native_password BY 'password';
            flush privileges;		
		*/
		
		}
		else
		{
			$targetfile .= "DB_".$_GET['database'].".sql";
			
			$cmd = "";

			// the full project database
			$cmd .= $acmd . " --add-drop-table --databases $_GET[database] >  $targetfile;";
			
			// other important data
			$noprimarykey = '| sed -e "s/([0-9]*,/(NULL,/gi"'; 
			$cmd .= "echo \"USE DPX\" >>  $targetfile;";
			$xcmd = " --databases DPX --single-transaction --skip-add-drop-table --skip-triggers --no-create-info --skip-opt --no-create-db ";
			$cmd .= $acmd . $xcmd . " --tables projects --where=\"name LIKE '$_GET[database]'\"  $noprimarykey >>  $targetfile;";
			$cmd .= $acmd . $xcmd . " --tables json --where=\"type like 'userbatch' and project LIKE '$_GET[database]'\" $noprimarykey >>  $targetfile;";
			$cmd .= "gzip $targetfile";
			$targetfile = "$targetfile.gz";
		}
		
	}
		
	$cmdshow = preg_replace("/\s-p[^\s]+\s/", " -p*** ",$cmd);
	$cmdshow = preg_replace("/MYSQL_PWD\=[^\s]+\s/", "MYSQL_PWD=*** ",$cmd);

	//die($cmd ."\n");
	
	if(1)
	{
		myecho("*******************************************************************************");
		myecho( "                           NORA database backup ");
		myecho( "*******************************************************************************");
		myecho( $cmdshow ."" );
	
		if( $GLOBALS['fromcommandline'] ||  isset($_GET['serious']) )
		{
			if(!is_dir($backuppath ))
				mymkdir($backuppath );
			
			myecho( "*******************************************************************************");
			
			$res = Array();
			exec($cmd . " 2>&1 ", $res, $ret);

			if($ret==0 && file_exists($targetfile) )
			{
				if(isset($_GET['export-defaults']) && $_GET['export-defaults']==1 )
					myecho("Succesfully finished exporting default table structure to the docker subdirectory" ."\n");
				else
					myecho("Succesfully finished writing to $targetfile. \nBUT MAKE SURE TO CHECK COMMAND OUTPUT FOR ANY ERRORS!!!  ". "\n");
			}
			else
			{
				myecho("Some error happenend. Check the command output." ."");
			}
		}
		else
		{
				myecho("I AM IN TESTMODE. For serious backup run with --serious." ."");
		}
	}


}



/************************************************************
Restore. WARNING! THIS WILL OVERWRITE current DATABASES!!!!
************************************************************/

function restore()
{
	/*********************************************
	check if mysql data directory is empty??
	**********************************************/
	
	
	/*********************************************
	Present list with available backups
	**********************************************/
	$bckpath = resolve_Route($GLOBALS['settings']->backup->sqlpath);
	$blist  = glob("$bckpath/*.*");
	usort( $blist, function( $a, $b ) { return filemtime($b) - filemtime($a); } );

	if(!isset($_GET['linenumber']))
	{	
		myecho("Scanning backup folder $bckpath ...");
		//var_dump($blist);
		foreach($blist as $k => $a)
		{
			$temp = explode('/',$a);
			$item = "($k) " . (filesize($a)/1024/1024)  . "MB  " . end($temp);
			$item = sprintf("(%2s) %5s MB   %s ", $k, (round((filesize($a)/1024/1024)*100)/100), end($temp));
			$item = sprintf("(%2s) %-50.s %5s MB ", $k, end($temp), (round((filesize($a)/1024/1024)*100)/100) );
			myecho( $item );
		}
		return false;
// 		myecho("Enter a line number:");
// 		myecho("");
// 		$ans = readline ("");
        $rfile = $blist[$ans];
	}
	else
	{	
        if(!is_numeric($_GET['linenumber'])) 
        {
            if(file_exists($_GET['linenumber']))
            {
                $rfile = $_GET['linenumber'];
            }
            else
            {
                echo "ERROR: the given input file '" . $_GET['linenumber'] . "' does not exist, aborting" ; 
                die();
            }
        }
        else
        {
            $ans = intval($_GET['linenumber']);
            $rfile = $blist[$ans];
        }
	}
	

	if(!file_exists($rfile))
	{
		myecho("Error: File not found '" . $rfile . "'");
		return false;
	}
	
	/*********************************************
	Full restore
	**********************************************/
	$cmd = "/dpx/docker/setupmysql restore $rfile ";
	if(gethostname() !== "noradocker")
	{
		$cmd = dirname(__FILE__) . "/../dpxcontrol docker bash '" . $cmd . '"'; 
	}
	else
	{
	
	}
	//myecho($cmd);
// 	myecho("******************************************************");
// 	myecho(" 			        	WARNING ");
// 	myecho("******************************************************");
// 	myecho("you are about to restore the mysql database from a backup.");
// 	myecho("THIS WILL CAN COMPLETELY DELETE your current database data.");
// 	myecho("Maybe you want to make another backup first.");
// 	myecho("Do you want to continue? (Y/N)");
// 	$ans = readline("");
// 	if($ans != "Y")
// 	{
// 		myecho("You chose 'No', Aborting.");
// 		return false;
// 	}

	system($cmd);
	
	// zcat foo.sql.gz | mysql -uroot -ppassword foo
	

}




	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
function parseInputKeyValue($argv)
{
    $json = array();
    for($k=1; $k<sizeof($argv)-1; $k+=2)
    {
      $json[substr( $argv[$k], 2, strlen($argv[$k]) )] =   $argv[$k+1];
    }
    return $json;

}
	
	

?>
