<?php
//ini_set(error_reporting(1));



// ======================================================================================
// Script can be called as ajax or from command line.
// Command line inputs are
//    -plainids <targetpacs>, id as in conf

// ======================================================================================



if(isset($argv) && sizeof($argv) > 1)
{
  $_GET = parseInputKeyValue($argv);
  $GLOBALS['fromcommandline'] = true;

}
else
{
  if(sizeof($_POST)>0) {$_GET = array_merge($_GET,$_POST);}
  $GLOBALS['fromcommandline'] = false;
}


// require_once(dirname(__FILE__) . '/settings.php');  // __FILE__ necessary for command line calls
// require_once(dirname(__FILE__) . '/routes.php');







/******************************************************
run
*****************************************************/
try
{
	$rp = new CryptClass(null);
	$rp->main($_GET);
	exit(0);
}
catch (Exception $e) 
{
	exit(1);
}






/******************************************************
	The cryp class
*****************************************************/
class CryptClass
{
	private $ivlen;
	private $iv;
	private $cipher; 
	private $key; 
	
	
	


	function __construct($args) 
	{
		$this->cipher = "AES-128-CBC";
		$this->ivlen  = openssl_cipher_iv_length($this->cipher);
		// must use a constant IV vector, otherwise the ids will always change
		$iv = 'TUExRWtLRTRJTVFaeWFEd1pKOERrQT09';
		$this->iv     = substr($iv, $this->ivlen);
		
		$this->sep = ',';
		
		$this->key = $_GET['key'];
		
		$this->alphanchars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$this->alphancharslength= strlen($this->alphanchars);

	}

	/******************************************************
	do encryption
	******************************************************/
	public function main($args)
	{

		if(strlen($this->key) == 0 )
			throw new Exception('Key must not be empty');
			
		if(!isset( $_GET['direction'] ))
			$_GET['direction'] = 'encrypt';

		$out = $this->dothecrypt_simple($_GET['ids'], $_GET['direction'] );
		
		$out = implode($this->sep , $out);
		
		echo ($out);
		
		return $out;
	
	}

	
	/******************************************************

	******************************************************/
	function map($str)
	{
		$out = array();
		for($k=0; $k<strlen($str); $k++)
		{
			$pos = strpos($this->alphanchars, substr($str, $k,1));
			if($pos !== false)
				$out[$k] = $pos;
			else	
				$out[$k] = -1;
		}
		return $out;
	}
	
	/******************************************************
	simple encryption
	******************************************************/
	function mycrypt($str, $key, $s)
	{
		$strm = $this->map($str);
		$keym = $this->map($key);
		$res = "";
		for($k=0; $k<sizeof($strm); $k++)
		{
			if($strm[$k] >= 0)
				$res .= $this->alphanchars[($this->alphancharslength*1000+$strm[$k]+ $s*$keym[$k%sizeof($keym)]*($k+1)) % $this->alphancharslength];
			else	
				$res .= $str[$k];
		}
		return $res;
	}
	

	
	
	/******************************************************
	simple encryption loop
	******************************************************/
	public function dothecrypt_simple($idlist, $direction)
	{
		$out = [];
		$idlist = explode($this->sep , $idlist);

		if($direction == 'encrypt')
		{
			foreach($idlist as $id)
				$out[] = $this->mycrypt($id, $this->key,1 );
		}
		if($direction == 'decrypt')
		{
			foreach($idlist as $id)
				$out[] = $this->mycrypt($id, $this->key,-1 );
		}

		return $out;	
	}
	
	
	
	/******************************************************
	openssl encryption
	******************************************************/
	public function dothecrypt_openssl($idlist, $direction)
	{
		$out = [];
		$idlist = explode($this->sep , $idlist);

		if($direction == 'encrypt')
		{
			foreach($idlist as $id)
				$out[] = base64_encode( openssl_encrypt($id, $this->cipher, $this->key, $options=0, $this->iv) );
		}
		if($direction == 'decrypt')
		{
			foreach($idlist as $id)
				$out[] = base64_decode(openssl_decrypt($id, $this->cipher, $this->key, $options=0, $this->iv) );
		}

		return $out;	
	}



}		






function parseInputKeyValue($argv)
{
    $json = array();
    for($k=1; $k<sizeof($argv)-1; $k+=2)
    {
		if(substr($argv[$k+1],0,1) == '-')
			throw new Exception('Error parsing input: ' . implode($argv, ' '  ) );
			
      $json[substr( $argv[$k], 1, strlen($argv[$k]) )] =   $argv[$k+1];
    }
     //$inputsummary = "=========== END OF INPUT   ===================\n";
     //$inputsummary .= print_r($json);
     //echo $inputsummary;
     return $json;

}
