<?php 
// this script is for service commands. 
// can be accessed via url (curl) or as php script from command line



// ********** DEMONSTATUS **************
// demonstatus: check if demon is running, email will be sent if not


// parse command line arguments into the get 
parse_str(implode('&', array_slice($argv, 1)), $_GET);





   require_once(dirname(__FILE__) . '/settings.php');
   require_once(dirname(__FILE__) . '/DPXMailer.php');
   $set = &$GLOBALS['settings']->mail;
   $set->simulate = false;
   

   
   // ================== testmail ==================
   if( isset($_GET['testmail'] ) )
   {
      $msg = "testmail content";
      $subject = "testmail";
      //$json_out['msg'] = DPXMailer_send($set->testuser_email, $subject, $msg);
      $json_out['msg'] = DPXMailer_sendmailToAdmins($subject, $msg);
      $json_out['success'] = 1;
   }
   
   // ================== demonwatch start / stop cronjob ==================
   elseif( isset($_GET['start']) )
   {
      if( file_put_contents("/etc/cron.hourly/" . DPXALIAS , "php  " . __FILE__ .  " status\n" ) ) 
	$json_out['msg'] = "cronjob started";
   }
   
  elseif( isset($_GET['stop']) )
   {
      if(unlink("/etc/cron.hourly/" . DPXALIAS)) // unlik deletes a file
	$json_out['msg'] = "cronjob stopped";
   }
   
   // ================== demonwatch status ==================
   elseif( isset($_GET['status']) )
   {
      // check the demon status and send alert to admins

      require_once('DPXMailer.php');
      $logfile = DPXROOT . '/var/syslogs/demon.active';
      if( !file_exists($logfile) )
      {
          $json_out['success'] = 1;
          $json_out['msg'] = "no demon.active file found in `$logfile` ";
      }
      else
      {
            $fileTime  = filemtime($logfile); // seconds
            $tdiff = time()  - $fileTime;
            $dtime = 10; // 10 minutes
            if($tdiff > 60 * $dtime)
            {
              // only sent alert message once. Remeber if sent with "alertWasSent"
              // DPX_demon() restart will reset this.
              $content = json_decode(file_get_contents($logfile), false);
              if($content == null ||  (isset($content->alertWasSent ) & $content->alertWasSent != 1)  )
              {
                    $json_out['success'] = 0;
                    $json_out['msg'] = "Demon is down";
                    //$json_out['DPXMailer_msg'] = DPXMailer_sendmailToAdmins('DPX_demon_error', "Sorry, the DPX demon seems to be down. Downtime more than $dtime minutes.");
					
					$msg = "Sorry, the DPX demon seems to be down. Downtime more than $dtime minutes.";
					$msg .= "My info is:  " . DPXALIAS . " from " . $set->instanceurl . "   " ;
                    $json_out['DPXMailer_msg'] = DPXMailer_send($set->serviceadmins, 'DPX_demon_error', $msg);
                    $content->alertWasSent = 1;
                    file_put_contents($logfile, json_encode($content));
                    
                    touch($logfile, $fileTime);// reset filetime to old one
              }
              else
              {
                    $json_out['success'] = 0;
                    $json_out['msg'] = "Demon is down. Service alert was already sent.";
              }

            }
            else
            {
              $json_out['success'] = 1;
              $json_out['msg'] = "demon ok";
            }
      }
    }
    
    else
    {
	  $json_out['success'] = 0;
	  $json_out['msg'] = "No command selected. Possible values are \n testmail\n start \n stop \n status\n";
    }
  



if(sizeof($argv)>0) // started from command line
{
  echo $json_out['msg'] ."\n";
}
else
{
  echo '<pre>' . var_export($json_out, true) . '</pre>';
}


?>