<?php

/*
params: 	 
	folder
	aetitle
	command: filterIncomingDicoms <default>
			 sortbystudy

*/


require_once(dirname(__FILE__) . '/../settings.php');
require_once(dirname(__FILE__) . '/../routes.php');


if(sizeof($argv) > 1)
{
	error_reporting(111);
	
    $params = parseInputKeyValue($argv);
    if(isset($params['logtofile']))
    {
      ob_start();
    }
    if(isset($params['command'])  &&  $params['command']== "sortbystudy")
    {
		sortbystudy($params['folder'], $params['move']);
    }
    elseif(isset($params['command'])  &&  $params['command']== "createdpxfile")
    {
		$info = filterIncomingDicoms($params);
    }
    else
    {
    	die("no command recognized. Possible commands are \n -command sortbystudy -move false\n -command createdpxfile\n\n");
    }


}
// call from webinterface
elseif(isset($_GET['command'])) 
{


}
else 
{
    	die("no command recognized. Possible commands are \n -command sortbystudy -move false\n -command createdpxfile\n\n -timeout xxx");
}

if(isset($params['logtofile']))
{
  $htmlStr = ob_get_contents();
  ob_end_clean(); 
  $logpath = resolve_Route( VARPATH . "/syslogs/storescp.log" );
  file_put_contents($logpath, $htmlStr, FILE_APPEND);
}




function filterIncomingDicoms($params)
{

    $folder = $params['folder'];

    // save (echo) the $folder also as encoded route for reimport dicoms
    $folder_enc = encode_Route($folder);
    echo "\n=======================================================================================================\n";
    echo date("Y D M j G:i:s") . " Filtering after STORESCP:  $folder_enc " ;
    echo "\n=======================================================================================================";

    
    if(!is_dir($folder))
    {

      echo ("Error: folder '$folder'' does not exist!\n");
      return false;
    }

    // ************************** workaround for splitted folders due to slow connections (dicom email ...) **********************
    // search for other folders of this same patient, created at a later time. If existing, copy dicoms into this folder and exit.

    // NOTE: Strangely, this also happens sometimes with fast connections, seperate folders with a few files are created
    // therfore, we need some sleep here to allow a newer dir to be created
    if( isset( $params['timeout'] ) )
		$ttimeout = $params['timeout'];
	else
		$ttimeout = 5;

	sleep( $ttimeout );

    if(1)
    {
		$pinfo = pathinfo(realpath($folder. '/'));
		$current = $pinfo['filename'];
		$matches = array(); preg_match_all (  "/(?<name>\w+)_(?<date>\d+)_(?<time>\d+)/" , $current, $matches, PREG_SET_ORDER ); 
		if(empty($matches))
		{
		  echo("Error: The folder $folder does not match the storescp pattern!\n");
		  return false;

		}
		$name = $matches[0]['name']; $date = $matches[0]['date']; $time = $matches[0]['time'];

		
		$dcms = glob($folder . "/*.dcm" );
		if(empty($dcms))
		{
		  echo("Error: The folder $folder does not contain dicom files\n");
			return false;
		}
	    $hdr = dicominfo( $dcms[0] );
		$hdr  = array_values($hdr)[0];
		//var_dump($hdr['StudyInstanceUID']);
		$studies = sortbystudy($pinfo['dirname'] . "/$name*" , false);
		$s =  $studies[ $hdr['StudyInstanceUID'] ] ;
		
		$folderlist = array_values($s);
		// more than one folder with SUID
		if(sizeof($folderlist) > 1)
		{
			$newest = end($folderlist);
			$newest  = $newest ['folderpath'];
			if( strpos($newest, $folder) === false )
			{
				if(!is_writable($folder))
				{
					echo("Error: folder $folder does not exist / not writable !\n");
					return false;
				}

				$cmd = "mv $folder/*dcm $newest";
				echo "... This study seems NOT to be finished (Ongoing data transfer of this study). Moving files to the newer folder:\n " . $cmd . "\n";

				system($cmd);

				rmdir($folder);
				
				return false;
				//die("\n");
			}
		}

	}
    // *************************************************************************************************************************
    

    // this is the default project, if no filter matches
    $info = array();
    //$info['targetProject'] = 'SANDBOX';
    
    //$info['user'] = DPXUSER; 
    // due to MATLAB license issues, we should run this as root. Or at least map to "runas" of DPXUSER
//    $info['user'] = "root";
    $info['user'] = IMPORTUSER;
    $info['folder']  =  $folder;
   
    

    
    //////////////////////////////////////// Scan the dicom directory ///////////////////////
    $files = scandir($folder);
    $file = false;
    
    foreach($files as $k => $f)
    {
      if(strpos($f, '.dcm') !== false)
	   $file = $files[$k];
    }
    if(!$file)
    {
	echo "No DICOM files in folder '$folder' \n";
        return false;
    }
    $hdr = dicominfo($folder . "/" . $file, true);
    
	// hdr is now a struct
    $hdr = array_values($hdr);
    $hdr = $hdr[0];
    
    //////////////////////////////////////// Scan the dicom directory ///////////////////////
    if(isset($params['aetitle']))
      $hdr['AETitle'] = $params['aetitle']; // capital AET for backward compatibility
    else
      $hdr['AETitle'] = "NO_AETITLE_SET";

    if(isset($params['aetitle']))
      $hdr['aetitle'] = $params['aetitle'];
    else
      $hdr['aetitle'] = "NO_AETITLE_SET";

      if(isset($params['port']))
      $hdr['port'] = $params['port'];
    else
      $hdr['port'] = "no_port_set";

      
    if(0)
    {
      echo("===== header info === \n");
      print_r( $hdr );
    }


	// ************ find the pacs associated with this dicoms
	//echo "========================================================================\n";
	if( isset($GLOBALS['settings']->projectfilter) )
	{
		$projectfilter = $GLOBALS['settings']->projectfilter;
		foreach($projectfilter as $p)
		{
			if(isset($p->DCMPHPFilterString))
			{
				echo "...testing for projectfilter '$p->targetProject' : " .$p->DCMPHPFilterString ;
				try
				{
					if( eval("return $p->DCMPHPFilterString  ;" ) )
					{
						$info['targetProject'] = $p->targetProject;
						echo " ... matching, importing to '$p->targetProject'!  \n";
						break;
					}
					else
					{
						echo " ... not matching. \n";
					  
					}
				}
				catch (ParseError $e) 
				{
					echo " ... Error catched!   " . $e->getMessage() . "\n";
				}
					
			}
		}
	}
    

    // ************ further filtering by study / sequence names  ....
    // to be configured and integrated

    write_dpx_file($info, $params);


    return $info;

}


function write_dpx_file($i, $params)
{

	
	$info = Array();
	
	//$info['datapath'] 	= $i['folder'];
	
	// do NOT resove the route
	$info['datapath'] = $dpxfilefolder = encode_route( $i['folder']  );

	
	$info['user'] 		= $i['user'];
	$info['project']  	= $i['targetProject'];
	
	if(isset($params['deleteafterimport']) && $params['deleteafterimport'] == 1)
		$info['deleteafterimport']  = 1;
	

	$dpxfilefolder = resolve_Route( VARPATH . "/import" );
	
	$pathinfo = pathinfo( $info['datapath'] );
	$foldername    = $pathinfo['filename'];
	$tfile = "$dpxfilefolder/$foldername.dpx";
	
	//echo "... writing dpx file with following info: " . str_replace('%2F', '/', http_build_query($info,'',', ')) . "\n";
	$loginfo = "";
	foreach($info  as $key=>$val)
	{
		$loginfo .= "$key=$val, ";
	}
	echo "-> writing dpx file with following info: " . $loginfo . "\n";
	//var_dump($info);
	
	file_put_contents($tfile, json_encode($info) );

}

 


// ======================================================================================
// ============= sortbystudy
// ======================================================================================
function sortbystudy($folder, $dothemove = false)
{

    if($folder=="/" || $folder=="//" || $folder=="" )
		die("Error: folder $folder cannot be the root folder!\n");
    

	// make relative path absolute	
    if( substr($folder,0,1 ) != "/" )
		$folder = getcwd() . "/"  . $folder;
	
	// check asterix
	if( strpos( $folder, '*') > 0)
		$dirs = glob($folder  , GLOB_ONLYDIR);
	else
		$dirs = glob($folder . '/*' , GLOB_ONLYDIR);
	
    if( sizeof($dirs) == 0 )
		die("Error: folder is empty.\n");

	$studies = Array();
	
	//$dirs = array_slice($dirs, 0,1500);
	//die( "nfolders " . sizeof($dirs). "\n\n" );
	
	// get the newest file per directory
	$firstfiles = Array();
	foreach($dirs as $d)
	{
		$files = glob("$d/*.dcm");
		$files = array_combine($files, array_map("filemtime", $files));
		arsort($files);
		$files = array_keys($files);
		if( sizeof($files) > 0) 
		{
			//echo $files[0] . "\n";
			$firstfiles[] = $files[0];
		}
	}

	$finfos = dicominfo( $firstfiles );
	//var_dump($finfos);
	foreach($finfos as $fpath => $info)
	{
		$subfolder = ( explode("/", $fpath) );		$subfolder = $subfolder[sizeof($subfolder)-2];
		$pi = pathinfo($fpath);
		$fullder = $pi['dirname'];
		$suid = $info['StudyInstanceUID'];

		$entry = Array('filetime'=> filemtime($fpath), 'folderpath'=>$fullder);
		if(!isset($studies[$suid]))
			$studies[$suid] = Array($subfolder =>  $entry);
		else	
			$studies[$suid][$subfolder] = $entry;

		//echo $info['InstitutionName'] . "\n";
	}

	//  check whether any study is distributed over several folders
	foreach($studies as $k => $s )
	{
		$nfolders = sizeof(array_keys($s));
		//echo "\nStudyInstanceUID $k is contained in $nfolders folders: " . implode(" ", array_keys($s));
		echo "\nINFO: StudyInstanceUID $k is contained in $nfolders folders. ";
		if( $nfolders > 1)
		{
			$folderlist = array_values($s);
			$newest = end($folderlist); 
			for($j = 0; $j<sizeof($folderlist)-1; $j++ )
			{
				$src = $folderlist[$j]['folderpath'];
 				$cmd = "mv $src/*.dcm $newest[folderpath]/ ;";

//				$cmd = "find $src/ -type f -name '*.dcm'  -exec mv -t $newest[folderpath]/ {} + ;";
 				$cmd .= "rmdir '$src';";

	 			if($dothemove)
	 			{
	 				echo "\nSERIOUS moving $cmd";
					//exec($cmd . " 2>&1 ", $res, $ret);  
					system($cmd);  
	 			}
	 			else
	 			{
	 				//echo "\nTEST mode, would be moving:   " . $cmd ;
	 			}
			}
			

		}

	}
	
	echo "\n";

	//var_dump($studies);
	return $studies;

}



// ======================================================================================
// ============= dicominfo
// ======================================================================================

function dicominfo($files, $alltags=false)
{

	$tags = array();
	$tags["0008,003e"] = 'SeriesDescription'; 
	$tags["0008,0018"] = 'SOPInstanceUID'; 
	$tags["0008,0080"] = 'InstitutionName'; 
	$tags["0008,0081"] = 'InstitutionAddress'; 

	$tags["0010,0020"] = 'PatientID'; 
	$tags["0010,0021"] = 'IssuerOfPatientID'; 
	$tags["0018,1000"] = 'DeviceSerialNumber'; 

	$tags["0020,000d"] = 'StudyInstanceUID'; 
	$tags["0020,000e"] = 'SeriesInstanceUID'; 
	$tags["0020,0011"] = 'SeriesNumber'; 


	$t = implode(' +P ', array_keys($tags));
	$tagskeys = (array_keys($tags));
	$stopafterelem = " --stop-after-elem " . end($tagskeys) ;
	$stopafterelem = "";

	if(!is_array($files))
		$files = Array($files);
	

	// if too many files, must chunk them ....
	// only the first file of a study is read, so assum
	$res = array();

	$chunksize = 200;
	$current = 0;
	$nsteps = ceil(sizeof($files)/$chunksize);
	if($nsteps > 1)
	{
		for($k=0; $k<$nsteps; $k++)
		{
			$tfiles = array_slice($files, $current, $chunksize);
			dcmdump($t, $tfiles, $res, $alltags);
			$current += $chunksize;
		}
	}
	else
	{
		dcmdump($t, $files, $res, $alltags);
	}




	
	// template header;
	$hdrt = array();
	$matches = array();
	foreach($tags as $k => $v)
	{
		$hdrt[$v] = 'TAG_NOT_SET';
	}

	$sep = "# dcmdump";
	$count = 0;
	$out = Array();
	$currentfile = "xxx";
	foreach($res as $row)
	{
		if(strpos($row, $sep) === 0  )
		{
			//   	 	$fname = Array();
			//   	 	preg_match( "/:\s(?<filename>[\/\w]+)/", substr($row, 3), $fname );
			//  	 	echo $fname[0] ."\n";
			$fname = substr($row, strpos($row, ":")+2);
			if($fname != $files[$count]) // just to be sure everything was all right with the files
			{
				echo "\nFile mismatch $fname vs ". $files[$count];
			}
			else
			{
				$count++;
				$currentfile = $fname;
				$out[$currentfile] = $hdrt;
				$out[$currentfile]['filename'] = $fname;
			}
		}
		else
		{
			//preg_match_all (  "/\(   (?<tag>\w{4},\w{4})   \)\s\w\w\s\[   (?<value>[^]]+)   \]\s#.*/x" , $row, $matches, PREG_SET_ORDER ); // x means igonore empty spaces
			preg_match_all (  "/\(   (?<tag>\w{4},\w{4})   \)\s\w\w\s\[   (?<value>[^]]+)\]\s+\#\s+\d+,\s\d\s(?<tagdesc>\w+)/x" , $row, $matches, PREG_SET_ORDER ); // x means igonore empty spaces
			//print_r($matches[0]);
			if(sizeof($matches)>0)
			{
				$out[$currentfile][$matches[0]['tagdesc']] = $matches[0]['value'];
				//$out[$currentfile][$tags[$matches[0]['tag']]] = $matches[0]['value'];
			
			}
		}
	}
	return ($out);
}



function dcmdump($t, $files, &$out, $alltags=false)
{
	if($alltags)
		$cmd = "dcmdump   " . implode(" ",  $files);
	else
		$cmd = "dcmdump  --print-file-search +P $t " . implode(" ",  $files);
	
	$res = array();
	exec($cmd . " 2>&1 ", $res, $ret);  
	if($ret !== 0)
	{
		echo var_dump($res);
		echo "dcmdump returned an error. Too many files? Chunk them smaller ";
	}
	else
	{
		$out = array_merge($out, $res);
	}
}





function addLogEntry($str, $res, $ret)
{
    echo $str;
    var_dump($res);
}


function parseInputKeyValue($argv)
{
    $json = array();
    for($k=1; $k<sizeof($argv)-1; $k+=2)
    {
      $json[substr( $argv[$k], 1, strlen($argv[$k]) )] =   $argv[$k+1];
    }
     return $json;
}



?>
