		var CSS_COLOR_NAMES = ["red","green","blue","magenta","cyan","yellow"];

	var buflen = 256;

	var cosine = [];
	var sine = [];
	var wlen = [6,9,16];
	var rho = 0.8;
	var rho2 = 0.5;

	var all_pow = new Array(buflen).fill(0);


	for (var j = 0; j < wlen.length;j++)
	{
		
			var c = [];
			var s = [];
			for (var k = 0; k < buflen; k++)
			{
				c[k] = Math.cos(k/wlen[j]*2*Math.PI);
				s[k] = Math.sin(k/wlen[j]*2*Math.PI);
			}
			cosine.push(c);
			sine.push(s);
		
	}


	function quadfilt(rho,rho2)
	{
		var tot_pow = new Array(buflen).fill(0);
		var efilt_cos = [];
		var efilt_sin = [];
		var efilt_pow = [];
		for (var j = 0; j < wlen.length;j++)
		{
			efilt_cos.push(new Array(buflen).fill(0));
			efilt_sin.push(new Array(buflen).fill(0));
			efilt_pow.push(new Array(buflen).fill(0));
		}

		var wlennum = wlen.length;
		function accum(x,t)
		{
			tot_pow[t] = tot_pow[(t-1+buflen)%buflen]*rho2;
			for (var j = 0; j < wlen.length;j++)
			{

				efilt_cos[j][t] = efilt_cos[j][(t-1+buflen)%buflen]*rho + x*cosine[j][t]*(1-rho);
				efilt_sin[j][t] = efilt_sin[j][(t-1+buflen)%buflen]*rho + x*sine[j][t]*(1-rho);


				var p = (efilt_sin[j][t]*efilt_sin[j][t]+efilt_cos[j][t]*efilt_cos[j][t]);
				efilt_pow[j][t] = efilt_pow[j][(t-1+buflen)%buflen]*rho2 + p*(1-rho2);
				tot_pow[t] += p*(1-rho2)/wlennum;
			}
			all_pow[t] += tot_pow[t];
		}

		

		return {
			accum:accum,
			response:efilt_pow,
			total:tot_pow
		};
	}



	var buffer_alpha = new Array(buflen).fill(0);
	var buffer_beta = new Array(buflen).fill(0);;
	var buffer_gamma = new Array(buflen).fill(0);
	var current_beta = 0;
	var current_gamma = 0;
	var current_alpha = 0;
	var current_t = 0;
	var absolute_t = 0;

	var filt_a = quadfilt(rho,rho2);
	var filt_b = quadfilt(rho,rho2);
	var filt_g = quadfilt(rho,rho2);

	var trick;
	var tricks = [{start:150,end:170,dt:30}]
	var isOnTrick = false;

	
/*
	setInterval(function()
	{
		buffer_beta[current_t%buflen] = current_beta;
		buffer_gamma[current_t%buflen] = current_gamma;
		current_t++;
	},30);

*/


    var $container = $("#flipMainContainer");

	var $plotContainer = $("<div id='plotcontainer'>").appendTo($container);
	var $svg2 = $("<svg> <polygon points='' style='opacity:0.5;fill:red;stroke:purple;stroke-width:1' /></svg></div>")
			   .appendTo($plotContainer);
	var $svg1 = $("<svg> <polygon points='' style='opacity:0.5;fill:yellow;stroke:purple;stroke-width:1' /></svg></div>")
			   .appendTo($plotContainer);
	var $svg3 = $("<svg> <polygon points='' style='opacity:0.5;fill:lightblue;stroke:purple;stroke-width:1' /></svg></div>")
			   .appendTo($plotContainer);


	setInterval(function()
	{
		plot($svg1,filt_a.response[0],0.5/wlen[0]);
		plot($svg2,filt_b.response[0],0.5/wlen[0]);
		plot($svg3,filt_g.response[0],0.5/wlen[0]);
		//plot($svg1,filt.response[0],0.5/wlen[0]);
		//plot($svg2,filt.response[1],0.5/wlen[1]);
		//plot($svg3,filt.response[2],0.5/wlen[2]);
		//plot($svg3,all_pow,0.02);
		showTricks();

	},450);


	function plot($svg,buffer,scfac)
	{

		var plotheight = $plotContainer.height();
        var plotwidth = $plotContainer.width();

		$svg.width(plotwidth);
		$svg.height(plotheight);

		var pstr = "";
		var $poly = $svg.children();
		var themax = 0;
		for (var i=0;i<buflen;i++)
			if (buffer[i] != undefined)
			if (Math.abs(buffer[i]) > themax)
				themax = Math.abs(buffer[i]);
		//scfac = 0.5/(0.0000000001+themax);
		for (var i=0;i<buflen;i++)
		{
			var k = (current_t+i)%buflen;
			pstr = pstr + (plotwidth*i/buflen) + "," + (plotheight-plotheight*scfac*buffer[k]) + " ";
		}
		pstr = pstr + plotwidth + "," + plotheight + " 0," + plotheight;
		$poly.attr("points",pstr);	
	}




	/*********** 3D *****************/


    var $canvas = $("<canvas class='canvas3D'></canvas>").appendTo($container);
    var engine = new BABYLON.Engine($canvas[0], true,{preserveDrawingBuffer: true}  );
    var scene = new BABYLON.Scene(engine);

 
    var camera = new BABYLON.ArcRotateCamera("ArcRotateCamera", 0, 0, 0, new BABYLON.Vector3(0,0,0), scene);
    camera.setPosition(new BABYLON.Vector3(0, 0, -20));
    camera.upVector = new BABYLON.Vector3(1,0,0)
//    camera.attachControl($canvas[0], true);

    var light = new BABYLON.HemisphericLight("light1", new BABYLON.Vector3(0, 1, 0), scene);
    light.intensity = 0.7;

  
    var mymobile = BABYLON.Mesh.CreateBox("mymobile", 2, scene);
    mymobile.scaling = new BABYLON.Vector3(2,1.5,0.3);
	

    scene.render();


    engine.runRenderLoop(function () {
	//		scene.render();
	  });

    //get orientation info
    if (window.DeviceOrientationEvent) 
    {
        window.addEventListener("deviceorientation", function (event) 
        {
            processGyro(event.alpha, event.beta, event.gamma);  
            scene.render();
        }, true);
    } 



    function formatNum(x)
    {
        if (x != undefined)            
            return x.toFixed(0);
        return "nan";
    }

    var trick_runnum = 0;
	function showTricks()
	{

		var plotheight = $plotContainer.height();
        var plotwidth = $plotContainer.width();
		var tmp = [];
		$plotContainer.find(".tinterval").remove();
		for (var k = 0; k < tricks.length;k++)
		{
			var trick = tricks[k];
			if (trick.start > absolute_t-buflen)
			{
				var $rect = $("<div class='tinterval' style='background:"+trick.color+" ;width:" + trick.dt/buflen*plotwidth +
												";height:"+plotheight*0.5+ 
												";top:"+plotheight*1+";left:"+ 
												plotwidth*(1-(((absolute_t-trick.start))%buflen)/buflen) + "'  >  ");
				$rect.appendTo($plotContainer);	
															
				tmp.push(trick);
			}
		}
		tricks = tmp;

	}



    if (window.DeviceMotionEvent)
    {
        window.addEventListener("devicemotion", function (eventData) 
        {

              var info, xyz = "[X, Y, Z]";

                         // Grab the acceleration from the results
              var acceleration = eventData.acceleration;
              info = xyz.replace("X", formatNum(acceleration.x));
              info = info.replace("Y", formatNum(acceleration.y));
              info = info.replace("Z", formatNum(acceleration.z));
              document.getElementById("moAccel").innerHTML = info;

              // Grab the acceleration including gravity from the results
              acceleration = eventData.accelerationIncludingGravity;
              info = xyz.replace("X", formatNum(acceleration.x));
              info = info.replace("Y", formatNum(acceleration.y));
              info = info.replace("Z", formatNum(acceleration.z));

              // Grab the rotation rate from the results
              var rotation = eventData.rotationRate;
              info = xyz.replace("X", formatNum(rotation.alpha));
              info = info.replace("Y", formatNum(rotation.beta));
              info = info.replace("Z", formatNum(rotation.gamma));
              document.getElementById("moRotation").innerHTML = info;

	current_beta = rotation.beta;
	current_gamma = rotation.gamma;
	current_alpha = rotation.alpha;
	buffer_beta[current_t] = current_beta;
	buffer_gamma[current_t] = current_gamma;
	buffer_alpha[current_t] = current_alpha;


	all_pow[current_t] = 0;
	filt_a.accum(current_beta,current_t);
	filt_b.accum(current_gamma,current_t);
	filt_g.accum(current_alpha,current_t);

	var thres = 2;
	var pow_thres = 70;

	if (isOnTrick)
	{
		trick.pow += all_pow[current_t]
		if (all_pow[current_t] < thres*0.9)
		{
			trick.end = absolute_t;
			trick.dt = trick.end - trick.start;
			var s = "<br> DT:" + trick.dt + " P:" + formatNum(trick.pow) + " MP:" + formatNum(trick.pow/trick.dt*10);
			if (trick.pow/trick.dt*10 > pow_thres && trick.dt < 250)
			{
				curtrick = s;	
				trick.color = CSS_COLOR_NAMES[Math.floor(Math.random()*CSS_COLOR_NAMES.length)];
				tricks.push(trick);
				trick_runnum++;
			}
			document.getElementById("trick").innerHTML = trick_runnum + "  " + tricks.length + "<br>" + curtrick + s;
				
			isOnTrick = false;
		}	

	}
	else
	{
		if (all_pow[current_t] > thres*1.1)
		{
			trick = {start:absolute_t,pow:0};
			isOnTrick = true;
		} 
	}


    document.getElementById("moAccelGrav").innerHTML = all_pow[current_t];


	current_t = (current_t+1)%buflen;
	absolute_t = absolute_t+1;


              // // Grab the refresh interval from the results
              info = eventData.interval;
            
        }, true);
    }

function processGyro(alpha,beta,gamma)
{
    mymobile.rotation.x = -gamma/90*Math.PI/2;
    mymobile.rotation.y = beta/90*Math.PI/2;
    //        mymobile.rotation.z = -0*event.alpha/90*Math.PI/2;
/*
	current_beta = beta;
	current_gamma = gamma;
	buffer_beta[current_t%buflen] = current_beta;
		buffer_gamma[current_t%buflen] = current_gamma;
		current_t++;


	filt.accum(current_beta,current_t);
*/

    $("#alpha").text(Math.round(alpha)); 
    $("#beta").text(Math.round(beta)); 
    $("#gamma").text(Math.round(gamma)); 

}
