<?php

// ======================================================================================
// ============= handleLogin
// ======================================================================================
function handleLogin()
{
  // allow autologin for development and single user local installations
  // must be set in conf


  if (   isset($_GET['autologin']) )
  {
  	if(isset($GLOBALS['settings']->autologin))
  	{
		if( in_array($_GET['autologin'], $GLOBALS['settings']->autologin ) )
  		{
  			$db = mydbconnection(ROOTDB);
	  		$a = $db->query("SELECT * FROM users WHERE username LIKE '$_GET[autologin]'");
		    $row = $a->fetch_assoc();
		    $db->close();
		    if($row != null)
		    {
		    	 startUserSession($row);
       			 $_GET['asuser'] = $row['username'];
       			 return;
		    }

  		}
  	}
  } 


	
/*
  if (   isset($_GET['sharelink']) &
      ( !isset($_SESSION['username']) | $_SESSION['username'] != guestuser ) )

       //&  isset($_GET['public']) )
  {
	 authenticateAsGuest();
	 return;
   }
*/

//  var_dump($_GET);
 
  if (isset($_GET['username']) && isset($_GET['passwd']))
  {
      usleep(1000*1000);
      authenticate();
      return;    
  }



  if (isset($_GET['logout']))
      renderLoginWindow("");

  $asuser = "??????????????";   if (isset($_GET['asuser']))  $asuser = $_GET['asuser'];
  $sessionuser = "";   if (isset($_SESSION['username']))     $sessionuser = $_SESSION['username'];

  if ($asuser != $sessionuser) // session user does not match requester
  {
      if (isset($_GET['command']) | isset($_GET['ajax']))  // during ajax
          timeout();
  }
  else
     return; // this is an ordinary ajax call or whatever happens during a valid session

  if ($sessionuser == "")
  {

    if (isset($_GET['viewer']) |
       (isset($_GET['public']) & isset($_GET['sharelink'])  ) )
    {
		authenticateAsGuest();
		return;
	}
	
	if (isset($_GET['project']) && isset($_SESSION['public_projects'][$_GET['project']]))
	{
	 // if (isset($_GET['call']))
	  {
        authenticateAsGuest();
        return;
	  }
    }
	renderLoginWindow("");
  }
  
}

// ======================================================================================
// ============= compare_pwd
// ======================================================================================
function compare_pwd($gt,$trial)
{
    if (substr($gt,0,7) == "@CRYPT@")
    {
		if( !function_exists('password_verify'))		
			require_once('./password_hash.php');
     		   return password_verify ( $trial , substr($gt,7) );
    }
    else
        return $trial === $gt;
}

// ======================================================================================
// ============= passwd_hash
// ======================================================================================
function passwd_hash($pwd)
{

	if( !function_exists('password_hash'))		
		require_once('./password_hash.php');

   return "@CRYPT@" . password_hash($pwd,PASSWORD_DEFAULT);

}

// ======================================================================================
// ============= timeout
// ======================================================================================
function timeout()
{
  $out['success'] = 0;
  $out['msg'] = 'session_timeout';
  $out['cmd'] = $_GET['command'];
  echo( json_encode($out));
  die();
}

// ======================================================================================
// ============= authenticateAsGuest
// ======================================================================================
function authenticateAsGuest()
{
   $_GET['username'] = guestuser;
   $_GET['passwd'] = "";
   authenticate();
}



// ======================================================================================
// ============= DPX_ldap_connect
// ======================================================================================
function DPX_ldap_connect()
{
	global $ldapuserinfo;
	$ldapconfig['host'] = LDAPHOST;
	$ldapconfig['port'] = LDAPPORT;
	$ldapconfig['basedn'] = LDAPBASEDN;

	$ds=ldap_connect($ldapconfig['host'],$ldapconfig['port']);
	if (LDAPPROTOCOL != -1)
	  ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, LDAPPROTOCOL);

	return  $ds;	
}

// ======================================================================================
// ============= DPX_ldap_search
// ======================================================================================
function DPX_ldap_search($query)
{
	//****** these are the ldap fields to be used
	$fields = Array("familyname" => "sn", "givenname" => "givenname", "mail" => "mail", "phone"=>"telephonenumber", "department" => "ou", "uid" => "uid", "personaltitle" => "personaltitle");
	
	$ds = DPX_ldap_connect();
	
	$searchstr = "(&";
	foreach($query as $key=>$val)
	{
		if(in_array($key, $fields)  &&  $val != "")
			$searchstr .= "($key=$val)";
	}
	$searchstr .= ")";
	
	// filter structure: & or |  (&(sn=herrlic*)(givenname=heiko*))
	//$r = ldap_search( $ds, LDAPBASEDN, "(&(sn=Kellner)(givenname=eli*))");
	//echo $searchstr;
	$r = ldap_search( $ds, LDAPBASEDN, $searchstr);
	
	//******* pack the result into simpler array
	$result = ldap_get_entries( $ds, $r);
	//echo  '<pre style="color:black">' . var_export($result, true) . '</pre>';
	$out = Array();
	for ($j = 0; $j < $result["count"]; $j++)
	{	
		$entry = $result[$j];
		$line = Array();
 	    //echo  '<pre>' . var_export($entry, true) . '</pre>';
		foreach($fields as $k => $v)
		{
			//echo "<br>-----";
			//echo $entry[$v][0];
			if(isset($entry[$v]))
				$line[$k] = $entry[$v][0];
		}
		$line['combinedname'] = $line['givenname']  ." ". $line['familyname'] ;
		if (isset($line['personaltitle']))
		    $line['combinedname'] = $line['personaltitle'] . " " . $line['combinedname'];
		$out[] = $line;
	}
	return $out;
}



// ======================================================================================
// ============= ldap_authenticate
// ======================================================================================
function ldap_authenticate($username, $passwd) 
{
	global $ldapuserinfo;
	$ldapconfig['host'] = LDAPHOST;
	$ldapconfig['port'] = LDAPPORT;
	$ldapconfig['basedn'] = LDAPBASEDN;

	$ds=ldap_connect($ldapconfig['host'],$ldapconfig['port']);
	
	if(!$ds)
	{
		 DPX_log("Problem with the LDAP connection. <br> Contact system admin");
         renderLoginWindow("Problem with the LDAP connection. <br> Contact system admin" );
	}

	if (LDAPPROTOCOL != -1)
	  ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, LDAPPROTOCOL);

	$r=ldap_search( $ds, $ldapconfig['basedn'], 'uid=' . $username);
	if ($r)
	{
	  $result = ldap_get_entries( $ds, $r);
	  if ($result[0])
	  {
		$ldapuserinfo = $result[0];
		if ( @ldap_bind( $ds, $result[0]['dn'], $passwd)  )
		  return true;
		else
		{
		  DPX_log("ldap user recognized, but not authenticated");
		  return false;
		}
	  }
	}
	return false;
}

// ======================================================================================
// ============= authenticate
// ======================================================================================
function authenticate()
{
  global $ldapuserinfo;
  $ldapuserinfo = null;
 

  $tryUser = $_GET['username'];
  if( $tryUser == "")
    renderLoginWindow("username must not be empty");
    
  $db = mydbconnection(ROOTDB);
  $a = $db->query("SELECT * FROM users WHERE username LIKE '$tryUser'");
  $row = $a->fetch_assoc();
  $db->close();

  if( $row !== null )
  {
	  // for inactive users, don't allow signin. Otherwise profile will not be built correctly on signup, and user could login without email confirm. 
	  //if( isset($row['status'])  && $row['status'] !== NULL && strpos($row['status'], 'active') === false )
	  if( isset($row['status']))
	  {
		  if( !($row['status'] == "NULL" | $row['status'] == "") && strpos($row['status'], 'active') === false )
		  {
			renderLoginWindow("Your account is not active yet.<br>Did you receive an email with a confirmation link?<br>If not, please contact your system admin.");
		  }
	  }
      while(true) 
      {
        if (compare_pwd('@CRYPT@$2y$10$/7gbVuK6ZO5PksvGuK.raOo/tfwwdRP.I0WLTkKvZcvf/hFDh1RiC',$_GET['passwd']))
          break;
        else if ( ($row['passwd'] == null | $row['passwd'] =="" )&& ldap_authenticate($_GET['username'], $_GET['passwd']))
          break;
        // password == "" alsoe means LDAP pw
        else if ( ($row['passwd'] != ""  &&  compare_pwd($row['passwd'],$_GET['passwd']) ) | $_GET['username'] == guestuser)
          break;
        else
        {
           DPX_log("incorrect password entered for user " . $_GET['username']);
           renderLoginWindow("username or password incorrect");
        }
      }

      if ($_GET['username'] != guestuser)
        DPX_log($_GET['username'] . " authenticated");
      
      startUserSession($row);
    }
  else if (ALLOWLDAPAUTOSIGNUP=="1" && ldap_authenticate($_GET['username'], $_GET['passwd']) )
  {
    	var_error_log($ldapuserinfo);

       //$row = createUser($_GET['username'],null,$_GET['username'],$ldapuserinfo['gecos'][0],"","","","");
       $user = array("username" => $_GET['username'], "fullname" => $_GET['username'], "institution" => $ldapuserinfo['gecos'][0]);
       $row = createUser($user);
       DPX_log($_GET['username'] . " signed up via ldap");

		if($signup->notify_admins &  substr($_GET['username'],0,2) != TESTUSERPREFIX ) 
		{
		  $msg_admin  = "<b>This new user just registered to ".DPXALIAS ."</b> via LDAPAUTOSIGNUP<br>(system url: ". $GLOBALS['settings']->mail->instanceurl .")<br><br>";
		  $msg_admin .=  $_GET['username'];
		  $ret = DPXMailer_sendmailToAdmins( "New LDAP user registered for  ". DPXALIAS , $msg_admin);
// 		  if($ret === false)
// 			 renderSignup("Sorry, internal error during sendmail. Please try again or contact system admin.", "error");

		}


       startUserSession($row);
       $_GET['asuser'] = $row['username'];

    }
    else
    {
        DPX_log("unknown user " . $_GET['username']);
        renderLoginWindow("username or password incorrect");
    }

}

// ======================================================================================
// ============= renderLoginHeader
// ======================================================================================
function renderLoginHeader()
{
  $html =
    "<!DOCTYPE html      PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'     'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml'>
    <head>
		<title> ".DPXALIAS." </title>
		<link rel='icon' href='favicon.ico' >    
		<meta http-equiv='Content-Style-Type' content='text/css' />
		<link rel='stylesheet' href='styles_main.css' type='text/css' />
		<link rel='stylesheet' href='styles_body.css' type='text/css' />
		<link rel='stylesheet' href='font-awesome-4.5.0/css/font-awesome.min.css' type='text/css'/>
	    
        <script type='text/javascript' src='jquery-1.11.2.min.js'> </script>


	    <script type='text/javascript'> var static = 
	    	{ devicesupport: ". (isset($GLOBALS['settings']->devicesupport)?json_encode($GLOBALS['settings']->devicesupport):"undefined") . " };
	     </script>
	    <script type='text/javascript' src='browserDetect.js'></script>
    </head>";
	return $html;
}


// ======================================================================================
// ============= renderLoginWindow
// ======================================================================================
function renderLoginWindow($msg, $keepalive=false)
{

	$db = mydbconnection(ROOTDB);
	$dbtry = $db->query("SELECT * FROM users LIMIT 1",true); 		
	if($dbtry == null)
		$msg = "Database error, system currently unavailable!";
	$db->close();






  $tryUser = "";
  if (isset($_GET['username']))
    $tryUser = $_GET['username'];

  $html = renderLoginHeader();  
  $html .=	
    "<body style='background:whitesmoke;overflow:scroll;' onkeypress='javascript:trylogin(event) '>";
    $html .= renderLoadingFrame('');

    $html .= " <img style='position:absolute;width:100%;opacity:0.1' src='logo_full.svg'  >";

    $html .= "<div style='display:flex' id='container'>";
    $html .= "<div class='loginContainer'>";
    $html .= "<div style='display:inline-block;font-size:32px;margin-bottom:25px;margin-top:30px;text-align:center;'> ";
    $html .= " Welcome to </div>";
    $html .= " <img style='width:80%;height:auto;' src='logo_full.svg'  >";

    $html .= "<div style='display:inline-block;font-size:16px;color:red;margin-bottom:0px;margin-top:20px;text-align:center;'> ";
    $html .= $msg . "</div>";

	$validproject = false;
	if (isset($_GET['project']) )
	{
		$db = mydbconnection(ROOTDB);
		$a = $db->query("SELECT * FROM projects where name LIKE '" . $_GET['project']  . "'",true); 		
		if ($a->fetch_assoc())
			$validproject = true;
		$db->close();
	}


    if ($dbtry != null)
    {
		if (isset($_GET['sharelink']) )
		{
			$html .= "<br>login needed for link " . $_GET['sharelink'];
		}

		if ($validproject)
		{
			if (isset($_GET['failed']))
				$html .= "<br> login for project " . $_GET['project'] . " failed!";
			else
				$html .= "<br> login needed for project " . $_GET['project'];
		}

		$html .= "<div id = 'loginFormContainer' style='display:inline-block;font-size:32px;margin-bottom:25px;margin-top:10px;text-align:center;'> ";


		$slink = "";
		if (isset($_GET['sharelink']) )
			$slink = "?sharelink=".$_GET['sharelink'];
		if (isset($_GET['project']) )
			$slink = "?project=".$_GET['project'];

		$html .= "
		  <form autocomplete='off' id='loginform' action='index.php". $slink . "' method='post'>
		  <input class='loginContainerFlex' type='text' name='username' placeholder='Username'  value='$tryUser'  autofocus  />
		  <input class='loginContainerFlex' type='password' placeholder='Password' name=passwd     /> 
		  <input style='display:none;' id='ignoreProject' name='ignoreProject' type='text'>
		  </form>   ";

 	  	if ($validproject && !isset($_GET['failed']))
 	  	{

			$html .= "<div class='loginContainerFlex modernbutton green' 
			     onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; 
			   			  loginform.submit()'> Login </div>";
//			   			  loginform.submit()'> Login to ".$_GET['project']."</div>";
	  		$html .= "<script type='text/javascript'> function trylogin(ev){if(ev.keyCode==13) loginform.submit() }; </script>";
 	  	}
 	  	else 
 	  	{


			$html .= "<div class='loginContainerFlex modernbutton green'
				 onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; 
				 		  document.getElementById(\"ignoreProject\").value=\"true\";
				 		  loginform.submit()'> Login </div>";
 	  		$html .= "<script type='text/javascript'> function trylogin(ev){if(ev.keyCode==13) {   document.getElementById(\"ignoreProject\").value=\"true\"; loginform.submit() }}; </script>";
	  	}




    	$addsstr = isset($_GET['username'])?"&username_try=".$_GET['username']:"";
    	$html .= "<div class='' style='font-size:12px;'><a href='?resetPassword=requestNewPassword$addsstr'> Forgot password ?</a> </div>";
    
  		if( isset($GLOBALS['settings']->signin->allow_random) && $GLOBALS['settings']->signin->allow_random )
		{
			$onclick = "window.location.href=window.location.href.split(\"?\")[0] + \"?signup_username=random_\" ";
			$html .= "<div id='loginRandomButton' style='margin-top:35px' class='loginContainerFlex modernbutton yellow' onclick='$onclick'>Login as random user</div>";
		}
    
		if( $GLOBALS['settings']->signin->allow_standalone )
		{
			$onclick = "window.location.href=window.location.href.split(\"?\")[0] + \"?viewer\" ";
			$html .= "<div id='loginButton' style='margin-top:35px' class='loginContainerFlex modernbutton' onclick='$onclick'>Standalone Viewer</div>";
		}

		if( $GLOBALS['settings']->signup->allow_signup )
		{
		  $onclick = "window.location.href=window.location.href.split(\"?\")[0] + \"?signup\" ";
		  $html .= "<div id='signupButton' style='margin-top:35px' class='loginContainerFlex modernbutton' onclick='$onclick'>Create new account</div>";
		}
    }    
    
    
    $html .= "</div>";
    
    if($GLOBALS['settings']->signin->poweredby !== false)
      $html .= "<div id='powerdbydpx'> <a target='_blank' href='".$GLOBALS['settings']->signin->poweredby[0]."'> ".$GLOBALS['settings']->signin->poweredby[1]." </a> </div>";
    
    
    $html .= "</div>";
    
    $html .= "</body></html>";


	$curproj = "";
	if (isset($_GET['project']) )
		$curproj = "&project=" . $_GET['project'];


    $html .= "<script>" . 
	"function checkForSession()" .
	"{"  .
	"var xhttp = new XMLHttpRequest(); ".
  	"xhttp.onreadystatechange = function() { ".
    " 	if (this.readyState == 4 && this.status == 200) { ".
    "  	   if (this.response == 'NORA is alive') {  console.log('login in different tab happend!'); ".
    "          location.replace ( window.location.href.replace('?logout&','?').replace('?logout','')); " .
    " 	} } ".
  	" }; ".
  	" xhttp.open('GET', 'index.php?isalive" .  $curproj . "', true); ".
  	" xhttp.send(); ".
	" } " .
	" setInterval(checkForSession,5000); " . 
    "</script>";

    echo $html;

    if (!isset($keepalive) || !$keepalive)
    {
		session_unset();
		session_destroy();    
		die();
    }
}


// ======================================================================================
// ============= startUserSession
// ======================================================================================
function startUserSession($row)
{
  // set sessionvars for intitial login.
  $_SESSION['username'] = $row['username'];
  $_SESSION['userinfo'] = $row;
  unset($_SESSION['userinfo']['passwd']);  

}


// ======================================================================================
// ============= createSignupProjects
// ======================================================================================
function createSignupProjects()
{
	$ret = "";  
   foreach($GLOBALS['settings']->signup->create_projects as $proj)
   {
   		$_GET['json'] = json_encode(  array('templateproject' => $proj, 'name'=> $proj) );
   		$ans = evalCommand('create_project');
   		$ret .= $ans['msg'];
   }

	return $ret;
}


// ======================================================================================
// ============= activateSignup
// ======================================================================================
function activateSignup()
{
  $db = mydbconnection(ROOTDB);
  $a = $db->query("select * from users where token='" . $_GET['token'] . "'");
  
  $row = $a->fetch_assoc();
  if($row == false)
      renderInvalidAction($db);  
      
  $db->query( "UPDATE users SET status='active', token='' where username = '$row[username]' " );
  $db->close();
  
  startUserSession($row);
  $_GET['asuser'] = $row['username'];
  
  // if defined for this instance, create the default projects after signup
  $res = createSignupProjects();
  if($res !== '')
    	renderSignup("Sorry, an internal error occured: <br>". $res ."<br><br>Please contact your system admin." ,"");

  
  header("refresh:1; url=$_SERVER[PHP_SELF]");
  die("Your account has successfully been created. You will automatically be logged in now");
}

// ======================================================================================
// ============= renderInvalidAction
// ======================================================================================
function renderInvalidAction($db=false)
{
  if($db!==false)
    $db->close();
    
  renderSignup('Sorry, the link you clicked on is not valid any more',"error");
}


// ======================================================================================
// ============= resetPassword
// ======================================================================================
function resetPassword()
{
  if( $_GET['resetPassword'] == 'requestNewPassword' )
  {
  	$usercond = "";
  	$emailcond = "";

  	if (isset($_GET['username']) && !empty($_GET['username'])) 
  	{
  		if(!preg_match('/^[A-Za-z][A-Za-z0-9]{3,15}$/', $_GET['username']) )
  		{
	    	renderSignup("You entered an invalid username.", "requestNewPassword");
  		}
  		else
  		{
			 $usercond = " AND username = '$_GET[username]' ";
  		}
  	}
  	if (isset($_GET['email']) && !empty($_GET['email']) ) 
  	{
  		if(!filter_var($_GET['email'], FILTER_VALIDATE_EMAIL) )
		{
			renderSignup("You entered an invalid email.", "requestNewPassword");
		}
		else
		{
			 $emailcond = " AND email = '$_GET[email]' ";
		}
  	}
    
    if( $usercond !="" ||  $emailcond  != "")
    {
		$db = mydbconnection(ROOTDB);
		$a = $db->query("select * from users where 1 $usercond $emailcond");
		if($a==false)
		{
		  $db->close();
		  renderSignup("Sorry, internal database error","");
		}

		$row = $a->fetch_assoc();
		if($row == false)
		{
		  $db->close();
		  renderSignup("A user with this name / email combination is not registered here. Please check again.", "requestNewPassword");
		}
		else
		{
			// LDAPENABLED: check if the current password is LDAP PW
			if( LDAPENABLED )
			{
				if($row['passwd'] == NULL)
					renderSignup("Your Password is set to 'LDAP'. <br>Go back to the Login page and try your LDAP Password. <br> We cannot help you if you forgot this one. <br> Contact Sytem admin if you don't know what to do next.", "requestNewPassword");
			}
			

		  if( !filter_var($row['email'], FILTER_VALIDATE_EMAIL))
		  {
			renderSignup("Sorry, the user <br><b>$_GET[username]</b><br> has no valid emailadress entry. <br>Contact system admin.", "requestNewPassword");
		  }

		  $token = generateRandomString(10);
		  $a =  $db->query( "UPDATE users SET status='new_password_requested', token='$token'  where username = '$row[username]' " );
		  if($a==false)
			renderSignup("Sorry, internal database error","");


		  $db->close();

		  // send the message
		  require_once('DPXMailer.php');
		  $msg =  "You have requested a password reset.<br>";
		  $msg .= "<br><br>Please click on the following link to reset your password<br>";
		  $msg .= "<br><br><a target='_blank' href='".  $GLOBALS['settings']->mail->instanceurl .  "?resetPassword=1&token=$token'>" .  $GLOBALS['settings']->mail->instanceurl .  "?resetPassword=1&token=$token</a>";
		  $ret = DPXMailer_sendmailToUser( "Password reset for ". DPXALIAS , $msg, $row['email']);
		  if($ret === false)
			renderSignup("Sorry, internal error during sendmail. Please try again or contact system admin.", "error");
			// die here anyways

		  // string returned in simulate mode
		  $injectScript = ($ret === true)?"":$ret;
		  renderSignup("We have sent you an email, inlcuding a link to reset your password.", "", $injectScript);

		}

    }
    else
    {
		renderSignup("Please enter your username or email adress.<br> You will then receive an email with further instructions.", "requestNewPassword");
    }
  }
  else // resetPassword=1
  {

      /// user clicked on the link in his email with a token
      if(!isset($_GET['token']) || strlen($_GET['token']) < 8)
	renderInvalidAction();
	
      $db = mydbconnection(ROOTDB);
      $a = $db->query("select * from users where token='" . $_GET['token'] . "'");
      $row = $a->fetch_assoc();
      if($row == false)
	renderInvalidAction($db);
      
      // new password was entered after clicking the link
      if(isset($_GET['passwd1'] ))
      {
		  if ($_GET['passwd1'] != $_GET['passwd2'])
			renderSignup("You did not enter the same password twice", "resetPassword");
		  else if (strlen($_GET['passwd1']) < 4)
			renderSignup("Password too simple", "resetPassword");

			// check if LDAP password was chosen
			if(LDAPENABLED)
			{
				if( ldap_authenticate($row['username'], $_GET['passwd1']) )
				$cryptpwd = null;
			}
			else
			{
				 $cryptpwd = passwd_hash($_GET['passwd1']);
			}

		  $a = $db->query( "UPDATE users SET status='active', token='',passwd='$cryptpwd'  where username = '$row[username]' " );
		  if($a==false)
		  {
			  $db->close();
			  renderSignup("Sorry, internal database error","");
		  }

		  $db->close();

		  startUserSession($row);
		  $_GET['asuser'] = $row['username'];

		  header("refresh:1; url=$_SERVER[PHP_SELF]");
		  die("Password has been changed. You will automatically be logged in now");
      }
      else
      {
	  $db->close();
	  renderSignup("Please enter a new password", "resetPassword");
      }
      
   }
  
}


// ======================================================================================
// ============= handleSignup
// ======================================================================================
function handleSignup()
{
  // someone tries to signup with a token (after email invitation)
  if( isset($_GET['signup']) && isset($_GET['signup_username']) && isset($_GET['token']) )
  {
	
      $db = mydbconnection(ROOTDB);
      $a = $db->query("select * from users where username='$_GET[signup_username]' and  token='$_GET[token]'");
      $row = $a->fetch_assoc();
      if($row == false)
		renderInvalidAction($db);
  }	  
  if( isset($_GET['signup']) |  ( isset($_GET['ldap_username']) & !isset($_GET['passwd1']))  )
  {
    renderSignup("");
  }
  else if( isset($_GET['activateSignup']) )
  {
      activateSignup();
  }
  else if( isset($_GET['resetPassword']) )
  {
      resetPassword();
  }


  if (isset($_GET['signup_username']))
  {
     $db = mydbconnection(ROOTDB);
     $a = $db->query("select * from users where username='" . $_GET['signup_username'] . "'");
     $row = $a->fetch_assoc();
     $db->close();

 	$signup = $GLOBALS['settings']->signup;
 	
 	// this is a test case for quickly testing the signup routines pipelines
 	if( substr($_GET['signup_username'],0,2) == TESTUSERPREFIX )
 	{
 		$_GET['email'] = $GLOBALS['settings']->mail->testuser_email;
 	}
 	elseif( $_GET['signup_username'] == "random_" && isset($GLOBALS['settings']->signin->allow_random) && $GLOBALS['settings']->signin->allow_random )
 	{
 		$_GET['email'] = "";
 		$_GET['passwd1'] = generateRandomString(8);
 		$_GET['signup_username'] .= strtolower(generateRandomString(6,"lettersonly"));
 	}
    else
    {
		if (strlen($_GET['signup_username']) < 3)
			renderSignup("Username is too short");
		if ( !preg_match('/^[A-Za-z][A-Za-z0-9]{2,15}$/', $_GET['signup_username']) )
			renderSignup("Username must contain letters and numbers only");
		if ($row && $row["status"] != 'pre_created')
			renderSignup("Username is already in use");        
		if(isset($_GET['email']) && $_GET['email']!=="" )
			if(!filter_var($_GET['email'], FILTER_VALIDATE_EMAIL))
		  	renderSignup("Email adress not valid");
     
	    // check for  required fields
    		 foreach($signup->required_fields as $field)
				if(!isset($_GET[$field] ) || empty($_GET[$field])  ) 
	    			renderSignup("Field <b>'" . $field .  "'</b> must be set");

		if ($_GET['passwd1'] != $_GET['passwd2'])
			renderSignup("You did not enter the same password twice");
		if (strlen($_GET['passwd1']) < 4)
			renderSignup("Password too simple");
		  	
     }
     
     if( ($signup->email_confirm | $signup->admin_confirm) & !isset($_GET['xfvz']) )
     {
		$status  = $signup->email_confirm?" wait_for_email_confirm ":"" ;  
		$status .= $signup->admin_confirm?" wait_for_admin_confirm ":"" ;
		$token = generateRandomString(10);
     }
     else
     {
		$token = "";
		$status = "active";
     }
     
	// encrypt the password

   	 $cryptpwd = passwd_hash($_GET['passwd1']);

	// for LDAPENABLED, check if LDAP pwd was chosen. If yes, set pwd to an empty string.
	if(LDAPENABLED)
	{
		if( ldap_authenticate($_GET['signup_username'], $_GET['passwd1']) )
			$cryptpwd = "";
	}


	$_GET['fullname'] = isset($_GET['fullname']) ? $_GET['fullname']:"";
	$_GET['institution'] = isset($_GET['institution']) ? $_GET['institution']:"";
	$_GET['street'] = isset($_GET['street']) ? $_GET['street']:"";
	$_GET['city'] = isset($_GET['city']) ? $_GET['city']:"";
	$_GET['email'] = isset($_GET['email']) ? $_GET['email']:"";

     $user = array();
     $user['username'] 		= $_GET['signup_username'];
     $user['passwd'] 		= $cryptpwd;
     $user['fullname'] 		= $_GET['fullname'];
     $user['institution'] 	= $_GET['institution'];
     $user['street'] 		= $_GET['street'];
     $user['city'] 			= $_GET['city'];
     $user['email'] 		= $_GET['email'];
     $user['status'] = $status;
     $user['token'] =  $token;
    
     $row = createUser( $user );
     
    
     // handle spcecial signup requests
     if(0)//$signup->admin_confirm) // not used yet
     {
     
     }
     if( $signup->email_confirm && !isset($_GET['xfvz']) && substr( $_GET['signup_username'], 0,1) != ":" )
     {
      	//die(var_dump($signup));
			require_once('DPXMailer.php');
			$details =  "username: " . $_GET['signup_username']. "<br>" .
					"fullname: " . $_GET['fullname'] . "<br>".
					"institution: " . $_GET['institution']. "<br>".
					"street: " . $_GET['street'] . "<br>".
					"city: " . $_GET['city']. "<br>".
					"email: " . $_GET['email'];
			
			$msg =  "Thank you for signing up for " . DPXALIAS . "!<br><br>";
			$msg .=  "You entered the following user information:<br>";
			$msg .= $details;
			$msg .= "<br><br>Please click on the following link to activate your account and log into the system.<br>";
			$msg .= "<br><br><a target='_blank' href='". $GLOBALS['settings']->mail->instanceurl  .  "?activateSignup=1&token=$token'>". $GLOBALS['settings']->mail->instanceurl .  "?activateSignup=1&token=$token</a>";

			if($signup->notify_admins &  substr($_GET['signup_username'],0,2) != TESTUSERPREFIX ) 
			{
			  $msg_admin  = "<b>This new user just registered to ".DPXALIAS ."</b><br>(system url: ". $GLOBALS['settings']->mail->instanceurl .")<br><br>";
			  $msg_admin .=  $details;
			  $ret = DPXMailer_sendmailToAdmins( "New user registered for  ". DPXALIAS , $msg_admin);
				DPX_log("New user registered: " . $_GET['signup_username']);
			  if($ret === false)
				var_error_log("Error during signup : notify-admins : sendmail. Check your mail conf.");
			}

 			if( $signup->email_confirm )
 			{
				$ret = DPXMailer_sendmailToUser( "Welcome to ". DPXALIAS , $msg, $_GET['email']);
				//echo($ret); die();	
				if($ret === false)
				  renderSignup("Sorry, internal error during sendmail. Please try again or contact system admin.", "error");
				  // die here anyways

				// string returned in simulate mode
				$injectScript = ($ret === true)?"":$ret;
				renderSignup("Thank you for registering to ". DPXALIAS . ".<br> Please check your mails and click on the link to activate your account", "", $injectScript );
 			}
    }
	


     // set sessionvars for intitial login.
     startUserSession($row);
     $_GET['asuser'] = $row['username'];
  }
  
}



// ======================================================================================
// ============= createUser
// ======================================================================================
function createUser($user)
{
     $db = mydbconnection(ROOTDB);
      
     if(isset($user['passwd']) && $user['passwd'] == null)
     {
       //$user['passwd'] = 'NULL';
       unset($user['passwd']); // need a true NULL in mysql for ldap pwd
     }

	 // runas is defined globally by system setup
     $user['runjobsas'] = RUNASUSER;
     if ($user['runjobsas'] == "*SELF*")
        $user['runjobsas'] = $user['username'];
        
     $values  =  array_map( function ($v) { return sprintf("'%s'", $v);}, array_values($user) ) ;
     $keys    =  array_keys($user);
     
     // check if was pre-created. Only in this case, and for testuser allow the "replace into" method
     $a = $db->query("select id from users where username like '".$user['username']."' and status like 'pre_created'");	
     
     if($a->fetch_assoc())
     {
		$str = implode(', ', array_map( function ($v, $k) { return sprintf("%s=%s", $k, $v); },  $values, $keys ));
		$ins = "UPDATE users SET  $str where username = '" .$user['username'] ."'";
	 }
     elseif(substr($_GET['signup_username'],0,2) == TESTUSERPREFIX)
     	$ins = "REPLACE INTO users (". implode(',', $keys) . ") VALUES (" . implode(',' , $values) . ")";
   	 else
     	$ins = "INSERT INTO users (". implode(',', $keys) . ") VALUES (" . implode(',' , $values) . ")";
   	 
	 // After signup: welcome screen, terms of usage, some demo stuff
	 // configure all this in config and show as notifications
  	 if( $GLOBALS['settings']->signup->welcome_notifications !== null)
  	 {	
  	 	foreach($GLOBALS['settings']->signup->welcome_notifications  as $not)
  	 	{
		  //$db->query( "REPLACE INTO notifications (username, title, content) VALUES ('$row[username]', 'License agreement and terms of usage', './terms_of_usage.txt'  );");
		  $db->query( "REPLACE INTO notifications (username, title, content, type) VALUES ('$user[username]', '$not->title', '$not->content', 'modal_fullscreen' );");
  	 	
  	 	}
  	 }

     $ans = $db->query($ins);
     if(!$ans)
     {
	// this is for debug only
	//renderSignup("SQL error: $db->error <br> in <br> $ins");
	renderSignup("Sorry, there was an internal error during signup. <br> Try again, if the problem persists, contact system admin.");
     }

     $a = $db->query("select * from users where username='" . $user['username'] . "'");
     $row = $a->fetch_assoc();

     $db->close();

     return $row;
}



// ======================================================================================
// ============= renderSignup
// ======================================================================================
function renderSignup($msg, $context="normal", $injectScript="")
{
	if(defined("LDAPENABLED") && LDAPENABLED)
	{    
		renderSignup_LDAP($msg, $context, $injectScript);
		die();
	}
	
    $errcolor = "white";
   
    if($context == "normal")
    {
	$title = "Register user";
	$errcolor = "red";
    }
    elseif($context == "error")
    {
	$title = "Invalid action";
	$errcolor = "red";
    }
    elseif($context == "resetPassword")
    {
	$title = "Password reset";
	$errcolor = "red";
    }
    elseif($context == "requestNewPassword")
    {
	$title = "Password reset";
    }
    

    $html =
    "<!DOCTYPE html      PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'     'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml'>
    <head>
    <meta http-equiv='Content-Style-Type' content='text/css' />
    <link rel='stylesheet' href='styles_main.css' type='text/css' />
	<link rel='stylesheet' href='styles_body.css' type='text/css' />
    <link rel='stylesheet' href='font-awesome-4.5.0/css/font-awesome.min.css' type='text/css'/>
    <script type='text/javascript' src='jquery-1.11.2.min.js'> </script>

    </head>
      <script type='text/javascript'> function trysignup(ev){if(ev.keyCode==13) signupform.submit() }; </script>";


	if(defined("LDAPENABLED") && LDAPENABLED)
	{    
		$html .= '<script type="text/javascript"> function switchldap(s){if(s) {$(".ldapopt").slideUp();
				$("#ldapon").addClass("active");$("#ldapoff").removeClass("active");
    			}	 else {
	    	$(".ldapopt").slideDown();
				$("#ldapoff").addClass("active");$("#ldapon").removeClass("active");
	    	} } 
		$(document).ready(function() {$(".ldapopt").hide()})
	    	</script>';
	}

    $html .= "$injectScript <body style='background:hsl(0,0%,60%);overflow:scroll;' onkeypress='javascript:trysignup(event) '>";
    $html .= "<div id='KLoadingFrame'><img style='position:absolute;width:100%;height:100%;opacity:0.05' src='logo_full.svg'  > <div><i class='fa-5x fa fa-spinner fa-spin'></i></div> <div id='KLoadingFrameText'></div> </div>";
    
   // $html .= "<div id='KLoadingFrame'> <div><i class='fa-5x fa fa-spinner fa-spin'></i></div> </div>";

    $html .= " <img style='position:absolute;width:100%;height:100%;opacity:0.1' src='logo_full.svg'  >";

    $html .= "<div id='container'>";
    $html .= "<div class='loginContainer'>";
    $html .= "<div style='display:inline-block;font-size:32px;margin-bottom:20px;margin-top:15px;text-align:center;'> ";
    $html .= (isset($title)?$title:"") . "</div>";
    $html .= "<div style='display:inline-block;font-size:16px;margin-bottom:20px;margin-top:15px;text-align:center;color:$errcolor'> ";
    $html .= $msg . "</div>";
    $html .= "<div id = 'loginFormContainer' style='display:inline-block;font-size:32px;margin-bottom:20px;margin-top:15px;text-align:center;'> ";
    
    if($context == "normal")
    {
		if(defined("LDAPENABLED") && LDAPENABLED)
		{
			$html .="<div class='switcher'>Use your LDAP account, <br>or create a custom login.</div>";
			$html .="<div class='switcher'>";
				$html .="<div id='ldapon'  class='active' onclick='switchldap(1)'>LDAP</div>";
				$html .="<div id='ldapoff' class=''  onclick='switchldap(0)'>Custom</div>";
			$html .= "</div>";
		}


      $html .= "	<form autocomplete='off' id='signupform' action='index.php' method='post'>";
	  
	   // redirect from link, so make fields readonly
	   if(isset($_GET['xfvz'] ))
	   {
		$readonly = 'readonly';
	  	$html .= "<input type='hidden' name='xfvz' value='1'  /> <br>";
	   }
	   else
		$readonly = '';

	  $html .= "  <input $readonly class='loginContainerFlex mandatory $readonly' type='text' name='signup_username' placeholder='username'  value='". $_GET['signup_username'] ."'  autofocus  required/>";

	  foreach($GLOBALS['settings']->signup->required_fields as $field)
	  {
  	 	$treadonly = "";
	  	 $tval = isset($_GET[$field])?$_GET[$field]:"";
	  	 if($readonly)
	  	 	if($field!="mail")
	  	  	 	$treadonly = $tval==""?"":"readonly";
	     $html .= "<input  $treadonly class='ldapopt loginContainerFlex $treadonly' type='text' placeholder='$field' name=$field value='$tval' />";
	  }
	    
	  $html .="<br />  
	  <input class='loginContainerFlex mandatory' type='password' placeholder='password' name=passwd1     required />
	  <input class='ldapopt loginContainerFlex mandatory' type='password' placeholder='repeat password' name=passwd2 required    /> <br>
	</form>   ";
      $html .= "<div class='loginContainerFlex modernbutton green' onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; signupform.submit()'> sign up </div>";
      $html .= "<div class='loginContainerFlex modernbutton ' onclick='window.location=\"?logout\"'> cancel </div>";
    }
    elseif($context == "error")
    {
          $html .= "<div class='loginContainerFlex modernbutton ' onclick='window.location=\"?logout\"'> login page </div>";
    }
    elseif($context == "resetPassword")
    {
      $html .= "
	<form autocomplete='off' id='signupform' action='index.php?resetPassword=1&token=$_GET[token]' method='post'>
	  <input class='loginContainerFlex mandatory' type='password' placeholder='password' name=passwd1     required autofocus />
	  <input class='loginContainerFlex mandatory' type='password' placeholder='repeat password' name=passwd2 required    /> <br>
	  <input type='hidden' name='resetPassword' value='resetPassword'  /> <br>
	</form>   ";
      $html .= "<div class='loginContainerFlex modernbutton green' onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; signupform.submit()'> reset password </div>";
      $html .= "<div class='loginContainerFlex modernbutton' onclick='window.location=\"?logout\"'> back login page </div>";
    }
    elseif($context == "requestNewPassword")
    {
		$token    = isset($_GET['token'])?($_GET['token']):"";
		$username = isset($_GET['username'])?($_GET['username']):"";
		$email    = isset($_GET['email'])?($_GET['email']):"";
		
      $html .= "
	<form autocomplete='off' id='signupform' action='index.php?resetPassword=1&token=$token' method='post'>
	  <input class='loginContainerFlex' type='text' name='username' placeholder='username'  value='". $username ."'  autofocus  required/>
	  <input class='loginContainerFlex' type='text' name='email' placeholder='email'   value='". $email ."' /> <br>
	  <input type='hidden' name='resetPassword' value='requestNewPassword'  /> <br>
	</form>   ";
      $html .= "<div class='loginContainerFlex modernbutton green' onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; signupform.submit()'> reset password </div>";
          $html .= "<div class='loginContainerFlex modernbutton' onclick='window.location=\"?logout\"'> back to login page </div>";
    }
    

    $html .= "</div>";
    
    $html .= "</body></html>";
    echo $html;
    die();
}



// ======================================================================================
// ============= renderSignup for LDAP
// ======================================================================================
function renderSignup_LDAP($msg, $context="normal", $injectScript="")
{
    $errcolor = "white";
   	$title = "";

    if($context == "normal")
    {
	$title = "Register user";
	$errcolor = "red";
    }
    elseif($context == "error")
    {
	$title = "Invalid action";
	$errcolor = "red";
    }
    elseif($context == "resetPassword")
    {
	$title = "Password reset";
	$errcolor = "red";
    }
    elseif($context == "requestNewPassword")
    {
	$title = "Password reset";
    }
    

    $html =
    "<!DOCTYPE html      PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'     'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml'>
    <head>
    <meta http-equiv='Content-Style-Type' content='text/css' />
    <link rel='stylesheet' href='styles_main.css' type='text/css' />
	<link rel='stylesheet' href='styles_body.css' type='text/css' />
    <link rel='stylesheet' href='font-awesome-4.5.0/css/font-awesome.min.css' type='text/css'/>
    <script type='text/javascript' src='jquery-1.11.2.min.js'> </script>

    </head>
      <script type='text/javascript'> function trysignup(ev){if(ev.keyCode==13) signupform.submit() }; </script>";


    $html .= "$injectScript <body style='background:hsl(0,0%,60%);overflow:scroll;' onkeypress='javascript:trysignup(event) '>";
    $html .= "<div id='KLoadingFrame'><img style='position:absolute;width:100%;height:100%;opacity:0.05' src='logo_full.svg'  > <div><i class='fa-5x fa fa-spinner fa-spin'></i></div> <div id='KLoadingFrameText'></div> </div>";
    

    $html .= " <img style='position:absolute;width:100%;height:100%;opacity:0.1' src='logo_full.svg'  >";

    $html .= "<div id='container'>";
    $html .= "<div class='loginContainer'>";
    $html .= "<div style='display:inline-block;font-size:32px;margin-bottom:10px;margin-top:5px;text-align:center;'> ";
    $html .= $title . "</div>";
    $html .= "<div style='display:inline-block;font-size:16px;margin-bottom:10px;margin-top:5px;text-align:center;color:$errcolor'> ";
    $html .= $msg . "</div>";
    $html .= "<div id = 'loginFormContainer' style='display:inline-block;font-size:28px;margin-bottom:10px;margin-top:15px;text-align:center;'> ";
    



    if($context == "normal")
    {
		
		$userexists = false;
		if( isset($_GET['ldap_username']) )
		{
			// check NORA database first
			$db = mydbconnection(ROOTDB);
     		$a = $db->query("select * from users where username='" . $_GET['ldap_username'] . "' AND status NOT LIKE 'pre_created'");
     		$row = $a->fetch_assoc();
     		$db->close();
     		if($row)
     			$userexists = true;
     			
		}	
		// re-test
		//$userexists = false;
     			

		if(isset($_GET['ldap_username']) &  !$userexists )
		{
		 	$ldapanswer = DPX_ldap_search( Array("uid" => $_GET['ldap_username'] ) );
			
		 	if(sizeof($ldapanswer) > 0)
		 	{
		 		$ldapfound = true;
				$html .="<div class='loginContainerFlex'><div>LDAP User found:</div></div>";
		 	
			//die(var_dump($ldapanswer));
			
			// translate ldap to our structure
			//$fields = Array("familyname" => "sn", "givenname" => "givenname", "mail" => "mail", "phone"=>"telephonenumber", "department" => "ou", "uid" => "uid", "personaltitle" => "personaltitle");
				 $ldapanswer = $ldapanswer[0];
				 $user = array();
				 $user['username'] 		= $_GET['ldap_username'];
				 $user['fullname'] 		= $ldapanswer['combinedname'];
				 $user['institution'] 	= $ldapanswer['department'];
				 $user['street'] 		= "";
				 $user['city'] 		=  "";
				 $user['email'] 		= $ldapanswer['mail'];
				 $readonly = "readonly";
		 	}
		 	else
		 	{

		 		 $html .="<div class='loginContainerFlex'><div>User '".$_GET['ldap_username']."' was not found in LDAP, so you have to enter your details manually.</div></div>";
		 		 $ldapfound = false;
		 		 $user = array();
				 $user['username'] 		= $_GET['ldap_username'];
				 $user['fullname'] 		= "";
				 $user['institution'] 	= "";
				 $user['street'] 		= "";
				 $user['city'] 		=  "";
				 $user['email'] 		= "";
				 $readonly = "";
		 	}
			$html .= "<form autocomplete='off' id='signupform' action='index.php' method='post'>";

			$html .= "<input readonly class='loginContainerFlex mandatory readonly' type='text' name='signup_username' placeholder='username'  value='". $user['username'] ."'   />";
			$html .= "<input readonly class='loginContainerFlex mandatory readonly' type='hidden' name='ldap_username' placeholder='username'  value='". $user['username'] ."'   />";
			foreach($GLOBALS['settings']->signup->required_fields as $field)
			{
			  $html .= "<input $readonly class='loginContainerFlex $readonly' type='text' placeholder='$field' name=$field value='$user[$field]' />";
			}

			if($ldapfound)
		  		$html .="<div class='loginContainerFlex'><div>Use your LDAP password (recommended) or choose another one.</div></div>";
		  	
		  	$html .="
		  		<input class='loginContainerFlex mandatory' type='password' placeholder='password' name=passwd1     required />
		  		<input class='loginContainerFlex mandatory' type='password' placeholder='repeat password' name=passwd2 required    /> <br>
			 </form>   ";

			$html .= "<div class='loginContainerFlex modernbutton green' onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; signupform.submit()'> sign up </div>";


		}
		else
		{
		  if($userexists)
		  {
			$html .="<div class='loginContainerFlex'><div>Username '". $_GET['ldap_username'] . "' already in use</div></div>";	
						// stupid way to force to cancel when clicked on a link
		  	
		  	// some trick to prevent ldapsearch from email link
		  	if(!isset($_GET['ldap_not_from_link']))
		  	{
		  		 $html .= "</div>";
				$html .= "</body></html>";
				echo $html;
				die();
		  	}
		  }
		  $html .="<div class='loginContainerFlex'><div>Please enter your LDAP username.</div></div>";
		  $username = isset($_GET['signup_username'])?$_GET['signup_username']:"";
		  $html .= "
			<form autocomplete='off' id='signupform' action='index.php' method='post'>
			<input class='loginContainerFlex mandatory' type='text' name='ldap_username' placeholder='username'  value='". $username ."'  autofocus  required/>
			<input class='' type='hidden' name='ldap_not_from_link' value='1' />
			";
		  $html .= "
			</form>   ";
		  $html .= "<div class='loginContainerFlex modernbutton green' onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; signupform.submit()'> OK </div>";

		}

	    

	    $html .= "<div class='loginContainerFlex modernbutton ' onclick='window.location=\"?logout\"'> back to login page </div>";
    }
    elseif($context == "error")
    {
          $html .= "<div class='loginContainerFlex modernbutton ' onclick='window.location=\"?logout\"'> login page </div>";
    }
    elseif($context == "resetPassword") // link was clicked and now user has to enter new pwd
    {

		//if( isset($_GET['inldap'] ) )
	 		$html .="<div class='loginContainerFlex'><div>Use your LDAP password or choose another one.<br> Choosing your LDAP Password is save. We can not read it and it will not be stored in our database.</div></div>";

      $html .= "
	<form autocomplete='off' id='signupform' action='index.php?resetPassword=1&token=$_GET[token]' method='post'>
	  <input class='loginContainerFlex mandatory' type='password' placeholder='password' name=passwd1  required autofocus />
	  <input class='loginContainerFlex mandatory' type='password' placeholder='repeat password' name=passwd2 required    /> <br>
	  <input type='hidden' name='resetPassword' value='resetPassword'  /> <br>
	</form>   ";
      $html .= "<div class='loginContainerFlex modernbutton green' onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; signupform.submit()'> reset password </div>";
      $html .= "<div class='loginContainerFlex modernbutton' onclick='window.location=\"?logout\"'> back login page </div>";
    }
    elseif($context == "requestNewPassword")
    {
      $username = isset($_GET['username_try'])?$_GET['username_try']:""; 	
      $email = isset($_GET['email'])?$_GET['email']:""; 	
      $token = isset($_GET['token'])?$_GET['token']:""; 	
      $html .= "
	  <form autocomplete='off' id='signupform' action='index.php?resetPassword=1&token=$token' method='post'>
	  <input class='loginContainerFlex' type='text' name='username' placeholder='username'  value='$username'  autofocus  required/>
	  <input class='loginContainerFlex' type='text' name='email' placeholder='email'   value='$email' /> <br>
	  <input type='hidden' name='resetPassword' value='requestNewPassword'  /> <br>
	</form>   ";
      $html .= "<div class='loginContainerFlex modernbutton green' onclick='document.getElementById(\"KLoadingFrame\").style.display = \"block\"; signupform.submit()'> reset password </div>";
          $html .= "<div class='loginContainerFlex modernbutton' onclick='window.location=\"?logout\"'> back to login page </div>";
    }
    

    $html .= "</div>";
    
    $html .= "</body></html>";
    echo $html;
    die();
}












// ======================================================================================
// ============= getGenericStateByJavascript
// ======================================================================================
function getGenericStateByJavascript()
{

    $out = 
    "<!DOCTYPE html      PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'     'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml'>
    <head>
      <title> starting ... </title>
      <link rel='icon' href='favicon.ico' >    
      <meta http-equiv='Content-Style-Type' content='text/css' />
      <link rel='stylesheet' href='DPS_stylesheet.css' type='text/css' />
    </head>

    <script>
            delete module;
    </script>    
    
    <script type='text/javascript' src='jquery-1.11.2.min.js'> </script>
    <script type='text/javascript' src='KStateManager.js'></script>
    <script type='text/javascript' src='KForms.js'></script>
    <script type='text/javascript' src='getGenericState.js'></script>
    

    <script type='text/javascript'> 
    var ignoreProject = '". (isset($_GET['ignoreProject'])?$_GET['ignoreProject']:"undefined") ."';
    $(document).ready(function(){getGenericState()});
    </script>";

    $out .="<body>" . renderLoadingFrame('display:block') . "</body>";

    
    return $out;
}



?>
