<?php

if (!defined("NORA_ESEP"))
  define("NORA_ESEP","NORA_ERROR_SEPARATOR");

class sqlinterface extends mysqli
{
   function query($str,$ignore = false)
   {
         $a = parent::query(($str));
         if ($ignore)
           return $a;
         else
         {
           if ($a == false)
           {
              $err = array("error"=>$this->error , "query"=> $str, "backtrace" =>debug_backtrace() );
              
              // careful, this will shoq db error messages to the user!
              if(1)
              {
                echo json_encode($err) . NORA_ESEP;
                echo( $this->error ) . NORA_ESEP;
              }
              error_log($this->error);

              return $a;
           }
           else
           {
              return $a;   
           }
         }
   }
}


function mydbconnection($database)
{  
  // backward compatibility: Old params win. Can be removed when everything is updated to new specs
  if(defined("DBURL_PHP"))
  {
      $dburl  = DBURL_PHP;
      $dbport =  DBPORT_PHP;  
  }

  // new with routes. These shall win  if existing.
  if(isset($GLOBALS['settings']->db_routes))
  {
      if(!isset($GLOBALS['hostname']));
          $GLOBALS['hostname'] = gethostname();
      
      $hostname = $GLOBALS['hostname'];  
      if (isset($GLOBALS['settings']->db_routes->$hostname))
          $dbspec = $GLOBALS['settings']->db_routes->$hostname;
      else
          $dbspec = $GLOBALS['settings']->db_routes->{'*'};
      
      $dburl  =  $dbspec->DBURL;
      $dbport =  $dbspec->DBPORT;   
  }

  if ($dburl == "localhost")
      $dburl = "127.0.0.1";

  if($dbport!="")
    $db =  new sqlinterface($dburl , DBUSER, DBPWD, INSTANCEPREFIX . $database, intval($dbport)  ) ;
  else
    $db =  new sqlinterface($dburl , DBUSER, DBPWD, INSTANCEPREFIX . $database ) ;
  
  //echo print_r($dbport,1);

  // set charset to utf8 ... must in fact correspond to database collation ...? Works for now.
  $db->set_charset('utf8') ;
  return $db;
}

function myquery($db, $q)
{
  $a = $db->query($q);
  if($a===false)
    return 'SQL error: ' . $db->error;
  else
    return ''; // empty message on success

}


//$testrow = array("id"=>"0", "ldap" => 1);
//$v = MDB_insertOrUpdate('users', array($testrow));


function MDB_getRows($table, $row, $tabletype = 'json',$project)
{
  if(!is_object($row))
    $row = (object)$row;

  if(!isset($row->type) )
    return  false;
  if(!isset($row->project))
      $row->project =  $project;

  $res = array('msg'=> '', 'json'=>null);

    $db = mydbconnection(ROOTDB);
    if($tabletype=='json') // jsontable: fixed structure of rights and search patterns and so on.
    {
        //$q = "SELECT id, json FROM $table WHERE project LIKE '$row->project' AND ( SUBSTRING(rights,0,1) LIKE '%r%' OR owner LIKE '$_SESSION[username]' ) AND type ='$row->type' ";
    
        // note: can match substr if project field, therefore this is a bit more complicated now.
        // these are fields with no match projectFieldInJSONTable IN projectList --> could be those remaining from deleted projects or if 'project' field was entered wrongly ...
        // viewersettings are special because:
        // 1. can change their project ==> the can dissapear if they match no project
        // 2. they can match with INSTR so a very general standard preset can be defined
        // for all other types, this MUST NOT be considered, otherwise wrong state might be taken!
        if( $row->type != 'state' & $row->type !== 'projectstate')// $row->type == 'viewersettings' | $row->type == 'userbatch')
        {
          $nonmatched =  "SELECT id from $table where id not IN ( SELECT t.id FROM $table as t JOIN projects as p WHERE INSTR(p.name, t.project) > 0  AND type ='$row->type' )";
          $nonmatched = "-1";
          //$q = "SELECT id, json FROM $table WHERE (id in ($nonmatched ) OR (INSTR('$row->project', project) > 0)  AND project!='' ) AND ( rights NOT LIKE '-%' OR owner LIKE '$_SESSION[username]' ) AND type ='$row->type' ";
//          $q = "SELECT id, json FROM $table WHERE (id in ($nonmatched ) OR (INSTR('$row->project', project) > 0)  OR project=''  OR project='*' ) AND ( rights NOT LIKE '-%' OR owner LIKE '$_SESSION[username]' ) AND type ='$row->type' ";
          $q = "SELECT id, json FROM $table WHERE ( project like '$row->project' OR project='*' ) AND ( rights NOT LIKE '-%' OR owner LIKE '$_SESSION[username]' ) AND type ='$row->type' ";

        }
        else 
        {
          $q = "SELECT id, json FROM $table WHERE project LIKE '$row->project'  AND ( rights NOT LIKE '-%' OR owner LIKE '$_SESSION[username]' ) AND type ='$row->type' ";
        }
          
        
        // Why INSTR('$row->project', project) > 0, pretty unreliable???
        
        // old
       
       //$q = "SELECT id, json FROM $table WHERE project LIKE '$row->project' AND ( rights LIKE '%r%' OR owner LIKE '$_SESSION[username]' ) AND type ='$row->type' ";
    }
    else
    {
        $q = "SELECT * FROM $table";
    }

    $a =  $db->query($q);
    //$a = false;
    if($a  == false )
    {
      $res['success'] = false;
      $res['msg'] =  $db->error  ;
      $db->close();
    }
    else
    {
      $arrayout = array();
      // fetch all rows. Overwrite row id of json if exists
      while($trow = $a->fetch_assoc())
      {
        if(isset($trow['json']))
        {
         
          $newrow = json_decode($trow['json']);
          if($newrow !== null)
          {
            // append (or overwrite ...) most valid id is always the SQL rowid !!
            $newrow->id = $trow['id'];   

            // also set the ownership and the rights from the dbrow ...??
            // no.
            // $newrow->owner = $trow['owner']

            $arrayout[] = $newrow;
          }
//           if( $row->type =='state')
//            var_dump($newrow);
        }
        else
          $arrayout[] = $trow;
      }
      $res['json'] = $arrayout;
     }


  return $res;
}


function MDB_deleteRow($table, $row)
{
  $res = array('msg'=> '', 'json'=>null);
  $db = mydbconnection(ROOTDB);
  $q = "DELETE FROM $table where id = '" . $row->id .  "'";
  $a = $db->query($q);
  if($a===false) $res['msg'] =  $db->error  ;
  if($a==0) $res['msg'] =  'ID to delete not found'  ;
  $db->close();
  return $res;
}


function MDB_insertOrUpdate($table, $rows, $params=null,$project)
{
  $res = array('msg'=> '', 'json'=>array());
  $db = mydbconnection(ROOTDB);
  $a = mysqli_query($db, "SHOW COLUMNS from $table"); $keys = array(); 
  while($row = $a->fetch_assoc())
  {   
    $keys[] = ($row['Field']);
    //  $keys[] = strtolower($row['Field']);
  }      
       
  // assume $rows is an array of rows to be inserted
  foreach($rows as $e)
  {
      if(!is_object($e)) $e = (object)$e;
      $newid =  MDB_insertOrUpdateRow($table,$e,$keys,$db,$project);
      if(!$newid) { $res['msg'] .=  "\n SQL Error: " . $db->error  ; }
      $res['json'][] = (object) array('id'=>$newid);
  }
  $db->close();

  return $res;
  //$json_out['msg'] = "You are guest, your settings will not be saved for the next session.";
}



function MDB_insertOrUpdateRow($table, $row, $keys, $db,$project)
{
  if(isset($keys['ID'])  )
  {
    $keys['id'] = $keys['ID']; 
    unset($keys['ID']);
  }
    
  foreach($keys as $k)
  {
     if($k==='ID') $k='id'; // IMPORTANT: in mysql, the id is CAN BE capital, in javascript ALWAYS lower. so set to lower.
     if(!isset($row->$k)) // if a field is not set, try to get from possible 'json' field: Attention: capital / small is a problem here!!!!
     {
        if(isset($row->json->$k))
          if( !is_object($row->json->$k) )
            $u[$k] = $row->json->$k; 
     }
     else  // take the given value
     {
        $u[$k] = $row->$k;
     }
     // for jsons, might have to escape ...
     if(isset($u[$k]) && is_string($u[$k]) && substr($u[$k],0,1) == "{")
     {
         $u[$k]  =  $db->real_escape_string($u[$k]);
     }

  }

  if(!isset($u['owner']) & in_array('owner',$keys))
      $u['owner'] =  $_SESSION['username'];
  if(!isset($u['project']) & in_array('project',$keys))
      $u['project'] =  $project;
  if(in_array('json',$keys))
   $u['json']     =  $db->real_escape_string(json_encode($row->json));

    if (isset($u['id']))
      $id = $u['id'];
    else 
      $id = NULL;   


    unset($u['id']); 
    
    $values  =  array_map( function ($v) { return sprintf("'%s'", $v);}, array_values($u) ) ;
    $keys    =  array_keys($u);

     //if the key is not given could be defined otherwise as MDB_uniquekey, try to find it
     //if( ($id===NULL | $id==="0" ) & isset($row->MDB_uniquekey) )
     if( isset($row->MDB_uniquekey) )
     {
       $q = "select id from $table where $row->MDB_uniquekey ";
       //$q = "select id from $table where id = '$id'  ";
       if( ($a = $db->query($q))  ==false)  { echo "database error. ";  return false; }
       if( ($trow = $a->fetch_assoc()) !== NULL)
       {
          $id = $trow['id'];
       }
       else
       {
          $id = "new";
       }
     } 

     // Be more strict with unknown ids: if no id is set, do nothing
     if($id===NULL)
     {
       echo "Error: no id was set / found for " . var_dump($id) ."\n";
       return false;
     }


    if(strpos($id, 'new') !== false | strpos($id, 'temp') !== false | $id==="0") // new item insertion requested. otherwise, update only
    {
      $q = "INSERT INTO $table (". implode(',', $keys) . ") VALUES (" . implode(',' , $values) . ")";
      //var_dump($q); return false;
      if(!$db->query($q))                 {               return false;               }
      return  mysqli_insert_id($db);
    }
    else
    {
        unset($u['id']); 
        $str = implode(', ', array_map( function ($v, $k) { return sprintf("%s=%s", $k, $v); },  $values, $keys ));
        $q = "UPDATE $table SET  $str where id = $id  ";
        if(!($a = $db->query($q)))                 {          return false;              }
        return $id;
    }
}

function MDB_createDBString($row)
{
    $values  =  array_map( function ($v) { return sprintf("'%s'", $v);}, array_values($row) ) ;
    $keys    =  array_keys($row);

    $out = Array();
    $out['keys']   = "(". implode(',',   $keys) . ")";
    $out['values'] = "(". implode(',' , $values) . ")";
    $out['update'] = implode(', ', array_map( function ($v, $k) { return sprintf("%s=VALUES(%s)", $k, $k); },  $values, $keys ));

    return $out;
}



?>
