// Modules to control application life and create native browser window
const {app, BrowserWindow, Menu,ipcMain} = require('electron')

// Keep a global reference of the window object, if you don't, the window will
// be closed automatically when the JavaScript object is garbage collected.
var mainWindow



function createWindow () {
  // Create the browser window.
  mainWindow = new BrowserWindow({width: 800, height: 600,icon: __dirname+'/norasicon.png',
  webPreferences: {nodeIntegration:true,contextIsolation:false,enableRemoteModule:true}})
  try {
	var state = JSON.parse(fs.readFileSync("./noraview.settings.json"))
  }
  catch(err)
  {
  	console.log("no settings found.")
  }

 if (state != undefined && state.viewer.proxy != undefined && state.viewer.proxy.trim() != "")
 {
      console.log("proxy config found")
      mainWindow.webContents.session.setProxy({proxyRules:state.viewer.proxy.trim()},() => {});
	  app.on('login', (event, webContents, request, authInfo, callback) => {
		callback(state.viewer.proxyuser,state.viewer.proxypwd); //supply credentials to server
		console.log("credentials to proxy supplied");
	  });
 }
 
  //if (process.argv[2]=='CVR' && process.argv.length==6)
//	mainWindow.hide();


  // and load the index.html of the app.
  mainWindow.loadFile('nora_electron_index.html')


  // Open the DevTools.
   //mainWindow.webContents.openDevTools()

  global.sharedObject = {args: process.argv, scriptdir:__dirname}


  console.log(".......... Welcome to NORA's viewer ..............")






  // Emitted when the window is closed.
  mainWindow.on('closed', function () {
    // Dereference the window object, usually you would store windows
    // in an array if your app supports multi windows, this is the time
    // when you should delete the corresponding element.
    mainWindow = null
  })
}

// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
app.on('ready', createWindow)

// Quit when all windows are closed.
app.on('window-all-closed', function () {
  // On macOS it is common for applications and their menu bar
  // to stay active until the user quits explicitly with Cmd + Q
  if (process.platform !== 'darwin') {
    app.quit()
  }
})

app.on('activate', function () {
  // On macOS it's common to re-create a window in the app when the
  // dock icon is clicked and there are no other windows open.
  if (mainWindow === null) {
    createWindow()
  }
})

// In this file you can include the rest of your app's specific main process
// code. You can also put them in separate files and require them here.




fs = require("fs");
ipcMain.on('rebuild-menu', buildMenu);
buildMenu();
ipcMain.on('consoleLog', function(event,arg)
{
	console.log(arg);
})

var ants;
ipcMain.on('processANTS', function(event,arg)
{
  
	    console.log("ANTS processing started!!!");
	    console.log(arg);


            var spawn = require( 'child_process' ).spawn;
           
            ants = spawn( arg.scriptpath  , arg.argarray );

            ants.stdout.on( 'data', data => {
			      mainWindow.webContents.send("ANTSstdout",data);
	       		  console.log(data.toString("utf8"));
            } );

            ants.stderr.on( 'data', data => {
	      		mainWindow.webContents.send("ANTSstderr",data);
	       		console.log(data.toString("utf8"));
            } );

            ants.on( 'close', code => {
	      		mainWindow.webContents.send("ANTSdone",code);
	      		if (code != 0 )
	       			console.log("script " + arg.scriptpath + " return error code " + code + "!");
	      		else
	       			console.log("script " + arg.scriptpath + " succcessfully finished!");
            } );
  
})


ipcMain.on('killAll', function(event,arg)
{
	console.log(arg);
  	app.quit();	
	
})



app.on('will-quit', function() {
  if (ants != undefined)
  	ants.kill();

  console.log('about to quit !');
  
});







function buildMenu(event, arg) {


var template = [
    {
      label: 'File',
      submenu: [
        {
          label: 'Load Files',
          click() { mainWindow.webContents.send('loadfiles'); }
        },
        {
          label: 'Load Folders',
          click() { mainWindow.webContents.send('loaddirs'); }
        },
        {
          label: 'Recent',
          submenu: [
            {
              label: 'Load Files',
              click() { mainWindow.webContents.send('loadfiles'); }
            } ]
        },
        {
          label: 'Save workstate',
          accelerator: 'Ctrl+S',
          click() { mainWindow.webContents.send('saveworkstate'); }
        },
        { type: 'separator' },
        {
          label: 'Settings',
          click() { mainWindow.webContents.send('settings'); }
        },
        {
          label: 'Toggle Fullscreen',
          accelerator: 'F11',
          click() {
                    mainWindow.setFullScreen(!mainWindow.isFullScreen());
                  }
        },
        {
          label: 'Toggle Devtools',
          accelerator: 'Ctrl+Shift+J',
          click() {
              mainWindow.webContents.toggleDevTools();
          }
        },
        { type: 'separator' },
        {
          label: 'Restart view',
          accelerator: 'F5',
          click() {
              mainWindow.reload();
          }
        },
        {
          label: 'Quit',
          click() {
              app.quit();
          }
        }
      ]
    }
  ];



	 fs.readFile("./recent.json",undefined, function(err,content)
					 {
						var recentmenu = [];
					 	if (content != undefined)
					 	{
					 		var names= JSON.parse(content);					 			
					 		for (var k = names.length-1;k >= 0;k--)
					 			recentmenu.push({
                                  label : names[k],
                                  click : function(fi) { return function()
                                  {
                                    mainWindow.webContents.send('loadrecent',fi);
                                  }}(names[k])
					 			})
					 	}

					 	template[0].submenu[2].submenu = recentmenu;

                        let resetMenu = Menu.buildFromTemplate(template);
                        Menu.setApplicationMenu(resetMenu);
	});

}
