<?php
//ini_set(error_reporting(0));

if(sizeof($_POST)>0) {$_GET = array_merge($_GET,$_POST);}

// ======================================================================================
// ======================================================================================

require_once(dirname(__FILE__) . '/session.php');

require_once(dirname(__FILE__) . '/inputparser.php');
require_once(dirname(__FILE__) . '/settings.php');  // __FILE__ necessary for command line calls
require_once(dirname(__FILE__) . '/routes.php');
require_once(dirname(__FILE__) . '/miscfuns.php');



session_write_close(); // do not lock other php script from this session




// ======================================================================================
// ============= Main function
// ======================================================================================
//$params = parseinput($argv);

if(isset($_GET['command']) && strpos($_GET['command'] , 'PACSQuery') === 0 ) // = 0 means starts with PACSQ
{
	$json_out = PACSQuery_run($_GET['command']);
	echo json_encode($json_out);
}

function PACSQuery_run($cmd )
{
	$klog = new KQueryLog();
	$res = Array();
	$q = new PACSQuery($klog);
	$json_out = Array();

	try
	{
		$klog->pushmsg(" ================== STARTED    $cmd  ===========================");
		//throw new Exception("asdad");
		if(isset($_GET['json']))
			$params = $_GET['json'];
		else
			$params = $_GET;

		if(!is_array($params))
			$params = json_decode($params, true);

	//error_log(print_r($params,1));


		if(		$cmd=='PACSQuery_findscu')
			$res = $q->query( $params );
		elseif(	$cmd=='PACSQuery_movescu')
			$res = $q->movescu( $params );
		elseif(	$cmd=='PACSQuery_dryimport')
			$res = $q->dryimport( $params );
		elseif(	$cmd=='PACSQuery_dryimport_full_study') // import full study based on StudyInstanceUID
			$res = $q->dryimport_full_study( $params );
		else
		{
			$res['responseRaw'] = "";
			throw new Exception("no command selected");
		}
		//$res['responseRaw'] =  mb_convert_encoding($res['responseRaw'], "HTML-ENTITIES", "UTF-8");     
//		$res['responseRaw'] =  mb_convert_encoding($res['responseRaw'], "UTF-8");     
		
		// this is the right one! Only this does convert öäü correctly
		if( isset($res['responseRaw']) )
			$res['responseRaw'] =  utf8_encode($res['responseRaw']);

		$json_out['json'] = $res;
		$json_out['msg'] = "";

	}
	catch (Exception $e) 
	{
		echo "NORA_PROGRESS_SEPARATOR";
		$klog->pusherr($e);
	}
	$klog->pushmsg(" ================== FINISHED    $cmd  ===========================");
	$json_out['log'] = $klog->getlog();
	return $json_out;
}



class KQueryLog
{
	private $err = Array();
	private $log = Array();
	private $vars = Array();
	
	private function timestamp()
	{
		return "[" . date('Y-m-d G:i:s') . "] ";
	}

	public function pushvar($key, $val)
	{
		/*
		if(!isset($this->$vars[$key]))
			$this->$vars[$key] = Array($x);
		else
			$this->$vars[$key][] = $x;
			*/
	}
	public function pushmsg($x)
	{
		$this->log[] = $this->timestamp() .$x;
	}
	public function pusherr($e)
	{
		$this->log[] = $this->timestamp() . "ERROR: " .  $e->getMessage();
		$this->err[] = $this->timestamp() . $e->getMessage();
	}

	public function getlog()
	{
		return Array("err"=>$this->err, "log"=>$this->log);
	}
	
}



// ======================================================================================
// ======================================================================================
// ============= PACSQuery
// ======================================================================================
// ======================================================================================
class PACSQuery
{
	public $dict ;
	public $seriousmode;

	private $pacsremote ;
	
	function __construct($klog) 
	{
		$dict = Array();
		//$dict['Modality']               = '(0040,0100)[0].Modality';
		$dict['Modality']               = '0008,0060';
		$dict['ModalitiesInStudy']      = '0008,0061';
		$dict['PatientID']              = '0010,0020';
		$dict['PatientName']            = '0010,0010';
		$dict['StudyDate']              = '0008,0020';
		$dict['StudyTime']              = '0008,0030';
		$dict['AccessionNumber']        = '0008,0050';
		$dict['SeriesDescription']      = '0008,103E';
		$dict['SeriesNumber']     		= '0020,0011';
		$dict['StudyInstanceUID']       = '0020,000D';
		$dict['StudyDescription']       = '0008,1030';
		$dict['qrmodel']    			= '0008,0052';
		$dict['PatientBirthDate']  		= '0010,0030';

		$this->dict = $dict;
		$this->klog = $klog;
		$this->seriousmode = 0;
		$this->debugverbose = 1; // output findscu / storescp commands, security risk?
		$this->findSCUPause = .2; // seconds
		$this->moveSCUPause =  2; // seconds

	}
	

	

	// ======================================================================================
	// ============= The main query function
	// ======================================================================================
	public function query($query, $retmode = "raw")
	{

		//var_dump($_SESSION['userinfo']['isadmin']);
	  	if( !($_SESSION['userinfo']['isadmin'] == 1  ||  isset($_SESSION['static']->pacsquery ) ) )
			throw new Exception("It seems that you tried to use the PACS Interface without permission using a hack. This incident will be reported.");


		///////////////// single patient, put in array
		if(isset($query['PatientID']))
			$query = Array($query);
			
		if(sizeof($query) > 100)
			throw new Exception("Too many patients  (". sizeof($query). ") at one time.");
		
		// search for (list of) patients
		// input must be array of [PIZ] or [PIZ, StudyDate]

		if($retmode == 'raw')
		{
			$responseRaw = "";
			foreach($query as $q)
			{
				$rawline =  $this->findscu($q);
				$responseRaw .= $rawline;
			}
			$res =Array('responseRaw' => $responseRaw);
		}
		else
		{
			$patients = Array();
			$responseRaw = "";
			foreach($query as $q)
			{
				$rawline =  $this->findscu($q);
				$obj = dicomparse($rawline);
				$responseRaw .= $rawline;
				$patients[$obj['PatientID']] = $obj;
			}
			$res = Array();
			$res['patients'] = $patients;
			$res['responseRaw'] = $responseRaw;
			$res['seriessummary'] =  $this->seriesSummary($patients);
		}
				
		
		return $res;
	}




	// ======================================================================================
	// ============= The main findscu function. takes single patient row as argument
	// ======================================================================================
	function findscu(&$qobj)
	{
		if($qobj==null || !isset($qobj['tags']))
		{
			throw new Exception("invalid query");
		}
		
		$q = $qobj['tags'];

		if( isset($qobj['seriousmode']) )
			$this->seriousmode = $qobj['seriousmode'];

		if( isset($qobj['unrestrictedmode']) && $qobj['unrestrictedmode']  )
			$unrestrictedmode = true;
        else
			$unrestrictedmode = false;


		//$pacsid = "UKLFR";
		$pacsid = $qobj['pacsid'];
		if( !isset($GLOBALS['settings']->pacsquery) || !isset($GLOBALS['settings']->pacsquery->$pacsid) )
			throw new Exception("PACS `".$pacsid."` is not in my list");
		else
			$pacs = $GLOBALS['settings']->pacsquery->$pacsid;


		/*****************************************************
		         minimum query search requirements. 
		         		Be careful here!! 
        We can put high load on pacs and we cannot kill receiving results!!!
		*****************************************************/
		// patient id or patient name must be set
		// minumum requirements for them
		// do not allow wildcards at current stage -> do not know what pacs will do with large query
		
		if($unrestrictedmode)
		    $validitymsg = "";
		else
		    $validitymsg = "Invalid PatientID or PatientName or StudyInstanceUID. ";
		    
		//$validitymsg = ""; // hard ! this is for development only!!!
		// check for valid StudyInstanceUID. (for remote retrival)
		// if given, allow query
		if( isset($q['StudyInstanceUID']) )
		{ 
			if( strlen($q['StudyInstanceUID']) < 10)
				$validitymsg = ("StudyInstanceUID `".$q['StudyInstanceUID']."` too short. ");
			elseif( strpos($q['StudyInstanceUID'], '*')  !== false  ||  strpos($q['StudyInstanceUID'], '%')  !== false )
				$validitymsg = ("StudyInstanceUID `".$q['StudyInstanceUID']."` must NOT contain a wildcard. ");
			else
				$validitymsg = '';
		}
		
		// check for valid patient id
		if( !empty($validitymsg) &&  isset($q['PatientID']) && !$unrestrictedmode)
		{ 
			if( strlen($q['PatientID']) < 4)
				$validitymsg = ("PatientID `".$q['PatientID']."` too short. ");
			elseif( strpos($q['PatientID'], '*')  !== false  ||  strpos($q['PatientID'], '%')  !== false )
				$validitymsg = ("PatientID `".$q['PatientID']."` must NOT contain a wildcard. ");
			else
				$validitymsg = '';
		}


		if( !empty($validitymsg) &&  isset($q['AccessionNumber']) && !$unrestrictedmode)
		{ 
			if( strlen($q['AccessionNumber']) < 4)
				$validitymsg = ("AccessionNumber `".$q['AccessionNumber']."` too short. ");
			elseif( strpos($q['AccessionNumber'], '*')  !== false  ||  strpos($q['AccessionNumber'], '%')  !== false )
				$validitymsg = ("AccessionNumber `".$q['AccessionNumber']."` must NOT contain a wildcard. ");
			else
				$validitymsg = '';
		}
		
		// check for valid patient name
		if( !empty($validitymsg) &&   isset($q['PatientName'] ) && !$unrestrictedmode)
		{
			$pnames = explode('^', $q['PatientName']);
			if( strlen($q['PatientName']) < 5   )
				$validitymsg = ("PatientName `".$q['PatientName']."` too short.");
			elseif( strpos($q['PatientName'], '^')  === false )
				$validitymsg = "` Need both, Family and GivenName, separated by ^ sign. ";
 			elseif( strpos($pnames[0], '*')  !== false )
 				$validitymsg = ("Patient FamilyName must NOT contain a wildcard. ");
 			elseif( strpos($pnames[0], '*')  == false && strlen($pnames[1])<2 )
 				$validitymsg = ("Patient GivenName too short. ");
			else
				$validitymsg = '';
		}
		

		/*****************************************************/


		/////////// set default values
		if(!isset($q['StudyDate']))
			$q['StudyDate'] = "*";
		
		if(!isset($q['SeriesDescription']))
			$q['SeriesDescription'] = "*";
		
		if(!isset($q['StudyDescription']))
			$q['StudyDescription'] = "*";
 		
//  		if(!isset($q['Modality']))
//  			$q['Modality'] = "*";

		// some PACS need a wildcard for StudyInstanceUID, eg this test server
		// e.g the publix pacs 184.73.255.26 11112 --call AWSPIXELMEDPUB:
		if(!isset($q['StudyInstanceUID']))
			$q['StudyInstanceUID'] = "*";

		if( strpos($q['StudyDate'], '*') !== false &&  strlen($q['StudyDate']) > 1 )
		{
			throw new Exception("Cannot search for number/wildcard mix in StudyDate '($q[StudyDate])''" );
		}
				
		if( $q['StudyDate'] != '*') 
		{
 			if(!is_numeric($q['StudyDate']) )
 			{
 				throw new Exception("Date is not a number!" );
 			}
			// shortcuts for daily search. If absolute date, check if valid (8 digits)
			if(strlen($q['StudyDate']) <= 3)
			{
				$start =  Date('Ymd', strtotime("-". $q['StudyDate']."days" ) );
				$end   =  Date('Ymd');
				$q['StudyDate'] = $start . "-" .$end;
			}
			elseif( strlen($q['StudyDate']) != 8)
			{
				throw new Exception("Invalid StudyDate '$q[StudyDate]'" );
			}
			
			/// intepret the study date range
			if( isset($q['DaysOffsetA']) && isset($q['DaysOffsetB']) && ( $q['DaysOffsetA'] != '0' || $q['DaysOffsetB'] !='0'  )  )
			{
				if(!is_numeric($q['DaysOffsetB']) ||  !is_numeric($q['DaysOffsetA']))
				{
					throw new Exception("DateRange is not a number!" );
				}

				if(substr($q['DaysOffsetA'],0,1) != '-' && substr($q['DaysOffsetA'],0,1) != '+')
                    $q['DaysOffsetA'] = "+" . $q['DaysOffsetA'];

				$datefrom = Date("Ymd", strtotime("". $q['DaysOffsetA']."days",  strtotime($q['StudyDate']) ) );
				$dateto = Date("Ymd", strtotime("+" . $q['DaysOffsetB'] . "days ", strtotime($q['StudyDate']) ) ) ;
				$q['StudyDate'] =  $datefrom . '-' . $dateto;
			}
		}

		if(isset($q['DaysOffsetA']))
			unset($q['DaysOffsetA']);
		if(isset($q['DaysOffsetB']))
			unset($q['DaysOffsetB']);
				
		// finally, check for valid Date (if patient name and patient id are very unsecific (*)
		if( !empty($validitymsg)  && !$unrestrictedmode )
		{
			// check if date range is not too broad
			$sdarr = explode('-', $q['StudyDate'] );
			if(sizeof($sdarr) > 1)
				$diff_in_days = (strtotime($sdarr[1]) - strtotime($sdarr[0])) / 3600 / 24;
			else
				$diff_in_days = 0; 
			//$this->klog->pushmsg(" =========== $diff_in_days  ");

			$min_date_range = isset($pacs->min_date_range)?intval($pacs->min_date_range):0;  
			if( $diff_in_days>$min_date_range ) 
				$validitymsg = ("StudyDate-Range = $diff_in_days, with unspecific PatientID/Name, could produce too many matches!");
			elseif( strpos($q['StudyDate'], '*') !== false ) 
				$validitymsg = ("Query too unspecific (too many *)");
			else
				$validitymsg = '';
		}

		// some check logic (PatientID, PatientName or StudyDate left invalid message
		if(!empty($validitymsg))
		{
			throw new Exception($validitymsg);
		}

		
		$QRModel = 'SERIES';
		$verbose = '--verbose';

		$cmd  = 'findscu  --timeout 180 --dimse-timeout 180 '  . $pacs->cfind ;
		$cmd .= " $verbose   -k 0008,0052='$QRModel'" ;

		// check out for good information
		// https://www.medicalconnections.co.uk/kb/Query_Parameters
		
		// For relational queries, some pacs need the correct -P or -S switch, on no unsupported keys. Leave -S for now
		$cmd .= ' -S -k SeriesDescription -k ProtocolName -k SeriesInstanceUID -k 0010,0010  ';
		
	
 		if(!isset($q['ModalitiesInStudy']))
			$cmd .= " -k ModalitiesInStudy";

 		if(!isset($q['Modality']))
			$cmd .= " -k Modality";
	
		$cmd .= " -k StudyTime";
		
		$cmd .= " -k PatientBirthDate";

		$cmd .= " -k PatientWeight";
		$cmd .= " -k PatientSize";
		$cmd .= " -k AccessionNumber";
		
		// Number of Series Related Instances 
		$cmd .= " -k NumberOfSeriesRelatedInstances";  // 0020,1209
		$cmd .= " -k SeriesNumber";  // 0020,1209
		
		foreach($q as $key => $val)
		{	
			if(isset($this->dict[$key]))
			{
				// some PACS do not like pure wildcard as search key.
				// 03/ 2021: except pixelmedtest test server on 184.73.255.26 11112 --call AWSPIXELMEDPUB
				// needs StudyInstanceUID with wildcard
				if($val == '*' && $this->dict[$key] != "0020,000D") 
					$cmd .= " -k " . $this->dict[$key];
				else
					$cmd .= " -k " . $this->dict[$key] . "='" . $val . "'";
			}
			else
			{
				throw new Exception("The key `".$key."` is not in my dictionary.");	
			}
		    
		}
		if(isset($q['PatientID']))
			$currmsg = " Searching: Patient $q[PatientID]" ;
		else
			$currmsg = " Searching ..." ;

		// for umlaute, must decode äö to utf.
		$cmd=utf8_decode($cmd);


		// log the move
		if(1)
		{
			$ip = isset($_SERVER['HTTP_X_FORWARDED_FOR'])? $_SERVER['HTTP_X_FORWARDED_FOR']:$_SERVER['REMOTE_ADDR'];
			$str =  "[" . date ("Y-m-d H:i:s", time() ) . "] $_SESSION[username],$ip (PACSQUERY $pacsid) FINDSCU PatientID $q[PatientID], PatientName: $q[PatientName]" ;
			file_put_contents(resolve_Route(VARPATH."/syslogs/") . '/pacsquery.log', $str.PHP_EOL , FILE_APPEND );
		}

		$this->klog->pushmsg("Running FINDSCU in " . ($this->seriousmode?"SERIOUSMODE ":"TESTMODE ")  . $currmsg);
		if($this->debugverbose )
			$this->klog->pushmsg(" :::  " . utf8_encode($cmd) ) ;

		if($this->seriousmode == true)
		{
			$res = Array();
			exec($cmd . " 2>&1 ", $res, $ret);
			$res = implode("\n", $res);
			
			if($ret!==0 || strpos($res, 'Error:')!==false)
			{
				$this->klog->pushmsg("CONNECTION OR DIMSE ERROR, check log");
				$this->klog->pushmsg($res);
				throw new Exception("Error in findscu. Check log.");	
			}
		}
		else
		{
			$res = testanswer();
		}
		
		if(isset( $qobj['findSCUPause'] ))
			$pausetime =  floatval( $qobj['findSCUPause']) ;
		else
			$pausetime = $this->findSCUPause;
		usleep( round( $pausetime*1000*1000) );
		return 	$res;

	}

	// ======================================================================================
	// ============= movescu
	// ======================================================================================
	public function movescu($query)
	{


		if( isset($query['seriousmode']) )
			$this->seriousmode = $query['seriousmode'];
		//$pacsid = "UKLFR";
		$pacsid = $query['pacsid'];
		if( !isset($GLOBALS['settings']->pacsquery) || !isset($GLOBALS['settings']->pacsquery->$pacsid) )
			throw new Exception("PACS for QR `".$pacsid."` is not in my list");
		else
			$pacs = $GLOBALS['settings']->pacsquery->$pacsid;


		// ************** if importing to a specific project, wait for data 
		if( $query['targetproject'] == "NONE" || $query['targetproject'] == "")
			$writedpxfile = 0;
		else
			$writedpxfile = 1;
		
		// always wait for data, so we already have the sorting into folder.
		$waitfordata = 1;	

		if( isset($query['PACSPREVIEW']) )		
			$PACSPREVIEW = $query['PACSPREVIEW'];
		else
			$PACSPREVIEW = false;
		
		//$starttime = microtime(true);
		// touch the store folder and get time for true system file time, can differ from other timers
		if( !isset($pacs->storescp_folder )) 
			//throw new Exception("PACS `".$pacsid."` does not have a valid storescp_folder");
			$storescp_folder=VARPATH."/import";
		else
			$storescp_folder = resolve_Route($pacs->storescp_folder);

        if( !is_dir($storescp_folder) ||  !is_writable($storescp_folder)  )
        {
            if( !mymkdir($storescp_folder) )								
                throw new Exception( "ERROR: STORESCP Folder $storescp_folder does not exist, is not writable or could not create it. ");		
        }
			

			
		touch( resolve_Route($storescp_folder) );
		$starttime = filemtime($storescp_folder );
		
		$tmpPathBase = resolve_Route( VARPATH . "/tmp/tempdatafrompacs/" );

		$totsize = sizeof(array_keys($query['series']));
		$it = 0;

		$responseRaw = "";
		$numexpectedinstances = 0;
		// run over all series for study

		if(strlen($storescp_folder) < 5)
				throw new Exception("storescp_folder '$storescp_folder' too short");


		// clean empty directories older than some time (20 minutes)
		$cmd = "find $storescp_folder -maxdepth 1 -empty -type d -cmin +20 -exec rmdir {} \+";
		system($cmd);
		$cmd = "find $tmpPathBase -maxdepth 3 -empty -type d -cmin +20 -exec rmdir {} \+";
		system($cmd);



		$out = Array();
		if(!$PACSPREVIEW)
			{echo "NORA_PROGRESS_SEPARATOR" . round(0); flush(); ob_flush();}
		foreach($query['series'] as $key => $q)
		{
			
			if(!$PACSPREVIEW)
 				{echo "NORA_PROGRESS_SEPARATOR" . round(100*(++$it)/$totsize); flush(); ob_flush();}
			
    		
			/////////////// check inputs
			if(!isset($q['PatientID'])) 
				throw new Exception("PatientID must be set.");
			if( strlen($q['PatientID']) < 4)
				throw new Exception("PatientID `".$q['PatientID']."` too short");
			if(!isset($q['SeriesInstanceUID'])) 
				throw new Exception("SeriesInstanceUID must be set.");
		

			$numexpectedinstances = strval($q['NumberOfSeriesRelatedInstances']);
			
			$QRModel = 'SERIES';
			$verbose = '--verbose';

			$cmd = "movescu  $verbose  ";
			//$cmd = "movescu --timeout 1000 --dimse-timeout 1000   $verbose  ";
			//$cmd .= " --output-directory /tmp/dicomnode";
			$cmd .=  ' -S -k 0008,0052=' . $QRModel . '  -k 0010,0020="' . $q['PatientID'] . '"  -k 0020,000e="' . $q['SeriesInstanceUID'] .'"'  ;
			// some pacs want also the StudyInstanceUID
			$cmd .=  ' -k 0020,000d="' . $q['StudyInstanceUID'] .'" '  ;
			$cmd .= " " . $pacs->cmove;
			// check out for good information
			// https://www.medicalconnections.co.uk/kb/Query_Parameters
			$currmsg = " Sending: Patient $q[PatientID] $q[PatientName]  Study $q[StudyInstanceUID] / Series  $q[SeriesDescription]" ;


            DPX_log_($currmsg);

			$this->klog->pushmsg("Running MOVESCU in ".($this->seriousmode?"SERIOUSMODE ":"TESTMODE ")  . $currmsg);
			if( $this->debugverbose )
				$this->klog->pushmsg(" ::: " . $cmd);
				

			if($this->seriousmode == true)
			{
				$res = Array();
				exec($cmd . " 2>&1 ", $res, $ret);
				$res = implode("\n", $res);
				//if($ret!==0 || strpos($res, 'Error:')!==false || strpos($res, 'ErrorComment:')!==false || strpos($res, 'Failed:')!==false)
				if($ret!==0 || strpos($res, 'Error:')!==false || strpos($res, 'ErrorComment:')!==false )
				{
					$this->klog->pushmsg("CONNECTION OR DIMSE ERROR, check log");
					$this->klog->pushmsg($res);
					throw new Exception("Error in movescu. Check log.");	
				}
				else if(strpos($res, 'OutOfResourcesSubOperations')!==false)
				{
					$this->klog->pusherr(new Exception("PACS returned 'OutOfResourcesError'. Check log."));	
					$this->klog->pushmsg($res);
					continue;
				}
				$responseRaw = $res;
			}
			else
			{
				$responseRaw .= "";
			}
  			
  			// log the move
  			if(1)
  			{
		        $ip = isset($_SERVER['HTTP_X_FORWARDED_FOR'])? $_SERVER['HTTP_X_FORWARDED_FOR']:$_SERVER['REMOTE_ADDR'];
	   			$str =  date ("Y-m-d H:i:s.", time() ) . " $_SESSION[username],$ip (PACSQUERY $pacsid) MOVESCU, PatientID $q[PatientID], PatientName: $q[PatientName], SUID  $q[SeriesInstanceUID]" ;
		        file_put_contents(resolve_Route(VARPATH."/syslogs/") . '/pacsquery.log', $str.PHP_EOL , FILE_APPEND );
  			}

			$out = Array('responseRaw' => $responseRaw);

			if($waitfordata)
			{

				$pname = trim($q['PatientName']);
				$guessed_name = clear_string($pname);

// 				$guessed_name = str_replace('^', '_', $guessed_name);
// 				$guessed_name = str_replace('-', '_', $guessed_name);
				$guessed_name = preg_replace('/\W/', "_", $guessed_name);
				$guessed_path = $storescp_folder . "/$guessed_name*";

				// target to copy all files to another folder
				if($writedpxfile)
				{
					$tmpPath = $tmpPathBase . $q['StudyInstanceUID'] . "_" . $starttime;
					$tmpPath = $tmpPathBase . $q['StudyInstanceUID'] . "_" . $starttime;
				}
				else
				{
					if(isset($query['targetsubfolder']) && $query['targetsubfolder'] != "" && $query['targetsubfolder'] != false)
						$tmpPath = $storescp_folder ."/".  $query['targetsubfolder'] . "/" . $guessed_name  ."_". $starttime;
					else
						$tmpPath = $storescp_folder . "/ZZX_$guessed_name"."_". $starttime;
				}
				
				
				// check for potential directory
				// no wait until everthing arrived
				$interval = 1;
				$timeout = isset($pacs->max_wait_time)?intval($pacs->max_wait_time):60;// max wait time
				$maxsteps = $timeout / $interval;
				$timetolerance = 4; // seconds, filemtime has seconds as units
				$success = false;

				$filelist = Array();

				$this->klog->pushmsg("waiting for data, maxsteps:" . $maxsteps);
				$testcounter = 0;
				for($k = 0; $k<$maxsteps; $k++)
				{
					
					if($this->seriousmode == false)
					{
						//$this->klog->pushmsg("I am in testmode, simulating ...");
						//$this->klog->pushmsg("Creating subfolder $tmpPath");
						if( !mymkdir($tmpPath) )								
							throw new Exception( "ERROR: Could not create subfolder: $tmpPath " );
						if( !mymkdir("$storescp_folder/$guessed_name") )								
							throw new Exception( "ERROR: Could not test subfolder: $storescp_folder/$guessed_name " );
						file_put_contents("$storescp_folder/$guessed_name/zzz1.dcm", "ada");
						file_put_contents("$storescp_folder/$guessed_name/zzz2.dcm", "ada");
						for($z=0; $z<2; $z++)
						{
							//usleep(1000/1000 * 1);
// 							echo "NORA_PROGRESS_SEPARATOR" . (100*($z)/10);
// 							flush();
// 							ob_flush();
						}
						//$success = true;break;
						$success = false;
					}

					$guessed_dir  = glob($guessed_path , GLOB_ONLYDIR);

					if(sizeof($guessed_dir) > 0) // ok, some dir found, check them all
					{
						// now must check all possible dirs which have files NEWER than the start time
						foreach($guessed_dir as $tdir)
						{
							$tlist = glob("$tdir/*.dcm");
							// run over all files and check if file arrived AFTER our start time. If yes, push to stack.
							foreach($tlist as $file)
							{
								//$this->klog->pushmsg("Checking directory:  $file starttime: $starttime, filetime: " . (filemtime($file) - $starttime ) );
								if(filemtime($file) > $starttime - $timetolerance)
								{
									// reset $k counter if any new file arrived
									if (!isset($filelist[$file]))
										$k=0;
									$filelist[$file] = 1;
								}
							}
						}

						$content = array_keys( $filelist );
						$nfiles  = sizeof($content);
						//if($k==0)
						if(0)
							$this->klog->pushmsg(" ... looking for received files (counter=$k,  already received " . $nfiles . "/" . $numexpectedinstances . ")");

						//************** all files of this series are here **********
						if( $nfiles >= $numexpectedinstances )
						{

							if( !$tmpPath || strlen($tmpPath) < 5  )		
								throw new Exception( "ERROR: Invalid temp path: $tmpPath " );
							if( !mymkdir($tmpPath) )								
								throw new Exception( "ERROR: Could not create subfolder: $tmpPath " );
							chmod($tmpPath, 06775);

							// move the files
							foreach ( $content as $ttt )
							{
								$fn = pathinfo($ttt)['basename'];
								$succ = @rename($ttt, $tmpPath . "/" . $fn);
								if($succ===false)
									throw new Exception( "ERROR: Could not move the dicom $ttt to $tmpPath, aborting." );
							}

							// convert to nii
							if($PACSPREVIEW > 0)
							{
								$niiPath = $tmpPath ."_nii_temp";
								mymkdir($niiPath);
								chmod($niiPath, 06775);
								$cmd = "dcm2nii -b  " . DPXROOT ."/src/matlab/dcm2nii.ini -f y -p n -e n -d n -i n -r n -c n -o '$niiPath' '$tmpPath';";

								$res = Array();
								exec($cmd . " 2>&1 ", $res, $ret);
								$res = implode("\n", $res);
								$this->klog->pushmsg( $cmd );
								$this->klog->pushmsg( $res );

								$niis = glob($niiPath ."/*.nii" );
								$this->klog->pushmsg("Found nii files:  " . implode('ddd', $niis));
								$out['filepath'] = $niis[0];
								// this will return the filepath to index php pacsquery. nii will be deleted there afterwards.
							}

							// ************ temporary preview only, delete the dicoms
							if( $PACSPREVIEW == 1)
							{
								if(sizeof(glob("$tmpPath/*.dcm"))>0)
									system("rm $tmpPath/*.dcm");

								rmdir($tmpPath);	
							}
							
							$success = true;
							break;
						}
					}
					usleep( $interval * 1000 * 1000 );  // interval for checking the directory

				}
				if(!$success)
				{
					$this->klog->pusherr(new Exception("TIMEOUT in series '$q[SeriesDescription]': received only $nfiles"."/"."$numexpectedinstances files in ".$timeout."s. Deleting and skipping this series."));
					// delete the incomplete series
					if(sizeof($filelist)>0)//$writedpxfile)
					{
						//$this->klog->pushmsg("      Deleteing incomplete series ..."  );
						$content = array_keys( $filelist );
						foreach ( $content as $ttt )
						{
							$succ = @unlink($ttt);
							if($succ===false)
								$this->klog->pusherr(new Exception( "ERROR: Could not delete the dicom $ttt to $tmpPath, aborting." ) );
						}
					}
					//throw new Exception( "TIMEOUT ERROR: No data arrived from PACS during $timeout s " );

				}
			} // waitfordata


		    // pause between series 
			if(isset( $query['moveSCUPause'] ) )
				$pausetime =  floatval($query['moveSCUPause']);
			else
				$pausetime = $this->moveSCUPause;
			
			$this->klog->pushmsg('sleeping: ' . $pausetime . ' seconds.');
			usleep( round( $pausetime*1000*1000) );

		} // end for each query loop


		if( $PACSPREVIEW != 1)
		{
			if($writedpxfile && isset($tmpPath))
			{
				$datapath = encode_route($tmpPath);

				$info = Array();
				$info['datapath'] 		=   $datapath;

                $alias = "noalias";
				if (isset($_SESSION['username']))
				  $alias = $_SESSION['username'];
                $info['alias'] = $alias;
                
				$info['user'] 		=  IMPORTUSER;
				$info['project']  = $query['targetproject'];
				$info['deleteafterimport']    = 1;
				$info['nooverwrite']    = $query['nooverwrite'] ;
				$info['anonymization']    = $query['anonymization'] ;
				$info['tag_study']    = $query['tag_study'] ;
				$info['tag_patient']    = $query['tag_patient'] ;
				$info['runautoexec']    = $query['runautoexec'] ;
				if(isset($query['queue']))
					$info['queue'] 		    = $query['queue'] ;


				if ($query['runautoexec'] && isset($query['queue']) )
					$info['autoexec_queue'] = $query['queue'] ;

				if(isset($query['fileID']))
					$info['fileID']    = $query['fileID'];

				$dpxfilefolder = resolve_Route( VARPATH . "/import" );
				$pathinfo = pathinfo(end($guessed_dir));
				$foldername    = $pathinfo['basename'];
				$tfile = "$dpxfilefolder/$foldername.dpx";

				if(is_writeable($dpxfilefolder) == false)
					throw new Exception( "ERROR: write_dpx_file: not writable. $tfile " );


				$this->klog->pushmsg("import started by writing dpx file $tfile");

                DPX_log_("autoexecute initiated");


				$jsonstring = json_encode($info);
				$this->klog->pushmsg("importinfo: " . $jsonstring);

				file_put_contents($tfile,$jsonstring );
			}
			else
				$this->klog->pushmsg("all files received, but no project import started. Data can be found in " . (isset($tmpPath)?$tmpPath:"N/A"));
		}

		if(!$PACSPREVIEW)
			{echo "NORA_PROGRESS_SEPARATOR";}


		return $out;
	}

	// ======================================================================================
	// ============= write info to patient table
	// ======================================================================================
	public function dryimport_full_study($query)
	{

		// test with 
		// localhost/DPX/pacsquery.php?command=PACSQuery_dryimport_full_study&StudyInstanceUID=1.2.276.0.38.1.1.1.3150.20180914130322.37804706&pacsid=UKLFR&project=KStroke
		// Kellner StudyInstanceUID: 11.2.276.0.38.1.1.1.3150.20180914130322.37804706
		//
		// returns with json object containing the SID created in patient table.


		if(!isset($query['pacsid']))
			throw new Exception("no pacsid set.");
		
		if(!isset($query['targetproject']))
			throw new Exception("no project set.");
		
		if(!isset($query['StudyInstanceUID']))
			throw new Exception("no StudyInstanceUID set.");

		$tobj = Array('pacsid'=>$query['pacsid'], 'findSCUPause', 0, 'tags'=>Array('StudyInstanceUID' => $query['StudyInstanceUID'], 'PatientID'=>'*', 'Modality'=>'*')  );
		$tobj['seriousmode'] = 1;

		$rawline =  $this->findscu($tobj);
		$aobj = dicomparse($rawline);
		//$this->klog->pushmsg( var_dump($aobj) );
		
		if(isset($aobj['studies']) && sizeof($aobj['studies']) > 0 )
		{
			$tobj = Array('pacsid'=>$query['pacsid'], 'targetproject'=>$query['targetproject'], 'studies'=> $aobj['studies'] );
			$out = $this->dryimport($tobj);
			
			return $aobj['studies'];

		}


	}





	// ======================================================================================
	// ============= write info to patient table
	// ======================================================================================
	public function dryimport(&$query)
	{


		require_once(dirname(__FILE__) . '/mydbconnection.php');

		if( isset($query['seriousmode']) )
			$this->seriousmode = $query['seriousmode'];

		$pacsid = $query['pacsid'];
		if( !isset($GLOBALS['settings']->pacsquery) || !isset($GLOBALS['settings']->pacsquery->$pacsid) )
			throw new Exception("PACS `".$pacsid."` is not in my list");
		else
			$pacs = $GLOBALS['settings']->pacsquery->$pacsid;

		$out = Array();
		$sql = "";

		$project = $query['targetproject'];
		$this->klog->pushmsg( "Inserting into $project");
		$db = mydbconnection( $project);
		
		// much faster without autocommit.
		// however, even better: optimise with multi inserts ( to be done)
		$db->autocommit(false);

		// walk over studies here
		foreach($query['studies'] as $suid => &$study)
		{
  		    $count = 0;
			$sql = Array();

			$studyHeaderWasAdded = false;

			foreach($study['series'] as $seid => &$q)
			{
				/////////////// check inputs
				if(!isset($q['PatientID'])) 
					throw new Exception("PatientID must be set.");
				if( strlen($q['PatientID']) < 4)
					throw new Exception("PatientID `".$q['PatientID']."` too short");
				if(!isset($q['SeriesInstanceUID'])) 
					throw new Exception("SeriesInstanceUID must be set.");
				
                // sorry, need both study date and time to create a sid right now and here
//                 if(!(isset($q['StudyTime']) && isset($q['StudyDate'])  ) )
//                 	continue;

//                 $stime =  explode(".", $q['StudyTime']);
//                 $stime = sprintf('%06s', $stime[0]);
//                 $sid = "#".  $q['StudyDate'] . $stime;
				
// 				$out['PatientID'] = $q['PatientID'];
// 				$out['StudyInstanceUID'] = $q['PatientID'];

				// add patient / study
				if(!$studyHeaderWasAdded )
				{
					$studyHeaderWasAdded = true;
					
					$name = explode("^", $q['PatientName']);
					$FamilyName = trim($name[0]);
					$GivenName =  trim(isset($name[1])?$name[1]:"" );
					$patientrow = Array('PIZ' =>  $q['PatientID'], 'FamilyName' => $FamilyName,  'GivenName' => $GivenName);
					$row = MDB_createDBString($patientrow);
					$sql[] = $qf = "INSERT INTO patients $row[keys] VALUES $row[values] ON DUPLICATE KEY UPDATE $row[update];";
					if(!$db->query($qf) ) throw new Exception("DB Errror:".  $db->error);
					
					$stime =  explode(".", $q['StudyTime']); $stime = sprintf('%06s', $stime[0]);
					$SID = "#".  $q['StudyDate'] . $stime;					

					$studyrow = Array(	'patients_id' =>  $q['PatientID'], 
										'StudyID' => $SID, 
										'StudyInstanceUID' => $q['StudyInstanceUID'], 
										'StudyDescription' => $q['StudyDescription'], 
										'StudyDate' => $q['StudyDate']
										);

					$row = MDB_createDBString($studyrow);
					//$sql[] = $qf ="INSERT INTO studies $row[keys] VALUES $row[values] ON DUPLICATE KEY UPDATE $row[update];";
					$sql[] = $qf ="INSERT INTO studies $row[keys] VALUES $row[values] ON DUPLICATE KEY UPDATE $row[update];";
					if(!$db->query($qf) ) throw new Exception("DB Errror:".  $db->error);
				}
				$count ++;
				
				$SeriesDescription = str_replace("/", "_", $q['SeriesDescription']);
				if($SeriesDescription == "")
					$SeriesDescription = $q['ProtocolName'];
					
				$FileName =  sprintf("s%03.0d.nii", intval($q['SeriesNumber']) ) ;
				
				// this is important: write the full info as json to FilePath. Only take relavant information
				$sfields = Array('PatientID', 'StudyInstanceUID', 'SeriesInstanceUID', 'InstanceAvailability', 'PatientName', 'NumberOfSeriesRelatedInstances', 'StudyDate');
				$seriesinfo = Array();
				foreach($sfields as $ss)
					$seriesinfo[$ss] = $q[$ss];
				$info = Array(
					  "pacsid" => $query['pacsid'],
					  "PACSPREVIEW"   => 1,
					  'seriousmode'   => $this->seriousmode,
					  "targetproject" => $project
					  );

				$info['series'] = Array($seriesinfo);

				$FilePath = "PACS://" . str_replace('\\', '\\\\', json_encode($info));
				//$this->klog->pushmsg( str_replace("\n", "<br>", var_export($FilePath,1)  ));
				
				$FTag = '/P/';

				$seriesrow = Array(	'patients_id'	=>  $q['PatientID'], 
									'studies_id' 	=>  $SID, 
									'FilePath' 		=>  $FilePath,
									'FileName' 		=>  $FileName,
									'SubFolder'		=>  $SeriesDescription,
									'Tag'			=>  $FTag
									);
				$row = MDB_createDBString($seriesrow);
				$sql[] = $qf = "INSERT INTO files $row[keys] VALUES $row[values] ON DUPLICATE KEY UPDATE  $row[update];";
				if(!$db->query($qf) ) throw new Exception("DB Errror:".  $db->error);

			}// end walk over series
			
			// reomove the series info, too much
			//unset($q['series']);

		}// end walk over studies;

		//if(!$db->multi_query(implode(';', $sql)) ) throw new Exception("DB Errror:".  $db->error);

		//$this->klog->pushmsg( implode('<br>', $sql) );
		//$out['sql'] = $sql;

		$sql = implode(';', $sql);
		$db->commit();
		$db->close();

		return $q;	
	}



	// ======================================================================================
	// ============= PACSQuery_seriesSummary 
	// ======================================================================================
	/* to be deleted
	function seriesSummary($patients)
	{
		$s = Array();
		foreach($patients as $PatientID => $patient)
		{
			foreach($patient['studies'] as $StudyID => $study)
			{
				foreach($study['series'] as $SeriesInstanceUID => $series)
				{
					if(isset($series['SeriesDescription']) )
					{
						if(!isset($s['SeriesDescription']))
						{	
							$s[$series['SeriesDescription']] = Array();
							$s[$series['SeriesDescription']]['SeriesDescription'] = $series['SeriesDescription'];
							$s[$series['SeriesDescription']]['nitems'] = 1;
						}	
						else
						{
							$s[$series['SeriesDescription']]['nitems'] += 1;
						}
					}
				}
			}	
		}
		return $s;
	}

	*/

	// create a file with information about this movescu job, for later use.
	// basically, this contains a patient name, and a target instance / project 
	/* not needed anymore ...?	
function create_info_file($query, $storescp_folder, $targetsubfolder="")
	{
// 		if( $query['targetproject'] == "NONE" || $query['targetproject'] == "")
// 		{
// 			return false;
// 		}

		$this->klog->pushmsg( "Creating info file for $query[StudyInstanceUID] in folder: $folder " );
		$info = Array();
		$q = $query['series'][0];
	    $info['PatientID']    		= $q['PatientID'];
	    $info['PatientName']    	= $q['PatientName'];
	    $info['StudyInstanceUID'] 	= $q['StudyInstanceUID'] ;
	    $info['targetsubfolder'] 	= $query['targetsubfolder'] ;
	    $info['targetproject'] 		= $query['targetproject'] ;
	    $info['runautoexec'] 		    = $query['runautoexec'] ;
	    $info['queue'] 		        = $query['queue'] ;
		
		$info['dpxfilefolder'] = resolve_Route( VARPATH . "/import" );

	    $filepath = $storescp_folder. "/" . $q['StudyInstanceUID'] .   ".movescu";
	    //umask(0666);
        file_put_contents($filepath, json_encode($info) );
        //chmod($filepath, 0664);
	}
	

	public function move_after_reception($StudyInstanceUID, $folder, $targetsubfolder="")
	{

		// wait some 100ms, maybe folder is not fully here yet
		usleep(100 * 1000);

		$this->klog->pushmsg( "Moving suid $StudyInstanceUID in folder: $folder " );
		if(!is_dir($folder))
		  throw new Exception("Error: folder $folder does not exist!\n");
		
    	$dirs = glob($folder . '/*' , GLOB_ONLYDIR);
    	$target = "";
    	foreach($dirs as $k => $tdir)
    	{
			$tdir = (realpath($tdir));
    		
    		$target = $tdir;

			$pi = pathinfo(realpath($tdir . '/'));
			$current = $pi['filename'];
			// only take folders matching storescp pattern
			$matches = array(); 
			preg_match_all (  "/(?<name>\w+)_(?<date>\d{8})_(?<time>\d+)/" , $current, $matches, PREG_SET_ORDER ); 
			if( sizeof($matches) == 0)
			{
				continue;
			}
			$dcmfiles = glob($tdir . "/*.dcm" );
			if( sizeof($dcmfiles) == 0)
			{
				continue;
			}
			//$this->klog->pushmsg( "This is a folder from storescp : $tdir " );
			$dcminfo = dicominfo($dcmfiles[0]);
			$suid = $dcminfo['StudyInstanceUID'];

			// this is the series to be moved
			if($StudyInstanceUID == $suid)
			{
				// can move either to a completely different folder, or just to a subfolder
				// right now, only subfolder is possible
				if($targetsubfolder != "" && $targetsubfolder != false)
				{
					//var_dump($pi);
					$target = ($pi['dirname'] . "/" .  $targetsubfolder . "/" . $pi['filename'] . "$suid");
					$targetsubpath = ($pi['dirname'] . "/" .  $targetsubfolder) ;
					
					if($targetsubfolder == "" || $target == false)
						throw new Exception( "ERROR: move_after_reception: Target folder cannot be empty. " );
					
					if(!is_dir($targetsubpath))
					{
						$md = mymkdir($targetsubpath);
						if($md !== true)					
							throw new Exception( "ERROR: move_after_reception: Could not create subfolder $targetsubpath " );
					}
					$cmd = "mv $tdir $target";
					$this->klog->pushmsg( "Moving folder: $cmd " );
					system($cmd);
				}
				else
				{
					$target  = $tdir;
				}
			}
    	}
    	return $target;
		    
	}

	public function write_dpx_file($dpxfilepath, $target, $user='dpxuser', $project='SANDBOX')
	{
		if($target=="" || $target == false)
			throw new Exception( "ERROR: write_dpx_file: target folder  cannot be empty. " );

		$pi = pathinfo(($target . '/'));
		$dpxfilename = ($dpxfilepath . "/" . $pi['filename'] . ".dpx");

		if(!is_writeable($dpxfilename))
			 throw new Exception( "ERROR: write_dpx_file: not writable. $dpxfilename " );

		$out = "";
		$out .= $target ."\n";
		$out .= $user ."\n";;
		$out .= $project."\n";;

		$this->klog->pushmsg( "writing dpx file " . $dpxfilename . "\n" . $out ."\n"  );
		//var_dump($dpxfilename);
		file_put_contents($dpxfilename,  $out );
	}
*/

}	


// ======================================================================================
// ============= parse a dicom string from dcmdump or findscu
// ======================================================================================
function dicomparse($str)
{
	/*
	//$cmd = "dcmdump +P ProtocolName " . $file;
	//$cmd = "dcmdump " . $file;

	$res = array();
	exec($cmd . " 2>&1 ", $res, $ret);

	echo "\n=========================\n";
	echo($cmd);
	var_dump($res);
	echo "\n=========================\n";

	*/
	//var_dump($str);

	$res = $str;

	$hdr = array();
	$matches = array();

	// for findscu
	$regexp = '/W: \((?<tag>\w{4}\,\w{4})\) \w\w \[(?<value>[^\]]+)\]\s+#\s+\d+,\s\d\s(?<tagdesc>\w+)/x';

	// for dcmdump
	$regexp = '/\((?<tag>\w{4}\,\w{4})\)\s\w\w\s\[(?<value>[^\]]+)\]\s+\#\s+\d+,\s\d\s(?<tagdesc>\w+)/x';
	
	$out = Array();
	
	//$out['responseRaw'] = $res;
	//$out['PatientID'] = 'GAP330790';
		$out['studies'] = Array();
			//$out['series'] = Array();
	
	//$us = explode('W: ---------------------------', $res);
	
	// for dcmdump
	//$us = explode('I: # Dicom-Data-Set', $res);
	$us = preg_split('/(I|W)\:\ \#\ Dicom-Data-Set/', $res);

	$nseries = sizeof($us);
	$out['nseries'] = $nseries;
	
	// walk over response blocks == image series
	// start from second match, first is query itself
	for($z=0; $z<$nseries; $z++)
	{
		$row = $us[$z];
		//$row = explode("\n", $row);
		preg_match_all (  $regexp , $row, $matches, PREG_SET_ORDER ); 
		if(sizeof($matches)== 0)
			continue;

		// prepare template
		$series = Array('StudyInstanceUID' => 'StudyInstanceUID_missing', 'SeriesInstanceUID' => 'SeriesInstanceUID_missing', 'StudyDescription' => 'StudyDescription_missing', "StudyDate"=>"StudyDate_missing", "PatientName"=>"PatientName_missing","PatientID"=>"PatientID_missing");
		
		// walk over matches == lines == tags
		foreach($matches as $tag)
		{
			{
				$series[$tag['tagdesc']] = str_replace("\0", "", $tag['value']); // remove the evil NULL chars ...!
			}
		}

		// this is the repeated initial query, do not store
		if($series['PatientID']=='*')	
			continue;	

		// this is for certain test pacses which do not give StudyInstanceUID
		if(!isset($series['StudyInstanceUID']))
			$series['StudyInstanceUID'] = 'no_study_instance_uid';
		
		//$series['StudyInstanceUID'] = sprintf('%sXX', $series['StudyInstanceUID']);

		//create the study object and set properties
		if(!isset($out['studies'][$series['StudyInstanceUID']]))
		{
			$tstudy = Array();

			$tstudy['PatientID'] = $series['PatientID'];
			$tstudy['PatientName'] = $series['PatientName'];
			$tstudy['StudyDate'] = $series['StudyDate'];
			$tstudy['StudyDescription'] = $series['StudyDescription'];

			$stime =  explode(".", $series['StudyTime']); $stime = sprintf('%06s', $stime[0]);
			$tstudy['SID'] = "#".  $series['StudyDate'] . $stime;

			$tstudy['series'] = Array();
			$out['studies'][$series['StudyInstanceUID']] = $tstudy;
		}
		
		// collect by SeriesInstanceUID
		$out['studies'][$series['StudyInstanceUID']]['series'][$series['SeriesInstanceUID']] = $series;	
		
		
//  		echo "--\n";
//  		print_r($series);
//  		print_r($series['SeriesInstanceUID']);
//  		echo "--\n";

	}

	//var_dump($out);

	return ($out);
}




function dicominfo($file)
{
  $tags = array();
  $tags["0008,003e"] = 'SeriesDescription'; 
  $tags["0020,0011"] = 'SeriesNumber'; 
  $tags["0020,000e"] = 'SeriesInstanceUID'; 
  $tags["0008,0018"] = 'SOPInstanceUID'; 
  
  
  $tags["0008,0080"] = 'InstitutionName'; 
  $tags["0008,0081"] = 'InstitutionAddress'; 
  $tags["0018,1000"] = 'DeviceSerialNumber'; 
  $tags["0010,0021"] = 'IssuerOfPatientID'; 

  $tags["0020,000d"] = 'StudyInstanceUID'; 
  $tags["0010,0020"] = 'PatientID'; 



  $t = implode(' +P ', array_keys($tags));
  $cmd = "dcmdump +P $t " . $file;
  
  $res = array();
  exec($cmd . " 2>&1 ", $res, $ret);  
  //addLogEntry("Reading DICOM Header of original file ... ", $res, $ret);
  //echo var_dump( $res );
  
  $hdr = array();
  $matches = array();
  foreach($tags as $k => $v)
  {
    $hdr[$v] = 'TAG_NOT_SET';
  }

  foreach($res as $row)
  {
      preg_match_all (  "/\(   (?<tag>\w{4},\w{4})   \)\s\w\w\s\[   (?<value>[^]]+)   \]\s#.*/x" , $row, $matches, PREG_SET_ORDER ); // x means igonore empty spaces
      //print_r($matches[0]);
      if(sizeof($matches)>0)
        $hdr[$tags[$matches[0]['tag']]] = $matches[0]['value'];
   }
 
   return ($hdr);
 
}

function testanswer()
{
	$str = file_get_contents("./dcmqueryteststring.txt");
	return $str;
}


function clear_string($str, $how = '-')
{
	$search = array("ä", "ö", "ü", "ß", "Ä", "Ö", 
					"Ü", "&", "é", "á", "ó", " ","'");
	$replace = array("ae", "oe", "ue", "ss", "Ae", "Oe", 
					 "Ue", "und", "e", "a", "o","_","_" );

	$str = str_replace($search, $replace, $str);
	return $str;
}

/*
function write_dpx_file($info)
{
	// do not write a dpx file for empty target project.
	if($info['targetProject'] == 'NONE' || $info['targetProject'] == '')
	{
		return false;
	}

    $out .= $info['folder'] ."\n";
    $out .= $info['user'] ."\n";;
    $out .= $info['targetProject']."\n";;
	$p = pathinfo( $info['folder'] );
	$parentfolder = $p['dirname'];
	$subfolder    = $p['basename'];

	if( isset($info['dpxfilefolder'] ) )
	{
		$dpxfilefolder = $info['dpxfilefolder'];
	}
	else
	{
		$dpxfilefolder = $parentfolder;
	}

    echo "writing dpx file " . $dpxfilefolder. "/" . $subfolder . ".dpx" ."\n". $out ."\n"  ;
    
    file_put_contents($dpxfilefolder. "/" . $subfolder . ".dpx", $out );

    
    exit(0);

}
*/




function DPX_log_($str)
{
	$user = "unknown";
	$proj = "unknown";
	if (isset($_SESSION['username']))
	  $user = $_SESSION['username'];
	if (isset($_GET['project']))
	  $proj = $_GET['project'];

	if ( isset($_SERVER['HTTP_X_FORWARDED_FOR']) ){
		$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	} 
	else{ 
		$ip = $_SERVER['REMOTE_ADDR'];
	}

	$str =  date ("Y-m-d H:i:s.", time() )  . ' ' . $user . ',' . $ip . ' (' . $proj . '):  ' . $str ; 
	file_put_contents(resolve_Route(VARPATH."/syslogs/") . '/access.log', $str.PHP_EOL , FILE_APPEND );
}
