







function getAgeSexRef(agegender,modelfolder)
{
	  try {
		var model = readModel(modelfolder);
	  } catch(err)
	  {
		 logProcess("Problem reading model file");
		 logProcess(err);
		 return;
	  }

	  var gender = model.getGender(agegender);
	  var age = model.getAgeRefNum(agegender).bin;
	  return ""+gender+(age+1);

}


function createDir(base,name)
{
	var fs = require('fs');
	var outpath;
	if (name != undefined)
	{
		var out = path.dirname(base);
		outpath = path.join(out,name);
	}
	else
		outpath = base;

	!fs.existsSync(outpath) && fs.mkdirSync(outpath);

	if (!fs.existsSync(outpath))
	{
		ipc.send('consoleLog',"not able to create folder " + outpath);
		return;
	}
	else
		return outpath;
}


function report_creator(args,base)
{
	  if (report_creator_CVR(args,base))
	  	 logProcess("veomorph started");
	  else 
	  	 logProcess("unknown report");


}







function processBASH(params,callback) //antspath, inpath,outpath,reportname,agegender,modelfolder, tpmfolder, options)
{



          var path = require('path');
       	  var ipc = require('electron').ipcRenderer;

     

          var $procframe = $("<div id='KProcFrame'><img style='position:absolute;width:100%;height:100%;opacity:0.05' src='logo_full.svg'  > <div> </div>  <div class='thespinner'><i class='fa-5x fa fa-spinner fa-spin'></i></div> <div id='KLoadingFrameTypeString'></div> <div id='KLoadingFrameText' class='CVR'></div> </div>").appendTo($(document.body));
           
          var $proctext = $procframe.find("#KLoadingFrameText");


          var log = "";
          
          //done(0);
          //return;

          ipc.on('ANTSstdout', function(event,arg)
          {
                log = log + arg;
                $proctext.html(log);
                $proctext.scrollTop($proctext[0].scrollHeight);          });

          ipc.on('ANTSstderr', function(event,arg)
          {
                log = log + "<span class='KCVRerror'>" +arg + "</span>";
                $proctext.html(log);
                $proctext.scrollTop($proctext[0].scrollHeight);

          });


          ipc.on('ANTSdone', function(event,code)
          {
                done(code);
          });

          function done(code)
          {
                if (code == 0)
                {
                    $proctext.html(" success!! ");
                    callback(params)
                }
                else
                {
                    $proctext.html(log + `<span class='KCVRerror'> Bash processing not properly finished, exited with code ${code} </span>` );
                    if (!debug)
                    {
                      ipc.send('killAll',{code:code});
                      /*
					   setTimeout(function() {
						 remote.getCurrentWindow().close(); },500);*/
                    }
                }

          }



          ipc.send('processANTS',params);


    	
}



function readModel(modelfolder)
{

        var fs = require('fs');
    
        var model = fs.readFileSync(path.join(modelfolder,'model.json'));
        model = JSON.parse(model);
        model.getAgeRefNum = function(agegender)
        {

			var agegender_default = 'M50';

            if (agegender == undefined)
            {
                agegender = agegender_default;
                logProcess('age/gender is undefined, taking ' + agegender);
            }



            var a = parseFloat(agegender.replace(/[a-zA-Z]/g,''));
            if (isNaN(a))
            {
                agegender =agegender_default;
                logProcess('age/gender is unvalid, taking ' + agegender);
                
            }
            for (var k = 0; k < model.agebins.length; k++)
            {
                if (a < model.agebins[k])
                {
                    if (k==0)
						return {bin:0, age:a};
                    else
                        {
                            if (a-model.agebins[k-1] < model.agebins[k]-a)
								return {bin:k-1, age:a};
                            else
								return {bin:k, age:a};
                        }

                }
            }
            return {bin:model.agebins.length-1, age:a}

        }

        model.getGender = function(agegender)
        {

            if (agegender == undefined)
            {
                agegender = 'M50';
                logProcess('age/gender is undefined, taking ' + agegender);
            }

            return agegender[0];
        }

        model.getOption = function (default_val,name)
        {
        	if (model.option)
				if (model.option[name] != undefined)
					return model.option[name];

			return default_val;
        }


        var modelSVM = fs.readFileSync(path.join(modelfolder,'modelSVM.json'));
        modelSVM = JSON.parse(modelSVM);

		function sigmoid(S,a,b)
		{
			return 1/(1+Math.exp(a*S+b));
		}



		for (var k = 0; k < modelSVM.scoreTransform.length;k++)
		{
		    var evalstr = modelSVM.scoreTransform[k].substring(4);
			modelSVM.scoreTransform[k] = function(evalstr) { return function(S) { return eval(evalstr) } }(evalstr);
		}
		model.SVM = modelSVM;

		


        return model;


}




function createImgRow(vp,views,rowclass,itemclass,scalefac)
{



	var mv = vp.getCurrentViewer();


	var $imgrow = $("<div class='"+rowclass+"'>  </div>");
	var imgrow = [];
	for (var k = 0; k < views.length;k++)
	{
		mv.setSlicingDimOfWorld(views[k].sl);
		mv.setSlicePos(views[k].sl,Math.round(views[k].num * scalefac));
		var lrsign = "";
		if (views[k].LRsign != undefined)
			lrsign = "<span class='LRlabel'>" + views[k].LRsign + "</span>";
		var cap = "";
		if (views[k].text != undefined)
			cap = "<span>"+views[k].text+"</span>";
		var $im = $("<div class='CVRimageItem'>"+cap+lrsign+" </div>").appendTo($imgrow);
		$im.append(crop(vp,views[k].clip))
		imgrow.push($im);
	}
	return $imgrow;

}


function crop(vp,clip)
{
	 return ( cloneCanvas( vp.getCurrentViewer().getCanvas(),clip));
}




function save($report,vp,outpath,dummyname)
{

	 html2canvas($report).then(function(canvas)
	  {
		 vp.panel.close();
//		 var blob = dataURItoBlob(canvas.toDataURL("image/jpeg",1));
		 var blob = dataURItoBlob(canvas.toDataURL());
		 KViewer.cacheManager.loadBlob(blob,dummyname,function(fobj)
		 {
			  KViewer.viewports[0].setContent(fobj, {intent:{}});
		 });

		 if (outpath != undefined)	
		 {
			  var savename = outpath;
			  var fileReader = new FileReader()
			  fileReader.onload = function(event) {
				 fs.writeFile( savename, Buffer.from(event.target.result),undefined,function(err)
				 { 
					 var ipc = require('electron').ipcRenderer;
					 if (err == undefined)
					 {
						logProcess('successfully saved ' + savename);
						if (!debug)
							ipc.send('killAll',{code:0});
					 }
					 else
					 {
						logProcess("problems during saving of " + savename);
						logProcess(err);
						if (!debug)
							ipc.send('killAll',{code:1});

					 }
				 });
			  };
			  fileReader.readAsArrayBuffer(blob);

		}

		 logProcess("done")


	  });

}




function loadReportData(data,callback,onerror)
{

		var inpath = data.inpath;
		delete data.inpath;

		var filekeys = Object.keys(data);
        var input = [];
        for (var k = 0; k < filekeys.length;k++)
        {
           if (data[filekeys[k]].name != undefined)
           {
			   input[k] = data[filekeys[k]].name;
			   input[k]= inpath + "/" + input[k];
			   input[k] = input[k].replace(/\/\//g,"/");
			   input[k] = input[k].replace(/\/\//g,"/");
           }
           else  if (data[filekeys[k]].absname != undefined)
           {
			   input[k] = data[filekeys[k]].absname;
           }
        }

        KViewer.cacheManager.loadFile(input,function(fobj)
        {

	        logProcess("loadfile callback");
            if (fobj.length>0)
            {


				//////////////////////// checking for file existence
               for (var k = 0; k < fobj.length;k++)
               {
                   if (fobj[k].error)
                   {
                        alertify.error(fobj[k].error)
                        logProcess(fobj[k].error)
                        if (!debug)
                        {
							if (onerror)
                            	onerror();
   							ipc.send('killAll');                        	
                        }
						return;
                   }
                   else
                   {
                   	  data[filekeys[k]].content = fobj[k].content;
                   	  data[filekeys[k]].fobj = fobj[k];
                   }
               }

			   callback(data);               

            }
        });
}















function report_creator_CVR(args,base)
{

    if (application.substring(0,3) == 'CVR')
    {

  	    var tpmfolder = path.join(base,'TPM');                     // actually only necessary for colbar.png at the moment
   	    var modelfolder = path.join(base,'TPM/refs_new5');         // to get the model.json and modelSVM.json
   	    var antspath = path.join(base,'CVR.sh');                   // this the path to the bash script doing all the ANTs processing
 
	    var agesexref =   getAgeSexRef(args[3],modelfolder);


		// this makes only the report sheet,
		// usage:  CVR agegender pathtosegmentation outnameofsheet
		// result report is in  pathtosegmentation/outnameofsheet
        if  (application == "CVR")  
        {
			var reportname;
			if (args[5] == undefined)
				debug = true;
			else
	       		reportname = path.join(args[4],args[5]);

	  		createCVRsheet(args[4],reportname,args[3], modelfolder, tpmfolder);

        }
        
        // this assumes segmentation is present, and computes zscores/roistats via ants and sheet
        // usage:  CVRstats agegender(3) pathtosegmentation(4) outnameofsheet(5)
		// result report is in  pathtosegmentation/outnameofsheet
        else if  (application == "CVRstats")  
        {
			var reportname;
			if (args[5] == undefined)
			    debug = true;
			else
	        	reportname = path.join(args[4],args[5]);
	    	   
	    	processBASH(
			{
                scriptpath:antspath,
                		 // inpath     outpath,      options   refnum
				argarray: [ args[4]   ,args[4],     1,     agesexref ] 
			}, 
			function (params)
			{
				  createCVRsheet(args[4],reportname,args[3],modelfolder,tpmfolder);							
			});
            
        }
        // this runs full pipeline
	    // usage:  CVRfull agegender(3) pathtoT1(4) outputpathsegmentation(5) outPATHofsheet(6)
	    // if you omit outPATHofsheet, program does not save report and does not close (for debugging)
        else if  (application == "CVRfull")    
        {

			if (args[6] == undefined)
				debug = true;

			var outpath = args[5];
			if (outpath == undefined)
				outpath = createDir( args[4],"VeoMorph");
			else 
				outpath = createDir( outpath);

			if (outpath == undefined)
		    {
		    	logProcess("problems during creation of output directory!!");
		    }


	    	processBASH(
			{
                scriptpath:antspath,
                		 // inpath     outpath,      options   refnum
				argarray: [ args[4]   ,outpath,     0,      agesexref ] 
			}, 
			function (params)
			{
				createCVRsheet(outpath,args[6],args[3],modelfolder,tpmfolder);							
			});
        }

        return true;


    }
    else
    	return false;





}








function createCVRsheet(inpath,outpath,agegender,modelfolder,tpmfolder)
{

		// some general preprations

        var $procframe = $("#KProcFrame");
        if ($procframe.length == 0)
               $procframe = $("<div id='KProcFrame'><img style='position:absolute;width:100%;height:100%;opacity:0.05' src='logo_full.svg'  > <div> </div>  <div class='thespinner'><i class='fa-5x fa fa-spinner fa-spin'></i></div> <div id='KLoadingFrameTypeString'></div> <div id='KLoadingFrameText'></div> </div>").appendTo($(document.body));

        $procframe.click(function()    {       $procframe.hide();      });
        if (debug)
            $procframe.hide();



        ViewerSettings.nVisibleCols = 2
        ViewerSettings.nVisibleRows = 2
        ViewerSettings.nVisibleBarports = 1;
        KViewer.ViewerSettings = ViewerSettings;
        KViewer.defaultFOV_mm = 520;
        KViewer.setViewPortLayout([ViewerSettings.nVisibleRows,ViewerSettings.nVisibleCols]);  
        KViewer.cacheManager.show(KViewer.viewports[15]);                    

        eagerDrawActive = true;
	
        fs = require('fs');
        dialog = require('electron').remote.dialog;


		// get model and subject related meta information
        var model = readModel(modelfolder);
        var gender = model.getGender(agegender);
        var Age = model.getAgeRefNum(agegender);
        var age = Age.bin;       
        var roi_ref_c1_mean = model['mean_rois_c1_' + gender][age]
        var roi_ref_c1_sigma = model['sigma_rois_c1_' + gender][age]
        var roi_ref_c3_mean = model['mean_rois_c3_' + gender][age]
        var roi_ref_c3_sigma = model['sigma_rois_c3_' + gender][age]



		
		// start with report

        var $report = $("<div id='KCVRFrame'></div>").appendTo($(document.body));
        $report.click(function()    {       $report.hide();      });

        $report.append($("<div class='CVRtext' > subjectage:"+Age.age+"  sex:" +gender+"<br>"+(new Date()).toISOString()+"</div>"));
        $report.append($("<div class='CVRzcaption' > z-score overlay for volume changes of GM and CSF </div>"));
		$report.append($("<img class='CVRcolbar' src='" + tpmfolder + "/colbar.png'>"));
        
        var $img1 = $("<div class='CVRimage1'> </div>").appendTo($report);
        var $img2 = $("<div class='CVRimage2'> </div>").appendTo($report);

        var $roilist = $("<div class='CVRroilist'> </div>").appendTo($report);
        var $svmresult = $("<div class='CVRsvmresult'> </div>").appendTo($report);


  



		// get some options		       

        var clim_zscore_c1 = model.getOption([2,6],"clim_zscore_c1");
        var clust_threshold_c1 = model.getOption(750,'clust_threshold_c1');
        var clim_zscore_c3 = model.getOption([3,7],'clim_zscore_c3');
        var clust_threshold_c3 = model.getOption(750,'clust_threshold_c3');
        var threshold_roioutlier = model.getOption(1.5,'threshold_roioutlier');
        var brightnessT1 = model.getOption(1.5,'brightnessT1');



		// do the actual work

        logProcess("Loading Image Resources")

		loadReportData({ inpath : inpath,
						 T1: { name: 'rectT1.nii.gz' } , 
						 zc1: { name: 'zscore_rect_c1.nii.gz' } ,
						 zc3: { name: 'zscore_rect_c3.nii.gz' } ,
						 zc1_MNI: { name: 'zscore_c1.nii.gz' } ,
						 zc3_MNI: { name: 'zscore_c3.nii.gz' } ,
						 roic1: { name: 'roistats_c1.txt' } ,
						 roic3: { name: 'roistats_c3.txt' } ,
						 svmproj: { name: 'projections.txt' } ,
						 atlas: {absname: path.join(tpmfolder,'atlas.nii') } },
		function(data)
		{


				//////////////////////// preprocessing images

				var scalefac = 1.5/data.T1.content.voxSize[0];    // all slice refereces are relative to a 1,5mm template, this factor scales if different res is desired					

				// switch sign of c1
				for (var k = 0; k < data.zc1.content.data.length;k++)
					 data.zc1.content.data[k] *= -1;
				// morphological cleaning on rect_zscores
				var im = data.zc1.content;
				bwconncomp(im.data, im.sizes, function(x) { return x>clim_zscore_c1[0]; }, clust_threshold_c1, im.data);
				var im = data.zc3.content;
				bwconncomp(im.data, im.sizes, function(x) { return x>clim_zscore_c3[0]; }, clust_threshold_c3, im.data);



				// switch sign of c1
				for (var k = 0; k < data.zc1_MNI.content.data.length;k++)
					 data.zc1_MNI.content.data[k] *= -1;
				// morphological cleaning on MNI_zscores
				var im = data.zc1_MNI.content;
				bwconncomp(im.data, im.sizes, function(x) { return x>clim_zscore_c1[0]; }, clust_threshold_c1, im.data);
				var im = data.zc3_MNI.content;
				bwconncomp(im.data, im.sizes, function(x) { return x>clim_zscore_c3[0]; }, clust_threshold_c3, im.data);

				
		



				///////////////////////// parse SVM projections

 				var svmresult = readSVMprojections(data.svmproj.content);		
				//$svmresult.append($("<div> decision: " + model.SVM.classes[svmresult.decision] + "</div>"));
				var $svmplot = $("<div class='svmplot'> </div>").appendTo($svmresult);
				var nclass = model.SVM.classes.length;

				if (model.SVM.type == "onevsone")
				{
					var sum = 0;
					for (var k = 0; k < nclass;k++)
						sum += 1-svmresult.probs[k*nclass+svmresult.decision];
					for (var k = 0; k < nclass;k++)
					{
						var p = Math.round((1-svmresult.probs[k*nclass+svmresult.decision])/sum*100);
						$svmplot.append($("<div class='svmbar' style='height:" + (p+0.1) + "%;'>"+ model.SVM.classes[k] + " (" +  p +"%)</div>"))
					}
					/*
						for (var k = 0; k < nclass;k++)
						{
							var p = 0;
							for (var j = 0; j < nclass;j++)
							{
								p += svmresult.probs[j*nclass+k];
							}
							p = Math.round(p/(nclass-1)*100);
							$svmplot.append($("<div class='svmbar' style='height:" + (p+1) + "%;'>"+ model.SVM.classes[k] + " (" +  p +"%)</div>"))
						}
					*/

					$svmplot.append($("<div class='svmmat'>" + svmresult.pstr + " <br> svmdate:" +model.SVM.date+ "</div>"));
				}
				else
				{
					for (var k = 0; k < nclass;k++)
					{
						var p = Math.round(svmresult.probs[k]*100);
						var addclass="";
						if (k==svmresult.decision)
							addclass = "decision";
						var $tbar = $("<div class='svmbar "+addclass+"' style='height:" + (p+0.1) + "%;'></div>").appendTo($svmplot);
						var $classlabel = $("<div class='''>"+ model.SVM.classes[k]  + "</div>").appendTo($tbar);
						var $probability = $("<div class='''> (" +  p +"%)  </div>").appendTo($tbar);

						
					}					
				}

				//////////////////////// parse and display ROI stats


				KViewer.atlasTool.addAtlas(data.atlas.fobj);
				var stats_c1 = KViewer.atlasTool.computeStats(data.atlas.fobj, data.zc1_MNI.content,function(x) { return ((x>0)?1:0);});
				var stats_c3 = KViewer.atlasTool.computeStats(data.atlas.fobj, data.zc3_MNI.content,function(x) { return ((x>0)?1:0);});


				var outliers = [];
				for (var k in stats_c1)				
				{
					var r = stats_c1[k];
					if (r.mean > 0.1)
						outliers.push({type:'c1',name:r.label.name,mm:r.vol_mm*r.mean,perc:r.mean*100});
				}
				for (var k in stats_c3)				
				{
					var r = stats_c3[k];
					if (r.mean > 0.2)
						outliers.push({type:'c3',name:r.label.name,mm:r.vol_mm*r.mean,perc:r.mean*100});
				}


             //   var outliers = readRoistats(data.roic1.content,data.roic3.content);
             //   outliers = outliers.sort((a,b) => (b.sortval - a.sortval) );
			
				var showRoi ;
				if (1)
				{

	                outliers = outliers.sort((a,b) => (b.mm - a.mm) );

					function showROI_num(r)
					{
						return "<span class='Ktype_"+r.type  +"'  >"+ 
									(r.mm/1000).toFixed(1) +   "mL (" + r.perc.toFixed(0)+ "%)" + " </span>";
					}
				  	var showRoi = showROI_num;
				}
				else
				{

	                outliers = outliers.sort((a,b) => (b.perc - a.perc) );
					function showROI_bar(r)
					{
						return "<div style='width:"+r.perc+"%' class='roibar Ktype_"+r.type  +"'  >"+ r.perc.toFixed(0)+ "%</div>";
					}
					var showRoi = showROI_bar;
				}


				var last_r1 = "";
                for (var k = 0; k < Math.min(8,outliers.length);k++)
                {
                   // if (math.abs(outliers[k].z) < threshold_roioutlier)
                     //   break;
                    var regions  = outliers[k].name.split("/");
                    var lrsign = ((regions[0][0]=='R')?" (R)":" (L)");
                    var r1 = regions[0].substring(2) ;
                    var r2 = regions[1].substring(2).replace(r1,'').replace('_','');

                 	if (last_r1 == r1)
                 	{
                    	$roilist.append($("<div>   <div> "+ r2 + lrsign +": "+showRoi( outliers[k])+"</div></div>"));
                 	}
                 	else
					{
						last_r1 =  r1;
                    	$roilist.append($("<div>  "+r1 + " <div> "+ r2 + lrsign +": "+showRoi( outliers[k])+" </span></div></div>"));
					}
                    
                }



                var vp = KPanelView((KViewer));
                vp.panel.$container.css('z-index',1000)
                vp.setSize(424,530)
                var mv;
                    
                ASyncSerial( [

                ()=> {  logProcess("Rendering top row") },
                ()=> {

                         /// cat some selected views
                         var views = [ {sl:1,num:75,clip:[20,10,80,100],text:"mesiotemporal",LRsign: 'R'},
                                        {sl:0,num:55,clip:[10,10,90,95],text:"",LRsign: 'R'},
                                          {sl:0,num:65,clip:[10,10,90,95],text:"parieto-occipital",LRsign: 'L'},
                                          {sl:2,num:79,clip:[10,10,90,90],text:"" ,LRsign: 'R'},
                                          {sl:1,num:108,clip:[20,10,80,100],text:"fronto-polar", LRsign: 'R'},
                                          {sl:1,num:90,clip:[20,10,80,100],text:"temporo-polar", LRsign: 'R'},
                                          {sl:0,num:61,clip:[20,30,70,90],text:"mesencephal/pons"},

                                               ];
                         vp.setContent(data.T1.fobj, {intent:{cmap:0}});

                         mv = vp.getCurrentViewer();
                         mv.setColorMapLims([mv.histoManager.clim[0],mv.histoManager.clim[1]*brightnessT1]);
                         
                         createImgRow(vp,views,"CVRimageRow LongRow","CVRimageItem",scalefac).appendTo($report);

                },
                ()=> {logProcess("Rendering overlays") },
                ()=> {
                       /// make mosaicview with overlay
                        vp.setContent(data.zc3.fobj, {intent:{transparent:false, overlay:true,cmap:1,clim:clim_zscore_c3}});
                        vp.setContent(data.zc1.fobj, {intent:{transparent:false, overlay:true,cmap:6,clim:clim_zscore_c1}});
                        mv = vp.getCurrentViewer();    

                        var views = [ {sl:0,num:55,clip:[10,10,90,95],LRsign: 'R'},
                                        {sl:1,num:78,clip:[10,10,90,90]},
                                          ];
                        createImgRow(vp,views,"CVRimageRow ShortRow Number1","CVRimageItem",scalefac).appendTo($report);

                        var views = [ {sl:0,num:65,clip:[10,10,90,95],LRsign: 'L'},
                                        {sl:2,num:78,clip:[10,10,90,90]},
                                          ];
                        createImgRow(vp,views,"CVRimageRow ShortRow Number2","CVRimageItem",scalefac).appendTo($report);


                     
                },
                ()=> { logProcess("Rendering mosaic") },
                ()=> {
                       /// make mosaicview with overlay
                  
                        mv = vp.getCurrentViewer();    
                        //mv.histoManager.setColorMapLims([0,400])
                        mv.setSlicingDimOfWorld(2);
                        mv.mosaicview.nx = 4;
                        mv.mosaicview.zoom=-1;
                        mv.mosaicview.start = 0.15;
                        mv.mosaicview.end = 0.7;
                        mv.mosaicview.mosaic_direction = true;
                        mv.setInnerLayout();
                        mv.switchToMosaic()
                        $img1.append( crop(vp) );
                     
 //vp.kill()
 //return "break";
 
                },
                ()=> { logProcess("Rendering 3D") },
                (callback)=> {


						callback()
						 return
                        var mv = vp.getCurrentViewer();    
                        // make a 3D example
                        //mv.histoManager.setCmap(0);
                        mv.switchTo3D(function()
                        {
                           mv.gl.camera.radius = 301;
                           mv.gl.camera.alpha = .5;
                           mv.gl.camera.beta = 1.2
                           mv.setWorldPosition(math.matrix([30,-80,-30,1]))
                           signalhandler.send('positionChange');
                           var ovl = mv.overlays[0];
                           ovl.histoManager.clim = [100,200]
                           mv.attachSurfaceRef(ovl,ovl.content)                   
                           waiter(()=> ovl.refSurfView != undefined , ()=>                       
                               {
                                  ovl.refSurfView.alphaMode=2;
                                  ovl.refSurfView.alpha=0.6;
                                  ovl.refSurfView.update();
                                  setTimeout(function()
                                  {
                                      $img2.append( crop(vp,[20,20,80,100]));
                                      callback();
                                  },0);
                               },200,20);

                       });

                },
                ()=> {
                      logProcess("saving")
                      save($report,vp,outpath,"veomorph.png");
                }
                ]) //AsyncSerial





			function readSVMprojections(content)
			{
				   var lines = content.split("\n");
				   var arr = [];
				   for (var k = 1; k < lines.length-1; k++)
					  arr.push(parseFloat(lines[k].split(" ")[1]));

				   var arr2 = []
				   for (var k = 0; k < arr.length/3; k++)
					  arr2.push(arr[3*k]+arr[3*k+1]+arr[3*k+2]);

				   var nclass;
				   if (model.SVM.type == "onevsone")
				   {
 			   	  	   nclass = 0.5 + Math.sqrt(0.25 + 2*arr2.length)

					   var score = [];
					   var prob = [];
					   var cnt = 0;
					   for (var k =0;k < nclass; k++)
					   {
						   score[k*nclass+k] = 0;
						   prob[k*nclass+k] = 0;
						   for (var j =k+1;j < nclass; j++)
						   {
							  score[j*nclass+k] = arr2[cnt];
							  score[k*nclass+j] = -arr2[cnt];
							  prob[j*nclass+k] = model.SVM.scoreTransform[cnt](arr2[cnt])
							  prob[k*nclass+j] = (1-prob[j*nclass+k]);
							  cnt++;
						   }
					   }

					   var votes = [];
					   for (var k =0;k < nclass; k++)
					   {
						   votes[k] = 0;
						   for (var j =0;j < nclass; j++)
							   votes[k] += Math.sign(score[j*nclass+k]);					   	
					   }

					   var decision = math.argmax(votes);


					   var str = "";
					   var str2 = "";
					   for (var k =0;k < nclass; k++)
					   {
							for (var j =0;j < nclass; j++)
							{
								str += score[j*nclass +k].toFixed(3) + " ";
								str2 += (prob[j*nclass +k]).toFixed(2) + " ";
							}
							str += "\n";
							str2 += "<br>";
					   }

						console.log(str2);

				 

				   }
				   else  if (model.SVM.type == "onevsall")
				   {
					    var score = [];
					    var prob = [];
				   	
				   		nclass = arr2.length;
					    for (var k =0;k < nclass; k++)
					    {
						   score[k] =  arr2[k];
						   prob[k] =  model.SVM.scoreTransform[k](arr2[k])
					    }

					    var decision = math.argmax(prob);
					    var votes = undefined;
					    var str2 = "";
					    for (var k =0;k < nclass; k++)
					    {
							str2 += (prob[k]).toFixed(2) + " ";
 					    }

				   }
				   



		

				   return {scores:score, probs:prob, votes:votes, decision:decision , pstr:str2};


			}



			function readRoistats(str_c1,str_c3)
			{
			   var rois = []
			   var lines_c1 = str_c1.split("\n");
			   var lines_c3 = str_c3.split("\n");
			   for (var k = 1; k < lines_c1.length-1; k++)
			   {
				   var entries_c1 = lines_c1[k].split(",");
				   var entries_c3 = lines_c3[k].split(",");
				   var z_c1 = (entries_c1[4]-roi_ref_c1_mean[k-1]) / roi_ref_c1_sigma[k-1];
				   var z_c3 = (entries_c3[4]-roi_ref_c3_mean[k-1]) / roi_ref_c3_sigma[k-1];
				   var proc_c1 = 100 * (entries_c1[4]-roi_ref_c1_mean[k-1]) / roi_ref_c1_mean[k-1];
				   var proc_c3 = 100 * (entries_c3[4]-roi_ref_c3_mean[k-1]) / roi_ref_c3_mean[k-1];
				   var mm_c1 = z_c1*entries_c1[2];
				   var mm_c3 = z_c3*entries_c3[2];

				   var sortval = 0;
				   if (mm_c1 < 0)
				   	  sortval = -mm_c1;
				   rois.push({name:entries_c1[0],size:entries_c1[2],z:z_c1,mm:sortval,proc:-proc_c1,type:'c1',sortval:sortval});

				   var sortval = 0;
				   if (mm_c3 > 0)
				   	  sortval = mm_c3;
				   rois.push({name:entries_c3[0],size:entries_c3[2],z:z_c3,mm:sortval,proc:proc_c3,type:'c3',sortval:sortval});
			   }
			   return rois;

			}

  

        

		});

 }
