<?php

function getRoute()
{

   // fallback on old stlye
   if (!isset($GLOBALS['settings']->dir_routes))
   {
      $GLOBALS['settings']->dir_routes = json_decode(file_get_contents(DPXROOT . '/conf/dir_routes.conf'));
      error_log('fallback on old dir_routes');
   }

    $hostname = gethostname();
    $dataroutes = $GLOBALS['settings']->dir_routes->{'*'};
    if (isset($GLOBALS['settings']->dir_routes->$hostname))
    {
    	$localroute = $GLOBALS['settings']->dir_routes->$hostname;
    	foreach ($localroute as $key => $val)
        	$dataroutes->$key = $val;
    }
    return $dataroutes;
}


function resolve_Route($fname)
{
    $dataroutes = getRoute();
    if ($fname[0] == ':')
    { 
//        error_log("routing   " .$fname);    
        $idx = strpos(substr($fname,1),':');
        if ($idx == false)
        {
            error_log("problem in route pattern in filename");
            return $fname;
        }
        $key = substr($fname,1,$idx);
        $route = $dataroutes->$key;
        if ($route == null)
        {
             error_log("the route " . $key . " not found for host " . gethostname());
             return $fname;
        }
        $route = str_replace('$DPXROOT', DPXROOT, $route);
        $route = $route . "/" .  substr($fname,$idx+2); 
        // remove possibly double slash from cat
        return str_replace("//", "/", $route);  

    }
    else
    {
	    $route = str_replace('$DPXROOT', DPXROOT, $fname);
        return str_replace("//", "/", $route);  
    	//return $route;
    }
    

}

function encode_Route($fname)
{
    $dataroutes = getRoute();

    if ($dataroutes == null)
      return $fname;
	
	$bestmatch = $fname;
	$bestmatchlen = 0;
	
    foreach($dataroutes as $tag => $path)
    {
        // add a trailing slash
        if ($path[strlen($path)-1] != '/')
          $path = $path . '/';
        
        // replace the DPXROOT var
        $path = str_replace('$DPXROOT', DPXROOT, $path);

		// we CANNOT take the first match, must take the BEST match (in terms of numbers
        $tlen = strlen($path);
        if ($path == substr($fname,0,strlen($path)) && $tlen > $bestmatchlen)
        {
			$bestmatch = ":" . $tag . ":" . substr($fname,strlen($path));
			$bestmatchlen = $tlen;
            //return ":" . $tag . ":" . substr($fname,strlen($path));
        }
    }

    return $bestmatch;
}

?>