<?php 


require_once('session.php');

require_once('synchronizer.php');


session_write_close(); // do not lock other php script from this session



function syncRequest($url_sync,$cloud_project,$cloud_username,$cloud_password,$local_project,$mode)
{

    // get DBs
    $cloudDB = postRequest($url_sync,$cloud_username,$cloud_password,$cloud_project,"getDB");
      
    $projObj =  getProject($local_project);
    $localDB = getProjectContent($local_project);


    // update local tables and get the ones missing in cloud
    $missing_in_cloud = array();
    $files_to_download = null;
    foreach($localDB as $name => $row)
    {
      $tmp = extendTable($localDB,$cloudDB,$name,$local_project);
      $missing_in_cloud[$name] = $tmp['missing'];
      $missing_in_locally[$name] = $tmp['updated'];
      $size_missing_in_cloud[$name] = sizeof($tmp['missing']);
      $size_missing_in_locally[$name] = sizeof($tmp['updated']);

    }
    $files_to_download = $missing_in_locally['files'];    
    $files_to_upload = $missing_in_cloud['files'];

  
    $upload_size = 0;
    foreach ($files_to_upload as $key => $file)
        $upload_size += $file['filesize'];
    $download_size = 0;
    foreach ($files_to_download as $key => $file)
        $download_size += $file['filesize'];
    
    
    echo json_encode(array('upload_size'=>$upload_size,'download_size'=>$download_size,'cloud'=>$size_missing_in_cloud,'local'=>$size_missing_in_locally)) . PHP_EOL;
    
    unset($missing_in_cloud['files']);
    
    if ($mode == 'bidir' | $mode == 'pull')
    {

		// download and add entries to DB
		$db = mydbconnection($local_project);    
		$cnt = 0;
		$already_downloaded_size = 0;
		$startedtime = time();

		foreach ($files_to_download as $key => $file)
		{
			$fileID = $file['ID'];

			// compute file destination
			$patrow = $db->query("select * from patients where PIZ='".$file['patients_id']."'")->fetch_assoc();
			$studrow = $db->query("select * from studies where StudyID='".$file['studies_id']."' AND patients_id='".$file['patients_id']."'")->fetch_assoc();
			$filedest = resolve_Route(hdr2PatientFolder($file['patients_id'],$file['studies_id'],$patrow,$studrow,$projObj['importfolder']));

			$fname = "";
			if ($file['SubFolder'] == "")
			  $fname = '/' . $file['Filename'];
			else 
			  $fname = '/' .$file['SubFolder'] . '/' . $file['Filename'];
			$filedest .= $fname;

			$fileshow = $file['patients_id'] . $file['studies_id'] . "   " . $fname;

			$file['FilePath'] = encode_Route($filedest);


			$already_downloaded_size += $file['filesize'];
			$elapsed = time()-$startedtime;
			$est_left_time = $elapsed * $download_size / $already_downloaded_size  - $elapsed;	
			$byte_left = $download_size - $already_downloaded_size;


			$cnt++;



			// inquirey download 
			if (!postRequestBinary($url_sync,$cloud_username,$cloud_password,$cloud_project,
						  "download_file",array("fileID"=>$fileID),$filedest))
					echo json_encode(array("error"=>1,"download"=>1,"cnt"=>$cnt,"name"=> $file['patients_id'] . "  " . $fname, "filesize"=>$file['filesize'])) . "\n";
			else
			{
				updateRow($db,'files',$file);        
					echo json_encode(array("download"=>1,"cnt"=>$cnt,"name"=> $file['patients_id'] . "  " . $fname, "filesize"=>$file['filesize'], 'est_time_left' => $est_left_time, 'byte_left' => $byte_left)) . "\n";
			}


			ob_flush();
			flush();

		}   

    }


    
    
    if ($mode == 'bidir' | $mode == 'push')
    {

		//send missings subjects/studies DB entries to cloud    
		postRequest($url_sync,$cloud_username,$cloud_password,$cloud_project,"updateDB",$missing_in_cloud);    
    

		$cnt = 0;
		$already_uploaded_size = 0;
		$startedtime = time();

		foreach ($files_to_upload as $key => $file)
		{
			$fname = "";
			if ($file['SubFolder'] == "")
			  $fname = '/' . $file['Filename'];
			else 
			  $fname = '/' .$file['SubFolder'] . '/' . $file['Filename'];



			$already_uploaded_size += $file['filesize'];
			$elapsed = time()-$startedtime;
			$est_left_time = $elapsed * $upload_size / $already_uploaded_size  - $elapsed;	
			$byte_left = $upload_size - $already_uploaded_size;


			if (!postFileBinary($url_sync,$cloud_username,$cloud_password,$cloud_project,$file))
				echo json_encode(array("error"=>1,"upload"=>1,"cnt"=>$cnt,"name"=> $file['patients_id'] . "  " . $fname, "filesize"=>$file['filesize'])) . "\n";
			else
			{
					echo json_encode(array("upload"=>1,
											"cnt"=>$cnt,
											"name"=> $file['patients_id'] . "  " . $fname, 
											"filesize"=>$file['filesize'],
											'est_time_left' => $est_left_time, 
											'hello'=> array('s' => $startedtime,
															't' => time(),
															'u' => $upload_size , 
															'a' => $already_uploaded_size),

											'byte_left' => $byte_left  )) . "\n";
			}
 		    ob_flush();
			flush();

			$cnt++;


		}

       
    }
    
    
    
    
    
    
}









//$url = 'http://10.224.50.240/miracs/htdocs';

/*

$url = 'http://10.224.50.240/miracs/htdocs';
//$url = 'http://192.168.178.117/VEO';


$cloud_project = "WHATEVER";
$cloud_username ="reisertm";
$cloud_password ="r";
$local_project = $cloud_project;
*/

$url = $_POST['cloudurl'];
$cloud_project = $_POST['project'];
$cloud_username = $_POST['user'];
$cloud_password = $_POST['passwd'];
$local_project = $_POST['localProject'];
$mode = $_POST['mode'];
$url_sync = $url . '/syncServe.php';


$db = mydbconnection(ROOTDB);
$a = $db->query("SELECT * FROM users WHERE username LIKE '".$_SESSION['username']."'");
$row = $a->fetch_assoc();
$db->close();


syncRequest($url_sync,$cloud_project,$cloud_username,$cloud_password,$local_project,$mode);


ob_end_flush();
flush();
