<?php 

require_once('settings.php');
require_once('mydbconnection.php');
require_once('patientTable.php');
require_once('login.php');


function getProjectContent($project)
{
    $db = mydbconnection($project);

    if ($db->connect_error != null)
    {
         echo json_encode(array('error'=>'database error: ' . $db->connect_error));
	error_log($db->connect_error);
        die();
    }
    
    
    
    $content = array(
                "patients" => getTable("patients",$db,['PIZ']),
                "studies" => getTable("studies",$db,['patients_id','StudyID']), 
                "files" => getTable("files",$db,['patients_id','studies_id','SubFolder','Filename']) 
                );

    $db->close();
    return $content;
}

function getTable($name,$db,$ID)
{
    $a = $db->query("SELECT * FROM " .  $name);
    $content = array();
    if ($a)
    {
        while($row = $a->fetch_assoc())
        {
	    $id = '';
	    for ($k=0;$k < sizeof($ID);$k++)
	      $id .= $row[$ID[$k]];        
            $content[$id ] = $row;
        }
    }
    return $content;

}






function extendTable($destDB,$srcDB,$name,$dest_project)
{
    if ($destDB == null)
        $local = array();
    else
        $local = $destDB[$name];
        
    $cloud = $srcDB[$name];
    
    $db = mydbconnection($dest_project);    
    $updated = array();
    
    foreach($cloud as $key => $row) {
            if (!isset($local[$key]))
            {
                 $updated[$key] = $row;
                 if ($name == 'files')
                 {
		//    echo "update scheduled " . $key . "\n";
                 }
                 else
                 {
                //    echo "updating " . $key . "\n";
                    updateRow($db,$name,$row);
                 }
            }
       }

    $diff = array();
    foreach($local as $key => $row) {
            if (!isset($cloud[$key]))
            {
                 $diff[$key] = $row;
              //   echo "missing " . $key . "\n";
            }
       }
              
               
    $db->close();
    return array('missing' => $diff, 'updated' => $updated);
}











function hdr2PatientFolder($piz,$sid,$patrow,$studrow,$importfolder)
{

  $folder = hdr2PatientPath($piz,$sid,$patrow,$studrow,$importfolder);
  $folder = $importfolder->datapath . '/' . $folder;  

  return $folder;

}



function hdr2PatientPath($piz,$sid,$patrow,$studrow,$importfolder)
{
  $folder = $importfolder->patientfolderpattern;
  $folder = str_replace(  '<name>', $patrow['FamilyName'],$folder);
  $folder = str_replace(  '<givenname>', $patrow['GivenName'],$folder);
  $folder = str_replace(  '<piz>', $piz,$folder);
  $folder = str_replace(  '<sid>', str_replace('#','',$sid),$folder);
  $folder = str_replace(  '<date>',$studrow['StudyDate'],$folder);
  
  return $folder;

}




function getRoute()
{

   // fallback on old stlye
   if (!isset($GLOBALS['settings']->dir_routes))
   {
      $GLOBALS['settings']->dir_routes = json_decode(file_get_contents(DPXROOT . '/conf/dir_routes.conf'));
      error_log('fallback on old dir_routes');
   }

    $hostname = gethostname();
    if (isset($GLOBALS['settings']->dir_routes->$hostname))
        $dataroutes = $GLOBALS['settings']->dir_routes->$hostname;
    else
        $dataroutes = $GLOBALS['settings']->dir_routes->{'*'};
    return $dataroutes;
}


function resolve_Route($fname)
{
    $dataroutes = getRoute();
    if ($fname[0] == ':')
    { 
        error_log("routing   " .$fname);    
        $idx = strpos(substr($fname,1),':');
        if ($idx == false)
        {
            error_log("problem in route pattern in filename");
            return $fname;
        }
        $key = substr($fname,1,$idx);
        $route = $dataroutes->$key;
        if ($route == null)
        {
             error_log("the route " . $key . " not found for host " . gethostname());
             return $fname;
        }
        $route = $route . "/" .  substr($fname,$idx+2); 
        // remove possibly double slash from cat
        return str_replace("//", "/", $route);  

    }
    
    return $fname;

}

function encode_Route($fname)
{
    $dataroutes = getRoute();

    if ($dataroutes == null)
      return $fname;
 
    foreach($dataroutes as $tag => $path)
    {
        if ($path[strlen($path)-1] != '/')
          $path = $path . '/';
        if ($path == substr($fname,0,strlen($path)))
        {
            return ":" . $tag . ":" . substr($fname,strlen($path));
        }
    }


    return $fname;

}




function updateRow($db,$table,$row)
{

   $a = mysqli_query($db, "SHOW COLUMNS from " . $table);
   $sqlkeys = array();
   while($r = $a->fetch_assoc())
     $sqlkeys[] = $r['Field'];

   $keys = array_keys($row);
   $keysStr = "(";
   $valsStr = "(";
   $updateStr = "";
   for($k=0;$k<sizeof($keys);$k++)
   {
      $found = false;
      for ($j=0;$j<sizeof($sqlkeys);$j++)
        if ($sqlkeys[$j] == $keys[$k])
        {
          $found = true;
          break;
        }

      if ($found)
      {
        $keysStr = $keysStr . $keys[$k] . ",";
        $valsStr = $valsStr . "'" . ($db->real_escape_string($row[$keys[$k]])) . "',";
        $updateStr = $updateStr . " " . $keys[$k] . " = VALUES(" . $keys[$k] . ")," ;
      }
      else
      {
        error_log("updatRow: warning: tried to update/insert '" . $keys[$k] . "' into '" .$table. "', but not present.");
      }
   }
   $valsStr = trim($valsStr,",") . ")";
   $keysStr = trim($keysStr,",") . ")";

   if ($valsStr == '()')
      return;


   $qf = "INSERT INTO " . $table . " " . $keysStr . " VALUES " . $valsStr .
         " ON DUPLICATE KEY UPDATE " . trim($updateStr,",");         
    return $db->query($qf);
}


function getProject($project)
{
   $db = mydbconnection(ROOTDB);
   $querystring = "SELECT * FROM projects where name = '".$project."'";
  
   if( ($a = $db->query($querystring)) )
   {
       $row = $a->fetch_assoc();
       $row['cmddesc'] = json_decode(str_replace("\n","",$row['cmddesc']));
       $row['jsondesc'] = str_replace("\\","\\\\",$row['jsondesc'] );
       $row['jsondesc'] = str_replace('\"','"'   ,$row['jsondesc'] );
       $jsondesc = json_decode( $row['jsondesc'] );
       $row['jsondesc'] = $jsondesc;
       
       if ($jsondesc  instanceOf stdClass)
       {
         if ($jsondesc->datafolders instanceOf stdClass)
            $row['importfolder'] = $jsondesc->datafolders;
          else
            $row['importfolder'] = $jsondesc->datafolders[$jsondesc->importfolder];
       } 
  }
  $db->close();
  return $row;

}






function send_file($projectDatabase,$fileID)
{
    $db = mydbconnection( $projectDatabase);
    $a = $db->query("SELECT *  FROM files as tf JOIN patients as tp JOIN studies as ts WHERE tf.ID='".$fileID."' AND tp.PIZ = ts.patients_id AND ts.StudyID = tf.studies_id  AND tp.PIZ = tf.patients_id");
    $filerow = $a->fetch_assoc();
    $filePath = resolve_Route($filerow['FilePath']);


    error_log("name:" . ($filePath));
    error_log("size:" . filesize($filePath));
    error_log("Content-Type: " . mime_content_type ($filePath ));
    header("X-Sendfile: ".$filePath);
    header("Content-Type: " . mime_content_type ($filePath ));
    header('Content-Length: '.filesize($filePath));
    header('Content-Disposition: attachment; filename="' . basename($filePath) . '"');

    $db->close();
    
}












   
function postRequest($url,$username,$password,$project,$cmd,$args=null)
{   // get cloud db
    $data = array("username"=>$username,"passwd"=>$password, "project" => $project , "command" => $cmd, "args" => json_encode($args));
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    
    curl_close($ch);
    if ($response == false || $code==404)
    {

	echo json_encode(array("error"=> "server error or wrong address code:" . $code . "! " . $url . " \n" .print_r($data,true))) . PHP_EOL;
	die();
    }
    $res = json_decode($response,true);    
    if (isset($res['error']))
    {
	echo json_encode($res) . PHP_EOL;
	die();
    }

    return $res;
}



function postRequestBinary($url,$username,$password,$project,$cmd,$args,$dest)
{ 

    $dname = dirname($dest);
    if (!@mkdir( $dname, 0755, true ))
    {
	$err = error_get_last()['message'];
	if (strpos($err , "exists" ) == false)
	{
	  echo json_encode(array("lasterror"=>"cannot create directory " . $dname . ": " . $err)) .  PHP_EOL;
	  return false;    
	}
    }
    

    $fp = fopen($dest, 'w');
    if ($fp == false)
    {
        echo json_encode(array("lasterror"=>"cannot open file " . $dest . " for writing ")) .  PHP_EOL;
        return false;
    }
      
    $data = array("username"=>$username,"passwd"=>$password, "project" => $project , "command" => $cmd);
    $data["args"] = json_encode($args);
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
    curl_setopt($ch, CURLOPT_FILE, $fp);
    $file = curl_exec($ch);
    $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
 
    if ($file == false || $code == 404)
    {
        echo json_encode(array("lasterror"=>"file" . $dest . " was not received")) .  PHP_EOL;    
        return false;
    }
    curl_close($ch);
    fclose($fp);
    
    return true;
    
}

function postFileBinary($url,$username,$password,$project,$file)
{
    $cfile = new CURLFile(resolve_Route($file['FilePath']));//,'application/xml', $file['Filename']); 

    
    $data = array("username"=>$username,"passwd"=>$password, "project" => $project , "command" => 'updateFile', 'filerow' => json_encode($file), 'file'=>$cfile);
    
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $header = array('Content-Type: multipart/form-data');
    curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
    $response = curl_exec($ch);
    $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    
    curl_close($ch);
    if ($response == false)
    {
        echo json_encode(array("lasterror"=>"file " . resolve_Route($file['FilePath']) . " was not found")) .  PHP_EOL;    
  	return false;
    }
    if ($code==404)
    {
        echo json_encode(array("upload"=>1,"lasterror"=>"cloud not reachable" )) .  PHP_EOL;    
  	die();
    }
    
    $res = json_decode($response,true);    
    if (isset($res['lasterror']) | $res['error'])
    {
	echo json_encode($res) . PHP_EOL;
	die();
    }

    return true;
    
    
    
    
    
    $res = json_encode($response_upload);
    if ($res['success'])
        return true;
    else
        return false;
}








