<?php



require_once('session.php');

// =================  http headers: Set content type. Force page reload for development purposes
header("Cache-Control: no-cache, no-store, must-revalidate"); // HTTP 1.1.
header("Pragma: no-cache"); // HTTP 1.0.
header("Expires: 0"); // Proxies.


header('Content-type: text/html; charset=utf-8');

// include other script files

// =================  Some global variables
define("riddelim","§");
define("project_user_delim","___");
define("NORA_ESEP","NORA_ERROR_SEPARATOR");
define("NORA_LOG","NORA_LOG:");
  
if(!defined("JSON_UNESCAPED_SLASHES"))
   define("JSON_UNESCAPED_SLASHES",64);

  
require_once('routes.php');
require_once('settings.php');
define("guestuser",GUESTUSER);


ini_set('error_log',resolve_Route(VARPATH . '/syslogs/apache.log'));


require_once('mydbconnection.php');
require_once('patientTable.php');
require_once('login.php');
require_once('miscfuns.php');


// merge get and post array to $_GET only. Convenience
if(sizeof($_POST)>0) {   $_GET = array_merge($_GET,$_POST);}

umask(0); // rights/permissions for saving/creating of files

// ================== debug ====================================
/*
error_log("-------------------------------------------------");
*/

if (isset($_GET['isalive']))
{
  if (isset($_SESSION['username']))
  {

    if($_SESSION['userinfo']['isadmin'] == '1')
    {
       echo "NORA is alive";
       return;
    }
    
    $db = mydbconnection(ROOTDB);
    if( ($a = $db->query( "SELECT * FROM rights where project='" . $_GET['project'] . "' AND username='".$_SESSION['username']."'")) )
    {
        if ($a->fetch_assoc())
        {
           echo "NORA is alive";
           return;
        }
    }
  }
  
  echo "NORA is dead";
  return;
}

if (isset($_GET['ignoreProject']) && $_GET['ignoreProject'] == 'true')
{
   $_GET['project'] = "";
} 	

if (!isset($_SESSION['current_pids']))
{
	$_SESSION['current_pids'] = array();
}


if (!isset($_SESSION['public_projects']))
{

  $public_projects = array();
  $db = mydbconnection(ROOTDB);
  if( ($a = $db->query( "SELECT * FROM rights where username='".guestuser."'")) )
  {
      while($row = $a->fetch_assoc())
        $public_projects[$row['project']] = true;
  }

  $_SESSION['public_projects'] = $public_projects;
}

// ================ manage the login/signup ===========================


handleSignup();

handleLogin();



// =================  fileupload  ============================
if(isset($_FILES["theROI"]))
{
  echo fileuploadBinary();
  return;
}

if(isset($_FILES["thefile"]))
{
  echo fileuploadDICOM();
  return;
}



// =================  This is for the viewer: Redirect to the required file ID or query

if(isset($_GET['fileID']))
{
  redirectToFile($_GET['fileID']);
  return;
}

if(isset($_GET['selectProject'])) // comes as ajax ...
{
    if ($_GET['selectProject'] != "undefined")
    {
      $json =   selectProject($_GET['selectProject'],false);     
      echo json_encode($json);
      return;
    }
}




$db = mydbconnection(ROOTDB);




// =========================== answer the request ====================

if(isset($_GET['command']))
{


  // not necessarily a project is transmitted, eg when getting a global json Table list
  if( isset($_GET['project']) )
  {
    $project = $_GET['project'];    
    $thestate = $_SESSION['state'][$project];  
//    $thestate->viewer->selectionMode = $_GET['selmode'];
  }



  // check if this is actually a queue
  if($_GET['command'] === 'ajaxQueue')
  {
    $out = array('success'=>true, 'msg'=>'');
    $list = json_decode($_GET['json'],false);
    foreach($list as $e)
    {

        $fields = array_keys((array) $e);
        for ($k=0;$k < sizeof($fields);$k++)
        {
          $fname = $fields[$k];
          if ($fname == 'state')
            deepExtend($_SESSION['state'][$project] , $e->state, true ) ; // why was this a false???
          else if($fname !== 'json' )
            $_GET[$fname] = $e->$fname;
        }

        if (!isset($e->json))
          $tempout  =  evalCommand($e->command);
        else
          $tempout  =  evalCommand($e->command, $e->json );

        $out['json'][] = $tempout;
    }
    send_ajax_return($out);
  }
  else
  {
    if (!isset($_GET['json']))
      send_ajax_return( evalCommand($_GET['command'] ));
    else
      send_ajax_return( evalCommand($_GET['command'], json_decode($_GET['json']) ) );
  }
  return false;
}


if(isset($_GET['ajax']))
{
  send_ajax_return( renderAjaxResponse( $_GET['ajax'] ) );
  return false;
}


// ======================= this should be used for every ajax return / command. Performs additional checks, like checking for new software updates / changes 
function send_ajax_return( $json)
{
    if (defined("SOFTWAREVERSION"))
      if(isset( $_SESSION['softwareversion'])  && SOFTWAREVERSION !=  $_SESSION['softwareversion'])
      {
        $json['versionmanagment'] = array("isupdated" => true, "softwareversion" => SOFTWAREVERSION);
      }

    // check for new notifications. but only if the this command is not to delete one, otherwise recursive loop ...
    if( true && isset($_GET['command']) && $_GET['command'] !== 'delete_notification'  ) 
    {    
      $rows = array();
      $db = mydbconnection(ROOTDB);
      $a = $db->query( "SELECT * FROM notifications WHERE  username LIKE '$_SESSION[username]'  " );
      if($a)
      {
        while($row = $a->fetch_assoc())
          $rows[] = $row;
      }

      if(!empty($rows))
      {
        $json['notifications'] = $rows;
      }
    }

    echo json_encode($json);
    return false;
}

// =================  synchronize the generic state: get it from javascript via a "bootstrap" ============================

if( !isset($_GET['genericstate']) )
{
  echo getGenericStateByJavascript();
  die();
}
else
{
  $_SESSION['genericstate'] = json_decode( $_GET['genericstate'], false );
  //var_dump( $SESSION['genericstate'] );  die();
}

$db->close();


//////////////////////////////////////////////////////////////////////////////////////
// =========== get the modules from database ========================
// ==. only on F5 therefore after ajax / command and so on.
// read all allowed projects together with rights and role and so on. -
//////////////////////////////////////////////////////////////////////////////////////

loadAllProjectInfo();




$project = "";

if (isset($_GET['project']))
{

    $project = $_GET['project'];
    if (isset($moduleInfo[$_GET['project']]))
    {

      if (!isset($_SESSION['state'][$project]))
      {
        selectProject($project,true);      
        $_GET['project'] = $project; 

      }

      if(isset($_GET['state']))
         deepExtend($_SESSION['state'][$project] , json_decode($_GET['state']), true ) ; // why was this a false???
    }
    else
      {

      }
}




////////////////////////////////////////////////////////////////
//if(!isset($_SESSION['softwareversion']))
// always set the newest software version after a full update
// To be done: put as suffix in all .js and .css, but not for developers
$_SESSION['softwareversion'] = SOFTWAREVERSION;




////////////////////////////////////////////////////////////////
// 

if(!isset($_SESSION['state']))
   $_SESSION['state'] = array();



////////////////////////////////////////////////////////////////
// read static, project independent variables 

//if (!isset($_SESSION['static']))
{
  $_SESSION['static'] = (object) array();
  $_SESSION['static']->guestuser = guestuser;

  if (isset($_GET['project']) && isset( $_SESSION['public_projects'][$_GET['project']]) )
  {
    $_SESSION['static']->public_projects = true;
  }
  $_SESSION['static']->DPXALIAS = DPXALIAS;
  $_SESSION['static']->SGE_QUEUES = $GLOBALS['settings']->SGE_QUEUES;
  $_SESSION['static']->MATLAB_QUEUES = $GLOBALS['settings']->MATLAB_QUEUES;
  $_SESSION['static']->SLURM_QUEUES = $GLOBALS['settings']->SLURM_QUEUES;
  $_SESSION['static']->DEFAULTQUEUE = $GLOBALS['settings']->DEFAULTQUEUE;
  if (isset($GLOBALS['settings']->RESTRICT_QUEUE_RIGHTS))
      $_SESSION['static']->RESTRICT_QUEUE_RIGHTS = $GLOBALS['settings']->RESTRICT_QUEUE_RIGHTS;
  if (isset($GLOBALS['settings']->ADMIN_QUEUES))
      $_SESSION['static']->ADMIN_QUEUES = $GLOBALS['settings']->ADMIN_QUEUES;
  if (isset($GLOBALS['settings']->devicesupport))
    $_SESSION['static']->devicesupport = $GLOBALS['settings']->devicesupport;
  if (isset($GLOBALS['settings']->PYTHON_ADDPATH))
    $_SESSION['static']->PYTHON_ADDPATH = $GLOBALS['settings']->PYTHON_ADDPATH;
  if (isset($GLOBALS['settings']->jupyter))
    $_SESSION['static']->jupyter = $GLOBALS['settings']->jupyter;
  if (isset($GLOBALS['settings']->defaultenvs))
    $_SESSION['static']->defaultenvs = $GLOBALS['settings']->defaultenvs;
  if (defined("REPORT_JSERRORS"))
    $_SESSION['static']->error_reporting = REPORT_JSERRORS;

   $_SESSION['static']->ldapenabled = LDAPENABLED;
   
   $_SESSION['static']->startup_macros = $GLOBALS['settings']->startup_macros;
   if (isset($GLOBALS['settings']->jail))
   {   	
       if (isset($GLOBALS['settings']->jail->resources))           
            $_SESSION['static']->jail_resources = $GLOBALS['settings']->jail->resources;
   }

  if (defined('ATLASPROJECT') && !isset($_SESSION['static']->atlas))
  {
    $atlasproject = ATLASPROJECT;
    $db = mydbconnection($atlasproject);
    if (!$db->connect_error)
    {
		$a = $db->query("SELECT * FROM files WHERE patients_id LIKE '". ATLASPID ."' AND studies_id LIKE '". ATLASSID ."' AND Tag LIKE '%/atlas/%'");
		if ($a)
		{
		  $_SESSION['static']->atlas = (object) array('project'=> $atlasproject , 'available' => array());
		  while($row = $a->fetch_assoc())
		  {
			$_SESSION['static']->atlas->available[] = $row;
		  }
		}
    }
  }

  $_SESSION['static']->spmbatches =  (object) array();
  if ($handle = opendir(DPXROOT . '/src/spmbatches')) {
    while (false !== ($entry = readdir($handle))) {
        if ($entry != "." && $entry != ".." && strpos($entry,"_job.m") !== false) {
            $thebatch = file_get_contents(DPXROOT . '/src/spmbatches' . '/' . $entry);
            $name = str_replace('_job.m','',$entry);
            $name = str_replace('SPM_','',$name);
            $_SESSION['static']->spmbatches->$name = $thebatch;
            //error_log("$entry\n");
        }
    }
    closedir($handle);
   }


$_SESSION['static']->softwareversion = SOFTWAREVERSION;


  $_SESSION['static']->forms =  (object) array();
  if ($handle = opendir(DPXROOT . '/src/forms')) {
    while (false !== ($entry = readdir($handle))) {
        if ($entry != "." && $entry != ".." && (strpos($entry,".json") !== false || strpos($entry,".html") !== false)) {
            $theform = (file_get_contents(DPXROOT . '/src/forms' . '/' . $entry));
            $name = str_replace('.json','',$entry);
            $_SESSION['static']->forms->$name = $theform;
        }
    }
    closedir($handle);
   }
 

    // these will also go into the conf routines soon
    $thecfg = (object) array();

    $cfgFile = DPXROOT . '/cfg.json.template' ;
    if(file_exists($cfgFile ))
    {
      $cfg = json_decode(file_get_contents($cfgFile));
      if($cfg === null)
          die("There is a fatal error in the config file. " . file_get_contents($cfgFile));
      $thecfg = $cfg;
    }

    $cfgFile = DPXROOT . '/cfg.json' ;
    if(file_exists($cfgFile ))
    {
      $customcfg = json_decode(file_get_contents($cfgFile));
      if($customcfg === null)
          die("There is a fatal error in the custom config file. " . file_get_contents($cfgFile) );
      deepExtend($thecfg, $customcfg, true );
    }
   $_SESSION['static']->cfg = $thecfg;


    $fsFile = DPXROOT . '/htdocs/FreeSurferLUT.json';
    if(file_exists($fsFile ))
    {
      $fsLUT = json_decode(file_get_contents($fsFile));
      if($fsLUT === null)
          error_log("There is an error in the Fressuerfer LUT. ");
      else
         $_SESSION['static']->FSLUT = $fsLUT;

    }

    
    // for now, read the pacs conf and rights every time, otherwise changes apply only after re - login
    //if( isset($GLOBALS['settings']->pacs )  !isset(&& $_SESSION['static']->pacs))
    if( isset($GLOBALS['settings']->pacs ) )
    { 
      $pacs = $GLOBALS['settings']->pacs;
      //unset($pacs->SELF); // needed for defaultSeriesNumber
      // for none admins, check for PACS rights. PACSen are right now in conf, if moved as a database, this can be simplified to a single join in future
      // Maybe be harder here! only allow pacs not for all admins, but if there is really a permission entry in rights table!
      if($_SESSION['userinfo']['isadmin'] != '1')
      {
        $pacs2 = (object)array();
		if(isset($pacs->SELF) ) 
			$pacs2->SELF = $pacs->SELF;
        $db = mydbconnection(ROOTDB);
        $a = $db->query("SELECT * FROM rights where project like 'PACS%' AND username LIKE '$_SESSION[username]'");
        if($a !== false)
        {
          while($row = $a->fetch_assoc())
          {
            // workaround, pacs in rights field should start with PACS_
            $p = substr($row['project'], 5, strlen($row['project'])-5);
            if($p == '*') // all pacsen are allowd
            {
                $pacs2 = $pacs;
                break;
            }
            // this pacs is allowed
            if(isset($pacs->$p) ) 
            $pacs2->$p = $pacs->$p;
          }
          $pacs = $pacs2;
        }
        $db->close();
        
      }
      // remove sensitive information (ip, aetitle and port)
      foreach($pacs as &$p)
      {
        unset($p->aetitle);
        unset($p->ip);
        unset($p->port);
      }
      $_SESSION['static']->pacs = $pacs;
      
      if( isset( $GLOBALS['settings']->allow_open_in_pacsclient) &&  $GLOBALS['settings']->allow_open_in_pacsclient )
        $_SESSION['static']->allow_open_in_pacsclient = 1;

    }

    
    /////// pacs query 
//     if( ( intval($_SESSION['userinfo']['isadmin']) > 0 && isset($GLOBALS['settings']->pacsquery )) )
//     { 
//       if($_SESSION['userinfo']['isadmin'] == '1')
//       {
//         $_SESSION['static']->pacsquery = array_keys((array)$GLOBALS['settings']->pacsquery);
//       }
//     }


    /////// queue rights
    $db = mydbconnection(ROOTDB);
    $a = $db->query("SELECT * FROM rights where project like 'QUEUE_%' AND username LIKE '$_SESSION[username]'");
    $available_queues = [];
    if($a !== false)
       while($row = $a->fetch_assoc())
	       $available_queues[] =  substr($row['project'],6);
    $db->close();
    $_SESSION['static']->available_queues = $available_queues;


    /////// pacs query rights
    if( isset($GLOBALS['settings']->pacsquery ) )
    { 
      $hasrights = 0;
      if( $_SESSION['userinfo']['isadmin'] == '1' )
      {
        $hasrights = 1;
      }
      else
      {
        $db = mydbconnection(ROOTDB);
        $a = $db->query("SELECT * FROM rights where project like 'PACSQUERY' AND username LIKE '$_SESSION[username]'");
        if($a !== false && $row = $a->fetch_assoc())
          $hasrights = 1;
        $db->close();
      }

      if($hasrights && sizeof($GLOBALS['settings']->pacsquery) >0)
      {
         $_SESSION['static']->pacsquery = array_keys((array)$GLOBALS['settings']->pacsquery);
         if(isset($GLOBALS['settings']->pacsquery_defaultsearch))
			$_SESSION['static']->pacsquery_defaultsearch = $GLOBALS['settings']->pacsquery_defaultsearch;
		  else
		  	$_SESSION['static']->pacsquery_defaultsearch = (object)array("PatientID"=>"12345678", 'PatientName'=>'Doe^John');
      }

    }

 
}



// ============= if nothing else is to be done, put standard main frame  =================

if (isset($_COOKIE['project']) && !isset($_GET['project']))
{
  $projectCookie =  json_decode($_COOKIE['project']);
  $username = $_SESSION['username'];
  if (isset($projectCookie->$username) & $username != guestuser)
  {
    $db = mydbconnection(ROOTDB);
    $a = $db->query("SELECT * from projects where name='".$projectCookie->$username."'");
    if ($a->fetch_assoc()) 
    {
    	
       foreach($_SESSION['moduleList'] as $m)
       {
       	   if ($m == $projectCookie->$username)
       	   {
              $project = $projectCookie->$username;
       	   	  break;
       	   }
       }

    }
    $db->close();
  }
}


echo renderMainWindow($project);







return;




////////////// extend
function deepExtend(&$target, $source, $add = true)
{
   $forbiddenVars = array('isadmin', 'currentProject', 'moduleInfo' );
   if(!is_array($source) & !is_object($source))
   {
       $target = $source;
      return;
   }
   else
   {
      if(is_null($target) & $add ) // add property array if not exists
      {
        if(is_array($source))
          $target = array();
        else if(is_object($source))
          $target = (object)array();
      }
     
      foreach($source as $key => $val)
      {
        if(in_array($key, $forbiddenVars, true))
               continue;
  
        if(is_array($target))
        {
          if(array_key_exists($key, $target ) | $add == true )
          {
             deepExtend($target[$key], $val ,$add );
          }
        }
        else if(is_object($target))
        {
          if(property_exists($target, $key) | $add == true )
          {
            deepExtend($target->$key,$val ,$add );
          }
        }
        else if(is_string($target))
        {
        	$target = $source;
        }        
        else
        {
          error_log("in deepextend:is this a bug?");
          $e = new Exception();
          error_log($e->getTraceAsString());
        }
	  }
  }
          //  var_dump($key);
  return $target;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////// select a new project ////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function setDefaultState($project)
{
  
  $_SESSION['state'][$project] =  json_decode(json_encode($_SESSION['genericstate'])); // clone the generic state with (object)

}


function loadAllProjectInfo()
{

  if(file_exists(DPXROOT . '/htdocs/dicom/conversion_dictionary.json'))
    $dict = json_decode( file_get_contents(DPXROOT . '/htdocs/dicom/conversion_dictionary.json')) ;
  else 
    $dict = null;


  $db = mydbconnection(ROOTDB);

  if ($_SESSION['userinfo']['isadmin'] === '1')  // if user is admin, show all modules / projects
    $querystring = "SELECT * FROM projects ORDER BY ID";
  else
    $querystring = "SELECT r.role,r.rights,p.* FROM projects AS p JOIN rights as r  WHERE p.name=r.project AND (username LIKE '$_SESSION[username]' OR username LIKE '<ANY>' OR username LIKE '".guestuser."'  )";

  $moduleInfo = array();
  if( ($a = $db->query($querystring,true)) )
  {
    while($row = $a->fetch_assoc())
    {

      // check if the corresponding database exists
      $querystring = "SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '".$row['name']."'";
      $a2 = $db->query($querystring);
      if( $a2->fetch_assoc() == false)
      {
        //error_log('Warning: DB not found for project ' . $row['name']);
        continue;
      }
  

       if (!isset($row['rights'] ))  $row['rights'] = '{"batchtool":"on","readonly":"off"}';

  //     $row['settings'] = json_decode(str_replace("\\","",$row['settings']));
       $row['rights'] = json_decode(str_replace("\\","",$row['rights']));
       if(! ($row['rights'] instanceOf stdClass) )
          $row['rights'] = (object)array();

//       $row['cmddesc'] = json_decode(str_replace("\n","\\n",$row['cmddesc']));
       
       $row['jsondesc'] = str_replace("\\","\\\\",$row['jsondesc'] );
       $row['jsondesc'] = str_replace('\"','"'   ,$row['jsondesc'] );
  	   $jsondesc = json_decode( $row['jsondesc'] );
  	   
  	   if (isset($jsondesc->alias))
  	       $row['alias'] = $jsondesc->alias;

       if ($_SESSION['userinfo']['isadmin'] === '1' || $row['role'] == 'admin')
       {
         $row['rights']->batchtool = 'on';
         $row['rights']->readonly = 'off';
         $row['role'] = 'admin';
       }
       if ($jsondesc  instanceOf stdClass)
       {
         if (isset($jsondesc->datafolders))
         {
			 if ($jsondesc->datafolders instanceOf stdClass)
				$row['importfolder'] = $jsondesc->datafolders;
			 else
				$row['importfolder'] = $jsondesc->datafolders[$jsondesc->importfolder];
         }
       } 
       if(isset($jsondesc->analysisfolder))
			$row['analysisfolder'] = $jsondesc->analysisfolder;
       if(isset($jsondesc->anonymization))
			$row['anonymization'] = $jsondesc->anonymization;
       if(isset($jsondesc->forceAnonymize))
			$row['forceAnonymize'] = $jsondesc->forceAnonymize;
    //  $row['jsondesc'] = $jsondesc;
       $row['dictionary'] = $dict;
       
      $admin = ($_SESSION['userinfo']['isadmin'] === '1') | ($row['role'] == 'admin');

      if ($row['hardCopy'] == '1' & !$admin)
        continue;

       
       $moduleInfo[$row['name']] = $row;

     }
  }

  $_SESSION['moduleInfo'] = $moduleInfo;  // array of module objects
  $_SESSION['moduleList'] = array_keys($moduleInfo);  // array of module names
  sort($_SESSION['moduleList'] );
  $db->close();



}





function selectProject($project,$duringfullrender)
{

  $json = array('success'=> false, 'msg'=>'');
  $_GET['project'] = $project;

  $db = mydbconnection(ROOTDB);
  //$querystring = "SHOW DATABASES LIKE '".$project."'";
  $querystring = "SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '".$project."'";
  if( ($a = $db->query($querystring)) )
  {
    // not found!!
    if( $a->fetch_assoc() == false)
    {
      if (!$duringfullrender)
        echo "project '".$project."' was not found in database " . NORA_ESEP;
      loadAllProjectInfo();
      $project = $_SESSION['moduleList'][0];
    }
  }

	// get list of all patient, study, file tags for this project
	$ptags = "";
	$ptags = "";
	$ftags = "";
	if(1)
	{
		$lim = 1000;
		$q = "SELECT GROUP_CONCAT(DISTINCT ptag SEPARATOR '') FROM $project.patients WHERE ptag NOT LIKE '' and ptag IS NOT NULL limit $lim";
		if( ($a = $db->query($q)) )
			while($t = $a->fetch_assoc())
				$ptags = (str_replace('//', '/', array_values($t)[0]));
		$q = "SELECT GROUP_CONCAT(DISTINCT stag SEPARATOR '') FROM $project.studies WHERE stag NOT LIKE '' and stag IS NOT NULL limit $lim";
		if( ($a = $db->query($q)) )
			while($t = $a->fetch_assoc())
				$stags = (str_replace('//', '/', array_values($t)[0]));
		$q = "SELECT GROUP_CONCAT(DISTINCT tag SEPARATOR '') FROM $project.files WHERE tag NOT LIKE '' and tag IS NOT NULL limit $lim";
		if( ($a = $db->query($q)) )
			while($t = $a->fetch_assoc())
				$ftags = (str_replace('//', '/', array_values($t)[0]));
				
		//var_dump($ftags);

	}

	// check if readingresults table exists
    $a = $db->query("SHOW TABLES FROM `$project` LIKE 'readingresults'");
    if (isset($_SESSION['moduleInfo'][$project]))
      	$_SESSION['moduleInfo'][$project]['hasReadingTable'] = ($a != false && $a->num_rows > 0);
	
    // get cmd info
    $querystring = "SELECT * FROM projects where name='$project'";
    if( ($a = $db->query($querystring,true)) )
    {
       if ($row = $a->fetch_assoc())
       {
		 if (substr($row['cmddesc'],0,8) == 'CMDPROJ:')
		 {
			$querystring = "SELECT * FROM projects where name='".substr($row['cmddesc'],8)."'";
			if( ($a = $db->query($querystring,true)) )
			   if ($row = $a->fetch_assoc())
                     $_SESSION['moduleInfo'][$project]['cmddesc'] = json_decode(str_replace("\n","\\n",$row['cmddesc']));

		 }
		 else
             $_SESSION['moduleInfo'][$project]['cmddesc'] = json_decode(str_replace("\n","\\n",$row['cmddesc']));
       }
    }

  
	$db->close();

	$json['taglist'] = array('ptags' => $ptags, 'stags' => $stags, 'ftags' => $ftags);



  // remember project even after logout  


  $projectCookie = (object) array();
  if (isset($_COOKIE['project']))
  {    
    if ($_COOKIE['project'] != null)
      $projectCookie = json_decode($_COOKIE['project']);    
  }
  
  $username = $_SESSION['username'];
  $projectCookie->$username = $project;
  setcookie('project',json_encode($projectCookie),time() + (10 * 365 * 24 * 60 * 60));


 
  $json['moduleInfo'] =   $_SESSION['moduleInfo'][$project];

  
    // set default state
  setDefaultState($project);
  $thestate = $_SESSION['state'][$project]; 


  $jsonrow =   MDB_getRows('json', array( 'type' => 'viewersettings', 'project' => $project ),'json',$project);
  if($jsonrow['msg'] !== "") // error occured ...
      $json['msg'] .= $jsonrow['msg']; 
  if(!empty($jsonrow['json']))
      $json['presetList'] = $jsonrow['json'];
  else
      $json['presetList'] = null;

  // load the current state for this project and overwrite defaults
  $jsonrow =  MDB_getRows('json',  array( 'type' => 'state', 'project' => $project ),'json',$project);
  if($jsonrow['msg'] !== "") // error occured ...
      $json['msg'] .= "<br/><br>" . $jsonrow['msg']; 
  if(!empty($jsonrow['json']))
  {
    // take the first state row. Normally there should be only one.
    // extend the state with the saved state       
     $json['state'] = $jsonrow['json'][0]; 
     //die( var_dump( $json['state']));
     deepExtend($thestate, $json['state'], true);
  }
  
  if( isset($json['presetList'])  ) // normally, this should be true, as there is always some preset (except very first project load without standard presets)
  {     
          $standard = null;
          $selected = null;
              
          foreach($json['presetList'] as $tp)   // walk over all presets, find the selected or the "standard" one
          {
              if($tp->id == $thestate->project_user->selectedViewerPreset) // this  is the selected preset
              {
                $selected = $tp;
                  // caution: must set this for old presets!!
                  //if(!property_exists($selected, 'tryUsingStandard'))  $selected->tryUsingStandard = false;
              }
              if(isset($tp->rights) && substr($tp->rights, 0,1) === 's') // this is a standard preset
              {
                $standard = $tp;
              }
          }
	  

          if (!isset($_GET['sharelink']))	  
          {
            // take the selected preset only if it does not say "tryUsingStandard instead of me"
            if($thestate->project_user->startupState == "rememberPreset" & $selected !== null  )   
            {
                deepExtend($thestate->viewer, $selected, true);
            }
            // standard was found, take this one
            if($thestate->project_user->startupState == "tryUsingStandard" & $standard !== null  )
            {
                deepExtend($thestate->viewer, $standard, true);
            }
          }
    }

       // do some integrity checks
    if( !is_numeric($thestate->viewer->displayOffset) )
           $thestate->viewer->displayOffset = 0;
    if( !is_numeric($thestate->viewer->numberDisplayedItems) )
           $thestate->viewer->numberDisplayedItems = 100;

  $json['userbatches'] = getUserbatches($project);


   



  if (!$duringfullrender)
  {
  

    $thestate->metaindices = getMetaIndices($project);

    $ptable = renderPatientTableContainer(true,$project);

    $json['patienttable'] = $ptable['html'];
    $json['studies'] = $ptable['studies'];
    $json['patients'] = $ptable['patients'];
    $json['files'] = $ptable['files'];
    $json['analysis'] = $ptable['analysis'];

    $json['state']  = $thestate ;
    $json['success'] = true;

  }
  return $json;


}


function getUserbatches($project)
{     
    // load user batches
    $userbatches = (object)array();
    $jsonrow =  MDB_getRows('json',  array( 'type' => 'userbatch' ),'json',$project);
    if(!empty($jsonrow['json']))
    {
      foreach($jsonrow['json'] as $row)
      {
        $temp = $row->name;
        //$userbatches->ss = var_dump($row);
        //var_error_log($row);
        if ($temp != "")
          $userbatches->$temp = $row;
      }
    }
    return $userbatches;

}

function getTableFields($name,$project)
{
     $db = mydbconnection($project);
     $fields = array();
     $a = $db->query('SHOW FIELDS FROM ' . $name);
     if ($a != false)
        while($field = $a->fetch_assoc())
            $fields[$field['Field']] = 1;
      $db->close();
     return $fields;
}

function getMetaIndices($project)
{
  $meta = array();
  $db = mydbconnection($project);
  
  $a = $db->query("select * from metaidx where metaname LIKE '" . $_SESSION['username'] . "\_%' OR metaname LIKE 'XSHARED\_%' OR metaname LIKE 'root\_%'");
  while(($row = $a->fetch_assoc()))
  {
    $meta[$row['metaname']] = $row;
  }  
  $db->close();
  return $meta;
}

function delMetaIndex($name,$project)
{
  $meta = array();
  $db = mydbconnection($project);
  $db->query("delete from metaidx where metaname like '" . $name . "'");

  $a = $db->query('SHOW FIELDS FROM metacontent LIKE "' . $name . '"');
  if ($a->fetch_assoc())
    $db->query('ALTER TABLE metacontent DROP COLUMN ' . $name);  
  $db->close();
  
}

function updateMetaIndex($project,$name,$psidquery=null)
{
    $db = mydbconnection($project);
    $a = $db->query('select * from metaidx where metaname LIKE "' . $name . '"');
    $db->close();
    while ($row = $a->fetch_assoc())
    {
        addMetaIndex($row['metaname'],json_decode($row['metaidx']),$row['level'],$row['type'],$project,$psidquery);
    }
}


function addMetaIndex($name,$index,$infotype,$type,$project,$psidselector=null)
{
    $db = mydbconnection($project);
    $already_in_table = false;
    $fromjsonfile = "";
    if ($index[0] == 'PATIENT' )
    {
       $already_in_table = true;           
       $infotype = "patient";
    }
    else if ($index[0] == 'STUDY')
    {
       $already_in_table = true;           
       $infotype = "study";     
       $sfields = getTableFields("studies",$project);
       if (!isset($sfield[$index[1]]));
       {
           $index = array($index[1]); 
           $already_in_table = false;               
       }
    }
    else if ($index[0] == 'TAG')
    {
       $already_in_table = true;      
       $infotype = strtolower($infotype);
       /*

       $sfields = getTableFields("studies",$project);
       if (!isset($sfield[$index[1]]));
       {
           $index = array($index[1]); 
           $already_in_table = false;               
       }*/
    }
    else if ($infotype == 'study' && sizeof($index)==1)
    {     
       $fromjsonfile = $index[0];    
    }


    if (substr($index[0],0,6) == "[META]")
        $index[0] = substr($index[0],6);


    $b = $db->query('select * from metaidx where metaname="' . $name . '"',true);
    if ($b == false)
       return $db->error;

    $a = $db->query('SHOW FIELDS FROM metacontent LIKE "' . $name . '"',true);
    if ($a == false)
       return $db->error;

    if ($a->fetch_assoc() == false && !$already_in_table)
    {
        $alter = 'ALTER TABLE metacontent ADD COLUMN ' . $name . ' ' . $type;
        $test = $db->query($alter,true);
        if ($test == null)
        {
           client_err("altertable: " .$db->error . ": " .$alter);
           return $db->error;
        }
    }

    $metacol = $b->fetch_assoc();
    //if ($metacol != false)
    //    $db->query('delete from metaidx where metaname="'. $name .'"');
    if ($metacol == false)
    {    	
        $db->query("insert metaidx (metaidx,metaname,type,level) VALUES ('" . json_encode($index) . "','" . $name .  "','" . $type .  "','" . $infotype . "')");
    }


    if (!$already_in_table)
    {         
        $psids = array();
        $psidquery = "";
        client_log($infotype);
        if ($infotype == 'study')
        {
          if ($psidselector != null)
          {
          	  if (is_array($psidselector) & sizeof($psidselector)>0)
          	  {
                  $arr = array();
                  for ($i=0;$i<sizeof($psidselector);$i++)
                  {
                      if (strpos($psidselector[$i], "#") !== false )
                          $arr[] = " concat(patients_id,StudyID)='" . $psidselector[$i] . "'";
                      else
                          $arr[] = " patients_id='" . $psidselector[$i] . "'";
                  }
                  $psidquery = " WHERE " . implode(" OR ",$arr);                      
          	  }
          	  else
                  $psidquery = " WHERE concat(patients_id,StudyID)  LIKE '" . $psidselector . "'";
          }
          $a = $db->query("select patients_id,concat(patients_id,StudyID) as psid from studies" . $psidquery);
        }
        else
        {
          if ($psidselector != null)
          {

          	  if (is_array($psidselector) & sizeof($psidselector)>0)
          	  {
                  $arr = array();
                  for ($i=0;$i<sizeof($psidselector);$i++)
                      $arr[] = " PIZ='" . $psidselector[$i] . "'";
                  $psidquery = " WHERE " . implode(" OR ",$arr);                      
                  client_log($psidquery);
          	  }
          	  else          	
                 $psidquery = " WHERE PIZ LIKE '" . $psidselector . "'";
          }
          $a = $db->query("select PIZ as psid from patients" . $psidquery);
        }
        while ($row = $a->fetch_assoc())
          $psids[] = $row['psid'];
        foreach ( $psids as $psid)
        {
            $info = getMetaInfo($psid,$project,false,$fromjsonfile);
            $found = true;

            for ($k=0;$k < sizeof($index);$k++)
            {
                $key = $index[$k];
                if (is_array($info))
                {
					if (!isset($info[$key]))
					{
					  $found = false;
					  break;
					}
					$info = $info[$key];                     
                }
                else
                {
					if (!isset($info->{$key}))
					{
					  $found = false;
					  break;
					}
					$info = $info->{$key};                     
                }
            }
          
  
            if ($found)
            {    
			   if ($info === false)
			   	  $info = 0;
			   if ( $type == "FLOAT") 
			       $info = (float)$info;
			   if ( $type == "INT") 
			       $info = (int)$info;
               $query =  'INSERT INTO metacontent (psid,' . $name . ') VALUES ("' . $psid . '","' . $info . '")  ON DUPLICATE KEY UPDATE ' . $name . '="' . $info . '"';
	           if ( !($type == "FLOAT" || $type == "INT") || is_numeric($info) )	     
	           {
		          $db->query($query);               
	           }
            }

            
       
        }
    }
   
    $db->close(); 
    return true;
}








function renderMainWindow($project)
{
  $html  = "";
  $htmlHeader = renderHeader();
  $html .= renderTopMenu($project);
  $html .= "<div  id ='frame'>";
  $html .= "<div id ='container'>"; // main container

  $temp = renderPatientTableContainer(false,$project);
  $html .= $temp['html'];

  // $html .= "<div class='containerDIV'>  </div>";
  $html .=  "<div class='containerDIVs'  id='myKView' style='width:100%'  > </div>";
  //       $html .= "</tr></table>";

  $html .= "</div>"; // END of outer container
  $html .= "</div>"; // END of frame
  $htmlFooter = renderFooter($project);





  //$htmlGridengineWindow = renderGridengineWindow();
  //return ($htmlHeader . $htmlGridengineWindow . $html .$htmlFooter );
  return ($htmlHeader  . $html .$htmlFooter );
}


function renderPatientTableContainer($ajax = true, $project)
{
  $selectionMode = "mp";
  if (isset($_SESSION['state'][$project]))
  {
    $thestate = $_SESSION['state'][$project]; 
    $selectionMode = $thestate->viewer->selectionMode;
    if ($selectionMode[1] == 'a')
      $s = "search_row_a";
    else
      $s = "search_row";
    if (isset($thestate->$s))
       $searchRow = $thestate->$s;    
  }


  $html  = "";
  $html .= "<div id ='patientTableContainer'  class='containerDIV' style='' >";
  $html .= "<div id ='thetable' >";

  if(1) // patient table tools div
  {
    //=================================
    $html .= "\n\n";
    $html .= "<div  id='patientTableTopTools'  class='patientTableTopTools'>";
    $html .= " <ul  class='menu_generic'>";

    if ($selectionMode[1] == 'p') $iscur = "current"; else $iscur = "";
    $html .=   "<li id='modeSelector_p' class='$iscur leveltab' onclick='switchtoLevel(\"p\")' ><a>Subjects</a> </li>";
    if ($selectionMode[1] == 's') $iscur = "current"; else $iscur = "";
    $html .=   "<li id='modeSelector_s' class='$iscur leveltab' onclick='switchtoLevel(\"s\")'><a>Studies</a> </li>";
    if ($selectionMode[1] == 'f') $iscur = "current"; else $iscur = "";
    $html .=   "<li id='modeSelector_f' class='$iscur leveltab' onclick='switchtoLevel(\"f\")'><a>Files</a> </li>";
    if ($selectionMode[1] == 'a') $iscur = "current"; else $iscur = "";
    $html .=   "<li id='modeSelector_a' class='$iscur leveltab' onclick='switchtoLevel(\"a\")'><a>Analysis</a> </li>";

    $html .= "<li class='refreshtable'  style='float:right' onclick='javascript:refreshButton(\"\");'><a> <i class='fa fa-refresh'></i></a> </li>";
    $html .=   "<li id='KSingleSelectionMode' style='float:right;' onclick='switchtoToggle()'><a> <i class='fa fa-hand-o-left'></i></a></li>";


    $projectForceAnonymize = 0;
    if (isset($_SESSION['moduleInfo'][$project]['forceAnonymize']))
    	$projectForceAnonymize = $_SESSION['moduleInfo'][$project]['forceAnonymize'];

    $projectRoleAdmin = $_SESSION['userinfo']['isadmin'] === '1';
    if (isset($_SESSION['moduleInfo'][$project]['role']))    
         $projectRoleAdmin = $projectRoleAdmin | ($_SESSION['moduleInfo'][$project]['role'] == 'admin');

    $project_anonym = !($projectForceAnonymize == 0 | $projectForceAnonymize == "");
    $user_deanonym = isset($_SESSION['moduleInfo'][$project]['rights']->deanonym) && $_SESSION['moduleInfo'][$project]['rights']->deanonym == "on"; 
    $user_deanonym = $user_deanonym | $projectRoleAdmin;

    if (!$project_anonym | $user_deanonym )      
	{
		 $fa = $_SESSION['userinfo']['forceanonymize'];
		 $cl = "";
         if ($fa == 1)
            $cl = "active";
         if ($fa == 2)
            $cl = "active2";            
         $isactive = $_SESSION['userinfo']['forceanonymize']==true;
		 $html .=  ("<li id='KAnonymMode' style='float:right;' onclick='switchAnonym()' class='".$cl."'><a> <i class='fa fa-user-secret'></i></a></li>");
	}

    $html .=  ("<li id='KInfoButton' style='float:right;' oncontextmenu='projectInfoButton(event)' onclick='projectInfoButton(event)' ><a> <i class='fa fa-info-circle'></i></a></li>");
    $html .=   "<li style='float:left;' onclick='settingsDialog.dialog.toggle();'><a> <i class='fa fa-cog'></i></a></li>";



  /*
    $html .= "<li class='levelswitcher'  style='float:right' >
    <ul id='KLevelSwitcher'> <li onclick='switchtoLevel(\"p\")'> <a > Patient </a> <i class='KViewLevel KLevel_p fa fa-circle-o'></i> </li>
                             <li onclick='switchtoLevel(\"s\")'> <a> Study </a> <i class='KViewLevel  KLevel_s fa fa-circle-o'></i></li>
                             <li onclick='switchtoLevel(\"f\")'> <a> File </a> <i class='KViewLevel  KLevel_f fa fa-circle-o'></i></li>
                             <li onclick='switchtoLevel(\"a\")'> <a> Analysis </a> <i class='KViewLevel  KLevel_a fa fa-circle-o'></i> </li> </ul>
    <a> <i class='fa fa-list-alt'></i></a> </li>";
    
    
    $html .=   "<li id='KSingleSelectionMode' style='float:right;' onclick='switchtoToggle()'><a> <i class='fa fa-hand-o-left'></i></a></li>";

    $html .=   "<li class='menu_generic_labelname' ><a> ".str_replace(project_user_delim,"/",$project)."</a> </li>";
    $html .=   "<li class='createpatient' style='float:left;z-index:0' onclick='createPatient();'><a> <i class='fa fa-user-plus'></i></a> </li>";

    if(isset( $_SESSION['static']->pacsquery))
      $html .=   "<li class='' style='float:left;z-index:0' onclick='PACSQuery();'><a> <i class='fa fa-product-hunt'></i></a> </li>";
*/


    $html .= "</ul>";
    $html .= "</div>";
    //=================================
  }

  //================================= edit mode bar

  $html .= "\n\n";
  if($selectionMode[0] == 'w') //
    $html .= "<div id='patientTableEditMode' class=''>";
  else
    $html .= "<div style='display:none' id='patientTableEditMode' class=''>";
  $html .= " <ul  class='patientTableEditMode menu_generic'>";

/*
  if($selectionMode[0] == 'p') //
  {
      $html .=   "<div style='position:absolute;overflow:hidden;width:90%;'> <li onclick='editPatientInfo(undefined);' id='patientTableEditModeTextFirst' > <a> <span>none</span> </a> </li>";
      $html .=   "<li id='patientTableEditModeTextSecond' > <a>  <span>none</span> </a> </li> </div>";
  }
  else
  {*/
      $html .=   "<div style='position:absolute;overflow:hidden;left:0px;width:90%;'><li onclick='clickonPatientBar(event);' id='patientTableEditModeTextFirst' > <a>  <span>none</span> </a> </li>";
      $html .=   "<li  id='patientTableEditModeTextSecond' > <a>  <span>none</span></a> </li> </div>";
  //}


  $html .= "<li class='Kpatientbarbutton' style='float:right; background:inherit;' onclick='patientTable_gotoRow(1)' > <a><i  class='fa fa-fw fa-step-forward'></i></a></li>   ";
  $html .= "<li class='Kpatientbarbutton'  style='float:right; background:inherit;' onclick='patientTable_gotoRow(-1)' > <a><i  class='fa fa-fw fa-step-backward'></i></a></li>   ";
  $html .= "<li class='Kpatientbarbutton' id='Kbacktoallbutton' style='float:right;display:none;background:inherit;' onclick='patientTableMirror.levelMode_backToAll()' > <a><i  class='fa fa-fw fa-arrow-circle-up'></i></a></li>   ";
  $html .= "<li class='Kpatientbarbutton' id='Kaddtagbutton' style='float:right;display:none;background:inherit;' onclick='addTagContextmenu(event);' > <a><i  class='fa fa-fw fa-plus'> TAG</i></a></li>   ";
 
  $html .= "</ul>";
  $html .= "</div  >";
  //=================================


  if (isset($searchRow->general))
     $value = $searchRow->general;
  else
     $value = "";
  
  $html .= "<form autocomplete=off onsubmit='return false;'  target='KsearchForms' class='KSearchFieldContainer' > 
              <input type='search' placeholder='file search' id='KSearchFieldGeneral' class='KSearchFields'  oncontextmenu='patientHeaderSearchBar(event);' name='general' value='$value' onkeydown='patientSearch_keydown(event);' onchange='patientSearch(event);' /> ";
  
   $html .=  "<span>
              <span class='KSearchField_clear fa_container' onclick='patientSearch_reset(event);' style='right:58px;' >
                  <i class='fa fa-close'></i>
                </span>
              <span class='KSearchField_clear fa_container' onclick='patientSearch_help(event);' style='right:42px' >
                  <i class='fa fa-question'></i>
                </span>
              <span class='KSearchField_clear fa_container' onclick='KTagPanel();' style='right:25px' >
                  <i class='fa'>T</i>
                </span>
              <span id='patientHeaderBarSearchButton' class='KSearchField_filterList  hover_bg_gray patientTableHeaderSearchCell fa_container'>
                  <i class='KCheckBox fa fa-list'></i>
                </span>
              </span>
                ";

   $html .= " <span class='.KSearchFieldGeneral_after'></span>";

   $html .= "</form>";



  $html .= "<div id ='patientTableAnotherInnerContainer' ><div id ='patientTableInnerContainer'  style=''  >";



  $res = array();
  if($ajax)   // render inerior only on ajax request;
  {
    $res = renderPatientTable(true,$project);
    $html .= $res['html'];
  }

  $html .= "</div></div>"; // END of patientTableInnerContainer DIV
  $html .= "</div>"; // END of aaaa

  $html .= "<div id ='patientTableLowerContainer'> <div> </div> </div> <div id ='patientThumbContainer'> <div onclick='KViewer.unZoomViewport();' id ='patientThumbBackButton'> <i class='fa fa-arrow-left'></i>  Close Zoomed View </div> </div> ";

  $html .= "</div>"; // END of patient Table container DIV

  $res['html'] = $html;

  return $res;
}



function renderLoadingFrame($style)
{
    $onclick = "window.location.href=window.location.href.split(\"?\")[0] + \"?logout\" ";
    $close = "<i onclick='$onclick' class='fa-5x fa fa-close'></i>"; // panic button
    return "<div style='".$style."' id='KLoadingFrame'><img style='position:absolute;width:100%;height:100%;opacity:0.05' src='logo_full.svg'  > <div>".$close."</div>  <div class='thespinner'><i class='fa-5x fa fa-spinner fa-spin'></i></div> <div id='KLoadingFrameTypeString'></div> <div id='KLoadingFrameText'></div> </div>";
}


function renderTopMenu($project)
{
  $html = "";
  $html .= "<div id='topMenu'> ";
  $html .= " <ul class='menu_generic  menu_scrollable'>";
//  $html .= "<li class='logo'> <div style='position:relative;overflow:hidden;width:100px;height:30px' ><img style='position:absolute;left:5px;height:60px;top:-15px' src='logo.svg'  > </div> </li>";
  $html .= "<li  class='menu_generic_labelname logo'><div><img src='logo.svg'  /> </div> </li>";

  if ($_SESSION['username'] != guestuser)
  {

    $headpselector = str_replace(project_user_delim,"/",$project);
    if (sizeof($_SESSION['moduleList']) == 0)
      $headpselector = "Project";



    $html .=   "<li style='margin-left:0px' ><a id='project_indicator'>".$headpselector." </a> <ul id='project_selector' class='small'>";
    $cnt = 0;

    $categorized = array();
    foreach( $_SESSION['moduleList'] as $tModule)
    {
    	  $visname = $tModule;
     
          if (isset($_SESSION['moduleInfo'][$tModule]['alias']) && isset($_SESSION['moduleInfo'][$tModule]['alias']) != "")
            $visname = $_SESSION['moduleInfo'][$tModule]['alias'];

           if ($_SESSION['moduleInfo'][$tModule]['hardCopy'] == '1')               
               $visname = "{" . $visname  . " (archive)";

		  $pos = strpos($visname,project_user_delim);
		  if ($pos !== false)
		  {
			 $u = substr($visname,0,$pos);
			 if (!isset($categorized[$u]))
				$categorized[$u] = array();
			 $vn = substr($visname,$pos+3);
			 $categorized[$u][$vn] =  $tModule;
		  }
		  else
			 $categorized[$visname] = $tModule;

    }
    ksort($categorized);


    $maxp = 20;
    
    if (sizeof($categorized) > $maxp-1)
      $html .=   "<li class='projectsearch nohover'> <input onkeyup='projectSearch(event);' /><i class='fa fa-search'></i> </li>";

        	
    foreach( $categorized as $k => $c)
    {
        if ($cnt > $maxp-1)
          $hidden = "projects found hidden";
        else
          $hidden = "projects found";
          



        if (!is_array($c))
        {
           $admin = ($_SESSION['userinfo']['isadmin'] === '1') | ($_SESSION['moduleInfo'][$c]['role'] == 'admin');
           if ($k[0] == '{' & !$admin)
              $hidden .= " archive";
           $archive = "";
           if ($k[0] == '{')
           	   $html .=   "<li class='".$hidden."'> <a onclick=\"selectProjectOnClick('" . $c . "',event);\">" . $k . "</a> </li>";
           else
           	   $html .=   "<li class='".$hidden."'> <a onclick=\"selectProjectOnClick('" . $c . "',event);\">" . $k . "</a> </li>";
           $cnt++;
        }
        else
        {
        	
           $html .=    "<li class='".$hidden."'><a><span> " . $k . "</span> <i class='fa fa-caret-right'></i></a> <ul class='submenu_scrollable'>";
           foreach ( $c as $j => $w ) 
           {
			  $admin = ($_SESSION['userinfo']['isadmin'] === '1') | ($_SESSION['moduleInfo'][$w]['role'] == 'admin');
			  $arch = "";
		      if ($k[0] == '{' & !$admin)
				  $arch .= " archive";
              $html .=   "<li class='".$arch."'> <a onclick=\"selectProjectOnClick('" . $w . "',event);\"> " . $j . "</a></li>";
           }
           $html .=   "</ul> </li >";
           $cnt++;

        }

    }




        
    if (sizeof($categorized) > $maxp-1)
       $html .=   "<li class='more'> <a onclick=\"moreProjects();\"> more ...</a></li>";


    if (!defined('DONOTALLOWCREATEWWWPROJECT') ||  DONOTALLOWCREATEWWWPROJECT == "false")
    {
      
      if ($cnt > 0)
          $html .=   "<hr style='width:100%;height:1px;'>"; 
      $default_projects = explode(",",DEFAULTPROJECTNAME);
      $default_projects_nice =  $default_projects;
      if (defined('DEFAULTPROJECTNAME_GUIname'))
          $default_projects_nice = explode(",",DEFAULTPROJECTNAME_GUIname);
      if (sizeof($default_projects) == 1)          
          $html .=   "<li ><a onclick=\"createProject();\"> Create new project</a></li>";
      else
      {
      	 for ($k=0;$k < sizeof($default_projects);$k++)
      	 {
              $html .=   "<li ><a onclick=\"createProject('".$default_projects[$k]."');\"> Create new project (".$default_projects_nice[$k].")</a></li>";      	 	
      	 }
      }
    }
      $html .=   "<li ><a onclick=\"updateProjectList();\"> Refresh List</a></li>";
    $html .=  "</ul></li>";
  }
  else
  {
      $html .=   "<li  class='menu_generic_labelname' ><a>". DPXALIAS ."</a></li>";
   
  }


  $html .=   "<li style='display:none' class='batchtool_menu_id'> <a onclick='commandDialog.toggle();'><i   class='fa fa-cog'></i> Batchtool</a></li>";
  $html .=   "<li style='display:none' class='batchtool_menu_id'> <a onclick='gridjobsDialog.toggle();'><i class='fa fa-list'></i> Gridstats</a></li>";


  if ($_SESSION['userinfo']['isadmin'] === '1')  
  {
/*
//    $adminmenu .=  "<li style='' id='phpmyadmin_menu'><a onclick='phpmyadmin(\"$_SERVER[SERVER_NAME]/phpmyadmin/\")'> <i class='fa  fa-database'></i> dbadmin </a> </li>";
//    $adminmenu .=  "<li style='' id='demonlog_menu'><a onclick='showdemonlog()'> <i class='fa  fa-file-text-o'></i> matlab log </a> </li>";
    $adminmenu .=  "<li style='' id='demonlog_menu'><a onclick='showapachelog()'> <i class='fa  fa-file-text-o'></i> apache log </a> </li>";
    $adminmenu .=  "<li style='' id='demonlog_menu'><a onclick='showdpxlog()'> <i class='fa  fa-file-text-o'></i> dpx log </a> </li>";
    $adminmenu .=   "<li> <a onclick='admin_dialog();'> <i class='fa fa-list'></i> advanced </a></li>";
    $html .= "<li><a> <i class='fa fa-cog'></i>admin</a> <ul>" . $adminmenu . "</ul> </li>";
*/

    $html .= "<li><a onclick='admin_dialog();'> <i class='fa fa-wrench'></i>admin</a> </li>";
  }

  if (isset($_SESSION['genericstate']->isDeveloperMode) && $_SESSION['genericstate']->isDeveloperMode)
     $html .=   "<li class='menu_generic_labelname menu_generic_devtool'><a> (devmode)</a> <li>";


// $html .=   "<li> <a onclick='presetManager.dialog.toggle();'><i class='fa fa-bars'></i> Settings </a></li>";


  if ($_SESSION['username'] == guestuser)
     $html .=   "<li  style='float:right' class='inverted_white' ><a onclick='login();'> <i class='fa fa-sign-in'></i> Login </a></li>";
  else
  {
    //   $html .=   "<li class='menu_generic_disabled'  > $_SESSION[username]</li>";
  
     {
         $html .= " <li id='topMenu_last' style='float:right'><a><i class='fa fa-cog'></i>$_SESSION[username]  </a> <ul class='rightmenu'>";
		 $html .=   "<li> <a onclick='userSettingsDialog.toggle();'><i class='fa fa-user'></i> Profile </a></li>";

		 if (sizeof($_SESSION['moduleList']) > 0)
		   $html .=   "<li> <a onclick='settingsDialog.dialog.toggle();' href='#'>   <i class='fa fa-cog'></i> Settings </a></li>";

		 $html .=   "<li> <a id='fullscreentoggle'><i class='fa fa-expand'></i> Fullscreen </a></li>";
		 $html .=   "<li> <a onclick='shareLink();' href='#'>   <i class='fa fa-share-alt'></i>  Share </a></li>";

		 if (isset($GLOBALS['settings']->jupyter))
			 $html .=   "<li style='display:none' class='batchtool_menu_id' > <a onclick='launchJupyter();' href='#'><i class='fa fa-circle'></i> Jupyter </a></li>";
		 $html .=   "<li> <a onclick='forkProject();' href='#'><i class='fa fa-code-fork'></i> Fork Project </a></li>";
		 $html .=   "<li> <a target='_blank' href='https://www.nora-imaging.org/doc/'><i class='fa fa-book'></i> Docs </a></li>";
		 $html .=   "<hr>";

		 $html .=   "<li> <a onclick='logout_and_check_unsaved();'> <i class='fa fa-sign-out'></i> Logout </a></li>";
    
         $html .= "</ul> </li>";
     }
     if(isset($_GET['sharelink']))  
     {
          $html .= " <li class='sharedLinkLeave' style='float:right'> <a onclick='leaveSharedlink()'> Leave shared link </a> </li>";
    	
     }
  }

  $html .= "</ul>  ";

  $html .= "</div>";
  return $html;

}









  function strpos_list($haystack, $needle)
  {
    if (strlen(trim($needle))==0 )
    return true;

    $needle = explode(',' ,  $needle);
    if(!is_array($needle)) $needle = array($needle);

    foreach($needle as $what)
    {
      //echo($what );echo "<br>";
      if( strpos(trim($haystack), trim($what))!==false ) return true;
    }
    return false;
  }





  function renderHeader()
  {

    $htmlHeader = "
    <!DOCTYPE html      PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'     'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml'>
    <head>
    <title> " . DPXALIAS . "</title>
    <meta http-equiv='Content-Type' content='text/html; charset=utf-8' />
    <meta http-equiv='Content-Style-Type' content='text/css' />
    <link rel='manifest' href='manifest.json'>    
    <link rel='icon' href='favicon.svg' > ";

    // this is the only proper way to really force browser to reload new code
    // use inline less compiler for development    
    

    if (isset($_SESSION['genericstate']->isDeveloperMode) && $_SESSION['genericstate']->isDeveloperMode )
        $appendTimeStamp = "";      
    else
        $appendTimeStamp = "?" .  SOFTWAREVERSION;

    $style_suffix = '';
    if (isset($_SESSION['userinfo']['styletheme']))
    {
       $style = $_SESSION['userinfo']['styletheme'];
       if ($style != 'classic' && $style != null)
          $style_suffix = '.' . $style;
         
    }


    $htmlHeader .=  "<script type='text/javascript'> var sharedLink; </script>";
    if(isset($_GET['sharelink']))
    {
        // sharedlink is a direct json in get
        if(substr($_GET['sharelink'], 0,1) == "{" )
        {
           $htmlHeader .=  "<script type='text/javascript'> sharedLink = ". (($_GET['sharelink'])) .";</script>";
        }
        else
        {
          $db = mydbconnection(ROOTDB);
          $q = "SELECT * FROM shares WHERE shareID = '" . $_GET['sharelink'] . "'";
          $a = $db->query($q);
          $row = $a->fetch_assoc();
          if ($row)
          {
             $htmlHeader .=  "<script type='text/javascript'> sharedLink = " . $row['json'] . "; 
                              sharedLink.shareID= '" . $_GET['sharelink'] . "';
                              sharedLink.ID='". $row['ID']. "';</script>";

             $shareinfo = json_decode($row['json']);
             if (isset($shareinfo->styletheme) & $shareinfo->styletheme != "" & $shareinfo->styletheme != 'classic' )
             {
                  $style_suffix = '.' . $shareinfo->styletheme;
             }

          }
          else          
             $htmlHeader .=  "<script type='text/javascript'> sharedLink = undefined; sharedLinkInvalid = true; </script>";


          $db->close();
        }
    }


    if(isset($_GET['call']))
       $htmlHeader .=  "<script type='text/javascript'> extern_call = ". (($_GET['call'])) .";</script>";
          


 
    
    $htmlHeader .= "
      <link rel='stylesheet' href='styles_body.css$appendTimeStamp' type='text/css' />
      <link rel='stylesheet' href='styles_KReading.css$appendTimeStamp' type='text/css'/>
      <link rel='stylesheet' href='styles_main$style_suffix.css$appendTimeStamp' type='text/css' />
      <link rel='stylesheet' href='styles_KView$style_suffix.css$appendTimeStamp' type='text/css'/>
      <link rel='stylesheet' href='font-awesome-4.5.0/css/font-awesome.min.css' type='text/css'/>    
      <link rel='stylesheet' href='chartjs/Chart.min.css' type='text/css'/>    

      ";
   
    $htmlHeader .= "
      <link rel='stylesheet' href='css_tree/_styles.css' type='text/css' />
      <link rel='stylesheet' href='alertify.core.css' type='text/css'/>
      <link rel='stylesheet' href='alertify.default.css' type='text/css'/>
      <link rel='stylesheet' href='codemirror-minified/lib/codemirror.css'>
      ";
    
    $htmlHeader .= "</head><body>";
    $htmlHeader .= renderLoadingFrame('display:block');

    return $htmlHeader;
  }

  function renderFooter($project)
  {


    $htmlFooter = "</body></html>";


    if (isset($_SESSION['genericstate']->isDeveloperMode) &&  $_SESSION['genericstate']->isDeveloperMode )
    {
        $appendTimeStamp = "";      
        $htmlFooter .=  "<script type='text/javascript'> isDeveloperMode = true; </script>";        
    }
    else

    {
        $appendTimeStamp = "?" .  SOFTWAREVERSION;
        $htmlFooter .=  "<script type='text/javascript'> isDeveloperMode = false; </script>";        
    }


    if (isset($_GET['firstProjectLoad']))
        $htmlFooter .=  "<script type='text/javascript'> firstProjectLoad = true; </script>";        


    $htmlFooter .= "

<!--

    <script type='text/javascript' src='dicom/daikon.js$appendTimeStamp'></script>

  -->


    <script>
         if (typeof module != 'undefined')
         {
            electron_phpserved = true
            delete module;            
         }
         else
            electron_phpserved = false;
    </script>

    <script type='text/javascript' src='jquery.js'> </script>
    <script type='text/javascript' src='dragster.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='alertify.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='notify.js$appendTimeStamp'> </script>
<!--
    <script type='text/javascript' src='jquery-1.11.2.min.js'> </script>
    <script type='text/javascript' src='jquery.js'> </script>
    <script type='text/javascript' src='html2canvas.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='sparc.js$appendTimeStamp'></script>
    <script type='text/javascript' src='balloons.js$appendTimeStamp'></script>
    <script type='text/javascript' src='q.js$appendTimeStamp'></script>
    <script type='text/javascript' src='gif.js$appendTimeStamp'></script>  
    <script type='text/javascript' src='dicom/dicomweb/dicomweb-client.js'></script>   
-->

    <script type='text/javascript' src='q.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KMiscFuns.js$appendTimeStamp'></script>


    <script type='text/javascript' src='KTableOperator.js$appendTimeStamp'></script>
    <script type='text/javascript' src='kmath.js$appendTimeStamp'></script>


    <script type='text/javascript' src='KStateManager.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KForms.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KTour.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KView/nifti.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KTools/KTools.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KView/KDataManager.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KView/KView.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KView/KViewPort.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KView/pako.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KView/KMedImg3D.js$appendTimeStamp'></script>

<!--
    <script type='text/javascript' src='KView/WMQL/KWMQLPanel.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KView/WMQL/WMQLparser.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KView/WMQL/KWMQLquery.js$appendTimeStamp'></script>
-->

    <script type='text/javascript' src='codemirror-minified/lib/codemirror.js$appendTimeStamp'></script>
    <script type='text/javascript' src='codemirror-minified/mode/shell/shell.js$appendTimeStamp'></script>
    <script type='text/javascript' src='codemirror-minified/mode/octave/octave.js$appendTimeStamp'></script>
    <script type='text/javascript' src='codemirror-minified/mode/javascript/javascript.js$appendTimeStamp'></script>

<!--
    <script type='text/javascript' src='imgproc/kissFFT.js'></script>
    <script type='text/javascript' src='imgproc/kissFFT_main.js'></script>
    <script type='text/javascript' src='zip/zip.js$appendTimeStamp'></script>
    <script type='text/javascript' src='zip/inflate.js$appendTimeStamp'></script>
    <script type='text/javascript' src='zip/z-worker.js$appendTimeStamp'></script>
    <script type='text/javascript' src='dicom/dicomReader.js$appendTimeStamp'></script>
    <script type='text/javascript' src='bruker2nifti.js$appendTimeStamp'> </script>
-->


    <script type='text/javascript' src='LargeLocalStorage.js$appendTimeStamp'></script>

    <script type='text/javascript' src='chartjs/Chart.min.js$appendTimeStamp'></script>
    <script type='text/javascript' src='chartjs/canvas2svg.js$appendTimeStamp'></script>
    <script type='text/javascript' src='chartjs/jspdf.min.js$appendTimeStamp'></script>


    <script type='text/javascript'>
    var NORA_SOFTWAREVERSION = '" . SOFTWAREVERSION . "'; 
    var riddelim = '".riddelim ."';
    var guestuser         = '". guestuser . "';

    var currentModule =  '$project';
    var url_pref =  '';

    var isadmin         = '". $_SESSION['userinfo']['isadmin']. "';
    var userinfo        = " .  json_encode($_SESSION['userinfo']) . ";
    var static_info     = " .  json_encode($_SESSION['static']) . ";
    var moduleList      = " .  json_encode($_SESSION['moduleList']) . ";

    </script>

<!--
    <script type='text/javascript' src='dcmnode.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='pacsquery.js$appendTimeStamp'> </script>
  -->

    <script type='text/javascript' src='KView/KMedImageViewer.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KView/KMiscViewer.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KView/KTableViewer.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KCommandDialog.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='DPX_argumentResolution.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='DPX_sharedBackendFuns.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KTools/KCacheManager.js'$appendTimeStamp> </script>
    <script type='text/javascript' src='KMain.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KReading.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KMacros.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KStartup.js$appendTimeStamp'> </script>

<!--
    <script type='text/javascript' src='KTools/KAnnotationTool.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KView/KMedImgCurve.js$appendTimeStamp'></script>
    <script type='text/javascript' src='KTools/KRoiTool.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KTools/DBSsimulation.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KTools/KAtlasTool.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KTools/KNavigationTool.js$appendTimeStamp'> </script>
    <script type='text/javascript' src='KTools/KObject3DTool.js$appendTimeStamp'> </script>
-->



    ";


   if (isset($GLOBALS['settings']->customimports) && $GLOBALS['settings']->customimports)
   {
	   if ($handle = opendir(DPXROOT . '/htdocs/customimports')) {
		 while (false !== ($entry = readdir($handle))) {
			if ($entry != "." && $entry != ".." && strpos($entry,".js") !== false) {
			  $htmlFooter .= "<script type='text/javascript' src='./customimports/$entry'> </script>";
			}
		 }
		 closedir($handle);
		}
   }


    
    // load any custom startup / and other scripts
    // to bundle a collection of javascript files, store them as json array in a json file
    if(isset($_GET['customscript']))
    {
		$scripts = explode(',', $_GET['customscript']);
		foreach($scripts as $s)
		{
			//$spath = resolve_Route(VARPATH . "/customscripts/");
			$spath = resolve_Route(DPXROOT . "/htdocs/var/customscripts/");
			if(file_exists( "$spath$s.json" ))
			{
			    $s = "$spath$s.json";
				$json = json_decode( file_get_contents($s)) ;
				$files = $json->files;
				$customsuffix = $json->version || "";
				foreach($files as $f)
				{
					  $htmlFooter .= "<script type='text/javascript' src='./var/customscripts/$f?$customsuffix'> </script>";
					  //$htmlFooter .= "<script async type='text/javascript' src='./var/customscripts/$f'> </script>";
				}
			}
			elseif(file_exists( "$spath$s.js" ))
			{
			   $htmlFooter .= "<script type='text/javascript' src='./var/customscripts/$s.js?".generateRandomString(3)."'> </script>";
			   //$htmlFooter .= "<script type='text/javascript'>". file_get_contents("$spath$s.js") ."</script>";
			   //http://localhost/miracx/index.php?project=CTStroke&customscripts=reading
			   
			}
			else
			{
			  die('Custom script ' . $s . ' out found');
			  error_log('Custom script ' . $s . ' out found');
			}

		}
    }    
    
    
    return $htmlFooter;

  }


   // subfunction to translate conditions to sql stuff
      function translateConditions($input, $type)
      {
        $out = Array();
        foreach($input as $t)
        {
          $temp = explode(':', $t);
          $key = substr( trim($temp[0]), 1) ; // remove the first part S, F , P
          $val = trim($temp[1]);

          $val = str_replace('*', '%', $val);

          if(stripos($key, 'TAG')!== false)
            $val = "%/" .$val. "/%";

          if( $val !== ""  )    
            $out[$key] = $val;

          if( $val == "NULL"  )    
            $out[$key] = "";

        }
        if ( sizeof($out)==0 )
          return false;
        else
          return  $out ;
      }

      function mergeQuery($A)
      {
        if( $A === false )
          return "1";
        
        $out = Array();
        foreach($A as $key => $val)
        {
          // if there is an | operator, interpret as regexp, otherwise as like
          if(strpos($val, "|") !== false )
            $out[]  = "$key REGEXP \"$val\"";
          else
            $out[]  = "$key LIKE \"$val\"";
        }
        return implode( $out, ' AND ' ) ;
      }

    function translatefileQuery($string)
    {
      $string =   urldecode($string);
      $string = preg_replace('/\s+/', ' ', $string);

      // translate subfolder/file.nii to FS... FFilename
      $fsel = false;
      $found = preg_match_all("/(?<subfolder>[^\s]+)\/(?<filename>[^\/^\s]+)/x", $string, $fsel );
      if($found)
      {
		$subfolder =  $fsel['subfolder'][0];
		$filename  =  $fsel['filename'][0];
		$string = "FSubFolder:$subfolder FFilename:$filename " . substr($string, strlen($subfolder)+strlen($filename)+1);
		//die($string);
      }      
      else
      {
     	  $parts = explode(' ', $string);
		  if (strpos($parts[0],":") == False)
		  {
			  $found = preg_match_all("/(?<filename>[^\/^\s]+)/x", $parts[0], $fsel );
			  if($found)
			  {		
				$filename  =  $fsel['filename'][0];
				$string = "FSubFolder:NULL FFilename:$filename " . substr($string, strlen($filename)+1);
			  }
		  }
      }
      // add whitespaces at end and beginnging
      $string = " $string ";
      
      // replace shortcuts and others
      $string = str_replace('SFIRST'  , 'SStudyDate:N0'     ,$string );
      $string = str_replace('SLAST'   , 'SStudyDate:N-0'    ,$string );
      //$string = str_replace('FILE:'   , 'FFilename:'    ,$string );



      $P = false; $S = false; $F = false;
      $regexp = '\w+:\s*[\w#%\/*()\.\-|]*'; // this is the basic pattern for search features
      //$regexp = '\w+:[\w\d#%*()]\s'; // this is the basic pattern for search features


      // find all matches and set to array
      preg_match_all("/\sP$regexp/", $string ,  $P );
      preg_match_all("/\sS$regexp/", $string ,  $S );
      preg_match_all("/\sF$regexp/", $string ,  $F );

      // PATIIENT
      $P = translateConditions($P[0], 'P' ); 
      $P = mergeQuery( $P );
      $PC = "patients_id IN (SELECT PIZ FROM patients WHERE $P )";
      

      // STUDY
      $S = translateConditions($S[0], 'S' );

      $datesorter = " ";
      if($S !== false )
      {
        foreach( $S  as $key => $val)
        {
          if(stripos($key,'StudyDate' ) !== false)
          {
            $v = $val;
            if (stripos($v ,'N') !== false) 
            {
              //$v = substr($v, 1);
              if ( stripos($v , '-') === false ) // start from OLDEST eg EARLIEST study
              {
                $datesorter = " ORDER BY StudyDate ASC LIMIT 1 OFFSET " . substr($v, 1) ;
              }
              else
              {
                $datesorter = " ORDER BY StudyDate DESC LIMIT 1 OFFSET " . substr($v, 2) ;
              }
              unset($S[$key]);
             }
          }
        }
        if(empty($S)) $S=false;
      }

      $S = mergeQuery($S);
      $SC = " RIGHT JOIN ( SELECT StudyID FROM studies WHERE $S AND $PC $datesorter ) as s on s.studyID=files.studies_id ";
      

      // FILE
      $F = translateConditions($F[0], 'F' );
      $F = mergeQuery($F);
      $FC = $F;

      if($P=="1" & $S=="1" & $F=="1")      
        $query = "SELECT * FROM files WHERE 0";
      else
        $query = "SELECT files.* FROM files " . $SC. " WHERE $PC AND $FC LIMIT 100 " ;

      //client_log("DPX-error: " .$query );
      //die($query);
      return $query;

    }

    function fileQuery($string,$project)
    {
      $query = translatefileQuery($string);
      $db = mydbconnection($project);
      $a = $db->query($query);
      $db->close();

      if(!$a)
      {
          $out = false;
      }
      else
      {
        $out = $a->fetch_assoc();
      }
      return $out;
    }


    function getMetaInfo($psid,$project,$echotype,$fromjsonfile)
    {

        $db = mydbconnection( $project);

        $res = array();  
        $sharppos = strpos($psid,'#');

        $patientinfo = true; 
        if ($sharppos !== false)
        {
          $PIZ = substr($psid,0,$sharppos);
          $SID = substr($psid,$sharppos);
          $patientinfo = false; 
        }
        else
        {
          $PIZ = $psid;
        }
        

        $query = "select * from patients where PIZ LIKE '$PIZ'";
        $a = $db->query($query); 
        $patientrow = $a->fetch_assoc();
        unset($patientrow['ID']);
        unset($patientrow['lastchange']);
        if ($patientinfo)       
            deepExtend($res,$patientrow,true);
                   
 
        if ($patientinfo)
          $query = "select * from studies where patients_id LIKE '$PIZ'";
        else
          $query = "select * from studies where patients_id LIKE '$PIZ' and StudyID LIKE '$SID'";


        $a = $db->query($query);
        while ($row = $a->fetch_assoc())
        {  
             $sid = $row['StudyID'];   
             
             //$query = "select * from files where (FileName LIKE 'nodeinfo.json' OR (FileName LIKE '%.json' and (SubFolder LIKE 'META' or SubFolder LIKE 'forms'))) and patients_id LIKE '$PIZ' and studies_id LIKE '$sid'";
             // why only allow jsons in META ...?
             $filesel = "(FileName LIKE '%.json' AND (SubFolder LIKE 'META' OR SubFolder LIKE 'forms'))";
             if ($fromjsonfile != "")
                 $filesel = "(FileName LIKE '$fromjsonfile.json' AND (SubFolder LIKE 'META' OR SubFolder LIKE 'forms'))";
               

             $query = "select * from files where (FileName LIKE 'nodeinfo.json' OR  $filesel) and patients_id LIKE '$PIZ' and studies_id LIKE '$sid'";
             //$query = "select * from files where (FileName LIKE 'nodeinfo.json' OR (FileName LIKE '%.json' AND (SubFolder LIKE '%'))) and patients_id LIKE '$PIZ' and studies_id LIKE '$sid'";

             $b = $db->query($query);
             while($node = $b->fetch_assoc())
             {
                $name = str_replace('.json','',$node['Filename']);
		        $resolvedFilePath = resolve_Route($node['FilePath']);
		        if (!file_exists($resolvedFilePath))
		          continue;

                $str = file_get_contents($resolvedFilePath);
                $str = str_replace("\\","\\\\",$str);
                $meta = json_decode($str);
                if ($meta == null)    
                {            
					$str = str_replace("Infinity","\"Infinity\"",$str);
					$str = str_replace("NaN","\"NaN\"",$str);
                    $meta = json_decode($str);
                }
                if (isset($meta->tag))
                    unset($meta->tag);


                if ($name == "nodeinfo")
                   deepExtend($row,$meta,true);
                else 
                {
                   if (!$echotype)                 
                      $row[$name] =  $meta;
                   else
                   {
                      if ($node['SubFolder'] == 'META')
                         $row["[META]".$name] =  $meta;
                      else if ($node['SubFolder'] == 'forms')
                         $row["[FORM]".$name] =  $meta;
                      else 
                         $row[$name] =  $meta;
                      
                   }

                }
             }
             if (isset($row['ID']))
          		unset($row['ID']);
             if (isset($row['lastchange']))
		        unset($row['lastchange']);

            /****************** get dicom header info *****************************/
            if($echotype && isset($row['StudyPath']))
            {
                $dicomheaderpath = resolve_Route($row['StudyPath'] . "/DICOM");
                //error_log($dicomheaderpath);
                if(!is_dir($dicomheaderpath))
                {
                    1;
                }
                else
                {
 					$files = scandir($dicomheaderpath);
 					$files = array_diff(scandir($dicomheaderpath), array('..', '.'));
                    $res['[DICOM]'] = [];
 					foreach($files as $tfile)
 					{
 						if(!preg_match("/\.mat$/", $tfile))
 						{
 							//error_log($tfile);
							//$cmd = "dcmdump --no-uid-names $dicomheaderpath/$tfile";
							$cmd = "dcmdump $dicomheaderpath/$tfile";

							$tres = array();
							exec($cmd . " 2>&1 ", $tres, $tret);

							  $hdr = array();
							  $hdr2 = array();
							  $matches = array();
							  foreach($tres as $trow)
							  {

                                  $baseregexp = "/\((?<tag>\w{4},\w{4})\)\s\w\w\s\[(?<value>.+)\]\s+\#\s+\d+,\s\d\s(?<descr>\w+)/x" ;

								  preg_match_all($baseregexp , $trow, $matches, PREG_SET_ORDER ); // x means igonore empty spaces
								  if(!empty($matches))
								  {
									$key = "(".$matches[0]['tag']. ") " . $matches[0]['descr']. "";
									$val = $matches[0]['value'];
									$val = preg_replace("/[^A-Za-z0-9-_\+\.:\s><\(\)]/", '_', $val);
									$hdr[$key] = $val;
									$hdr2[$matches[0]['descr']] = $val;
									
									}
								  else
								  {
								  }
							   }
							   $snum = isset($hdr2['SeriesNumber'])?$hdr2['SeriesNumber']:0;
							   $sdesc = isset($hdr2['SeriesDescription'])?$hdr2['SeriesDescription']:"nosdesc";

                               $snum = substr($tfile, - 8,4);
                               //error_log(var_dump($hdr));
							   $res['[DICOM]'][$sdesc."_".$snum] = $hdr;

 						}
 					}

                 }
            }


  
             if ($patientinfo)
             {
                if (isset($res['STUDIES']))
                    $res['STUDIES'][$sid] = $row;
                else
                    $res['STUDIES'] = array($sid => $row);
             }
             else
                deepExtend($res,$row,true);
        }


        if (isset($_SESSION['moduleInfo'][$project]['hasReadingTable']) && $_SESSION['moduleInfo'][$project]['hasReadingTable'])
        {

			if ($patientinfo)
			  $query = "select * from readingresults where patients_id LIKE '$PIZ'";
			else
			  $query = "select * from readingresults where patients_id LIKE '$PIZ' and studies_id LIKE '$SID'";


			$b = $db->query($query);
			while($node = $b->fetch_assoc())
			{
				$row = array();
				$json = json_decode($node['json']);
				if (isset($json->formcontent))
					$row[$node['formid'].'_'.$node['user'].'_'.$node['iterator']. '.reading'] = $json->formcontent;
				deepExtend($res,$row,true);
			}

        }
        		        
        if (!$patientinfo)  
        {     
          if (!$echotype)            
            $res['PATIENT'] = $patientrow;
          else
            $res['[SQL]PATIENT'] = $patientrow;
        }

        //DPX_log($psid . "    11111111111--------->" . print_r($res,true));
           
        $db->close();


        return $res;
   
    }


    function echoMetaInfo($fileID,$project)
    {
    
        $psid  = substr($fileID,5);
        
        $fname = "patient meta information.json";
        $finfo = '{"meta":"true","type":"patient","fileID":"'.$fileID.'"}';
        if (strpos($psid,'#') != false)
        {
          $fname = "study meta information.json";
          $finfo = '{"meta":"true","type":"study","fileID":"'.$fileID.'"}';
        }

        header("Content-type: text/plain");
	    header('Content-Disposition: attachment; filename="' . $fname . '"');
        header('DPX-filename: ' . $fname  );
        header('DPX-fileinfo: ' . $finfo );
     
        $res = getMetaInfo($psid,$project,true,"");
        echo json_encode($res);
     
        return;
     }

  function client_log($str)
  {
      if(is_array($str) | is_object($str))
        $str = json_encode($str);
      echo NORA_LOG . $str . NORA_ESEP;       
  }

  function client_err($str)
  {
      if(is_array($str) | is_object($str))
        $str = json_encode($str);
      echo $str . NORA_ESEP;       
  }

  
  function DPX_log($str)
  {
    $user = "unknown";
    $proj = "unknown";
    if (isset($_SESSION['username']))
      $user = $_SESSION['username'];
    if (isset($_GET['project']))
      $proj = $_GET['project'];

    if ( isset($_SERVER['HTTP_X_FORWARDED_FOR']) ){
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } 
    else{ 
        $ip = $_SERVER['REMOTE_ADDR'];
    }

    $str =  date ("Y-m-d H:i:s.", time() )  . ' ' . $user . ',' . $ip . ' (' . $proj . '):  ' . $str ; 
    file_put_contents(resolve_Route(VARPATH."/syslogs/") . '/access.log', $str.PHP_EOL , FILE_APPEND );
  }


  function redirectToFile($fileID)
  {
  	  session_write_close(); 

     $dbname = "";

     if( isset($_GET['json']))
     {
       $json = json_decode($_GET['json']);
       if (isset($json->project))
           $dbname = $json->project;
     }
     
     if (isset($_GET['project']))
        $dbname = $_GET['project'];
     
     if ($dbname == "")
     {
        echo("no project selected");
        header("DPX-error: No project selected");
        DPX_log("no project selected");  
        return;     
     }
     
     if (!isset($_SESSION['moduleInfo'][$dbname]) && (!defined('ATLASPROJECT') || ATLASPROJECT!=$dbname) && strpos($_SERVER['HTTP_REFERER'],"sharelink") == false )
     {
        echo("unallowed access");
        header("DPX-error: unallowed access");
        error_log("unallowed access");       
        DPX_log('fileID:' . $fileID . ' UNALLOWED ACCESS'); 
        return;
     }
  
     $_GET['project'] = $dbname;
    
     DPX_log('send fileID:' . $fileID ); 

     if (substr($fileID,0,5) == 'meta_')
     {
        echoMetaInfo($fileID,$dbname);
        return;
     }

     
     // *********** these files are in a remote pacs
     // two ways: either, the fileID has starts with PACS:://<json-string>
     // or in db, but the FilePaht has this signature
     // latter case considered somwhere down

     function getFromRemotePACS($json_in)
     {    
        // now, two possibilities: either 
        //    1. preview only: 
        //    2. preview,  and write dpx file afterwards to import

        require_once(dirname(__FILE__) . '/pacsquery.php');
       
        
        $_GET['json'] = $json_in;
        
        $json = PACSQuery_run("PACSQuery_movescu");

        $err = $json['log']['err'];
        if(sizeof($err) > 0)
        {
           header('DPX-error: '  . $err[0]  ." (see log)" );
           echo "json_in:" .   var_dump(json_encode($json_in));
           echo "\n -----\n log:" .       implode("\n", $json['log']['log']);
          
           //error_log(json_encode($json));
           error_log( var_export($json, true ) );

           if(isset($json['responseRaw']))
              echo "\n -----\n response:" .  implode("\n", $json['responseRaw']);
           return;
        }

        if(isset($json['json']['filepath']))
        {
           $filePath = $json['json']['filepath'];
        }
        else
        {
           header('DPX-error: No nifti file created. see log' );
           echo  var_dump($json);
           return;
        }

        $row = Array();
        $row['ID'] = htmlentities($filePath);
        $row['FilePath']  = htmlentities($filePath);
        $row['Filename']  = htmlentities('tempimage.nii');
        $row['SubFolder'] = htmlentities('subfolder');
        $row['filesize']  = filesize($filePath);
        
        header("Content-type: " . mime_content_type ($filePath) );
        header('Content-Length: '. $row['filesize']);
        header('Content-Disposition: attachment; filename="' . $row['Filename'] . '"');
        header('DPX-filename: ' . $row['Filename'] );
        header('DPX-fileinfo: ' . json_encode($row)   );
       

        if(!is_readable($filePath ))
        {
          header('DPX-error: ' . "File not readable: $filePath"   );
          return;
        }

        $fp = fopen($filePath, 'rb');
        fpassthru($fp); 
        fclose($fp);
        
        // delete the temp nifti file again 
        if(strlen($filePath > 10))
        {
          $i = pathinfo($filePath);
          unlink($i['dirname']. "/*.*");
          rmdir($i['dirname']);
        }

        return; 
     } 
     // end of getFromRemotePACS
     
     function getReadingJSON($json_in, $dbname)
     {
     	    $db = mydbconnection( $dbname);
     	    $x = explode('_', $json_in);

   	    	$query = "select * from readingresults where ID = '$x[0]' AND formid = $x[1] ";

			$a = $db->query($query);
			if( ($row = $a->fetch_assoc() ) )
			{
			     $thefilename = "$row[formid]_$row[user]_$row[iterator].reading";

				$xrow = Array();
				$xrow['ID'] = $json_in;
				$xrow['FilePath']  = $json_in;
				$xrow['Filename']  = $thefilename;
				$xrow['SubFolder'] = "META";
				$xrow['filesize']  = 0;
				//$xrow['Tag']  = "FORM";

				header("Content-type: " . "text/plain");
				header('Content-Length: '. $row['filesize']);
				header('Content-Disposition: attachment; filename="' . $thefilename . '"');
				header('DPX-filename: ' . $thefilename );
				header('DPX-fileinfo: ' . json_encode($xrow)   );
				header('DPX-formid: ' .  $row['formid']   );
				
				echo $row['json'];
			}
			else
			{
  				header('DPX-error: ' . "No reading entry found for: $json_in"   );
          		return;				
			}
			$db->close();

    
     }
	 // end of getReadingJSON


     $pacsstr = 'PACS://';
     $rstring = 'READING://';
     if(strpos($fileID, $pacsstr) === 0 ) // starts with 0
        return getFromRemotePACS(substr($fileID, strlen($pacsstr)) );
     else if(strpos($fileID, $rstring) === 0 ) // starts with 0
        return getReadingJSON(substr($fileID, strlen($rstring)), $dbname );
     else if(!is_numeric($fileID))
       $query = translatefileQuery($fileID,$dbname);
     else
       $query = "SELECT * FROM files WHERE id = $fileID";
  
    $db = mydbconnection( $dbname);
    $a = $db->query($query);
    if($a==false)
    {
        header("DPX-error: Database error:  '$db->error' in query: $query");
        error_log("DPX-error: Database error:  $db->error ");
        $db->close();
        return;
    }

    if( !($row = $a->fetch_assoc()) )
    {
      //header("DPX-error: File with ID / pattern newline $fileID newline not found.");
      header("DPX-error: Query empty: $query .");
      $db->close();
      return;
    }

    // get series info
    $qf = "SELECT StudyPath,StudyID,StudyDate FROM studies WHERE StudyID LIKE '".$row['studies_id']."' AND patients_id='".$row['patients_id']."'";
    $a = $db->query($qf);
    $jsoninfo = null;
    if (($srow = $a->fetch_assoc()))
    {
        $node = resolve_Route($srow['StudyPath'] . '/nodeinfo.json');
        if (file_exists($node)) 
        {
          $jsoninfo = json_decode(file_get_contents($node));
          if (isset($jsoninfo->Series))
          {
              $jsoninfo = $jsoninfo->Series;
              $p = $row['SubFolder'] . "/" . $row['Filename'];
              $p =  str_replace(".gz","",$p);
              $p =  str_replace(".nii","",$p);
              if (isset($jsoninfo->$p))
                $jsoninfo = $jsoninfo->$p;
              else
                $jsoninfo = null;
          }
          else
            $jsoninfo = null;
        }
    }



    /************************************************
    *  coreg / transform info for this study ??
    ************************************************/
    $coreginfo = null;
    $qf = "SELECT * FROM files WHERE TAG like '%SCOREG%' AND Subfolder like 'transforms' AND Filename like '%.json' AND studies_id = '$row[studies_id]' AND patients_id='$row[patients_id]' ";
    $a = $db->query($qf);
    //error_log(var_dump($a->fetch_assoc()));
    while (($srow = $a->fetch_assoc()))
    {
        $coregfile = resolve_Route($srow['FilePath']);
        if (file_exists($coregfile)) 
        {
           $coreginfo = json_decode(utf8_encode(file_get_contents($coregfile)));
		   if ($coreginfo->IDspecific)
		   {
			   if ($row['FilePath'] == $coreginfo->filepath_target)
				   break;
			   else 
				  $coreginfo = null;
		   }
          
        }

    }

    $db->close();




    $filePath =  $row['FilePath'];

    // ***** second case of pacs:  "PACS://" is in FilePath, the rest is a structured json with necessary info
    if(strpos($filePath, $pacsstr) === 0 ) // starts with 0
    {
      // must cat a variable to the json ...
       $localjson = json_decode( substr($filePath, strlen($pacsstr)), true );
       if( isset($json->PACSPREVIEW) )
          $localjson['PACSPREVIEW'] = $json->PACSPREVIEW;
       
       $localjson['seriousmode'] = 1;
       $localjson['fileID'] = $fileID;
       
       $pres =  getFromRemotePACS( $localjson );
       return;
    }

    $filePath =  str_replace("//","/",$filePath);
    $filePath = resolve_Route($filePath);
    
    
    //$row['FilePath'] = htmlentities($filePath);
    unset($row['FilePath']);
    $row['Filename'] = htmlentities($row['Filename']);
    $row['SubFolder'] = htmlentities($row['SubFolder']);


    $maxfilesize = 4095*1000*1000;
    if (isset($_SESSION['state'][$dbname]))
    {
		$thestate = $_SESSION['state'][$dbname];  
		$maxfilesize_param = $thestate->viewer->maxfilesizeImage;
		if ($maxfilesize_param > 128 && $maxfilesize_param < 4096)
			 $maxfilesize = $maxfilesize_param*1000*1000;
    }
         

    if (isset($row['MULTIFILE']) && $row['MULTIFILE'] == "1")
    {
        $farr = array();
        error_log($row['FilePath']);
        foreach (glob( $row['FilePath']) as $filename) {
          $farr[] = $filename;
        }
        

        $hdrlength = 352;
        $datalength = filesize($farr[0])-$hdrlength;
        $filelength = $hdrlength + $datalength*sizeof($farr);

        $Num = sizeof($farr);
      
        if ($filelength > $maxfilesize)
        {
            $Num = floor($maxfilesize/$datalength);
            $filelength = $hdrlength + $datalength*$Num;
    	    header('DPX-note: file exceeded size of ' . ($maxfilesize/1000000) .  ' MB, just sent leading part');

        }


        header("Content-type: " . mime_content_type ($farr[0] ));
        header('Content-Length: '. $filelength);
        header('Content-Disposition: attachment; filename="' . $row['Filename'] . '"');
        header('DPX-filename: ' . $row['Filename'] );
        header('DPX-fileinfo: ' . json_encode($row)   );

        $fp = fopen($farr[0], 'rb');
        echo fread($fp, 40);	    
        $inttype = 'v'; // little or bigendian, v or n
        fseek($fp, 2,SEEK_CUR);
        echo pack($inttype, 4);
        echo fread($fp,2*3);
        fseek($fp, 2,SEEK_CUR);
        echo pack($inttype, $Num);	    
        echo fread($fp,$hdrlength+$datalength-40-2*5);        
        //echo fpassthru($fp);        
        fclose($fp);


        for ($k=1;$k < $Num;$k++)
        {
            $fp = fopen($farr[$k], 'rb');
            fseek($fp, $hdrlength);
            echo fread($fp, filesize($farr[$k])-$hdrlength);
            // echo fpassthru($fp);
            fclose($fp);
        }
        return;


    }

    if (!is_readable($filePath))
    {
      header("DPX-error: File not readable: $filePath .");
      return;
    }

    $row['identifier'] = file_identifier($filePath);
    


    
    // check if this is NIFIT hdr / img combination. In this case, cat the 2 files and change header accordingly
    if (substr($filePath, sizeof($filePath)-4) == 'hdr' )
    {
       $trunk =  substr($filePath, 0, sizeof($filePath)-4);
       $hdr = $trunk . 'hdr';
       $img = $trunk . 'img';

       if (filesize($hdr) == 348 | filesize($hdr) == 352) // double check if this is a valid NIFTI header
       {
          $outname = basename($trunk . 'nii');

          $row['filesize'] = filesize($hdr) + filesize($img);
          header("Content-type: " . mime_content_type ($filePath ));
          header('Content-Length: '. filesize($hdr) + filesize($img));
          header('Content-Disposition: attachment; filename="' . $outname . '"');
          header('DPX-filename: ' . $outname );
          header('DPX-fileinfo: ' . json_encode($row)   );


            $fp = fopen($hdr, 'rb');
            // read and flush first block
            echo (fread($fp, 108));
            // now, write the new value for vox_offset. must be 352 for concatenated files
            echo (pack('f', 352));
            // read the rest until "magic number"
            fseek($fp, 108+4);
            echo (fread($fp,348-108-4-4));
            // change the "magic number" to n+1. This indicates that hdr and data are in same file
            echo hex2bin('6E2B3100'); // hex representation of char "n+1"
            // These next 4 bytes or normally zero. First byte indicates length of extended header
            echo hex2bin('00000000');
            fclose($fp);

            // stream the image file
            $fp = fopen($img, 'rb'); 	  fpassthru($fp); 	  fclose($fp);
            return;
       }

    }
    else if (substr($filePath, sizeof($filePath)-6) == '2dseq' )
    {

        $visu_pars = substr($filePath, 0, sizeof($filePath)-6)  . 'visu_pars';
        error_log($visu_pars);
        $row['fileseries'] = true;
        $row['filesize'] = array(filesize($visu_pars),filesize($filePath));
        $row['filenames'] = array('visu_pars','2dseq');

        header("Content-type: " . mime_content_type ($filePath ));
        header('Content-Length: '.  (filesize($visu_pars)+filesize($filePath)) );
        header('Content-Disposition: attachment; filename="' . basename($filePath) . '"');
        header('DPX-filename: ' . basename($filePath) );
        header('DPX-fileinfo: ' . json_encode($row)   );


        $fp = fopen($visu_pars, 'rbn');
        fpassthru($fp); 
        fclose($fp);

        $fp = fopen($filePath, 'rbn');
        fpassthru($fp); 
        fclose($fp);

        return;


    }
    else if (substr($filePath, sizeof($filePath)-5) == '.mat' && !isset( $_GET['downloadFile'] )   )
    {

        if (filesize($filePath) > 500000)
        {
          header("DPX-error: matfile too large, sorry!" . $filePath);
          return;
        }



        header('Content-Disposition: attachment; filename="' . basename($filePath) . '"');
        header('DPX-fileinfo: ' . json_encode($row)   );

        if (1)
        {
			header('DPX-filename: ' . substr( basename($filePath), 0, sizeof( basename($filePath))-4). 'json');
			$fp = popen(DPXROOT . '/htdocs/mat2json ' . $filePath, 'r');			
			fpassthru($fp); 
			pclose($fp);

        }
        else // sometime in future we will read hdf5 from clientside
        {
			header('DPX-filename: ' . basename($filePath) );			
			$fp = fopen($img, 'rb'); 	  fpassthru($fp); 	  fclose($fp);
            fpassthru($fp); 
            fclose($fp);

        }

        return;     

    }
    else if  (substr($filePath, sizeof($filePath)-4) == 'nii' & filesize($filePath) > $maxfilesize )
    {
      
        // Very large files: 
        //   If timeseries, send only part of the series.
        //   If volume, send only center slices of the volume
        //   nifti header:  ndims:40 sx:42 sy:44, sz:46, st: 48
        $hdrlength = 352;
        //$datalength = filesize($filePath)-$hdrlength;
        $fp = fopen($filePath, 'rb');

        $hdr1 = fread($fp, 40);	    
        $inttype = 'v'; // little or bigendian, v or n
        //fseek($fp, 2,SEEK_CUR);
        //$hdr2 = pack($inttype, 4); // set ndims to 4
        //$hdr3 = fread($fp,2*3);        
        
        //$ndims = 4;
          
        $temp = unpack('s', fread($fp,2));
          $ndims = $temp[1];
        $temp = unpack('s', fread($fp,2));
          $sx = $temp[1];
        $temp = unpack('s', fread($fp,2));
          $sy = $temp[1];
        $temp = unpack('s', fread($fp,2));
          $sz = $temp[1];
        $temp = unpack('s', fread($fp,2));
          $st = $temp[1];


        $wordwid = floor((filesize($filePath)-$hdrlength)/($sx*$sy*$sz*$st));
        $datalength = $sx*$sy*$sz*$st*$wordwid;


        if ($st > 1)
        {
            $piecesize = floor($datalength/$st);
            $st = floor($maxfilesize / $piecesize);
            $pieces = $st;
            $dpxnote = "DPX-note: file exceeded size of " . ($maxfilesize/1000000) .  " MB. Sent only $pieces timeframes";
        }
        else
        {
            $piecesize = $datalength/$sz;
            $sz = floor($maxfilesize / $piecesize);
            $pieces = $sz;
            $dpxnote = "DPX-note: file exceeded size of " . ($maxfilesize/1000000) .  " MB. Sent only ".($pieces)." slices";
        }
        $senddatasize = $pieces*$piecesize;
        /*
        error_log("piecesize " . $piecesize);
        error_log("pieces " . $pieces);
        error_log("wordwid " . $wordwid);
        error_log("filesize " . (filesize($filePath)));
        error_log("sendata " . $senddatasize);
        */
        header('Content-Length: '. ($hdrlength + $senddatasize));
        header($dpxnote);
        header("Content-type: " . mime_content_type ($filePath ));
        header('Content-Disposition: attachment; filename="' . $row['Filename'] . '"');
        header('DPX-filename: ' . $row['Filename'] );
        header('DPX-fileinfo: ' . json_encode($row)   );

        echo $hdr1;
        echo pack($inttype, $ndims);
        echo pack($inttype, $sx);	    
        echo pack($inttype, $sy);	    
        echo pack($inttype, $sz);	    
        echo pack($inttype, $st);	    
        // send rest of header
        echo fread($fp,$hdrlength-40-2*5 );        

        // must chunk the fread further, do in $sx chunks
        $chunksize = $senddatasize/$sx;
        error_log($chunksize);
        for($k=0; $k<$sx; $k++)
        {
          echo fread($fp,$chunksize);        
        }
     //  echo fread($fp,$hdrlength-40-2*5 + $senddatasize);        


    // test: read full file and echo. Does not work on kellnere's computer with large files ... -> must always chunk with echo and fread!!
//         fclose($fp);DPX_log("kjkJ");

//         $fp = fopen($filePath, 'rb');
//         echo fread($fp, filesize($filePath));        

        fclose($fp);
        return;


    }

    




    $use_xsendfile = false;
    
    
    $row['filesize'] = filesize($filePath);
    if ($use_xsendfile)
      header("X-Sendfile: ".$filePath);
    header("Content-Type: " . mime_content_type ($filePath ));
    header('Content-Length: '.filesize($filePath));
    header('Content-Disposition: attachment; filename="' . $row['Filename'] . '"');
    header('DPX-filename: ' . $row['Filename'] );
    header('DPX-fileinfo: ' . json_encode($row)   );
    if ($jsoninfo != null)
    {
      header('DPX-jsoninfo: ' . (json_encode($jsoninfo))   );
    }
    if ($coreginfo != null)
    {
      header('DPX-coreginfo: ' . (json_encode($coreginfo))   );
    }


    if (!$use_xsendfile)
    {
        $fp = fopen($filePath, 'rb');
        fpassthru($fp); 
        fclose($fp);
    }

  }



  function evalCommand($command, $json_in = false)
  {
    if( $json_in !== false)
      $_GET['json']  = json_encode( $json_in );
    $json_out = array();
    $json_out['success'] = false;
    $json_out['msg'] = '';
    $json_out['json'] = '';

    if (isset($_GET['project']))
      $project = $_GET['project'];
    else
      $project = "";      
    $projectDatabase = $project;

    if ($project == "") // project is not set during public shared links
    {
    	if ($command != "get_fileidentifier")
    	{
			client_log("project not set: " . $command);
			DPX_log("project not set: " . $command);
			client_log($json_in);
    	}
    }

    $physical_move = false;
    $physical_del = false;

    if ($project != "")
    {

		if (!isset($_SESSION['state'][$project]))
			DPX_log("project ".$project." not present: " . $command);
		if (!isset($_SESSION['state'][$project]->viewer))
			DPX_log("project ".$project." state->viewer not present: " . $command);
		if (!isset($_SESSION['state'][$project]->viewer->physrename))
			DPX_log("project ".$project." state->viewer->physrename not present: " . $command);


		$physical_move = $_SESSION['state'][$project]->viewer->physrename;
		$physical_del = $_SESSION['state'][$project]->viewer->physdelete;
    }

    if ($physical_del)
       $permQuery = " AND permission LIKE '%w%'";
    else 
       $permQuery = " AND permission LIKE '%w%'";
    try
    {

      if ($command=='report_js_error')
      {
        $db = mydbconnection(ROOTDB);
        $jsonString = $db->real_escape_string( $_GET['json'] );
        $url = substr($_SERVER['REMOTE_ADDR'],0,255);
        $q = "INSERT INTO error_js (url,user,error) VALUES ('$url','".$_SESSION['username']."','$jsonString')";
        $a = $db->query($q);
        $db->close();

      }
      if ($command=='del_user_cmd')
      {
        $cmdname = ($_GET['cmdname']);
        $db = mydbconnection(ROOTDB);
        $q = "DELETE FROM cmdstore WHERE cmdname LIKE '" . $cmdname . "' AND owner LIKE '" . $_SESSION['username'] . "'";
        error_log($q);
        $a = $db->query($q);
        if ($a)
           $json_out['success'] = true;
        else
           $json_out['success'] = false;

        $db->close();

      }
      if ($command=='getuserbatches')
      {
          $json_out['content'] = getUserbatches($project);
          $json_out['success'] = true;          
      }
      if ($command=='toggle_fav_user_cmd')
      {
        $state = ($_GET['state']);
        $cmdname = ($_GET['cmdname']);
        $db = mydbconnection(ROOTDB);
        $q = "UPDATE cmdstore SET fav='".$state."' WHERE cmdname LIKE '" . $cmdname . "' AND owner LIKE '" . $_SESSION['username'] . "'";
        error_log($q);
        $a = $db->query($q);
        if ($a)
           $json_out['success'] = true;
        else
           $json_out['success'] = false;

        $db->close();

      }
      elseif ($command=='update_row')
      {
        if ($_SESSION['userinfo']['isadmin'])
        {
          $db = mydbconnection(ROOTDB);
          $json = json_decode($_GET['json']);

          $row = $json->row;
          updateRow($db,$json->table,(array) $json->row);

          $db->close();
          $json_out['success'] = 1;
        }
        else
        {
           $json_out['msg'] = 'unallowed DB access by non-root user';
           $json_out['success'] = false;
        }

      }
      elseif ($command=='update_user_cmd')
      {
        $db = mydbconnection(ROOTDB);
        $jsonString = ($_GET['json']);
        $jsonString = str_replace("\\\"","`",$jsonString);
        $jsonString = str_replace("'","`",$jsonString);
        $jsonString = str_replace("\\","\\\\",$jsonString);

        $row = array('jsondesc' => $jsonString, 'cmdname' => $_GET['cmdname'], 'project' => $project, 'owner' => $_SESSION['username'], 'fav' => $_GET['fav']);
        updateRow($db,'cmdstore',$row);

        $db->close();
        $json_out['success'] = 1;
      }
      elseif ($command=='createfile')
      {
        $json = json_decode($_GET['json']);
        createFile($json,$projectDatabase);
        $json_out['success'] = 1;
      }
      elseif ($command=='getfileinfo')
      {
            $json = json_decode($_GET['json']);
            $db = mydbconnection( $projectDatabase);
            $theclause = "SELECT * from files WHERE ID=" . $json->fileID ;
            $tmp = $db->query($theclause);
            if ($row = $tmp->fetch_assoc())
            {
               $json_out['success'] = 1;
               $path = resolve_Route($row['FilePath']);

			    
			   $DateModified = date ("Y-m-d H:i:s.", filemtime($path) );
			   $DateModified = substr($DateModified,0,19);
               $row['DateModified_fs'] = $DateModified;       
               $sss =  substr(shell_exec("ls -l " . $path),0,10);
              // client_log("mmmm" . $sss);
               $row['ls-l'] = htmlentities(shell_exec("ls -l " . $path));
               $json_out['info'] = $row;
            }
            else
               $json_out['success'] = 1;


      }
      elseif ($command=='validate_files')
      {
              
              $jsonString = ($_GET['json']);
              $argarr = json_decode($jsonString);
              
              $db = mydbconnection( $projectDatabase);
              foreach($argarr as $args)
                foreach($args as $arg => $a )
                {
                    if ($arg != "funref")
                    {
                      $a->resolved = array();
                      for ($k=0;$k<sizeof($a->sels);$k++)
                      {

                        $fclause = "";
                        $pos_p = strpos($a->sels[$k]," ");
                        $psid = substr($a->sels[$k],0,$pos_p);


						$sharppos = strpos($psid,'#');
						if ($sharppos !== false)
						{
						  $PIZ = substr($psid,0,$sharppos);
						  $SID = substr($psid,$sharppos);
						  $psid_selector = "(patients_id LIKE '". $PIZ . "' AND studies_id LIKE '". $SID . "')";
						}
						else
						{
						  $psid_selector = "(patients_id LIKE '". $psid .  "')";
						}

                        while(true)
                        {

                          $pos_n = strpos($a->sels[$k]," ",$pos_p+1);
                          if ($pos_n == false)
                          {
                            $sstr = substr($a->sels[$k],$pos_p+1);
                            if ($sstr == '')
                              break;
                          }
                          else
                          {
                            if ($pos_n-$pos_p-1 <= 0)
                            {
                              $pos_p = $pos_n;
                              continue;
                            }
                            $sstr = substr($a->sels[$k],$pos_p+1,$pos_n-$pos_p-1);
                          }

                          $cpos = strpos($sstr,',');
                          if ($cpos !== false)
                            $sstr = substr($sstr,0,$cpos);


                          if (substr($sstr,0,4) == 'TAG:')
                          {
                              $fclause .= " (Tag LIKE '%/" . substr($sstr,4) . "/%') OR";
                          }
                          else
                          {                
                              $pos = strrpos($sstr,"/");
                              if ($pos !== false)
                                  $fclause .= " (subFolder LIKE '" . substr($sstr,0,$pos) . "' AND Filename LIKE '". substr($sstr,$pos+1) . "') OR ";
                              else 
                                  $fclause .= " (subFolder LIKE '' AND Filename LIKE '". $sstr . "') OR ";
                          }

                          if ($pos_n == false)
                            break;
                          $pos_p = $pos_n;
                        }
                        $fclause = "(" . $fclause . " 0) AND ". $psid_selector;
                        $theclause = " (SELECT 1 from files WHERE " . $fclause . " LIMIT 1 )";
                        $theclause = str_replace('*','%',$theclause);
                        $tmp = $db->query($theclause);

                        if ($tmp->fetch_assoc())
                        {
                           $a->resolved[$k] = 1;
                        }
                        else
                          $a->resolved[$k] = 0;
                        
                      }
                    }
                }
              $db->close();
              $json_out['res'] =  $argarr;
              $json_out['success'] =1; 

      }
      elseif ($command=='remove_cmd')
      {
         $db = mydbconnection(ROOTDB);
         $db->query("delete from commands where jobid='".$_GET['jobid']."'");
         $db->query("UPDATE gridjobs SET state='?' where  jobid='" . $_GET['jobid'] . "'");         
         $db->close();

      }

      elseif ($command=='unidentify')
      {
         $objs = json_decode($_GET['json']);
         $res = "";
	     for($k=0;$k<sizeof($objs);$k++)
		 {
		     $obj = $objs[$k];
			 $execString = DPXROOT .  "/src/node/nora -p " . $project . " --changeID " . $obj->piz . " --anonym";
			 client_log($execString);
	         $res = $res . shell_exec($execString) . "<br>";
		 }
		 $json_out['success'] = 1;
         $json_out['content'] = $res;

      }
      elseif ($command=='changePID')
      {

         $json = json_decode($_GET['json']);
         $execString = DPXROOT .  "/src/node/nora -p " . $project . " --changeID " . $json->exec . " 2>&1";
         client_log($execString);
         $res = shell_exec($execString);
         $json_out['success'] = 1;
         $json_out['content'] = $res;

      }
      elseif ($command=='importcsv')
      {
      	 savePIDforAbort();
         $json = json_decode($_GET['json']);
         $csvcontent = $json->csv;
         $jsonname = $json->jsonname;
         $tmpuid = generateRandomString(10) . ".csv";         
		 $tmpfname = resolve_Route(VARPATH."/tmp/").$tmpuid;
		 file_put_contents($tmpfname,$csvcontent);
         $execString = DPXROOT .  "/src/node/nora -p " . $project . " --importcsv " .$tmpfname . " PSID --dest " . $jsonname;
         client_log($execString);
         $res = 0;
         $res = shell_exec($execString);
         client_log($res);
         unlink($tmpfname);
         $json_out['success'] = 1;
         $json_out['content'] = $res;
         clearPIDforAbort();

      }
      elseif ($command=='abort')
      {
      	 $str = "killing processes:";
		 foreach($_SESSION['current_pids'] as $id => $value)
         {
      	    posix_kill($id,9);
      	    $str = $str . $id . " ";
         }
         error_log($str);
      	 $_SESSION['current_pids'] = [];
         $json_out['success'] = 1;
         $json_out['content'] = "";
      	 
      }
      elseif ($command=='find_unreferenced')
      {
      	 savePIDforAbort();
         $execString = DPXROOT .  "/src/node/nora -p " . $project . " --find_unreferenced 2>&1";
         client_log($execString);
         $res = shell_exec($execString);
         $tmpuid = generateRandomString(10);
		 $tmpfname = "/tmp/DPX".$tmpuid;
		 file_put_contents($tmpfname,$res);
         $json_out['success'] = 1;
         $json_out['content'] = $tmpuid.$res;
         error_log("find_unreferenced done");
         clearPIDforAbort();

      }
      elseif ($command=='deletetmp')
      {
         $json = json_decode($_GET['json']);
		 $tmpfname = "/tmp/DPX".$json->id;
         $res = file_get_contents($tmpfname);
         unlink($tmpfname);
      }
      elseif ($command=='delete_unreferenced' | $command=='recover_unreferenced')
      {
         $json = json_decode($_GET['json']);

		 $tmpfname = "/tmp/DPX".$json->id;
         $res = file_get_contents($tmpfname);
		 $keys = $json->keys;
         $i = strpos($res,"JSON:");
		 $data =  json_decode(substr($res,$i+5));
		 $filepaths = array();

         for ($k=0; $k < sizeOf($keys);$k++)
          {
          	 $t = $keys[$k];
          	 $x0 = $t[0];
          	 $x1 = $t[1];
             $filepaths[] = resolve_Route($data->$x0->$x1);
          }
		 
		 if ($command=='delete_unreferenced')
		 {

            //for ($k=0; $k < sizeOf($filepaths);$k++)
            //    unlink($filepaths[$k]);

		 }
		 if ($command=='recover_unreferenced')
		 {
		 	$files = "";
            for ($k=0; $k < sizeOf($filepaths);$k++)
                $files .= "'".$filepaths[$k]."' ";
            $execString = DPXROOT .  "/src/node/nora -p " . $project . " -a " . $files;
            $res = shell_exec($execString);            
       //     client_log($execString);
            $json_out['success'] = 1;
            $json_out['content'] = $res;

		 }

         
      }
      elseif ($command=='exportmeta')
      {

      	 savePIDforAbort();

         $json = json_decode($_GET['json']);
         $execString = DPXROOT .  "/src/node/nora -p " . $project . 
                     " --exportmeta '" . $json->objs . "' '" . $json->fileselector .
                     "' --keys '" . $json->keyselector . "'" . 
                     " --csv_type " . $json->csv_type . 
                     " --header_type " . $json->header_type ;
         if (isset($json->subject_level))
             $execString .= " --subject_level";
         client_log($execString);
         error_log($execString);
         $res = shell_exec($execString);
         $json_out['success'] = 1;
         $json_out['content'] = $res;

         clearPIDforAbort();

      }
      elseif ($command=='tagstats')
      {

         $json = json_decode($_GET['json']);
         $execString = DPXROOT .  "/src/node/nora -p " . $project . " --tagstats";
         client_log($execString);
         $res = shell_exec($execString);
         
         $json_out['success'] = 1;
         $json_out['content'] = $res;

      }
      elseif ($command=='submit_job')
      {

        $json_out['demonInfo'] = checkDemonStatus();
        if (isset($json_out['demonInfo']['nosubmit']) && $json_out['demonInfo']['nosubmit'] == 1)
            $json_out['success'] = 1;
        else
        {            

			$jsonString = ($_GET['json']);
			if (isset($_GET['testMode']) )
			   $testMode = $_GET['testMode'];
			else
			   $testMode = "0";
			if ($testMode == "true")
				  $testMode = 1;
			if ($testMode == "false")
				  $testMode = 0;
			$db = mydbconnection(ROOTDB);
			$jsonString = str_replace("\\\"","\\\\\"",$jsonString);
			$jsonString = str_replace("'","`",$jsonString);
			$user =$_SESSION['username'];
			$runasuser =$_SESSION['username'];
			// run as another user if isset in usertable
			if( isset($_SESSION['userinfo']['runjobsas']) )
			{
			  if( !empty($_SESSION['userinfo']['runjobsas']))
				{$runasuser = $_SESSION['userinfo']['runjobsas'];}
			}

			$already = false;
			$jobid = "a";
			if ($testMode == "1")
			{ 
			  $res = $db->query("SELECT * from commands where testmode='1' AND jsondesc='" . $jsonString . "'");
			  if ($res->fetch_assoc())
			  {
				  $json_out['success'] = 0;
				  $json_out['msg'] = 'Sorry, already in test queue, check MATLAB console';
				  $already = true;
			  }
			  else
			  {
				if(isset($_GET['jobid']))
				{
				  $res = $db->query("SELECT * from gridjobs where jobid='" . $_GET['jobid'] . "'");
				  $db->query("UPDATE gridjobs SET state='TEST' where  jobid='" . $_GET['jobid'] . "'");
				  $jobid = $_GET['jobid'];
				}

			  }
			}

			if (!$already)
			{

			   $secret_command = get_secret();
			   $secure = "";
			   if ($secret_command != "")
			   {
				$jsonString = encrypt_aes($runasuser . '|' . $jsonString,$secret_command);
				$secure = "(secure)";
			   }
			   $q = "INSERT INTO commands (jobid,jsondesc,type,project,user,runas,testmode) VALUES ('" . $jobid . "','" . $jsonString . "','submit_job','" . $project . "','" .  $user . "','" . $runasuser . "','". $testMode ."')";
			   DPX_log("submit_job ".$secure.":  '" . $project . "','" .  $user . "','" . $runasuser . "','". $testMode ."'");

			   $db->query($q);
			}

			$db->close();
        }
      }
      elseif ($command=='killAllJobs')
      {
          $user =$_SESSION['username'];
          $db = mydbconnection(ROOTDB);
          $tmp = array('user' => $user, 'project' => $project );          
          $q = "DELETE from commands where user='" . $user . "' AND project='" . $project . "'";
          $a = $db->query($q);

          $q = "INSERT INTO commands (jsondesc,type,user,runas) VALUES ('" . json_encode($tmp) . "','killAllJobs','" .  $user . "','" . $runasuser . "')";
          $a = $db->query($q);
          $db->close();
          $json_out['success'] = 1;

      }
      elseif ($command=='kill_job' | $command=='hold_job' | $command=='unhold_job'  | $command=='suspend_job' | $command=='unsuspend_job' | substr($command,0,4) == 'nice')
      {
       $jsonString = ($_GET['json']);
        $user =$_SESSION['username'];
        $runasuser =$_SESSION['username'];
        $db = mydbconnection(ROOTDB);
        $q = "INSERT INTO commands (jsondesc,type,user,runas) VALUES ('" . $jsonString . "','". $command ."','" .  $user . "','" . $runasuser . "')";
        $a = $db->query($q);
        $db->close();
        $json_out['success'] = 1;
      }
      elseif ($command=='cleardead_job')
      {
        $tokill = json_decode($_GET['json']);
        $db = mydbconnection(ROOTDB);
        if (sizeOf($tokill) > 0)
        {
          $q = "( ";
          for ($k=0; $k < sizeOf($tokill);$k++)
              $q .= "jobid='" . $tokill[$k] . "' OR ";
          $q .= " 0 )";
 		  $q1 = "delete from gridjobs where (error IS NOT NULL)  AND  " . $q;
		  $q2 = "delete from commands where 1 AND " . $q;
        }
        else
        {
 		  $q1 = "delete from gridjobs where (error IS NOT NULL) AND owner='". $_SESSION['userinfo']['username'] ."'";
		  $q2 = "delete from commands where user='". $_SESSION['userinfo']['username'] ."'";
        }
        
        $a = $db->query($q1);
        $a = $db->query($q2);
        $db->close();

        // process
        $json_out['success'] = 1;
      }
      elseif ($command=='reimport_dicoms')
      {
        
        $dfolder = ($_GET['folder']);
	$dfolder = resolve_Route($dfolder);
        $json_out['msg'] = "Writing dpx file for '$dfolder'... refresh this window to check the reimport";
        $ret = system("php " . dirname(__FILE__) .  '/dicom/storescp_helper.php -command createdpxfile -logtofile 1 -timeout 0 -folder ' . $dfolder);
      }
      elseif ($command=='clearlog')
      {
        
        $logfile = ($_GET['logfile']);
        if(!isset($_GET['logfile']))
			return false;
   

		if ($logfile == 'js_error')
		{
		}
		if ($logfile == 'filesystem')
		{
		}
		else
		{
		    $syslogpath = resolve_Route(VARPATH."/syslogs/");
		    $filePath = $syslogpath . $logfile;
		    if(file_exists($filePath))
		    {
              file_put_contents($filePath, date("Ymd G:j:s"). "   --- file was cleared ---");
		    }
            $json_out['msg'] =  "";
 		}
      }
      elseif ($command=='showlog')
      {
        if(!isset($_GET['logfile']))
			return false;
        
        $logfile = ($_GET['logfile']);
        
        $subject = "none";
        if(isset($_GET['subject']))
            $subject = ($_GET['subject']);
   
        $lines = 500;
        if(isset($_GET['full']))
        {
            $lines = 5000;
        }

		if ($logfile == 'js_error')
		{
			$db = mydbconnection(ROOTDB);
			$a = $db->query("SELECT * FROM error_js ORDER BY ID DESC LIMIT 500");
			$res = "";
			if($a!==false)
			while($row = $a->fetch_assoc() )
				$res = "<br>" . implode(" ", array_values($row)) . $res;
			
			$json_out['content'] = $res;
		}
		elseif($logfile=='filesystem')
		{
            function folderSize ($dir)
            {
                $size = 0;
                foreach (glob(rtrim($dir, '/').'/*', GLOB_NOSORT) as $each) {
                    $size += is_file($each) ? filesize($each) : folderSize($each);
                }
                return $size;
            }
            $res = "";
            
            $dir = resolve_Route(VARPATH . "/import") ; $res .= "<br>" . $dir . ": " .  round(folderSize( $dir )/1024/1024) ." MB"  ;
            $dir = resolve_Route(VARPATH . "/imgdata") ; $res .= "<br>" . $dir . ": " . round(folderSize( $dir )/1024/1024) ." MB" ;
            $dir = resolve_Route(VARPATH . "/sqldata") ; $res .= "<br>" . $dir . ": " . round(folderSize( $dir )/1024/1024) ." MB" ;
            $json_out['content'] = $res;

		}
		else
		{
		    $syslogpath = resolve_Route(VARPATH."/syslogs/");
            $onlyadmin = false;
            if( strpos($logfile , 'jdpx') == false)
            {
				$filePath = $syslogpath . $logfile;
				$onlyadmin = true;
			}
			else // a process log file etc ..?
			{
				$filePath = resolve_Route(VARPATH . '/' . $logfile);
			}


            if($onlyadmin && !$_SESSION['userinfo']['isadmin'])
            {
               $json_out['msg'] = "You do not have permissions to logfile '$logfile'! "; 
            }
            else            
            {
              $filePath = html_entity_decode($filePath);

              if (substr($logfile,0,8) == "function")
              {
                  $jobname = substr($logfile,9);
				  $db = mydbconnection(ROOTDB);

				  $res = $db->query("SELECT * from gridjobs where jobname='" . $jobname . "'");
                  $row = $res->fetch_assoc();

				  $json_out['content'] =  $row['jsondesc'];
				  $json_out['msg'] = '';
				  $json_out['success'] = 1;

                  $db->close();


              }
              else
              {

				  if(!file_exists($filePath))
				  {
					$json_out['content'] =  "Sorry, the log file '$filePath' does not exist.";
					$json_out['msg'] = '';

					if (substr($logfile,0,9) == "logs/jdpx")
					{
						$jobname = substr($logfile,10);
						$json_out['content'] =  "The log file for '$jobname' does not exist.<br>The job was not yet launched, be patient.";
					}
				  }
				  elseif(!is_readable($filePath))
				  {

					 $json_out['msg'] = "Sorry, the log file '$filePath' is not readable "; 
					 if ($logfile == 'apache.log')
						  $json_out['msg'] .=  "<br> error_log = " . ini_get('error_log') . "<br> writeable? " . (is_writable(ini_get('error_log')) ? 'Yes' : 'No') .  "<br>";

				  }
				  else
				  {
                      if (strpos($subject,"IDSET") === false & strpos($logfile,"jdpx.IDSET") != false)
    					  $textlog = tailfromSubstring($filePath,$subject,$lines);
    			      else
					      $textlog = tailCustom($filePath, $lines);
					  $textlog = iconv( 'UTF-8', 'UTF-8//IGNORE', $textlog);
					  $textlog = str_replace("\n","<br>", $textlog);
					  $textlog = str_replace("Warning","<span style='color:orange'> Warning</span>", $textlog);

					  // in demon log we want to create links to the log/error files
					  if( $logfile == 'daemon.log' )
					  {

					  }
					  elseif( $logfile == 'storescp.log' )
					  {

					  }
					  else
					  {
						$textlog = str_replace("Error","<span style='color:red'> Error</span>", $textlog);
						$textlog = str_replace("error","<span style='color:red'> error</span>", $textlog);
					  }
					  $textlog .= "<br></br>";
					  $json_out['content'] =  $textlog;
					  $json_out['msg'] = '';

					  $json_out['success'] = 1;
				  }
              }
            }
		}
      }
      elseif ($command=='get_gridstats')
      {
          $db = mydbconnection(ROOTDB);
          $gridjobs = array();
          if( ($a = $db->query("SELECT * FROM gridjobs where module LIKE '".str_replace('___','%',$projectDatabase)."' ORDER BY state DESC, jobid ASC ")) !== false)
          {
            while($row = $a->fetch_assoc())
            {
              $rowid = "x" . $row['patients_id'] . riddelim. $row['studies_id']; // for an empty subfolder, set the parent as the study expander
              $row['rowid'] = $rowid;
              unset($row['jsondesc']);
              $gridjobs[$row['jobid']] = $row;
            }
          }
          $json_out['content'] =  $gridjobs;
          $json_out['msg'] = '';
          $json_out['success'] = 1;

          $db->close();

      }
      elseif ($command=='delete_notification')
      {
        $jsonString = ($_GET['json']);
        $objs = json_decode($jsonString);
        $db = mydbconnection( ROOTDB);
        if (isset($objs->username))
        {
        	if ($_SESSION['username'] == $objs->username)
                $a = $db->query("DELETE FROM notifications WHERE username='$objs->username';");			
        }
        else
        {
			for($k=0;$k<sizeof($objs);$k++)
			{
				$obj = $objs[$k];
				$a = $db->query( "DELETE FROM notifications WHERE id LIKE '$obj->ID'; " );
			}
        }
        $db->close();
        $json_out['msg'] = "";
        $json_out['success'] = 1;
      }
      elseif ($command=='get_cluster')
      {
		    $logpath = resolve_Route(VARPATH."/syslogs/cluster/*");

			foreach (glob( $logpath) as $filename) {
			  $farr[] = $filename;
			}
            $json_out['result'] = $farr;
            $json_out['success'] = 1;

      }                
      elseif ($command=='delete_from_filepattern')
      {
        $jsonString = ($_GET['json']);
        $cmd = json_decode($jsonString);
        $files = $cmd->files;
        $items = $cmd->items;
        $q = "0 ";
        for($k=0;$k<sizeof($files);$k++)
        {
           $s = explode("/",$files[$k]->filename);
           if ($files[$k]->type == "file")
               $q .= "OR (subfolder LIKE '".$files[$k]->subfolder."' AND filename LIKE '".$s[sizeof($s)-1]."') ";
           if ($files[$k]->type == "subfolder")
               $q .= "OR (subfolder LIKE '".$files[$k]->subfolder."') ";
        }
        $qp = "0 ";        

        if ($cmd->typ == "patient")
        {
			for($k=0;$k<sizeof($items);$k++)
                $qp .= "OR patients_id='".$items[$k]."' ";
        }                
        else
        {
			for($k=0;$k<sizeof($items);$k++)
                $qp .= "OR (patients_id='".$items[$k][0]."' AND studies_id='".$items[$k][1]."') ";
        }
        $update = "delete from files where (".$qp.") AND (".$q.")";
        $db = mydbconnection( $projectDatabase);
	    $a = $db->query($update);
        $db->close();    
        $json_out['msg'] = "";        
		$json_out['success'] = 1;
           
      }
      elseif ($command=='delete_file')
      {
        $jsonString = ($_GET['json']);
        $objs = json_decode($jsonString);
        $db = mydbconnection( $projectDatabase);
        $q="";
        $deletedFiles = [];

        // this is mainly for debugging purposes
        $deleteFromDB = true;

        // this will physically delete files. To be tested in more detail 

        $deleteFromFileSystem = $physical_del;

        for($k=0;$k<sizeof($objs);$k++)
        {
            $obj = $objs[$k];
        
            DPX_log("delete " . $obj->type . ": " . $obj->piz .  $obj->sid . " " . $obj->subfolder . "/" . $obj->filename);


            if ($obj->type == "patient")
            {

                


                $fileanswer = $db->query("SELECT FilePath FROM files   WHERE studies_id LIKE '%' AND patients_id LIKE '" . $obj->piz . "'; " );

				$pq = "DELETE FROM patients WHERE PIZ LIKE '" . $obj->piz . "'; ";
				$sq = "DELETE FROM studies WHERE StudyID    LIKE '%' AND patients_id LIKE '" . $obj->piz . "'; ";
				$fq = "DELETE FROM files   WHERE studies_id LIKE '%' AND patients_id LIKE '" . $obj->piz . "'; ";
                if($deleteFromDB)
                {
                  $a = $db->query($pq);
                  $a = $db->query($sq);
                  $a = $db->query($fq);
                }

                unset($_SESSION["currentPatients"][$project][$obj->rowid]);
                
            }
            else if ($obj->type == "study")
            {
                $fileanswer = $db->query("SELECT FilePath FROM files WHERE studies_id LIKE '" . $obj->sid . "' AND patients_id LIKE '" . $obj->piz . "'; ");

				$sq = "DELETE FROM studies WHERE StudyID LIKE '" . $obj->sid . "' AND patients_id LIKE '" . $obj->piz . "'; ";
				$fq = "DELETE FROM files WHERE studies_id LIKE '" . $obj->sid . "' AND patients_id LIKE '" . $obj->piz . "'; ";
				// delete also patient if he has no more studies... 
				$pq = "DELETE p FROM patients p LEFT JOIN studies s ON p.PIZ = s.patients_id WHERE p.PIZ LIKE '" . $obj->piz . "' AND s.id IS NULL; ";
                if($deleteFromDB)
                {
                   $a = $db->query($sq);
                   $a = $db->query($fq);
                   $a = $db->query($pq);
                }

                unset($_SESSION["currentStudies"][$project][$obj->rowid]);



            }
            else if ($obj->type == "subfolder")
            {
              $fileanswer = $db->query("SELECT FilePath FROM files WHERE (subfolder LIKE '" . $obj->subfolder . "' OR subfolder LIKE '" . $obj->subfolder
              . "/%') " . $permQuery . " AND studies_id LIKE '" . $obj->sid . "' AND patients_id LIKE '" . $obj->piz . "'");

              $q = "DELETE FROM files WHERE (subfolder LIKE '" . $obj->subfolder . "' OR subfolder LIKE '" . $obj->subfolder
              . "/%') AND studies_id LIKE '" . $obj->sid . "' AND patients_id LIKE '" . $obj->piz . "'";
                if($deleteFromDB)
                {
                  $a = $db->query($q);
                }
            }
            else if ($obj->type == "file")
            {
              $fileq =  " ID=" . $obj->fileID ;
              $row = $db->query("SELECT FilePath,permission FROM files WHERE " . $fileq)->fetch_assoc();
			  $permission=$row['permission'];
		  	  if (strpos($permission, "w") == false && $permission != "link")
              {         
                  $db->close();      
                  return array('msg'=>'Sorry, deleting failed, permission denied', 'success'=>false);
              } 

              $q = "DELETE FROM files WHERE " . $fileq;
              if($deleteFromDB)
              {
                  $a = $db->query($q);
              }
              if ($permission != "link")
              	 $fileanswer = $db->query("SELECT FilePath FROM files WHERE " . $fileq);              
              else 
              	$fileanswer = null;
            }

			if ($fileanswer != null)
			{
				// append the files to be deleted
				while($row = $fileanswer->fetch_assoc() )
				{
				  $deletedFiles[] = resolve_Route($row['FilePath']);
				}
			}
        }
        $db->close();
        
        // this will REALLY delete the files from harddisk ...
        if($deleteFromFileSystem)
        {
            // create a List of folders, to be able to delete empty folders afterwards
            $folderList = [];
            foreach($deletedFiles as $dfile)
            {
               // some check that we do not mess in a root directory ...?
               if( strlen($dfile) > 5 &&   is_writable($dfile) )
               {
                 $pinfo = pathinfo($dfile);
                 $folderList[$pinfo['dirname']] = $pinfo['dirname'];
                 unlink($dfile);
               }
            }
            
            // delete empty folders
            $cmd = "";
            foreach($folderList as $dFolder)
            {
              $cmd .=  "find \"$dFolder\" -maxdepth 1  -type d -empty -delete;";
            }

            if(strlen($cmd) > 10 )
              system($cmd);            
            //$json_out["msg"] = $cmd;

        }

        if ($q!="")
          $json_out['success'] = 1;

      }
      elseif ($command=='rename_file')
      {
        $jsonString = ($_GET['json']);
        $cmd = json_decode($jsonString);
		$db = mydbconnection( $projectDatabase);

		if (isset($cmd->along))
		{
		    if ($cmd->along->typ == "study" | $cmd->along->typ == "patient")
			{	 
				if ($cmd->obj->type == "subfolder")
				{

					for ($k=0;$k<sizeof($cmd->along->items);$k++)
					{
					   $obj = (object) array("type" => "subfolder", 
											 "subfolder" => $cmd->obj->subfolder, 
											 "piz" => $cmd->along->items[$k][0],
										     "sid" => $cmd->along->items[$k][1] );
				       $torename[] = (object) array('obj' => $obj, 'newname' => $cmd->newname); 
					}

				}
			    else
				{
				    $q = "0";
					if ($cmd->along->typ == "study")
					{
						for ($k=0;$k<sizeof($cmd->along->items);$k++)
							$q .= " OR (studies_id='" . $cmd->along->items[$k][1] . "' AND patients_id='".$cmd->along->items[$k][0]."')";
					}
					else
					{
						for ($k=0;$k<sizeof($cmd->along->items);$k++)
							$q .= " OR (patients_id='".$cmd->along->items[$k][0]."')";
					}
					$q = "(" . $q . ")";	

                    $fname = explode("/", $cmd->obj->filename);
                    $fname = $fname[sizeOf($fname)-1];

					$q .= " AND (subfolder='" . $cmd->obj->subfolder . "' AND Filename='" .  $fname . "')";
					$q = "SELECT ID,patients_id,studies_id from files where " . $q;

					$a = $db->query($q);

					$torename = array();
	                while($row = $a->fetch_assoc())
					{
					   $obj = (object) array("type" => "file", "fileID" => $row["ID"], "piz" => $row["patients_id"] , "sid" => $row["studies_id"] );
				       $torename[] = (object) array('obj' => $obj, 'newname' => $cmd->newname); 
					}
				}

//return array('msg'=>'not yet', 'success'=>false); 


			}
		}
		else
		{
			$torename = [$cmd];
		}

		$errors = "";
		$numsuccess = 0;

	    for ($k=0;$k<sizeof($torename);$k++)
		{
			$renameobj = $torename[$k];
	        $obj = $renameobj->obj;  
	        $newname = $renameobj->newname;
	        $newname = trim($newname, "/\\  \n\r\t\v\0");
	        $qf = "SELECT StudyPath FROM studies WHERE StudyID='".$obj->sid."' AND patients_id='".$obj->piz."'";
	        $a = $db->query($qf);
	        $row = $a->fetch_assoc();
	        $studypath = $row['StudyPath'];
	
	        if ($obj->type == "file")
	        {
	           $rpos = strripos($newname,"/");
	           $newsubfolder = substr($newname,0,$rpos);
	           $newfilename = substr($newname,$rpos+1);
	           if ($rpos==false)
	              $newfilename = $newname;
	
	           $a = $db->query("SELECT FilePath,permission from files WHERE ID='".$obj->fileID."'" );
	           $filerow = $a->fetch_assoc();
	 		   $permission = $filerow['permission'];
			   if (strpos($permission, "w") === false && $permission != "link")
			   {
				   $errors .= 'Sorry, moving failed, permission denied (' . $permission . '); ' . $obj->piz . ' ' . $newname . '<br>';
				   continue;
			   }
	           if ($physical_move && $permission != "link")
	           {
	             $oldfilepath = $filerow['FilePath'];
	             $newfilepath = $studypath . "/" . $newname;
		 		 $qf = "SELECT FilePath FROM files WHERE FilePath='".$newfilepath."'";
				 $a = $db->query($qf);
				 $row = $a->fetch_assoc();
				 if ($row['FilePath'] == $newfilepath)
				 {
					$errors .= "File already exists; " . $obj->piz . " " . $newname . "<br>";
					continue;
				 }
	             mymkdir(resolve_Route($studypath ."/" . $newsubfolder));
	             if (rename(resolve_Route($oldfilepath),resolve_Route($newfilepath)))
	             {
	               $q = "UPDATE files SET subfolder='".$newsubfolder."',filename='".$newfilename."',FilePath='".$newfilepath."' WHERE ID=".$obj->fileID  . $permQuery;
	               $a = $db->query($q);
	             }
	             else
	             {
					$errors .= "permission denied; " . $obj->piz . " " . $newname . "<br>";
					continue;

	             }
	           }
	           else
	           {
	             $q = "UPDATE files SET subfolder='".$newsubfolder."',filename='".$newfilename."' WHERE ID=".$obj->fileID;
	             $a = $db->query($q);
	           }
	        }
	        else if ($obj->type == "subfolder")
	        {
	           if ($physical_move)
	           {
	               $qf = "SELECT ID FROM files WHERE ( subfolder LIKE '".$obj->subfolder."' OR subfolder LIKE '".$obj->subfolder."/%' )  AND studies_id='".$obj->sid."' AND patients_id LIKE '" . $obj->piz . "'" ;
	               $a = $db->query("(" . $qf . " AND permission NOT LIKE '%w%' )");
	               if ($a->fetch_assoc() != null)
	               {
						 $errors .= "renaming failed, permission denied; " . $obj->piz . " " . $newname . "<br>";
 						 continue;
	               }             
	               $oldSubFolder = $studypath . '/' . $obj->subfolder . '/';
	               $oldSubFolder_alt = encode_Route(resolve_Route($studypath . '/' . $obj->subfolder)) . '/';
	               $newSubFolder = $studypath . '/' . $newname . '/';
	
				   $oldSubFolder = str_replace('//','/',$oldSubFolder);
				   $newSubFolder = str_replace('//','/',$newSubFolder);

				   if (rename(resolve_Route($oldSubFolder),resolve_Route($newSubFolder)))
	               {
	                   $q = "UPDATE files SET FilePath=replace(replace(FilePath,'".$oldSubFolder."','".$newSubFolder."'),'".$oldSubFolder_alt."','".$newSubFolder."'),subfolder=replace(subfolder,'".$obj->subfolder."','".$newname."') WHERE (subfolder='".
	                         $obj->subfolder."' OR subfolder LIKE '".$obj->subfolder."/%') AND studies_id='".$obj->sid."' AND patients_id LIKE '" . $obj->piz . "'";                   
	                   $a = $db->query($q);
	               }
				   else
					   $errors .= "problem during rename; " . $obj->piz . " " . $obj->subfolder . "->" .  $newname . "<br>";

	           }
	           else
	           {
	             $q = "UPDATE files SET subfolder=replace(subfolder,'".$obj->subfolder."','".$newname."') WHERE (subfolder='".
	                         $obj->subfolder."' OR subfolder LIKE '".$obj->subfolder."/%') AND studies_id='".$obj->sid."' AND patients_id LIKE '" . $obj->piz . "'";
	             $a = $db->query($q);
	           }
	
	        }
	        else if ($obj->type == "study")
	        {
	           $q = "UPDATE studies SET StudyDescription='".$newname."' WHERE StudyID='".$obj->sid."' AND patients_id LIKE '" . $obj->piz . "'";
	           error_log($q);
	           $a = $db->query($q);
	        }

			$numsuccess++;
		}

        $db->close();
		if ($errors == "")
		{
			if ($numsuccess == 1)
			    return array('success'=>true);                    
			else 
			    return array('msg'=>$numsuccess."/".sizeof($torename)." items successfully renamed", 'success'=>true);                    
		}
		else
		    return array('msg'=>$errors, 'success'=>false);                    


      }
      elseif ($command == 'compress' || $command =='decompress')
      {
        $status_code = mycompression($command, $projectDatabase, $physical_move, $permQuery);
        if ($status_code === true)
        {
            $json_out['success'] = 1;
        }
        else
        {
        	return $status_code;
        }
      }
      elseif ($command=='move_file')
      {
        $jsonString = ($_GET['json']);
        $moveobj = json_decode($jsonString);
        $db = mydbconnection( $projectDatabase);


		if (isset($moveobj->along))
		{
			for($r=0;$r<sizeof($moveobj->along->items);$r++)
			{
				$nsrc = array();
				for($k=0;$k<sizeof($moveobj->src);$k++)
		        {
					if ($moveobj->src[$k]->type == 'file')
					{
						$moveobj->src[$k]->piz = $moveobj->along->items[$r][0];
						$moveobj->src[$k]->sid = $moveobj->along->items[$r][1];
						$obj = $moveobj->src[$k];
		                $split = explode("/", $obj->filename);	                
						$fname = $split[sizeof($split)-1];
						$q = "SELECT * from files WHERE patients_id='" . $obj->piz.  "' AND studies_id='" . $obj->sid.  "' AND subfolder='" . $obj->subfolder . "' AND Filename='" . $fname . "'";
		                $a = $db->query($q);
					    if ($a != null) 
						if ($row = $a->fetch_assoc())
						{
						    $moveobj->src[$k]->fileID = $row['ID'];
							$nsrc[] = $moveobj->src[$k];
						}
					}
					if ($moveobj->src[$k]->type == 'subfolder')
					{
						$moveobj->src[$k]->piz = $moveobj->along->items[$r][0];
						$moveobj->src[$k]->sid = $moveobj->along->items[$r][1];
						$nsrc[] = $moveobj->src[$k];

					}
				}
				$moveobj->dest->piz = $moveobj->along->items[$r][0];
				$moveobj->dest->sid =$moveobj->along->items[$r][1];
			    $s = array(); deepExtend($s,$nsrc);
			    $d = (object) array(); deepExtend($d,$moveobj->dest);
				$srcs[] = $s;
				$dests[] = $d;
			}

		}
		else
		{
	        $srcs = array($moveobj->src);  $dests = array($moveobj->dest);

		}

		$errors = "";
		$numsuccess = 0;
		

        for($r=0;$r<sizeof($srcs);$r++)
        {
			$src = $srcs[$r];
			$dest = $dests[$r];

	        for($k=0;$k<sizeof($src);$k++)
	        {
	            $q = "";
	            $obj = $src[$k];
	            error_log($obj->type."--->".$dest->type);

	            if (($obj->type == "subfolder" & ($dest->type == "subfolder" | $dest->type == "file")) | ($obj->type == "subfolder" & $dest->type == "study" ))
	            {
	              if ($dest->type == "study")
	                $dest->subfolder = "";
	              $newsubfolder = "";
	              $rest = "";
	              $last = strrchr($obj->subfolder, "/");
	              if ($last)
	              {
	                $last = substr($last,1);
	                $rest =  substr($obj->subfolder,0,strlen($obj->subfolder)-strlen($last)-1);
	                if ($dest->subfolder == "")
	                  $newsubfolder = "replace(f.subfolder,'".$rest."/','".$dest->subfolder."')";
	                else
	                  $newsubfolder = "replace(f.subfolder,'".$rest."','".$dest->subfolder."')";
	              }
	              else
	              {
	                if ($dest->subfolder == "")
	                    $newsubfolder = "concat(f.subfolder,'')";
	                else
	                    $newsubfolder = "concat('".$dest->subfolder."/',f.subfolder)";
	              }
	
	              $qf = "SELECT ID FROM files WHERE ( subfolder LIKE '".$obj->subfolder."' OR subfolder LIKE '".$obj->subfolder."/%' )  AND studies_id='".$obj->sid."' AND patients_id LIKE '" . $obj->piz . "'" ;
	              $a = $db->query("(" . $qf . " AND permission NOT LIKE '%w%' )");
	
	              if ($a->fetch_assoc() != null)
	              {
					 $errors .= 'Sorry, moving failed, permission denied for ' . $obj->piz . $obj->sid . ' ' . $obj->subfolder . '<br>';
					 continue;
	              }
	              if ($physical_move)
	              {
	                  $qf = "(" . $qf . $permQuery . ")";
	
	
	                  $a = $db->query("SELECT StudyPath from studies WHERE StudyID='".$obj->sid."' AND patients_id LIKE '" . $obj->piz . "'");
	                  $row = $a->fetch_assoc();
	
	                  $a = $db->query("SELECT StudyPath from studies WHERE StudyID='".$dest->sid."' AND patients_id LIKE '" . $dest->piz . "'");
	                  $destrow = $a->fetch_assoc();
	
	                  $deststudypath = $destrow['StudyPath'];
	                  
	                  if ($deststudypath[strlen($deststudypath)-1] == "/")
	                      $deststudypath = substr($deststudypath,0,-1);
	
	                  if ($last)
	                  {
	                    if ($dest->subfolder == "")
	                    {
	                      $newFilePathSQL = "replace(concat('".$deststudypath."/',replace(f.subfolder,'".$rest."/','".$dest->subfolder."'),'/',f.Filename),'//','/')";
	                    }
	                    else
	                    {
	                      $newFilePathSQL = "replace(concat('".$deststudypath."/',replace(f.subfolder,'".$rest."','".$dest->subfolder."'),'/',f.Filename),'//','/')";
	                    }
	                  }
	                  else
	                  {
	                    $newFilePathSQL = "replace(concat('".$deststudypath."/','".$dest->subfolder."','/',f.subfolder,'/',f.Filename),'//','/')";
	                  }
	
	                  $subfoldername = "";
	                  $origsubfolder = explode("/", $obj->subfolder);
	                  $subfoldername = "/". $origsubfolder[sizeOf($origsubfolder)-1];
	                  $oldFilePath = $row['StudyPath'] . "/" .$obj->subfolder;
	                  $newFilePath = $destrow['StudyPath'] . "/" . $dest->subfolder . $subfoldername;
	                  mymkdir(resolve_Route($newFilePath));
	                  
	                  error_log("physically moving " . resolve_Route($oldFilePath) . " to " . resolve_Route($newFilePath));
	                  if (rename(resolve_Route($oldFilePath),resolve_Route($newFilePath)))
					  {
	                    $q = "UPDATE files AS f, ".$qf." AS a   SET f.patients_id='".$dest->piz."',f.studies_id='".$dest->sid."',f.subfolder=".$newsubfolder.",f.FilePath=".$newFilePathSQL." WHERE f.ID=a.ID";
					  }
			          else 
					  {
					    $errors .= 'problem during renaming of ' . $obj->piz . $obj->sid . ' ' . $obj->subfolder . '<br>';
					    continue;
					  }

	
	              }
	              else
	              {
	                $q = "UPDATE files AS f, (".$qf.") AS a   SET f.patients_id='".$dest->piz."',f.studies_id='".$dest->sid."',f.subfolder=".$newsubfolder." WHERE f.ID=a.ID";
	              }
	            }
	            else if ($obj->type == "file" & $dest->type == "study" )
	            {
	
	              $a = $db->query("SELECT * from files WHERE ID=".$obj->fileID );
	              $row = $a->fetch_assoc();
	              $permission = $row['permission'];
	              if (strpos($permission, "w") == false && $permission != "link")
	              {
					   $errors .= 'Sorry, moving failed, permission  (' . $permission . ') denied for ' . $obj->piz . $obj->sid . ' ' . $obj->subfolder . '<br>';
					   continue;
	              }
	              if ($physical_move  && $permission != "link")
	              {
	
	                $a = $db->query("SELECT StudyPath from studies WHERE StudyID='".$dest->sid."' AND patients_id LIKE '" . $dest->piz . "'");
	                $destrow = $a->fetch_assoc();
	                
	                $newFilePath = $destrow['StudyPath'] . "/" . $row['Filename'];
	                mymkdir(resolve_Route($destrow['StudyPath']));
	                
	                error_log("physically moving " . resolve_Route($row['FilePath']) . " to " . resolve_Route($newFilePath));
	                if (rename(resolve_Route($row['FilePath']),resolve_Route($newFilePath)))
	                  $q = "UPDATE files SET subfolder='',patients_id='".$dest->piz."',studies_id='".$dest->sid."',FilePath='".$newFilePath."' WHERE ID=".$obj->fileID;
			        else 
					    $errors .= 'problem during renaming of ' . $obj->piz . $obj->sid . ' ' . $obj->subfolder . '<br>';

	              }
	              else
	                  $q = "UPDATE files SET subfolder='',patients_id='".$dest->piz."',studies_id='".$dest->sid."' WHERE ID='".$obj->fileID."'";
	
	            }
	            else if ($obj->type == "file" & ($dest->type == "subfolder" | $dest->type == "file")) 
	            {


	              $a = $db->query("SELECT Filename,FilePath,permission from files WHERE ID=".$obj->fileID );
	              $row = $a->fetch_assoc();
	              $permission = $row['permission'];
	              if (strpos($permission, "w") == false && $permission != "link")
	              {
					   $errors .= 'Sorry, moving failed, permission  (' . $permission . ') denied for ' . $obj->piz . $obj->sid . ' ' . $obj->subfolder . '<br>';
					   continue;
	              }
	              if ($physical_move && $permission != "link")
	              {
	        
	                $a = $db->query("SELECT StudyPath from studies WHERE StudyID='".$dest->sid."' AND patients_id LIKE '" . $dest->piz . "'");
	                $destrow = $a->fetch_assoc();
	                
	
	                $newFilePath = $destrow['StudyPath'] ."/". $dest->subfolder . "/" . $row['Filename'];
	                mymkdir(resolve_Route($destrow['StudyPath'] . "/". $dest->subfolder ));
	                error_log("physically moving " . $row['FilePath'] . " to " . $newFilePath);
	                if (rename(resolve_Route($row['FilePath']),resolve_Route($newFilePath)))
	                    $q = "UPDATE files SET subfolder='".$dest->subfolder."',patients_id='".$dest->piz."',studies_id='".$dest->sid."',FilePath='".$newFilePath."' WHERE ID=".$obj->fileID;
			        else 
					    $errors .= 'problem during renaming of ' . $obj->piz . $obj->sid . ' ' . $obj->subfolder . '<br>';
	              }
	              else
	                  $q = "UPDATE files SET subfolder='".$dest->subfolder."',patients_id='".$dest->piz."',studies_id='".$dest->sid."' WHERE ID=".$obj->fileID;
	            }

	            if ($q!="")
	            { 
	  			  $numsuccess++;
	              error_log($q);
	              $json_out['success'] = $db->query($q);
	            }
	            else
	              $json_out['success'] = 0;
	
	        }
		}

client_log($errors);
		if ($errors == "")
		{
			if ($numsuccess == 1)
			    return array('success'=>true);                    
			else 
			    return array('msg'=>$numsuccess . " items successfully moved", 'success'=>true);                    
		}
		else
		    return array('msg'=>$errors, 'success'=>false);                    

        $db->close();
      }
      elseif ($command == 'updatefolder')
      {
           $jsonString = ($_GET['json']);
           $toupdate = json_decode($jsonString);
           $json_out['success'] = 0;   
           for ($k = 0; $k < sizeof($toupdate);$k++)
           {
	          $execString = DPXROOT .  "/src/node/nora -p " . $project . " -u " . $toupdate[$k]->piz . $toupdate[$k]->sid;
              if ($toupdate[$k]->subfolder != "")
				$execString .= ' ' . $toupdate[$k]->subfolder;
	          client_log($execString);
	          $res = shell_exec($execString);
		   }
           $json_out['success'] = 1;
           $json_out['content'] = $res;

	  }
      elseif ($command == 'clone_file')
      {
           $jsonString = ($_GET['json']);
           $clonejob = json_decode($jsonString);
           $json_out['success'] = 0;   

           for ($k = 0; $k < sizeof($clonejob);$k++)
           {
			   $fileinfo = $clonejob[$k]->fileinfo;
			   $src = $clonejob[$k]->src;
			   $db = mydbconnection( $projectDatabase);
			   $a = $db->query("SELECT FilePath FROM files where ID=".$src);
			   if ($a != null) 
				 if ($row = $a->fetch_assoc())
				 {
					$filePath = resolve_Route($row['FilePath']);
					if (is_readable($filePath))
					{
					   $ret = json_decode(createFileBinary($fileinfo,$filePath,false));
					   $json_out['success'] = $ret->success;                             	
					   $json_out['msg'] = $ret->msg;
					}
				 }

           }

      }
      elseif ($command=='copy_study')
      {

    	savePIDforAbort();

        $jsonString = ($_GET['json']);
        $copyjob = json_decode($jsonString);

        $db = mydbconnection( $projectDatabase);
        $db_dest = mydbconnection( $copyjob->dest);
        for ($k = 0; $k < sizeof($copyjob->src);$k++)
        {
            $copyobj = $copyjob->src[$k];
            if ($copyobj->type == 'file')
            {
              copyStudy($projectDatabase,$db,$copyjob->dest,$db_dest,$copyobj->piz, $copyobj->sid, $copyobj->fileID );
            }
            else if ($copyobj->type == 'subfolder')
            {
              copyStudy($projectDatabase,$db,$copyjob->dest,$db_dest,$copyobj->piz, $copyobj->sid, "" , $copyobj->subfolder);
            }
            else if ($copyobj->type == 'study')
            {
              copyStudy($projectDatabase,$db,$copyjob->dest,$db_dest,$copyobj->piz, $copyobj->sid);
            }
            else if ($copyobj->type == 'patient')
            {
               error_log("SELECT StudyID FROM studies WHERE patients_id LIKE '" . $copyobj->piz ."'");
               $a = $db->query("SELECT StudyID FROM studies WHERE patients_id LIKE '" . $copyobj->piz ."'");
               while($row = $a->fetch_assoc())
                 copyStudy($projectDatabase,$db,$copyjob->dest,$db_dest,$copyobj->piz,$row['StudyID']);
            }
        }

        $db->close();
        $db_dest->close();
        
      	clearPIDforAbort();

      }
      elseif ($command=='get_fileidentifier')
      {
        $jsonString = ($_GET['json']);
        $info = json_decode($jsonString);
        $json_out['identifier'] = "";
        $json_out['success'] = 1;   
        if (!($projectDatabase == "" || $projectDatabase==null || !isset($projectDatabase)))
        {      
          $db = mydbconnection( $projectDatabase);
          $a = $db->query("SELECT FilePath FROM files where ID=".$info->fileID);
          if ($a != null) 
            if ($row = $a->fetch_assoc())
            {
                $filePath = resolve_Route($row['FilePath']);
                if (is_readable($filePath))
                    $json_out['identifier'] = file_identifier($filePath);            
            }
            $db->close();                
        }
      }
      elseif ($command=='tag_files' | $command=='tag_files_del')
      {
     	savePIDforAbort();

        $jsonString = ($_GET['json']);
        $tagobj = json_decode($jsonString);
        $objs = $tagobj->objs;
        $tag = str_replace('/',' ',$tagobj->tag);

        $db = mydbconnection( $projectDatabase);
        for($k=0;$k<sizeof($objs);$k++)
        {
            $obj = $objs[$k];
            $a = $db->query("SELECT Tag FROM files WHERE ID=" . $objs[$k]);
            $row = $a->fetch_assoc();

            if ($command == 'tag_files')
            {
               if ($row['Tag'] == "")
                  $row['Tag'] = '/' . $tag . '/';
               else
               {
                  if (strpos($row['Tag'], '/' . $tag . '/') === false)
                      $row['Tag'] = $row['Tag'] . $tag . '/';
               }
            }
            else if ($command == 'tag_files_del')
            {
               if ($row['Tag'][0] != "/")
                    $row['Tag'] = '/' . $row['Tag'];
               if ($tag == "[[[ALL]]]")
                  $row['Tag'] = "";
               else
                  $row['Tag'] = str_replace('/' . $tag . '/', '/',$row['Tag']);
            }

            $db->query("UPDATE files SET Tag='".$row['Tag']."' WHERE ID=" . $objs[$k]);

        }
        $db->close();
        $json_out['success'] = 1;

     	clearPIDforAbort();

      }
      elseif ($command=='tag_items' | $command=='tag_items_del')
      {

     	savePIDforAbort();

        $jsonString = ($_GET['json']);
        $tagobj = json_decode($jsonString);
        $objs = $tagobj->objs;
        $tag = str_replace('/',' ',$tagobj->tag);

        $db = mydbconnection( $projectDatabase);
        $tstart = microtime(true);
        // this is the old SLOW version, will be replaced in future 
        if(1)
        {        
          for($k=0;$k<sizeof($objs);$k++)
          {
              $TAGNAME = "PTag";
              $TABLE = "patients";
              $WCLAUSE =  "PIZ='".$objs[$k]."'";
              $sharppos = strpos($objs[$k],riddelim);
              $idlist[] = $objs[$k];
              if ($sharppos !== false)
              {
                $PIZ = substr($objs[$k],0,$sharppos);
                $SID = substr($objs[$k],$sharppos+2); // riddelim , length of riddelim goes here
                $TAGNAME = "STag";
                $TABLE = "studies";
                $WCLAUSE =  "StudyID='".$SID."' AND patients_id='".$PIZ."'";
              }
              $a = $db->query("SELECT ".$TAGNAME." FROM ".$TABLE." WHERE ".$WCLAUSE);
              $row = $a->fetch_assoc();

              if ($command == 'tag_items')
              {
                 if ($row[$TAGNAME] == "" | $row[$TAGNAME] == "/")
                    $row[$TAGNAME] = '/' . $tag . '/';
                 else
                 {
                    if (strpos($row[$TAGNAME], '/' . $tag . '/') === false)
                        $row[$TAGNAME] = $row[$TAGNAME] . $tag . '/';
                 }

              }
              else if ($command == 'tag_items_del')
              {
                 if ($row[$TAGNAME][0] != "/")
                    $row[$TAGNAME] = '/' . $row[$TAGNAME];
                
                 if ($tag == "[[[ALL]]]")
                    $row[$TAGNAME] = "";
                 else
                    $row[$TAGNAME] = str_replace('/' . $tag . '/', '/',$row[$TAGNAME]);
              }

              $db->query("UPDATE ".$TABLE." SET ".$TAGNAME."='".$row[$TAGNAME]."' WHERE ".$WCLAUSE);
          }
        }
      /* this is the much faster method, but yet to be tested */
      else
      {
      if(sizeof($objs)>0)
      {
        $firstobj = $objs[0];
        $sharppos = strpos($firstobj,riddelim);
        // these ares studies
        $pizlist = [];
        $sidlist = [];
        if ($sharppos !== false)
        {
          for($k=0;$k<sizeof($objs);$k++)
          {
            $sharppos = strpos($objs[$k],riddelim);
            //echo $objs[$k]. "\n";
            $pizlist[] = substr($objs[$k],0,$sharppos);
            $sidlist[] = "'". substr($objs[$k],$sharppos+2)."'"; // riddelim , length of riddelim goes here
            $TAGNAME = "STag";
            $TABLE = "studies";
          }
          $WCLAUSE = " patients_id in ( ". implode($pizlist, ',') . ") AND StudyID in (" . implode($sidlist, ',') . ") ";

        }
        else
        {
            $TAGNAME = "PTag";
            $TABLE = "patients";
            $WCLAUSE = " PIZ in ( ". implode($objs, ',') . ") ";
        }
        
        if ($command == 'tag_items')
        {
          $fullquery = ("UPDATE $TABLE SET $TAGNAME = CASE WHEN $TAGNAME > '' THEN CONCAT($TAGNAME, '$tag/')  ELSE '/$tag/' END WHERE $WCLAUSE AND $TAGNAME NOT LIKE '%/$tag/%'"  );
        }
        else if ($command == 'tag_items_del')
        {
           if ($tag == "[[[ALL]]]")
             $fullquery = ("UPDATE $TABLE SET $TAGNAME = '' WHERE $WCLAUSE"  );
           else
             $fullquery = ("UPDATE $TABLE SET $TAGNAME = CASE WHEN LENGTH(REPLACE($TAGNAME, '/$tag/', '')) = 0 THEN REPLACE($TAGNAME, '/$tag/', '') ELSE  REPLACE($TAGNAME, '/$tag/', '/') END WHERE $WCLAUSE AND $TAGNAME LIKE '%/$tag/%'"  );
        }

        $db->query($fullquery);

      }
      }

        $db->close();

        // report the duration
        //$tend = microtime(true);
        //$json_out['msg'] = "ooo " . ($tend-$tstart);


        $json_out['success'] = 1;

     	clearPIDforAbort();
        

      }
      elseif ($command=='get_study_content')
      {
        $jsonString = ($_GET['json']);
        $obj = json_decode($jsonString);
        $db = mydbconnection( $projectDatabase);
        $rowids = $obj->rowids;
        if (!isset($obj->showassocs))
          $obj->showassocs = (object) array();
        for($k=0;$k<sizeof($rowids);$k++)
        {
            $rowid = $rowids[$k];
            $parts = explode(riddelim, $rowid);
            $piz = $parts[0];
            $sid = isset($parts[1])?$parts[1]:'';
            $temp = isset($obj->showassocs->$rowid)?$obj->showassocs->$rowid:false;
            $json_out['x' . $rowid] = renderStudy($piz,$sid,$db, $temp);
        }
        $db->close();
        $json_out['success'] = 1;

      }
      elseif ($command=='resolve_file_query')
      {
        
        $jsonString = ($_GET['json']);
        $obj = json_decode($jsonString);
  
        $db = mydbconnection( $projectDatabase);
        $fileQuerys = $obj->fileQuerys;
        $resolved_files = array();
        for($k=0;$k<sizeof($fileQuerys);$k++)
        {
			// special treatment for reading jsons
			if(strpos($fileQuerys[$k], '.reading') > 0 )
			{	
				$str =str_replace('.reading', '', $fileQuerys[$k]);


				$P = false; $S = false; $F = false;

				// find all matches and set to array
				preg_match_all("/FFilename:(?<filename>\S+)/", $str ,  $F );
				preg_match_all("/\sPPIZ:(?<patients_id>\S+)/", $str ,  $P );
				preg_match_all("/\sSStudyID:(?<studies_id>\S+)/", $str ,  $S );
				if(sizeof($F['filename']) >0 )
				{
 					$ttt = explode('_', $F['filename'][0] );
 					$formid = $ttt[0];
 					$user = $ttt[1];
 					$iterator = $ttt[2];

 					$query = "select * from readingresults where formid=$formid AND user like '$user' AND iterator=$iterator";

					if(sizeof($P['patients_id'])>0)
						$query .= " AND patients_id like '".$P['patients_id'][0]."'";
					if(sizeof($S['studies_id']>0))
						$query .= " AND studies_id like '". $S['studies_id'][0] ."'";

					$a = $db->query($query);
					if( ($row = $a->fetch_assoc()) )
					   $resolved_files[] = "READING://" . $row['ID'] ."_" . $row['formid'];
				}


			}
			else
			{
				$arr = explode(' OR ', $fileQuerys[$k]);
				$fis = array();
			
				for ($j=0;$j < sizeof($arr);$j++)
				{
					$query = translatefileQuery($arr[$j],$projectDatabase);
					$a = $db->query($query);

// 					error_log(var_dump($obj));
// 					error_log(var_dump($a));


// 					if( ($row = $a->fetch_assoc()) )
// 					   $fis[] = $row['ID'];
					
					// Return ALL matches, decide on client side what to do with multimatches
					if ($a != null)
					  while($row = $a->fetch_assoc())
						  $fis[] = $row['ID'];

				}
				if (sizeof($fis) > 0)
					// Return ALL matches, decide on client side what to do with multimatches
				  //$resolved_files[] = $fis[0];
				  $resolved_files[] = $fis;
				else
				  $resolved_files[] = "";
			}

        }
        $db->close();
        $json_out['resolved_files'] = $resolved_files;
        $json_out['success'] = 1;

      }

      elseif ($command=='resolve_psid_query')
      {
        $jsonString = ($_GET['json']);
        $obj = json_decode($jsonString);
        $db = mydbconnection( $projectDatabase);
        $psids = $obj->psids;
        $resolved_psids = array();
        for($k=0;$k<sizeof($psids);$k++)
        {
            $psid = $psids[$k];
            $psid = explode('#', $psid);
            if(sizeof($psid) > 1)
            {
               $q = "SELECT concat(patients_id,StudyID) as psid FROM studies where patients_id LIKE '".$psid[0] . "' AND StudyID LIKE '#" . $psid[1] . "'";
            }
            else
            {
               if (substr($psid[0],0,4) == 'STAG')
               {
                   $q = "SELECT concat(patients_id,StudyID) as psid FROM studies where STag LIKE '%/" . substr($psid[0],5) . "/%' AND patients_id != 'ANALYSIS'";
               }
               else
                  $q = "SELECT concat(patients_id,StudyID) as psid FROM studies where patients_id LIKE '" . $psid[0] . "%'";
            }
//               $q = "SELECT concat(patients_id,StudyID) as psid FROM studies where StudyID LIKE '" . $psid . "%'";
//             else
//               $q = "SELECT concat(patients_id,StudyID) as psid FROM studies where patients_id LIKE '" . $psid . "%'";


//             if ($psid[0] == '#')
//               $q = "SELECT concat(patients_id,StudyID) as psid FROM studies where StudyID LIKE '" . $psid . "%'";
//             else
//               $q = "SELECT concat(patients_id,StudyID) as psid FROM studies where patients_id LIKE '" . $psid . "%'";
            $a = $db->query($q);
            if ($a != null)
              while($row = $a->fetch_assoc())
                  $resolved_psids[] = $row['psid'];

        }
        $json_out['psids'] = $resolved_psids;
        $db->close();
        $json_out['success'] = 1;
      }
      elseif ($command=='update_patients')
      {
       	 $json_out['content'] = "";
       	 $json_out['success'] = 0;
      	 if (isset($_SESSION['state'][$project]))
      	 {
			 $thestate = $_SESSION['state'][$project];  
			 $selModeOfQuery = $thestate->viewer->selectionMode[1];

			 if (isset($_GET['selectionModeOfQuery']))
				  $selModeOfQuery = $_GET['selectionModeOfQuery'][1];

			 if ($selModeOfQuery == $thestate->viewer->selectionMode[1])
			 {
				$json_out['content'] = renderPatientTable(false,$project);
				$json_out['success'] = 1;
			 }
      	 }

      }
      elseif ($command=='download_hashmap') // selected files are colected vias symbolic links
      {
         $jsonString = ($_GET['json']);
         $dinfo = json_decode($jsonString);
         $obj = $dinfo->objs;

      	 $res = array();
         for ($k=0;$k < sizeOf($obj);$k++)
             $res[$obj[$k]->piz] = hashmap($obj[$k]->piz);
         $json_out['content'] = $res;
         $json_out['success'] = 1;
         


      }
      elseif ($command=='initiate_download_fileset') // selected files are colected vias symbolic links
      {
      
      
		 // check if zip is installed on this system, otherwise trouble finding the error
		 if ( empty(shell_exec("which zip")) )
		 {
			$json_out['msg'] = "'zip' is not installed on the server. Contact system admin. ".
			$json_out['success'] = 0;
		 }
      
         $jsonString = ($_GET['json']);
         $dinfo = json_decode($jsonString);
         $obj = $dinfo->objs;

         $tmpfname = tempnam("/tmp", "DPX");
         unlink($tmpfname);
         mymkdir($tmpfname);

         $totsize = 0;

         function ano($frow,$dinfo)
         {
	          if ($dinfo->anonym > 0)
              {
				$frow['FamilyName'] = $frow['FamilyName'][0];
                $frow['GivenName'] = $frow['GivenName'][0];
              }
              if ($dinfo->anonym == 2)
			  {
			    $frow['patients_id'] = hashmap($frow['patients_id']);
			  }
			  return $frow;
	
         }

         $db = mydbconnection( $projectDatabase);
         for ($k=0;$k < sizeOf($obj);$k++)
         {

            if ($obj[$k]->type == 'file')
            {
              $a = $db->query("SELECT *  FROM files as tf JOIN patients as tp JOIN studies as ts WHERE tf.ID='".$obj[$k]->fileID."' AND tp.PIZ = ts.patients_id AND ts.StudyID = tf.studies_id  AND tp.PIZ = tf.patients_id");
              $filerow = $a->fetch_assoc();



              $filerow['FilePath'] =resolve_Route($filerow['FilePath']);

			  $filerow=ano($filerow,$dinfo);

              $folder = hdr2PatientPath($filerow['patients_id'],$filerow['studies_id'], $filerow,$filerow);
              
              $folder = $tmpfname . '/' . $folder . '/' . $filerow['SubFolder'];
              mymkdir($folder);
              $link = $folder . '/' . $filerow['Filename'];
              symlink($filerow['FilePath'], $link);
              $totsize += filesize($filerow['FilePath']);

            }
            else if ($obj[$k]->type == 'study' | $obj[$k]->type == 'patient')
            {
                if ($obj[$k]->type == 'study')
                    $a = $db->query("SELECT *  FROM files as tf JOIN patients as tp JOIN studies as ts WHERE ts.StudyID='".$obj[$k]->sid."' AND tp.PIZ = ts.patients_id  AND tp.PIZ='".$obj[$k]->piz."' AND ts.StudyID = tf.studies_id   AND tp.PIZ = tf.patients_id");
                else if ($obj[$k]->type == 'patient')
                    $a = $db->query("SELECT *  FROM files as tf JOIN patients as tp JOIN studies as ts WHERE tp.PIZ='".$obj[$k]->piz."' AND tp.PIZ = ts.patients_id AND ts.StudyID = tf.studies_id   AND tp.PIZ = tf.patients_id");
                else 
                    continue;
                if ($a != null)
                  while($filerow = $a->fetch_assoc())
                  {

	        		  $filerow=ano($filerow,$dinfo);
    
                      $folder = hdr2PatientPath($filerow['patients_id'],$filerow['studies_id'], $filerow,$filerow);
                      $filerow['FilePath'] =resolve_Route($filerow['FilePath']);

                      $folder = $tmpfname . '/' . $folder . '/' . $filerow['SubFolder'];
                      mymkdir($folder);
                      $link = $folder . '/' . $filerow['Filename'];
                      symlink($filerow['FilePath'], $link);
                      $totsize += filesize($filerow['FilePath']);

                  }
            }
          }
          $db->close();

          $json_out['content'] = array("name"=>$tmpfname, "size"=> $totsize);
          $json_out['success'] = 1;


      }
      elseif ($command=='download_fileset') // actual download and cleanup
      {
          $jsonString = ($_GET['json']);
          $obj = json_decode($jsonString);
          
          set_time_limit(0);    
          session_write_close(); // that we do not lock the session file, in case of big files

          $tmpfname = $obj->name;
          $totsize = $obj->size+3000;
          // be carfeul with this, we just assume the header less than 3000 bytes, otherwise archive is corrupted

          if (!isset($obj->cleanup))
          {

            // Sending headers
            $downloadname = "DPX_" . $_GET['project'] . date("_Y-m-d_H-i") . '.zip';  
            header('Content-Type: application/zip');
            header('Content-Disposition: attachment; filename="'.$downloadname.'"');          
          //  header('Content-Length: '. $totsize); // turned off, otherwise sometimes archive corrupted
            header('Content-Transfer-Encoding: binary');
            ob_clean();
            flush();

            // On the fly zip creation
            chdir($tmpfname);
            
            // add stderr here ... was the only 
            $fp = popen('zip -0 -q -r - *  2>&1 ', 'r'); 
            while (!feof($fp)) {
                echo fread($fp, 8192);
                ob_flush();
                flush();
            }
            pclose($fp);
          }
          
          
          // clean up  tmp folder
          foreach( new RecursiveIteratorIterator( 
              new RecursiveDirectoryIterator( $tmpfname, FilesystemIterator::SKIP_DOTS | FilesystemIterator::UNIX_PATHS ), 
              RecursiveIteratorIterator::CHILD_FIRST ) as $value ) {
                  $value->isLink() ? unlink( $value ) : rmdir( $value );
          }
          rmdir($tmpfname );

          if (!isset($obj->cleanup))
            return;
          
          $json_out['success'] = 1;
          $json_out['msg'] = "";

      }
      elseif ($command=='update_full_patients')
      {
      	//  savePIDforAbort();

         $c = renderPatientTable(true,$project);
         $json_out['studies'] = $c['studies'];
         $json_out['patients'] = $c['patients'];
         $json_out['analysis'] = $c['analysis'];
         $json_out['files'] = $c['files'];
         $json_out['numfiles'] = $c['numfiles'];
         $json_out['forceanonymize'] = $c['forceanonymize'];
         $json_out['content'] = $c['html'];
         $json_out['success'] = 1;

     	//  clearPIDforAbort();


      }


      elseif ($command=='change_shared_access')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
         $db = mydbconnection(ROOTDB);

         function getProjInfo($db,$p)
         {
			 $qf = "SELECT * FROM projects WHERE name LIKE '$p'";
			 $a = $db->query($qf);
			 $row = $a->fetch_assoc();
			 $x = str_replace('\\','\\\\', $row['jsondesc'] );
			 $x = str_replace('\"','"', $x );                      
			 $row['jsondesc'] = json_decode($x);
			 return $row;
         }

         function setProjInfo($db,$row)
         {
			$row['jsondesc'] = json_encode($row['jsondesc']);
			$row['jsondesc'] = str_replace('\\/', '/', $row['jsondesc']);
			$row['jsondesc'] = str_replace('\\\\','\\', $row['jsondesc'] );

			return updateRow($db,'projects',$row);

         }

         function empty_shared()
         {
            return (object) ["granted" => (object)[], 
							   "receiving" => (object)[] ];
         }


         $row = getProjInfo($db,$project);

         if ($json->type=="todel")
         {
         	$projdesc = $row['jsondesc'];
         	$target = $json->target;
			unset($projdesc->sharedAccess->granted->$target);
            setProjInfo($db,$row);
		    $json_out['sharedAccess'] = $projdesc->sharedAccess;
		    $json_out['success'] = 1;    

            
            $row_target = getProjInfo($db,$json->target);
         	$projdesc = $row_target['jsondesc'];
			unset($projdesc->sharedAccess->receiving->$project);
            setProjInfo($db,$row_target);
         }

         if ($json->type=="getresource")
         {
         	$projdesc = $row['jsondesc'];
         	if (!isset($projdesc->sharedAccess))
         	    $projdesc->sharedAccess = empty_shared();
         	$target = $json->target;
			$projdesc->sharedAccess->receiving->$target = 1;
            setProjInfo($db,$row);			
		    $json_out['sharedAccess'] = $projdesc->sharedAccess;
		    $json_out['success'] = 1;    
            
         }
         if ($json->type=="delresource")
         {
         	$projdesc = $row['jsondesc'];
         	if (!isset($projdesc->sharedAccess))
         	    $projdesc->sharedAccess = empty_shared();
         	$target = $json->target;
			unset($projdesc->sharedAccess->receiving->$target);
            setProjInfo($db,$row);			
		    $json_out['sharedAccess'] = $projdesc->sharedAccess;
		    $json_out['success'] = 1;    
            
         }
		

         if ($json->type=="toadd")
         {
         	$projdesc = $row['jsondesc'];
         	if (!isset($projdesc->sharedAccess))
         	    $projdesc->sharedAccess = empty_shared();
         	$target = $json->target;
			$projdesc->sharedAccess->granted->$target = 1;
			if (!setProjInfo($db,$row))
			{

			   $json_out['success'] = 0;
			   $json_out['msg'] =  $db->error;
			   error_log($db->error);
			}
			else
			{
               $row_target = getProjInfo($db,$json->target);
               $projdesc_target = $row_target['jsondesc'];
			   if (!isset($projdesc_target->sharedAccess))
         	      $projdesc_target->sharedAccess = empty_shared();
               $projdesc_target->sharedAccess->receiving->$project = 1;
			   if (!setProjInfo($db,$row_target))
			   {
				   $json_out['success'] = 0;
				   $json_out['msg'] =  $db->error;
				   error_log($db->error);
			   	
			   }
			   else
			   {			 
                   $json_out['sharedAccess'] = $projdesc->sharedAccess;
			       $json_out['success'] = 1;    
			   }
			}

         	
         }
         $db->close();
      }
	  elseif ($command=='change_project_property')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
         $db = mydbconnection(ROOTDB);

         $qf = "SELECT * FROM projects WHERE name LIKE '$project'";
         $a = $db->query($qf);
         $row = $a->fetch_assoc();
   	     $x = str_replace('\\','\\\\', $row['jsondesc'] );
   	     $x = str_replace('\"','"', $x );                      
         $projdesc = json_decode($x);
         //$projdesc = json_decode($row['jsondesc'] );


         $json_out['success'] = 0;

         if ($json->property == 'clin_info' | $json->property == 'anonymization')
         {
		     $prop = $json->property ;
             $projdesc->$prop = $json->value;
             $json_out['success'] = 1;
         }
         if ($json->property == 'clin_info')
         {
             $projdesc->clin_info = $json->value;
             $json_out['success'] = 1;
         }
         
         if ($json->property == 'forceAnonymize')
         {
             $projdesc->forceAnonymize = $json->value;
             $row['forceAnonymize'] = $json->value;
             $json_out['success'] = 1;
         }

         if ($json->property == 'hardCopy')
         {
             $row['hardCopy'] = $json->value;
             $json_out['success'] = 1;

         }

         if ($json_out['success'] == 1)
         {

			 $row['jsondesc'] = json_encode($projdesc);
			 $row['jsondesc'] = str_replace('\\/', '/', $row['jsondesc']);
			 $row['jsondesc'] = str_replace('\\\\','\\', $row['jsondesc'] );

			 if(updateRow($db,'projects',$row) === false)
			 {
				$json_out['success'] = 0;
				$json_out['msg'] =  $db->error;
			 }
         }

         $db->close();


      }
      elseif ($command=='create_project')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
         $db = mydbconnection(ROOTDB);
         
          $default_projects = explode(",",DEFAULTPROJECTNAME);
          // template basisi for the new project.
          if(isset($json->templateproject))
             $templateproject = $json->templateproject;
	      else
	      {
	         $templateproject = $default_projects[0];
	      }

         $qf = "SELECT * FROM projects WHERE name LIKE '$templateproject'";
         $a = $db->query($qf);
         $row = $a->fetch_assoc();
         
         if($row == false)
         {
            $json_out['success'] = 0;
            $json_out['msg'] = "Error: Template $templateproject was not found in database. Aborting.";
            return $json_out;
         }
   	    
   	     $row['jsondesc'] = str_replace('\\','\\\\', $row['jsondesc'] );
   	     $row['jsondesc'] = str_replace('\"','"', $row['jsondesc'] );                      
         $projdesc = json_decode($row['jsondesc']);
         $parent_module_name = $row['module'];

         if($projdesc == null)
         {
            $json_out['success'] = 0;
            $json_out['msg'] = "Error: The project `$templateproject` could not be parsed correctly. Aborting";
//            $json_out['msg'] .= "<br><br>" . json_last_error_msg();
            $json_out['msg'] .= "<br><br>" . $row['jsondesc'];
            
            return $json_out;
         }

         // cat the username befor the projectname ...? 
         // to be made more flexible, also with " public to all etc...".
         if( $_SESSION['username'] != "root")
         {
            $projname = $_SESSION['username'] . project_user_delim . $json->name;
         }
         else
         {
            $projname = $json->name ;
         }

         $qf = "SELECT * FROM projects WHERE name LIKE '$projname'";
         $a = $db->query($qf);
         $row_exist = $a->fetch_assoc();
         
         // do not overwrite the project for non-testusers
         if(substr($_SESSION['username'],0,2) !== TESTUSERPREFIX && $row_exist == true)
         {
            $json_out['success'] = 0;
            $json_out['msg'] = "Error: The project ´ $projname ` already exists. Aborting.";
            return $json_out;
         }
     

         // make datafolders an array  if not already 
         if($projdesc->datafolders != null &&  !is_array($projdesc->datafolders) )
           $projdesc->datafolders = array($projdesc->datafolders);

        if (0)
        {           
			$WCPatients = "where PIZ != 'ANALYSIS'";
			$WCStudies = "where patients_id != 'ANALYSIS'";
			$WCFiles = "where patients_id != 'ANALYSIS'";
        }
        else
        {
			$WCPatients = "";
			$WCStudies = "";
			$WCFiles = "";
        }           
           
         if (isset($json->fork) && $json->fork == true)
         {
            $qf = "SELECT * FROM projects WHERE name LIKE '".$default_projects[0]."'";
            $a = $db->query($qf);
            $row_default = $a->fetch_assoc();
   	        $row_default['jsondesc'] = str_replace('\\','\\\\', $row_default['jsondesc'] );
   	        $row_default['jsondesc'] = str_replace('\"','"', $row_default['jsondesc'] );                      
            $defaultprojdesc = json_decode($row_default['jsondesc']);
            if($defaultprojdesc->datafolders != null &&  !is_array($defaultprojdesc->datafolders) )
               $defaultprojdesc->datafolders = array($defaultprojdesc->datafolders);


            $defaultprojdesc->datafolders[0]->datapath =  str_replace($default_projects[0], $projname ,$defaultprojdesc->datafolders[0]->datapath);      
            $defaultprojdesc->analysisfolder->datapath =  str_replace($default_projects[0], $projname ,$defaultprojdesc->analysisfolder->datapath);      
            $newdatapath = $defaultprojdesc->datafolders[0]->datapath;
            $projdesc->datafolders = array_merge($projdesc->datafolders,$defaultprojdesc->datafolders);
            $projdesc->analysisfolder = $defaultprojdesc->analysisfolder;
            $projdesc->importfolder = sizeOf($projdesc->datafolders)-1;
            $row['parent'] = $json->templateproject;
            $parent_module_name = $defaultprojdesc->module;

            $projdesc->parent = $json->templateproject;
            if( isset($json->selectedItems) )
            {
				$plist = implode("','",$json->selectedItems->patientIDs);
				$slist = implode("','",$json->selectedItems->studyIDs);
				$flist = implode("','",$json->selectedItems->fileIDs);
				
				if( strlen($plist) > 0 )
					$WCPatients = " WHERE piz in ('$plist')";
				if(strlen($slist) > 0  )
					$WCStudies = " WHERE patients_id in ('$plist') and StudyID in ('$slist') ";					
				if( strlen($flist) > 0  )
					$WCStudies = " WHERE patients_id in ('$plist') and StudyID in ('$slist') and fileID in ('$flist')";
			}
			
         }
         else
         {

             // new convention: The defaultproject containts a writable path as FIRST datafolder.
             // This way, demo can contain, both readable examples, and a writable user specific folder.
             // expect an array

             $projdesc->datafolders[0]->datapath =  str_replace($templateproject, $projname ,$projdesc->datafolders[0]->datapath);     
             if (isset($projdesc->analysisfolder))
                 $projdesc->analysisfolder->datapath =  str_replace($templateproject, $projname ,$projdesc->analysisfolder->datapath);      
              
             $newdatapath = $projdesc->datafolders[0]->datapath;
         }


         
         
         if(!mymkdir( resolve_Route($newdatapath )))
         {
              $json_out['success'] = false;
              $json_out['msg'] = '<br><br>Error: Could not create Directory. Permission denied. <br/><br/> ' . resolve_Route($newdatapath) ;
              error_log($json_out['msg']);
              return $json_out;
         }

         if (isset($projdesc->procinfo_defaultproject) && $projdesc->procinfo_defaultproject != "")
         	$row['cmddesc'] = 'CMDPROJ:' . $projdesc->procinfo_defaultproject;

         unset($row['ID'] ); 
         $row['name'] = $projname;
         $row['module'] = $parent_module_name;
          
         // this will replalce slashes / with \/ --> json2mat will not read it properly. so, correct.
         $row['jsondesc'] =   json_encode($projdesc);
         // un-escape the slashes, otherwise matlab cannot read it ... php 5.3 could do this with option JSON_UNESCAPED_SLASHES
         $row['jsondesc'] = str_replace('\\/', '/', $row['jsondesc']);
		 $row['jsondesc'] = str_replace('\\\\','\\', $row['jsondesc'] );

         $rights = '{"batchtool":"on","readonly":"off"}';
    
         if(updateRow($db,'projects',$row) === false)
         {
            $json_out['success'] = false;
            $json_out['msg'] =  $db->error;
         }

         if( updateRow($db,'rights',array('username' => $_SESSION['username'],'project' => $projname,
                        'role' => 'admin', 'rights' => $rights )) === false)
         {
            $json_out['success'] = false;
            $json_out['msg'] =  $db->error;
         }

         $db->query('DROP DATABASE IF EXISTS ' . $projname );


         
         $cloneTable = function($tname, $wclause='') use (&$db,&$projname,&$templateproject)
         {
			$a = $db->query("SHOW COLUMNS from $templateproject.$tname");
			$keys = array();
			while($row = $a->fetch_assoc())
				$keys[] = $row['Field'];
			
			$keys = implode(',', $keys);

			$db->query("CREATE TABLE $projname.$tname LIKE  $templateproject.$tname");
            $db->query("INSERT INTO $projname.$tname ($keys) SELECT $keys FROM $templateproject.$tname $wclause");
         };

         $db->query('CREATE DATABASE ' . $projname );
         
         $cloneTable('patients', $WCPatients);
         $cloneTable('studies',  $WCStudies);
         $cloneTable('files',    $WCFiles);
         
         $cloneTable('metaidx');
         $cloneTable('metacontent');

         $db->query("update $projname.files set permission='link'");

         // get project into project list
         loadAllProjectInfo();

         // reset studypath 
		 $qf = "SELECT * FROM $projname.studies";
		 $a = $db->query($qf);
		 while($row = $a->fetch_assoc())
		 {			 
			 $studypath = hdr2PatientFolder($row['patients_id'], $row['StudyID'], $row,$row, $projname);
             $db->query("update $projname.studies set StudyPath='". $studypath ."'   where patients_id='" . $row['patients_id'] . "' AND StudyID='". $row['StudyID'] . "'");
		 }



         // check if something is in the project
         $a = $db->query("SELECT id FROM $projname.patients");
         $row = $a->fetch_assoc();
         $db->close();


         $_GET['project'] = $projname;

         loadAllProjectInfo();
         
         // only create new patient if project is empty ( template projects can contain examples )
         if($row == false)
         {
/*            $pinfo = (object) array("piz"=>"ANALYSIS","sid"=>"#study0001","content"=>(object)array(
                              "PatientsName"=>(object)array("FamilyName"=>"noname","GivenName"=>"noname"),
                              'StudyDate' => date("Ymd")));*/
            $pinfo = (object) array("piz"=>"ANALYSIS","sid"=>"#ana001","content"=>(object)array(
                              "PatientsName"=>(object)array("FamilyName"=>"noname","GivenName"=>"noname"),
                              "StudyDescription"=>"ana001",
                              'StudyDate' => date("Ymd")));
            createPatient($projname,$pinfo);
            savePatientStudyInfo($projname,$pinfo);
	     }
	 
         setDefaultState($projname);

         $json_out['content'] = $projname;
         $json_out['success'] = 1;
 

      }
      elseif ($command=='create_rights')
      {
        $jsonString = ($_GET['json']);
        $json = json_decode($jsonString);
        $db = mydbconnection(ROOTDB);
        $a = $db->query("SELECT * from users where username='$json->username'");
        if(!$a->fetch_assoc())
        {
          // assume user not found.
          //$json_out['content'] = "user `$json->username` not registered in system nor in LDAP.";
          //$json_out['success'] = 0;
          //if(ALLOWLDAPAUTOSIGNUP)
          if(LDAPENABLED) // allow this always.
          {
            $res = DPX_ldap_search(Array("uid"=>$json->username));
            if( sizeof($res)>0 )
            {
              $json_out['ldapuserfound'] = 1;
              $json_out['success'] = 1;
            }
          }
          else
          {
              $json_out['content'] = "user `$json->username` not registered in system. Please invite him now";
              $json_out['success'] = 1;

          }
        }
        else
        {
          $json_out['success'] = 1;
        }

        if($json_out['success'] == 1)
        {
          $role = $json->rights->role;
          unset($json->rights->role);
          $rights = json_encode($json->rights);
          if(updateRow($db,'rights',array('username' => $json->username,'project' => $json->project, 'role' => $role, 'rights' => $rights )))
          {
             $json_out['success'] = 1;
          }
          else
          {
            $json_out['content'] = "error creating / updating user rights";
            $json_out['success'] = 0;
          }
        }
      }
      elseif ($command=='delete_project_rights')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
         $db = mydbconnection(ROOTDB);
         $a = $db->query("SELECT * from rights where username='$json->username' AND project='$json->project'");
         if ($a->fetch_assoc()) // just a shared project 
         {
            if(isset($json->rightsid) )
              $a = $db->query("DELETE from rights where id='$json->rightsid'");
            else
              $a = $db->query("DELETE from rights where username='$json->username' AND project='$json->project'");
            $json_out['success'] = 1;
         }
         else
         {
            $json_out['content'] =  "no granted rights for this user, or user/rightsid not existing";
            $json_out['success'] = 0;
         }
      }
      elseif ($command=='delete_user')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
 		 // only admins can delete users
 		 if( $_SESSION['userinfo']['isadmin'] == '1' )
 		 {
 		   if(isset($json->username) && $json->username !=null)
 		   {
             $db = mydbconnection(ROOTDB);
             $q = "DELETE from rights where username='$json->username' AND project='%'";
             $db->query($q);
             $q = "DELETE from users where username='$json->username'" ;
             $db->query($q);
             $json_out['success'] = 1;
 		   }
 		 }
 		 
      }
      elseif ($command=='create_user')
      {
 		 if( $_SESSION['userinfo']['isadmin'] == '1' )
 		 {
 		   if(isset($json_in->uid) && $json_in->uid !=null)
 		   {
 		   		if ( !preg_match('/^[A-Za-z][A-Za-z0-9]{2,15}$/', $json_in->uid) )
 		   		{
					$json_out['msg'] = "username must only contain letters and numbers";
					$json_out['success'] = 0;
 		   		}
 		   		else
 		   		{
					$user = array("username"=>$json_in->uid, "email"=>isset($json_in->mail)?$json_in->mail:"" );
					$user['status'] = "pre_created";
					$user['token'] =  generateRandomString(10);
 				    $user['runjobsas'] = RUNASUSER;
					if ($user['runjobsas'] == "*SELF*")
						$user['runjobsas'] = $user['username'];


					$db = mydbconnection(ROOTDB);
					$a = $db->query("select id from users where username like '".$json_in->uid."'");
					if($a->fetch_assoc() ) 
					{
						$json_out['msg'] = "User with id '<b>".$json_in->uid."</b>' already exists!";
						$json_out['success'] = 0;
					}
					else
					{
						$values  =  array_map( function ($v) { return sprintf("'%s'", $v);}, array_values($user) ) ;
						$keys    =  array_keys($user);
				
						$q = "INSERT INTO users (". implode(',', $keys) . ") VALUES (" . implode(',' , $values) . ")";
						$db->query($q);
						$json_out['success'] = 1;
						$json_out['user'] = $user;
					
					}
					$db->close();
				}
 		   }
 		 }
 		 
      }
      elseif ($command=='project_rights_get_list')
      {
        $jsonString = ($_GET['json']);
        $json = json_decode($jsonString);
		$db = mydbconnection(ROOTDB);
		$project = $json->project;
		$allowed = false;
		if( $_SESSION['userinfo']['isadmin'] == '1' )
			$allowed = true;
		else
		{
			$a = $db->query("SELECT * from rights where username='$_SESSION[username]' AND project='$json->project'");
			if($a->fetch_assoc())
				$allowed = true;
		}
		if(!$allowed)
		{
            $json_out['content'] =  "no granted rights for this user or user not existing";
            $json_out['success'] = 0;
		}
		else
		{
			$a = $db->query("SELECT * from rights where project='$project' order by username");
			$out = Array();
			while($row = $a->fetch_assoc())
				$out[] = $row;
			$json_out['json'] =  json_encode($out);
		}
      }
      
      elseif ($command=='delete_project')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
         $db = mydbconnection(ROOTDB);
         $a = $db->query("SELECT * from projects where name='$json->project'");
         if ($a->fetch_assoc()) 
         {
            unset($_SESSION['moduleList'][$json->project]);
            $json_out['success'] = 1;
            if ( !$db->query("DELETE from projects where name='$json->project'")
             | !$db->query("DELETE from rights   where project='$json->project'")
             | !$db->query("DELETE from json where project='$json->project'")
             | !$db->query("DROP DATABASE IF EXISTS $json->project")     )
                $json_out['msg'] = 'Notice: Some issues occured when removing database entries'; 

         }
         else
         {
            $json_out['content'] =  "project not existing";
            $json_out['success'] = 0;
         }

      }

      elseif ($command=='create_patient')
      {
         if(  $_SESSION['moduleInfo'][$project]['importfolder']->patientfolderpattern === null)
         {
             $json_out['msg'] =  "Error: This project does not contain a valid importfolder. No patient creation / file upload possible.";
             $json_out['msg'] .= var_dump($_SESSION['moduleInfo'][$project]);
             return($out);
         }

         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
        
         $a = createPatient($projectDatabase,$json);
         $json_out['msg'] = $a;
      }
 
      elseif ($command=='getNewCustomPIZ')
      {
         $json_out['json'] = getNewCustomPIZ($projectDatabase);
      }
      elseif ($command=='create_study')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);

         $a = createStudy($projectDatabase,$json);
         $json_out['msg'] = $a;


      }
      elseif ($command=='updateTopMenu')
      {
         loadAllProjectInfo();
         
         $json_out['html'] = renderTopMenu($projectDatabase);

      }
      elseif ($command=='update_analysis_folder')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);

         $db = mydbconnection( $projectDatabase);
         updateAnalysisFiles($json->piz,$json->sid,$db);
         $json_out['msg'] = '';


      }
      elseif ($command=='clean_files')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);

         $db = mydbconnection( $projectDatabase);
         cleanStudy($json->piz,$json->sid,$db);
         $json_out['msg'] = '';


      }
      elseif ($command=='get_patientinfo')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
         $db = mydbconnection( $projectDatabase);
         $qf = "SELECT * FROM patients WHERE PIZ='".$json->piz."'";
         $a = $db->query($qf);
         $row = $a->fetch_assoc();
         $json_out['content'] = json_encode($row);
         $json_out['success'] = 1;
         $db->close();

      }
      elseif ($command=='get_studyinfo')
      {
         $jsonString = ($_GET['json']);
         $json = json_decode($jsonString);
         $db = mydbconnection( $projectDatabase);
         $qf = "SELECT * FROM studies JOIN patients WHERE patients_id=PIZ AND StudyID='".$json->sid."'";
         $a = $db->query($qf);
         $row = $a->fetch_assoc();
         $json_out['content'] = json_encode($row);
         $json_out['success'] = 1;
         $db->close();

      }
      elseif ($command=='save_patientinfo_studyinfo')
      {
    	 $moduleInfo = $_SESSION['moduleInfo'];

		 if ($moduleInfo[$project]['rights']->readonly != 'off')
		 {
			$json_out['msg'] = "no permission";
			$json_out['success'] = 0;
		 }
		 else 
		 {
			 $jsonString = ($_GET['json']);
			 $json = json_decode($jsonString);
			 savePatientStudyInfo($projectDatabase,$json);
			 $json_out['success'] = 1;
		 }

      }
      elseif ($command=='save_json')
      {

  
    	 $moduleInfo = $_SESSION['moduleInfo'];

		 if ($moduleInfo[$project]['rights']->readonly != 'off')
		 {
			$json_out['msg'] = "no permission";
			$json_out['success'] = 0;
		 }
		 else 
		 {

			 $jsonString = ($_GET['json']);

			 $json = json_decode($jsonString);
			 $db = mydbconnection( $projectDatabase);
			 $qf = "SELECT * FROM studies as s JOIN patients as p WHERE p.PIZ=s.patients_id AND s.StudyID='".$json->study."' AND s.patients_id='".$json->piz."'";
			 $a = $db->query($qf);
			 $row = $a->fetch_assoc();

	   //      $studypath = $row['StudyPath'];
			 $studypath = resolve_Route(hdr2PatientFolder( $json->piz,$json->study, $row,$row, $project));

			 $name = str_replace(".json","",$json->name) . ".json";
			 if (isset($json->SubFolder))
				 $subfolder = $json->SubFolder;
			 else
				 $subfolder = $json->subfolder;
			 if (isset($json->tag))
			 {
			   $tag = str_replace("//","/","/" . $json->tag . "/");
			   $json->content->tag = $tag;
			 }
			 $path = str_replace("//","/", $studypath."/".$subfolder."/".$name);
			 //echo "afas" . $json->piz;

			 $targetDir = resolve_Route($studypath."/".$subfolder);
			 if (!file_exists($targetDir))
			 {
				 mymkdir( $targetDir );
			 }

			 if(!is_writable($targetDir))
			 {
			   $json_out['msg'] = "Error: No permissions to write into directory " . $targetDir;
			   $json_out['success'] = 0;
			 }
			 else
			 {

			   if (!file_put_contents(resolve_Route($path),json_encode($json->content, JSON_UNESCAPED_SLASHES)))
			   {
				 $db->close();
				 $json_out['msg'] = "Problems during writing file_put_contents of " . resolve_Route($path);
				 $json_out['success'] = 0;
			   }
			   else
			   {

				 $filesize = filesize(resolve_Route($path));
				 $DateModified = date ("Y-m-d H:i:s.", filemtime(resolve_Route($path)) );
				 $DateModified = substr($DateModified,0,19);

				 $fileinfo = (object) array();
				 $fileinfo->filesize = $filesize;
				 $fileinfo->DateModified = $DateModified;
				 $fileinfo->FilePath = encode_Route($path);
				 $fileinfo->Filename = $name;
				 $fileinfo->SubFolder = $subfolder;
				 $fileinfo->Tag = $tag;
				 $fileinfo->permission = "rw";
				 $fileinfo->studies_id = $json->study;
				 $fileinfo->patients_id = $json->piz;
				 updateRow($db,"files",(array) $fileinfo);


				 //$q = "REPLACE INTO files (Filename,FilePath,SubFolder,Tag,studies_id,patients_id,DateModified,filesize) " . 
				 //     "VALUES ('" . $name . "','" . $path . "','" . $subfolder."','".$tag."','".$json->study."','".$json->piz."','".$DateModified."',".$filesize.")";
				 //$db->query($q);

				 updateMetaIndex($projectDatabase,"%", $json->piz . "%");


				$a = $db->query("SELECT ID FROM files where FilePath='".$path."'");
				$row = $a->fetch_assoc();


				$db->close();

				$json_out['msg'] = "";
				$json_out['fileID'] = $row['ID'];             
				$json_out['success'] = 1;
			   }
			}
		 }

      }
      elseif ($command=='updateMetaValue')
      {
          $jsonString = ($_GET['json']);

          $json = json_decode($jsonString);
          $db = mydbconnection( $projectDatabase);
          $metaname = substr($json->metakey,5);
          $a = $db->query("select * from metaidx where metaname LIKE '" . $metaname . "'");
          $metaidx = $a->fetch_assoc();

          $keyseq = json_decode($metaidx['metaidx']);

          if ($keyseq[0] == 'PATIENT')
          {
             $hashpos = strpos($json->rowid, "#");
             if ($hashpos)
                $piz =  substr($json->rowid, 0, $hashpos);        
     //        client_log($keyseq)    ;
             $db->query("UPDATE patients SET $keyseq[1]='" . $json->value . "' where PIZ=$piz"); 
          }
          else
          {

            $val = $json->value;

            if ($val == "")
              $valupdate = "NULL";
            else
              $valupdate = '"' . $val . '"';

            $type = $metaidx['type'];
            // update metatable
            $query =  'INSERT INTO metacontent (psid,' . $metaname . ') VALUES ("' . $json->rowid . '",' . $valupdate . ')  ON DUPLICATE KEY UPDATE ' . $metaname . '=' . $valupdate ;
            if ( !($type == "FLOAT" || $type == "INT") || is_numeric($val) || $val == "" )	     
               $db->query($query);               

            // update 
            if (sizeof($keyseq) == 1)
            {
                array_unshift($keyseq,"nodeinfo");
            }


            $name = $keyseq[0].".json";



            $a = $db->query("SELECT * FROM files where filename='".$name."' AND concat(patients_id,studies_id) LIKE '".$json->rowid."'");

            $metajson = $a->fetch_assoc();
            if ($metajson)
            {
               $filepath = resolve_Route($metajson['FilePath']);
               $str = file_get_contents($filepath);
               $str = str_replace("\\","\\\\",$str);
               $metacontent = json_decode($str,true);
               $newlycreated = false;
            }
            else
            {
               $metacontent = array();
               $newlycreated = true;
            }




            if ($newlycreated)
            {

                $qf = "SELECT * FROM studies as s JOIN patients as p WHERE p.PIZ=s.patients_id AND concat(patients_id,StudyID) LIKE '".$json->rowid."'";
                $a = $db->query($qf);
                $row = $a->fetch_assoc();

                $studypath = resolve_Route(hdr2PatientFolder( $row['patients_id'],$row['StudyID'], $row,$row, $project));

                $subfolder = 'META';
                $filepath = $studypath."/".$subfolder."/".$name;

                $targetDir = resolve_Route($studypath."/".$subfolder);
                if (!file_exists($targetDir))
                   mymkdir( $targetDir );


                if(!is_writable($targetDir))
                {
                    $json_out['msg'] = "Error: No permissions to write into directory " . $targetDir;
                    $json_out['success'] = 0;
                }
            }


            // write json
            $tmp = &$metacontent;
            for ($k=1; $k<sizeof($keyseq); $k++)
            {
              if ($k == sizeof($keyseq)-1)
                  $tmp[$keyseq[$k]] = $val;
              else
              {
                  if (!isset($tmp[$keyseq[$k]]))
                    $tmp[$keyseq[$k]] = array();
                  $tmp = &$tmp[$keyseq[$k]];
              }
            }


            if (!file_put_contents ($filepath , json_encode($metacontent,JSON_UNESCAPED_SLASHES)))
            {
               $db->close();
               $json_out['msg'] = "Problems during writing file_put_contents";
               $json_out['success'] = 0;
            }
            else if ($newlycreated)
            {
               $filesize = filesize(resolve_Route($filepath));
               $DateModified = date ("Y-m-d H:i:s.", filemtime(resolve_Route($filepath)) );
               $DateModified = substr($DateModified,0,19);

               $tag = '';
               $q = "REPLACE INTO files (FileName,FilePath,SubFolder,Tag,studies_id,patients_id,DateModified,filesize) " . 
                    "VALUES ('" . $name . "','" . $filepath . "','" . $subfolder."','".$tag."','".$row['StudyID']."','".$row['patients_id']."','".$DateModified."',".$filesize.")";
               $db->query($q);
            }


            // for updateing patient's meta
             $piz = $json->rowid;
             $hashpos = strpos($json->rowid, "#");
             if ($hashpos)
                $piz =  substr($json->rowid, 0, $hashpos);            
             $query =  'SELECT ' . $metaname . ' FROM metacontent  where psid LIKE "' . $piz. '#%"';
             $a = $db->query($query);               
             $patstr = "";
             while ($row = $a->fetch_assoc())
             { 
                  if ($row[$metaidx['metaname']] != "")
                    $patstr .= $row[$metaidx['metaname']] . ',';

             }
             if ($patstr != "")
               $patstr = substr($patstr,0,sizeof($patstr)-2);

             $json_out['patients_meta'] = $patstr;
          }
          $json_out['success'] = 1;
                


          $db->close();
          
      }
      elseif ($command=='jsonTable_load')
      {
          $json_out  = MDB_getRows('json', $json_in,'json',$project);
      }
      elseif ($command=='jsonTable_delete')
      {
         $json_out  = MDB_deleteRow('json', $json_in);
      }
      elseif ($command=='jsonTable_insertOrUpdate')
      {
         //var_dump($json_in);return;
         $json_out  = MDB_insertOrUpdate('json', $json_in,null,$project );  // careful, here we expect array / list of rows
       }
      elseif ($command=='userTable_save')
      {
         if (isset($json_in[0]->passwd))
              $json_in[0]->passwd = passwd_hash($json_in[0]->passwd);
         if (isset($json_in[0]->isadmin))
         	unset($json_in[0]->isadmin);
         if (isset($json_in[0]->runjobas))
         	unset($json_in[0]->runjobas);
         	
         $json_out  = MDB_insertOrUpdate('users', $json_in,null,$project );  // careful, here we expect array / list of rows
         deepExtend($_SESSION['userinfo'], $json_in[0], false);   // must update the session usersettings ...

      }
      elseif ($command=='passwordChange')
      {
         $db = mydbconnection(ROOTDB);
         $a = $db->query("SELECT * FROM users WHERE username LIKE '$_SESSION[username]'");
         $row = $a->fetch_assoc();
         $db->close();
         if($row == null)
         {
            $json_out['msg'] = "Error while checking your old password.";
         }
         else
         {
           $oldok = false;
           // check old password
           if(LDAPENABLED && ($row['passwd'] == null | $row['passwd'] =="" ))
           {
             $oldok = ldap_authenticate($_SESSION['username'], $json_in[0]->oldpasswd );
           }
           else
           {  
             $oldok = compare_pwd($row['passwd'], ($json_in[0]->oldpasswd) ) == true;
           }  
           
           if(!$oldok)
           {  
               $json_out['custom_msg'] = "You entered a wrong 'old password'.";
               $json_out['custom_success'] = 0;
           }
           else
           {
               // is new pw ldap?
               if( LDAPENABLED && ldap_authenticate($_SESSION['username'], $json_in[0]->passwd ) )
               {
                 $json_in[0]->passwd = "";
               }
               else
               {  
                  $json_in[0]->passwd = passwd_hash($json_in[0]->passwd);
               }
               $json_out  = MDB_insertOrUpdate('users', $json_in,null,$project );  // careful, here we expect array / list of rows    
               $json_out['custom_success'] = 1;
               $json_out['custom_msg'] = "Password successfully changed.";
           }
         }
      }

     elseif ($command=='share')
     {
          $db = mydbconnection(ROOTDB);
          if(isset($_GET['shareID']) && $_GET['shareID'] )
          { 
             $id = $_GET['shareID'];
             if (isset($_GET['ID']))
             {
                $theid = $_GET['ID'];
                $q = "REPLACE INTO shares (ID,shareID,json) VALUES ('" . $theid . "','" . $id . "','" . $db->real_escape_string($_GET['json']) . "')";
             }
             else
             {
                $q = "INSERT INTO shares (shareID,json) VALUES ('" . $id . "','" . $db->real_escape_string($_GET['json']) . "')";
             }
          }
          else
          {
            $id = generateRandomString();
            client_log("deprecated");
            $q = "INSERT INTO shares (shareID,json) VALUES ('" . $id . "','" . $db->real_escape_string($_GET['json']) . "')";
          }
          $db->query($q);
          $db->close();
          $json_out['id'] = $id;
          $json_out['success'] = 1;

      }
    elseif ($command=='delMetaIndex')
      {
          delMetaIndex($json_in->name,$project);
          $json_out['metaindices'] = getMetaIndices($project);
          $json_out['success'] = 1;

      }
    elseif ($command=='addMetaIndex')
      {
      
      	  savePIDforAbort();
             
		  // user-specific, or root?
		  if( $json_in->shared )
          	$name = "XSHARED_" . $json_in->name;
		  else
          	$name = $_SESSION['username'] . '_' . $json_in->name;

          $res = addMetaIndex($name,$json_in->index,$json_in->level,$json_in->type,$project,$json_in->items);
          if ($res)
          {
            $json_out['metaindices'] = getMetaIndices($project);
            $json_out['success'] = 1;
          }
          else
          {
            $json_out['msg'] = "something went wrong, check console";
            $json_out['success'] = 0;            
          }
          clearPIDforAbort();
      }
    elseif ($command=='updateMetaIndex')
      {
      	  savePIDforAbort();
          set_time_limit(0);    
          updateMetaIndex($project,$json_in->name,$json_in->items);
          $json_out['success'] = 1;         
          clearPIDforAbort();

      }
    elseif ($command=='ldapsearch')
      {
        $json_out['json'] = DPX_ldap_search(  json_decode($_GET['json'], true)  );
      }
    elseif ($command=='inviteUser')
      {
         //$D = Array("signup_username" => "kellnerfff", "email" => "pups");
         $json_out['json'] = inviteUser( json_decode($_GET['json'], true) );
      }
    elseif ($command=='render_email')
      {
		  // this function will render a defailt email from a template
          require_once('DPXMailer.php');
          $json = json_decode($_GET['json']);
          $mailmsg = DPXMailer_createTemplateMessage($json);
          $json_out['json'] = Array('mailmsg' => $mailmsg);
      }
    elseif ($command=='send_email')
      {
          require_once('DPXMailer.php');
          $json = json_decode($_GET['json']);
          $mailret = DPXMailer_send($json->to, $json->subject, $json->msg, true);
          $json_out['json'] = Array('custom_msg' => $mailret);
      }
      
      
    elseif ($command=='admin_sessions_list')
      {
         if($_SESSION['userinfo']['isadmin'])
            $json_out['json'] = session_manager_list( );
      }
    elseif ($command=='admin_sessions_delete')
      {
         if($_SESSION['userinfo']['isadmin'])
            $json_out['json'] = session_manager_delete(json_decode($_GET['json'], true) );
      }
    elseif ($command=='admin_users_list')
      {
         if($_SESSION['userinfo']['isadmin'])
         {
			$db = mydbconnection(ROOTDB);
			$ufields = Array();
			$a = $db->query('SHOW FIELDS FROM users' );
				if ($a != false)
					while($field = $a->fetch_assoc())
						$ufields[] = $field['Field'];
			
// 			$a = $db->query( "SELECT u.*,r.id as rights_id,r.username as rights_username,r.project,r.role,r.rights FROM users u LEFT JOIN rights  r ON u.username=r.username 
// 				    	UNION SELECT u.*,r.id as rights_id,r.username as rights_username,r.project,r.role,r.rights FROM users u RIGHT JOIN rights  r ON u.username=r.username order by username, rights_username");
			$a = $db->query( "SELECT * from users order by username");
			
			if($a!==false)
			{
				//$lastrow = $a->fetch_assoc();
				$res = Array();//$lastrow);
				while($row = $a->fetch_assoc() )
				{
					//unset($row['passwd']);
					$row['type'] = 'user';
					$res[] = $row;
					$b = $db->query( "SELECT * from rights where username='$row[username]' order by project");
					while($rowr = $b->fetch_assoc() )
					{
						//unset($rowr['username']);
						$rowr['type'] = 'rights';
						$res[] = $rowr;
					}
				}
			}
			$json_out['json'] = Array();
			$json_out['json']['list'] = $res;
         
         }
      }
	  elseif ($command=='project_getdbrow' && ($_SESSION['userinfo']['isadmin'] | 
	                                          $_SESSION['moduleInfo'][$_GET['project']]['role'] == 'admin' ) )
      {
			if(isset($_SESSION['moduleInfo'][$_GET['project']]))
			{
                $db = mydbconnection(ROOTDB);
                $b = $db->query( "SELECT * FROM projects where name LIKE '". $_GET['project'] ."'");
                if($row = $b->fetch_assoc())
                {
    				//$json_out['json'] = json_encode( $_SESSION['moduleInfo'][$_GET['project']] );
    				// Historically, coming from matlab we allowed unescaped single backslashes in json strings.
    				// However, this will make problems, cannot be parsed in javascript not in php.
    				// Hence, must escape all unescaped backslahes (except \")
    				//$row['jsondesc'] = str_replace("\\","\\\\",$row['jsondesc'] );
                    //$row['jsondesc'] = str_replace('\"','"'   ,$row['jsondesc'] );
    				
					$row['jsondesc'] = str_replace('\"','mysuperquotesubstitute'   ,$row['jsondesc'] );
					$row['jsondesc'] = str_replace("\\","\\\\",$row['jsondesc'] );
					$row['jsondesc'] = str_replace('mysuperquotesubstitute','\\"'   ,$row['jsondesc'] );
                    
                    // this does not work as in javascript ... 
                    //$row['jsondesc'] = preg_replace('/(\\?)([^"])/', "\\\\"   ,$row['jsondesc'] );
                    
                    $json_out['json'] = json_encode($row);
    				//echo var_dump($json_out['json']);
                }
                else
                {
                  $json_out['msg'] = "Error loading project dbrow. Maybe missing rights.";
                  $json_out['success'] = 0;
                }
			}
			else
			{
				$json_out['msg'] = "Error loading project dbrow. Maybe missing rights.";
				$json_out['success'] = 0;
			}
      }
	  elseif ($command=='project_setdbrow' && ( $_SESSION['userinfo']['isadmin'] 
	                                            | $_SESSION['moduleInfo'][$_GET['project']]['role'] == 'admin' ) )
      {
			if(isset($_SESSION['moduleInfo'][$_GET['project']]))
			{
		         $json_out  = MDB_insertOrUpdate('projects', $json_in,null, "" );  // careful, here we expect array / list of rows
			}
			else
			{
				$json_out['msg'] = "Error saving oading project dbrow. Maybe missing rights.";
				$json_out['success'] = 0;
			}

         
      }

      
    }
    catch (Exception $e)
    {
       $json_out['errormsg'] = 'PHP Error: !!!!' .   $e->getMessage() . ' '  . $e->getWarning();
       error_log(var_dump($e));
    }
    $json_out['mem'] = $_SESSION['mem'];

    header('Content-Type: text/plain');
    return $json_out;

  }


function checkDemonStatus()
{
        $logfile = DPXROOT . '/var/syslogs/demon.active';
        if( !file_exists($logfile) )
        {
            $demonIsRunning = false;
            $tdiff = 60 * 99999;
            $out = array('isrunning' => $demonIsRunning, 'info' => '', 'deadtime' => $tdiff  ); 
        }
        else
        {

          $fileTime  = filemtime($logfile);
          $utime = defined(DEMONUPDATETIME)?DEMONUPDATETIME:10;
          $utime = $utime + 50;
          if ( $fileTime > time() - $utime   ) // 30 seconds dead limit
             $demonIsRunning = true;
           else
              $demonIsRunning = false;

           $tdiff = time()  - $fileTime*1;

		   $str = file_get_contents($logfile);
		   $out = json_decode($str,true);
           $out['isrunning'] = $demonIsRunning;
           $out['info'] = "";
           $out['deadtime'] = $tdiff;

        }

        return $out;
}


function renderAjaxResponse($what)
{
    // This function handles all ajax responses: This can be
    // return the patienttable, gridjobstable, logfiletable, daemon/agent running status,
    // function should also be able to handle changes only in tables in future

    $out = array('json'=>'', 'errormsg'=>'');
    try
    {
      if($what === 'gridjobtable')
      {
        $out['gridjobtable']  =   renderGridengineTable($_GET['json']);
        // check if demon is running
        $out['demonInfo'] = checkDemonStatus();
      }
      else if($what === 'fileQuery')
      {
        error_log("Bug:: No project set, where should this project come from??");
        $out['json']  =  fileQuery($_GET['fileQueryString'],"");
      }

    }
    catch (Exception $e)
    {
      $out['errormsg'] = 'PHP Error: !!!!' ;//.   $e->getMessage() . ' '  . $e->getWarning();
      error_log(var_dump($e));
    }

  header('Content-Type: text/plain');
  return( $out );

}



function renderGridengineTable($json)
{

  $searchstate = json_decode($json);
  $searchfields = $searchstate->fields;

  // table heading
  $db = mydbconnection(ROOTDB);
  $a = mysqli_query($db, "SHOW COLUMNS from gridjobs");// or die(mysqli_error($db));;
  $keys = array();
  while($row = $a->fetch_assoc())
  {
    $keys[] = $row['Field'];
  }
  $keys = array("actions", "function","subject","state","jobname","start","queue","module","error","owner","runas","jobid","lastupdate");

  $html = "<div id='gridjobtable'><table class='jobTable'>";



  $html .= "<thead><tr><td></td>";

  foreach($keys as $tKey )
  {
    $val = "";
    if (isset($searchfields->$tKey))
      $val = $searchfields->$tKey;

    $temp =   "<form autocomplete=off onsubmit='return false;' target='KsearchForms' > <input class='gridjobtablesearchfield'  name='$tKey' value='$val' onkeyup='gridjobtable_search(event)' /> </form>";
    $html .= "<td class='jobTableSearchCell'>" . $temp .  "</td>";
  }


  $html .= "</tr><tr><td>" . "<input type='checkbox' onchange=gridjobcheck_toggleall(event); name='gridjobcheck_master' >" .  "</th>";
  foreach($keys as $tKey )
  {
    $html .= "<td>" . $tKey .  "</td>";
  }
  $html .= "</tr></thead>";

  $html .= "<tbody>";


  $clause = "WHERE 1 ";
  $skeys = array_keys((array)$searchfields);

  for ( $k=0; $k < sizeOf($skeys); $k++)
  {
      $thekey = $skeys[$k];
      if ($searchfields->$thekey != "")
      {
        if ($skeys[$k] == "subject")
          $clause  .= " AND (concat(patients_id,studies_id) LIKE " . "'" . $searchfields->$thekey . "%'  OR patients_id LIKE " . "'" . $searchfields->$thekey . "%'  OR studies_id LIKE " . "'" . $searchfields->$thekey . "%')";
        else if ($skeys[$k] == "function")
          $clause  .= " AND function LIKE '" . $searchfields->$thekey . "%' ";
        else
          $clause  .= " AND " . $skeys[$k] . " LIKE " . "'" . $searchfields->$thekey . "%' ";
      }
  }

  // table content
  $offset = $searchstate->OFFSET;
  $limit = $searchstate->LIMIT;
  if( ($a = $db->query("SELECT * FROM gridjobs ". $clause ." ORDER BY FIELD(module,'".$_GET['project']."') DESC , state DESC, jobid ASC, start DESC LIMIT ".$limit." OFFSET " . $offset)) !== false)
  {
    while($row = $a->fetch_assoc())
    {
      $jobid = " jobid='" .$row['jobid'] . "'";
      $jobid .= " jobname='" .$row['jobname'] . "'";
      $col = "<tr>";
      if ($row['state'] == "r")
  	       $col = "<tr $jobid style='background:green'>";
      if ($row['state'] == "S")
	       $col = "<tr $jobid style='background:orange'>";
      if ($row['error'] != null)
      { 
          if ($row['error'] == "DONE")
	          $col = "<tr $jobid class='DONE'>";
          else
	          $col = "<tr $jobid style='background:red'>";
      }
      if ($row['state'] == "TEST")
	       $col = "<tr $jobid style='background:red' class='TEST'>";

	  $reappeared = true;     
      if ($row['lastupdate'] == "T" && $row['state']=="r" && !($row['error'] == null || $row['error'] == "DONE"))
      {
  	       $col = "<tr $jobid style='background:green'>";
//	       $col = "<tr $jobid style='background-image: linear-gradient(red, green);' >";
	        $reappeared = true;     
      }

      if ($row['studies_id'] == 'undefined' | $row['studies_id'] == '#undefined')
		 $subjectstr = $row['patients_id'];
	  else
		 $subjectstr = $row['patients_id'] . $row['studies_id'] ;

      $html .= $col;

      $html .= "<td  class ='' onclick =''><input type='checkbox' id='".$row["jobid"]."' name='gridjobcheck' class='gridjobcheck' value='" . $row["jobid"] . "'></td>";

      foreach($keys as $tKey )
      {
        if ($tKey == "function")
        {
           if (!(isset($row[$tKey]) && $row[$tKey] !== null))
              $html .= "<td class=''> <span> non DPX </span> </td>";
           else
           {
             $tmp = explode('-',$row[$tKey]);
             if (sizeOf($tmp) > 2)
               $tmp = $tmp[sizeOf($tmp)-1];
             else
               $tmp = $row[$tKey];
             $html .= "<td class=''> <span class='link jsonLink' onclick=gridjobs_showjson('".$row["jobname"]."'); > " . $tmp ." </span> </td>";
           }
        }
        else if ($tKey == "state")
        {
			$s = explode(" ",$row['runas']);
			$str = "";
			if (sizeof($s) >= 2)
			{
				$wid = 19/(sizeof($s)-1) . "px";
				for ($k=1;$k<sizeof($s);$k++)
				{
					$nums = explode("/",str_replace('(','',str_replace(')','',$s[$k])));
				    if (sizeof($nums) == 2)
					{
						$done = floatval($nums[0]);
						$tot = floatval($nums[1]);
						if ($tot > 1)
						{
					        $perc = (100*($done-0.1)/$tot) . "%";
							$str .= "<div style='top:".(3+$wid*($k-1))."px;height:". $wid  .";width:" . $perc . "' class='jobprogress'> </div>";
						}
					}
				}
			}
			$html .= "<td class=''>" . $str . "<span class='jobstate'>" .  str_replace("-","&nbsp",$row[$tKey]) ." </span></td>";
        }
        else if ($tKey == "actions")
        {
             $html .= "<td class ='gridactionbutton'>";             
             if ($row['error'] != null ) //|| $row['lastupdate'] == 'R')
             {
                $html .= " <i onclick=\"gridjobs_showlog('" . $row["jobname"] . ".error','" . $row["function"] . "','".$subjectstr."');\" class='fa'> err</i>";
                $html .= " <i onclick=\"gridjobs_showlog('" . $row["jobname"] . ".log','" . $row["function"] . "','".$subjectstr."');\" class='fa'> log</i>";
                $html .= " <i onclick='clearDead([\"" . $row['jobid'] . "\"]);' class='fa fa-trash'> </i>";
                $html .= " <i onclick='resubmitJob(event);' class='fa fa-refresh'> </i>";
                $html .= " <i onclick='removeTestJob(event);' class='fa fa-times'> test </i>";
             }
             else
             {
                $html .= " <i onclick=\"gridjobs_showlog('" . $row["jobname"] . ".log','" . $row["function"] . "','".$subjectstr."');\" class='fa'> log</i>";
                if ($row['function'] == "jupyter")
                {
                    $html .= " <i onclick='popup_jupyter(\"" . $row['jobname'] . "\");' class='fa fa-circle'> jupyter</i>";     
                }
                $html .= " <i onclick='gridjobs_send(\"kill\",[\"" . $row['jobid'] . "\"]);' class='fa fa-trash'> </i>";
             }
            $html .= " </td>";
        }
        else if ($tKey == "jobname" && isset($row[$tKey]) && $row[$tKey] !== null)
	       $html .= "<td class='' > <span class='link' onclick=\"gridjobs_showlog('" . $row["jobname"] . ".log','" . $row["function"] . "');\" > " .  $row[$tKey] ." </span></td>";
        else if ($tKey == "subject")
        {
	       $fstr = $subjectstr;
	       if ($row['patients_id'] == 'ANALYSIS')
	         $fstr = $row['studies_id'];
	       $html .= "<td class=''> <span class='link' onclick=\"patientTable_jumpToRow('" . $subjectstr . "','" . $row['module'] . "' ); \" >" .  $fstr ."  </span></td>";
        }
	    elseif ($tKey == "error")
	    {
	       if ($row[$tKey] == null) 
	            $row[$tKey] = 'no';
	       $val = $row[$tKey];
	       if (substr($val,0,13) == "<mark>Job not" && $reappeared)
	           $val = "(no)";
           $html .= "<td> <span class='link' onclick=\"gridjobs_showlog('" . $row["jobname"] . ".error');\" > <span class='Kerrortext'>" .  $val ."</span> </span>  </td>";
	    }
        else
          $html .= "<td class=''> <span>" .  str_replace("-","&nbsp",$row[$tKey]) ." </span></td>";
      }
      $html .= "</tr>";
    }
  }
  $html .= "</tbody>";
  
  $html .= "</table>";
  $html .= "</div>\n\n"; // end tabel container div

  $res = array();
  $res['html'] = $html;

  $x = $db->query('select count(*) as cnt from gridjobs where state="r" and  (error IS NULL)');
  $res['running'] = $x->fetch_assoc()['cnt'];
  $x = $db->query('select count(*) as cnt from gridjobs where state LIKE "qw%" or state="hqw%" ');
  $res['queued'] = $x->fetch_assoc()['cnt'];
  $x = $db->query('select count(*) as cnt from gridjobs where (error IS NOT NULL) ');
  $res['error'] = $x->fetch_assoc()['cnt'];

  $x = $db->query('select count(*) as cnt from gridjobs where module="' . $searchstate->project . '" and state="r" and  (error IS NULL)');
  $res['running_project'] = $x->fetch_assoc()['cnt'];
  $x = $db->query('select count(*) as cnt from gridjobs where module="' . $searchstate->project . '" and  state="qw" or state="hqw%" ');
  $res['queued_project'] = $x->fetch_assoc()['cnt'];
  $x = $db->query('select count(*) as cnt from gridjobs where module="' . $searchstate->project . '" and  (error IS NOT NULL) ');
  $res['error_project'] = $x->fetch_assoc()['cnt'];

  $db->close();
  return $res;

}



///////////////////// fileupload

function fileuploadDICOM()
{
  $project = $_GET["project"];
  
  if(  $_SESSION['moduleInfo'][$project]['importfolder']->patientfolderpattern === null)
  {
      $out['msg'] =  "Error: This project does not contain a valid importfolder. \n" . $_SESSION['moduleInfo'][$project]['importfolder']->patientfolderpattern ."\nNo patient creation / file upload possible.";
      return($out);
  }

  error_log("file received, name: " . $_FILES['thefile']['name'] . "     type: " . $_FILES['thefile']['type'] );

  $DPXimportpath = resolve_Route(VARPATH . '/import/');


  // check file type

  if(! ($_FILES['thefile']['type'] == 'application/x-compressed-tar' |
        $_FILES['thefile']['type'] == 'application/x-tar' |
        $_FILES['thefile']['type'] == 'application/x-zip-compressed' |
        $_FILES['thefile']['type'] == 'application/x-gtar-compressed' |
        $_FILES['thefile']['type'] == 'application/zip')
        )
        {
        $out['msg'] = "file type not accepted";
        $out['success'] = 0;
        error_log("wrong file type");
        return json_encode($out);
	}

	
  $ext = pathinfo($_FILES['thefile']['name'], PATHINFO_EXTENSION);
  $suff_filnamezip = generateRandomString(32) . "." . $ext;

  // find a new filename
  $cnt = 0;
  while(true)
  {
      $fname = $DPXimportpath . $_SESSION['username'] . '_' . $project . '_' . $cnt . $suff_filnamezip ;

      if( !file_exists($fname ) )
	      break;
      $cnt = $cnt +1;
  }



  // move into DPX import folder
  if(!move_uploaded_file($_FILES['thefile']['tmp_name'], $fname))
  {
     $out['msg'] = "Error moving the uploaded file";
     error_log($out['msg']);
     $out['success'] = 0;
     return json_encode($out);
  }

  $project = $_GET["project"];
  $user = $_GET["asuser"];
  $runasuser = $_SESSION['userinfo']['runjobsas'];

  if ($user == $_SESSION['username'])
  {

    error_log("write uploadcmd into DB");
    
    $fname_encoded = encode_Route($fname);
							
    $info = Array();
    $info['datapath'] 		=  $fname_encoded;
    $info['user'] 		= $runasuser;
    $info['project']  = $project;
    $info['deleteafterimport']  = true;

    file_put_contents($fname . '.dpx',  json_encode($info));
    file_put_contents($fname . '.txt',  json_encode($_FILES['thefile']));

    // initiate import here

    $out['msg'] = "file " . $_FILES['thefile']['name'] . " uploaded";
    $out['success'] = 1;
    return json_encode($out);
  }


  $out['msg'] = "problems during upload";
  $out['success'] = 0;
  return json_encode($out);

}


function fileuploadBinary()
{

	  $fileinfo = json_decode($_POST['theROIinfo']);
	  $fileinfo->FilePath = html_entity_decode($fileinfo->FilePath);
	  $fileinfo->Filename = html_entity_decode($fileinfo->Filename);
	  $fileinfo->SubFolder = html_entity_decode($fileinfo->SubFolder);
      return createFileBinary($fileinfo,$_FILES['theROI']['tmp_name'],true);

}


function createFileBinary($fileinfo,$src,$move)
{
  $project = $_GET['project'];

  $moduleInfo = $_SESSION['moduleInfo'];
   
  if ($moduleInfo[$project]['rights']->readonly != 'off')
  {
        $out = array();    	
		$out['msg'] = "no permission";
		$out['success'] = 0;
		return json_encode($out);

  }



  $db = mydbconnection( $project);



  
  if ($fileinfo->FilePath == "")
  {

         $qf = "SELECT * FROM studies as s JOIN patients as p WHERE p.PIZ=s.patients_id AND s.StudyID='".$fileinfo->studies_id."' AND s.patients_id='".$fileinfo->patients_id."'";
         if( ($a = $db->query($qf)) == false)
         {
            $json_out['success'] = false;
            $json_out['msg'] = "dberror: " . $db->error;
            return json_encode($json_out);
         }
         $row = $a->fetch_assoc();  
         
         if ($row == null)
         {
            if ($fileinfo->usenativePID)
            {
                $updaterow = (object) array("piz"=> $fileinfo->patients_id, "sid"=> $fileinfo->studies_id, "content" => $fileinfo);
                createPatient($project,$updaterow);         

                // refetch
                $qf = "SELECT * FROM studies as s JOIN patients as p WHERE p.PIZ=s.patients_id AND s.StudyID='".$fileinfo->studies_id."' AND s.patients_id='".$fileinfo->patients_id."'";
                if( ($a = $db->query($qf)) == false)
                {
                    $json_out['success'] = false;
                    $json_out['msg'] = "dberror: " . $db->error;
                    return json_encode($json_out);
                }
                $row = $a->fetch_assoc();  
                
            }
            else
            {
                $json_out['success'] = false;
                $json_out['msg'] = "corresponding subject/study not found";
                return json_encode($json_out);         
            }
         }

         $studypath = resolve_Route(hdr2PatientFolder( $fileinfo->patients_id ,$fileinfo->studies_id, $row,$row, $project));

//         $studypath = resolve_Route($row['StudyPath']);

         if ($fileinfo->SubFolder == "")
         {
            mymkdir( $studypath . "/" . $fileinfo->SubFolder );
            $fileinfo->FilePath = $studypath . "/" . $fileinfo->Filename;
         }
         else
         {
            mymkdir( $studypath . "/" . $fileinfo->SubFolder );
            $fileinfo->FilePath = $studypath . "/" . $fileinfo->SubFolder . "/" . $fileinfo->Filename;
         }

  }

  $fileinfo->FilePath  = str_replace('//','/',$fileinfo->FilePath); 

  $rouPath = encode_Route($fileinfo->FilePath);
  $absPath = resolve_Route($fileinfo->FilePath);

  
  $dname = dirname($absPath);
  if (!@mkdir( $dname, 0755, true ))
  {
	$err = error_get_last();
	$err = $err['message'];
	if (strpos($err , "exists" ) == false)
	{
	      $out['msg'] = "cannot create directory " . $dname . ": " . $err;
          error_log($out['msg']);
          $out['success'] = 0;
          return json_encode($out);
	}
  }
      
  
  if ($move)
  {
	  $err = move_uploaded_file($src,$absPath);
	  if(!$err)
	  {		
		 var_error_log($err);
		 $out['msg'] = "Error moving the uploaded file: " . $_FILES["theROI"]["error"];
		 error_log($out['msg']);
		 $out['success'] = 0;
		 return json_encode($out);
	  }
  }
  else 
  {

      if (!copy($src,$absPath))
      {
		 error_log($src . "->". $absPath);
		 var_error_log($err);
		 $out['msg'] = "Error copying file.";
		 error_log($out['msg']);
		 $out['success'] = 0;
		 return json_encode($out);      	
      }
  }

  DPX_log("file saved " . $fileinfo->patients_id . $fileinfo->studies_id . " " . $fileinfo->SubFolder . "/" . $fileinfo->Filename);


  //chmod($absPath,0664);


  
  $fileinfo->filesize = filesize($absPath);
  $fileinfo->DateModified = date ("Y-m-d H:i:s.", filemtime($absPath) );
  $fileinfo->DateModified  = substr($fileinfo->DateModified,0,19);
  $fileinfo->FilePath = $rouPath;
  if (!isset($fileinfo->permission))
      $fileinfo->permission = "rw";

  unset($fileinfo->identifier);
  unset($fileinfo->usenativePID);
  updateRow($db,"files",(array) $fileinfo);

  $a = $db->query("SELECT ID FROM files where FilePath='".$rouPath."'");
  $row = $a->fetch_assoc();
 // error_log("SELECT ID FROM files where FilePath='".$rouPath."'");
  $db->close();

  $out['msg'] = ""; //"file uploaded";
  $out['fileID'] = $row['ID'];
  $out['success'] = 1;

  return json_encode($out);
}


function var_error_log( $object=null ){
    ob_start();                    // start buffer capture
    var_dump( $object );           // dump the values
    $contents = ob_get_contents(); // put the buffer into a variable
    ob_end_clean();                // end capture
    error_log(str_replace("\\n",'', $contents ));        // log contents of the result of var_dump( $object )
 
}


function updateRow($db,$table,$row)
{

   $a = mysqli_query($db, "SHOW COLUMNS from " . $table);
   $sqlkeys = array();
   while($r = $a->fetch_assoc())
     $sqlkeys[] = $r['Field'];

   $keys = array_keys($row);
   $keysStr = "(";
   $valsStr = "(";
   $updateStr = "";
   for($k=0;$k<sizeof($keys);$k++)
   {
      $found = false;
      for ($j=0;$j<sizeof($sqlkeys);$j++)
        if ($sqlkeys[$j] == $keys[$k])
        {
          $found = true;
          break;
        }

      if ($found)
      {
        $keysStr = $keysStr . $keys[$k] . ",";
        $valsStr = $valsStr . "'" . ($db->real_escape_string($row[$keys[$k]])) . "',";
        $updateStr = $updateStr . " " . $keys[$k] . " = VALUES(" . $keys[$k] . ")," ;
      }
      else
      {
        //error_log("updatRow: warning: tried to update/insert '" . $keys[$k] . "' into '" .$table. "', but not present.");
        //$e = new Exception();
        //error_log($e->getTraceAsString());
        
      }
   }
   $valsStr = trim($valsStr,",") . ")";
   $keysStr = trim($keysStr,",") . ")";

   if ($valsStr == '()')
      return;


   $qf = "INSERT INTO " . $table . " " . $keysStr . " VALUES " . $valsStr .
         " ON DUPLICATE KEY UPDATE " . trim($updateStr,",");         
    return $db->query($qf);
}



function getNewCustomPIZ($projectDatabase)
{
  // for custom piz when creating a patient.
  // custom piz shall start with `C`
  $db = mydbconnection( $projectDatabase);
  $qf = "SELECT * FROM patients WHERE PIZ LIKE 'C%' AND LENGTH(PIZ)=8 ORDER BY LENGTH( PIZ) DESC,PIZ DESC LIMIT 0,1  ";
  $a = $db->query($qf);
  $patientrow = $a->fetch_assoc();
  if($patientrow=== null)
  {
    $maxpiz = "C0000001";
  }
  else
  {
    $maxpiz = "C" . sprintf("%07d",   intval(substr($patientrow['PIZ'],1))+1) ;
    //$maxpiz = "C" .(substr($patientrow['PIZ'],1)) ;
  }
  return $maxpiz;

}

function createPatient($projectDatabase,$json)
{
  $db = mydbconnection( $projectDatabase);
  if($json->piz == null || trim($json->piz) == "" )
  {
    $res =  "Creation of Patient with empty ID is not possible";
    return $res;
  }
  

  $qf = "SELECT * FROM patients WHERE PIZ='".$json->piz."'";
  $a = $db->query($qf);
  $patientrow = $a->fetch_assoc();
  if($patientrow!== null)
  {
    $res =  "The Patient with ID `$json->piz` is already in database.";
    //echo $res;
    //return $res; 
  }

  if(substr($json->sid, 0,1)!=="#")
      $json->sid = "#" . $json->sid;


  // if the project has no sid in regex, piz is used as sid ....
  $theSID = $json->sid;
  if (strpos(hdr2PatientPath("XXX","THESIDPC",array(),array(),$projectDatabase),"THESIDPC") == false)
      $theSID = "#" . $json->piz;



  $update_pat = array('PIZ' => $json->piz,
             'Sex' => 'M',
             'BirthDate' => '',
             'FamilyName' => 'noname',
             'GivenName' => 'noname',
             );

  $update_stud = array('StudyID' => $theSID,
             'patients_id' => $json->piz,
             'StudyInstanceUID' => '',
             'StudyDescription' => 'New Study',
             'StudyPath' => '',
             'StudyDate' => date("Ymd") );


  if (isset($json->content))
  {
    foreach($update_pat as $key => $value)
    {
        if (isset($json->content->$key) && trim($json->content->$key)!=="")
            $update_pat[$key] = $json->content->$key;
    }

    foreach($update_stud as $key => $value)
    {
        if (isset($json->content->$key) && trim($json->content->$key)!=="")
            $update_stud[$key] = $json->content->$key;
    }
  }


  $update_stud['StudyPath'] = hdr2PatientFolder($json->piz,$theSID, $update_pat,$update_stud,$projectDatabase);


  updateRow($db,'patients',$update_pat);
  updateRow($db,'studies',$update_stud);



  savePatientStudyInfo($projectDatabase,$json);

  $db->close();

  return "";
}


function createStudy($projectDatabase,$json)
{
  
  if(substr($json->sid, 0,1)!=="#")
      $json->sid = "#" . $json->sid;

  $db = mydbconnection( $projectDatabase);
  if($json->sid == null || trim($json->piz) == "" )
  {
    $res =  "Creation of Study with empty ID is not possible";
    return $res;
  }
  

  $qf = "SELECT * FROM studies WHERE patients_id = '".$json->piz."' AND StudyID='".$json->sid."'";
  $a = $db->query($qf);
  $patientrow = $a->fetch_assoc();
  if($patientrow!== null)
  {
    $res =  "The Study with ID `$json->sid` is already in database.";
    return $res;
  }

  $update_stud = array('StudyID' => $json->sid,
             'patients_id' => $json->piz,
             'StudyInstanceUID' => '',
             'StudyDescription' => 'New Study',
             'StudyPath' => '',
             'StudyDate' => date("Ymd") );


  if (isset($json->content))
  {
    foreach($update_stud as $key => $value)
    {
        if (isset($json->content->$key) && trim($json->content->$key)!=="")
            $update_stud[$key] = $json->content->$key;
    }
  }


   $qf = "SELECT * FROM patients WHERE PIZ='".$json->piz."'";
   $a = $db->query($qf);
   $row = $a->fetch_assoc();


   $studfold = hdr2PatientFolder($json->piz,$json->sid, $row,$update_stud,$projectDatabase);
   if ($studfold == false)
   {
      return "analysisfolder not created, ask your nora admin!!";
   }

   $update_stud['StudyPath'] = $studfold;


   updateRow($db,'patients',array('PIZ'=>$json->piz)); // just to be sure that patient is there
   updateRow($db,'studies',$update_stud);

   savePatientStudyInfo($projectDatabase,$json);

   //extendNodeinfo($db, $update_pat,$update_stud);
  



   if (defined('ATLASPROJECT') && $json->piz == 'ANALYSIS' && $json->templatefiles)
      updateAnalysisFiles($json->piz,$json->sid,$db);

   $db->close();

   return "";
}


function updateAnalysisFiles($piz,$sid,$db)
{

    $atlasproject = ATLASPROJECT;
    $db_src = mydbconnection($atlasproject);
    $a = $db_src->query("SELECT * FROM files WHERE patients_id LIKE '". ATLASPID ."' AND studies_id LIKE '". ATLASSID ."'");
    if ($a)
    {
      while($row = $a->fetch_assoc())
      {
        $row['patients_id'] = $piz;
        $row['studies_id'] = $sid;
        unset($row['ID']);
        $row['permission'] = 'link';
        updateRow($db,"files",$row);
      }
    }

    cleanStudy($piz,$sid,$db);

    $db_src->close();

}

function cleanStudy($piz,$sid,$db)
{
    $a = $db->query("SELECT * FROM files WHERE patients_id LIKE '". $piz ."' AND studies_id LIKE '". $sid ."'");
    if ($a)
    {
       while($row = $a->fetch_assoc())
       {       
          if (! file_exists(resolve_Route($row['FilePath'])))
          {
              $db->query("DELETE FROM files where ID='". $row['ID'] ."'");
          }

        }

    }
   

}



function extendNodeinfo($db,$update_pat, $update_stud)
{

   $node = $update_stud['StudyPath'] . '/nodeinfo.json';
   if (!file_exists($node))
   {
      mymkdir( resolve_Route($update_stud['StudyPath'] ) );
      file_put_contents(resolve_Route($node), json_encode((object) array()));
   }


   updateRow($db,'files', array('Filename' => 'nodeinfo.json',
                           'FilePath' => encode_Route($node),
                           'SubFolder' => '',
                           'Tag' => '',
                           'studies_id' =>  $json->sid,
                           'patients_id' => $json->piz) );

   //client_log($node);

 
}


function setArrayValue(&$arr,$key,$obj,$keys)
{
   $found = true;
   for ($k = 0; $k < sizeof($keys);$k++)
   {
      $s = $keys[$k];
      if (isset($obj->$s)) 

        $obj = $obj->$s;
      else
      {
         $found = false;
         break;
      }
   }   
   if ($found)
      $arr[$key] = $obj;

}




function savePatientStudyInfo($projectDatabase,$json)
{

 $db = mydbconnection( $projectDatabase);
 $content = $json->content;
 
 $qf = "SELECT FamilyName,GivenName,PIZ,BirthDate FROM patients WHERE PIZ='".$json->piz."'";
 $a = $db->query($qf);
 $patrow = $a->fetch_assoc();

 $qf = "SELECT * FROM studies WHERE StudyID LIKE '".$json->sid."' AND patients_id='".$json->piz."'";

 $a = $db->query($qf);
 $nodes = array();
 $sids = array();

 while($row = $a->fetch_assoc())
 {

    $node = resolve_Route($row['StudyPath'] . '/nodeinfo.json');
    $sid = $row['StudyID'];

    if (file_exists($node)) // already existing nodeinfo
      $new_content = json_decode(file_get_contents($node));
    else  // no nodeinfo existing
      $new_content =  (object) array();
    // overwrite new_content with json->content
    if ($json->sid == '%')  
    {  
   
       $content = $json->content->$sid;
    }
    else
        $content = $json->content;
 
    foreach($content as $key => $value)
       $new_content->$key = $value;

 
    $update_pat = $patrow;
    setArrayValue($update_pat,'Sex',$new_content,array('PatientsSex'));
    setArrayValue($update_pat,'BirthDate',$new_content,array('PatientsBirthDate'));
    setArrayValue($update_pat,'FamilyName',$new_content,array('PatientsName','FamilyName'));
    setArrayValue($update_pat,'GivenName',$new_content,array('PatientsName','GivenName'));

    $update_stud =$row;
    if ($json->sid != "%")
    {
        setArrayValue($update_stud,'StudyInstanceUID',$new_content,array('StudyInstanceUID'));
        setArrayValue($update_stud,'StudyDescription',$new_content,array('StudyDescription'));
        setArrayValue($update_stud,'StudyDate',$new_content,array('StudyDate'));
    }

    $update_stud['StudyPath'] = hdr2PatientFolder($json->piz,$sid, $update_pat,$update_stud,$projectDatabase);

    if (!file_exists($node))
    {
      $node = resolve_Route($update_stud['StudyPath'] . '/nodeinfo.json');
      mymkdir( resolve_Route($update_stud['StudyPath'] ) );
    }
 


    updateRow($db,'studies',$update_stud);
    updateRow($db,'patients',$update_pat);
    updateRow($db,'files', array('Filename' => 'nodeinfo.json',
                           'FilePath' => encode_Route($node),
                           'SubFolder' => '',
                           'Tag' => '',
                           'studies_id' =>  $sid,
                           'patients_id' => $json->piz) );
                           //error_log(json_encode($new_content));
  


    file_put_contents($node, stripslashes(json_encode($new_content,JSON_UNESCAPED_SLASHES)));


 }
 $db->close();
}




function copyStudy($src,$db,$dest,$db_dest,$piz,$study,$fid,$subfolder)
{

    $qf = "SELECT * FROM studies WHERE StudyID='".$study."' AND patients_id='".$piz."'";
    $a = $db->query($qf);
    $studyrow = $a->fetch_assoc();
    $qf = "SELECT * FROM patients WHERE PIZ='".$studyrow['patients_id']."'";
    $a = $db->query($qf);
    $patientrow = $a->fetch_assoc();

    
    $studyrow['StudyPath'] = hdr2PatientFolder($piz,$study,$patientrow,$studyrow,$dest);
    
 //   $studypath = $studyrow['StudyPath'];
 //   $df =  json_decode(str_replace("\\","",$_SESSION['moduleInfo'][$dest]['datafolders']));
 //   $destfolder = $df->datafolders[$df->importfolder]->datapath;
 //   error_log("copy " . $studypath . " to " . $destfolder);

     
    unset($patientrow['ID']);
    unset($studyrow['ID']);
    updateRow($db_dest,"patients",$patientrow);
    updateRow($db_dest,"studies",$studyrow);

    $nodeinfo = "FileName='nodeinfo.json' AND studies_id='".$study."' AND patients_id='".$piz."'";

    if (isset($fid) && !empty($fid))
	    $qf = "SELECT * FROM files WHERE ID='".$fid."' OR " . $nodeinfo;
    else if (isset($subfolder) && !empty($subfolder))	    
        $qf = "SELECT * FROM files WHERE (SubFolder LIKE '".$subfolder."/%' OR SubFolder='".$subfolder."' OR FileName='nodeinfo.json') AND studies_id='".$study."' AND patients_id='".$piz."'";
    else        
        $qf = "SELECT * FROM files WHERE studies_id='".$study."' AND patients_id='".$piz."'";
	$a = $db->query($qf);
	while($row = $a->fetch_assoc())
	{
	  unset($row['ID']);
	  $row['permission'] = 'link';
	  updateRow($db_dest,"files",$row);
	}

}

function generateRandomString($length = 50, $flag=0) 
{
	if($flag=="lettersonly")
		$characters = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	elseif($flag=="numbersonly")
		$characters = '0123456789';
	else
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}


function hdr2PatientFolder($piz,$sid,$patrow,$studrow,$project)
{

  if (!isset($project))
      $project = $_GET['project'];

  $folder = hdr2PatientPath($piz,$sid,$patrow,$studrow,$project);

  $datapath = $_SESSION['moduleInfo'][$project]['importfolder']->datapath;
  if ($piz == 'ANALYSIS')
  {
  	if (isset($_SESSION['moduleInfo'][$project]['analysisfolder']->datapath))
        $datapath = $_SESSION['moduleInfo'][$project]['analysisfolder']->datapath;
    else
        return false;
  }

  $folder = encode_Route($datapath . '/' . $folder);  

  return $folder;

}



function hdr2PatientPath($piz,$sid,$patrow,$studrow,$project)
{
  if (!isset($project))
      $project = $_GET['project'];
  
   

  $folder = $_SESSION['moduleInfo'][$project]['importfolder']->patientfolderpattern;


  if ($piz == 'ANALYSIS')
    $folder = $_SESSION['moduleInfo'][$project]['analysisfolder']->patientfolderpattern;


  if (isset($patrow['FamilyName']))
      $folder = str_replace(  '<name>', $patrow['FamilyName'],$folder);
  if (isset($patrow['GivenName']))
      $folder = str_replace(  '<givenname>', $patrow['GivenName'],$folder);
  $folder = str_replace(  '<piz>', $piz, $folder);
  $folder = str_replace(  '<sid>', str_replace('#','',$sid), $folder);
  $folder = str_replace(  '<date>', $studrow['StudyDate'], $folder);


  
  return $folder;

}





/**
 * Slightly modified version of http://www.geekality.net/2011/05/28/php-tail-tackling-large-files/
 * @author Torleif Berger, Lorenzo Stanco
 * @link http://stackoverflow.com/a/15025877/995958
 * @license http://creativecommons.org/licenses/by/3.0/
 */
function tailCustom($filepath, $lines = 1, $adaptive = true) {
    // Open file
    $f = @fopen($filepath, "rb");
    if ($f === false) return false;
    // Sets buffer size, according to the number of lines to retrieve.
    // This gives a performance boost when reading a few lines from the file.
    if (!$adaptive) $buffer = 4096;
    else $buffer = ($lines < 2 ? 64 : ($lines < 10 ? 512 : 4096));
    // Jump to last character
    fseek($f, -1, SEEK_END);
    // Read it and adjust line number if necessary
    // (Otherwise the result would be wrong if file doesn't end with a blank line)
    if (fread($f, 1) != "\n") $lines -= 1;

    // Start reading
    $output = '';
    $chunk = '';
    // While we would like more
    while (ftell($f) > 0 && $lines >= 0) {
        // Figure out how far back we should jump
        $seek = min(ftell($f), $buffer);
        // Do the jump (backwards, relative to where we are)
        fseek($f, -$seek, SEEK_CUR);
        // Read a chunk and prepend it to our output
        $output = ($chunk = fread($f, $seek)) . $output;
        // Jump back to where we started reading
        fseek($f, -mb_strlen($chunk, '8bit'), SEEK_CUR);
        // Decrease our line counter
        $lines -= substr_count($chunk, "\n");
    }
    // While we have too many lines
    // (Because of buffer size we might have read too many)
    while ($lines++ < 0) {
        // Find first newline and remove all text before that
        $output = substr($output, strpos($output, "\n") + 1);
    }
    // Close file and return
    fclose($f);
    return trim($output);
}



function tailfromSubstring($filepath, $string, $lines = 10) {
    // Open file
    $f = @fopen($filepath, "rb");
    if ($f === false) return false;

    $output = '';
    $cnt = 0;
    while (!feof($f))
    {
        $buffer = fgets($f);
        if(strpos($buffer, $string) !== FALSE)
        {
            $cnt++;
        }
        if ($cnt > 0)
        {
        	$output .= $buffer;
            $cnt++;
        }
        if ($cnt > $lines)
            break;
    }   
    fclose($f);
    return $output;
}


function grepSystemProcess($process, $filter = false)
{

  $out = array();

  $ret = shell_exec('ps -aef | grep '. $process);
  //return $ret;
  $arr = explode("\n", $ret);
  for($k=0; $k<sizeof($arr); $k++)
  {
    $tline = $arr[$k];
    if(strpos($tline, 'grep') !== false)  // the grep itself
       continue;

   if($filter !== false)
   {
      if( strpos($tline, $filter) !== false   )    
       $out[] = $tline;

   }
   else
   {
       $out[] = $tline;
   }
  }
  
  if (sizeof($out>0))
    return $out;
  else
    return false;

}




function file_identifier($filePath)
{       
    $fstat = stat($filePath);
    return $fstat['size'] . '_' . $fstat['mtime'];
}        
        
function savePIDforAbort()
{
      	 $id =  getmypid();
      	 $_SESSION['current_pids'][$id] = true;
         session_write_close(); 
}

        
function clearPIDforAbort()
{
      	 $id =  getmypid();
      	 unset($_SESSION['current_pids'][$id]);         
}


function createFile($json,$projectDatabase)
{

 $db = mydbconnection( $projectDatabase);
 $content = $json->content;
 
 $qf = "SELECT * FROM studies WHERE StudyID='".$json->sid."' AND patients_id='".$json->piz."'";
 $a = $db->query($qf);
 $studyrow = $a->fetch_assoc();
 $qf = "SELECT * FROM patients WHERE PIZ='".$studyrow['patients_id']."'";
 $a = $db->query($qf);
 $patientrow = $a->fetch_assoc();
    
 $path = resolve_Route(hdr2PatientFolder($json->piz,$json->sid,$patientrow,$studyrow,$projectDatabase));

 mymkdir($path);

 if ($json->subfolder != "")
 {
 	 $path = $path . "/" .  $json->subfolder;
     mymkdir($path);
     $path = $path . "/" . $json->filename;
 }
 else
     $path = $path . "/" . $json->filename;
 $fid = fopen($path,"w");
 fwrite($fid,$json->content);
 fclose($fid);

 $filesize = filesize($path);

 $DateModified = date ("Y-m-d H:i:s.", filemtime($path) );
 $DateModified = substr($DateModified,0,19);

 
 
 
 updateRow($db,'files', array('Filename' => $json->filename,
                       'FilePath' => encode_Route($path),
                       'SubFolder' => $json->subfolder,
                       'Tag' => $json->tag,
                       'permission' => "rw",
                       'filesize' => $filesize,
                       'DateModified' => $DateModified,
                       'studies_id' =>  $json->sid,
                       'patients_id' => $json->piz) );

 DPX_log("file created " . $json->piz .  $json->sid . " " .$json->subfolder . "/" . $json->filename);



 $db->close();
}


/*
 * Compress/Decompress a file given in $_GET with gzip.
 * $command: 'compress', 'decompress'
 * $projectDatabase: stuff to access the database to register the new file.
 * $physical_move: indicates policy on moving files on disk or just in database.
 * $permQuery: additional limit for selecting the files to modify in the database.
 * return true on success, else an array with error status.
 */
function mycompression($command, $projectDatabase, $physical_move, $permQuery)
{
	$jsonString = ($_GET['json']);
	$obj = json_decode($jsonString);
	if ($obj->type != "file")
	{
		$db->close();
		return array('msg'=>'Sorry, can only use compression/decompression on files.', 'success'=>false);
	}
	$newname = $obj->filename;                                // could also just use filenames from database for compression/decompression
	$newname = trim($newname, "/\\  \n\r\t\v\0");
    if ($command == 'decompress')
    {
    	$gzip_or_gunzip = "gunzip --force";
        $newname = rtrim($newname, ".gz");
    }
    else
    {
    	$gzip_or_gunzip = "gzip --force";
    	$newname = $newname . ".gz";
    }

	$db = mydbconnection( $projectDatabase);
	$qf = "SELECT StudyPath FROM studies WHERE StudyID='".$obj->sid."' AND patients_id='".$obj->piz."'";
	$a = $db->query($qf);
	$row = $a->fetch_assoc();
	$studypath = $row['StudyPath'];


	$rpos = strripos($newname,"/");
	$subfolder = substr($newname,0,$rpos);
	$newfilename = substr($newname,$rpos+1);
	if ($rpos==false)
		$newfilename = $newname;

	$a = $db->query("SELECT FilePath,permission from files WHERE ID='".$obj->fileID."'" );
	$filerow = $a->fetch_assoc();
	$permission = $filerow['permission'];
	$oldfilepath = $filerow['FilePath'];
	$newfilepath = $studypath . "/" . $newname;
	$resolved_oldfilepath = resolve_Route($oldfilepath);   // database lookup
	if (strpos($permission, "w") === false || $physical_move == false)
	{
		$db->close();      // physical write permission required for compression
		return array('msg'=>'Sorry, permission denied (' . $permission . ')', 'success'=>false);
	}
	if ( !file_exists($resolved_oldfilepath) ) 
	{
		$db->close();  
		return array('msg'=>'File not found.', 'success'=>false);
	}
	if (strpos($resolved_oldfilepath, "'") !== false)    // escape $resolved_oldfilepath for execution of $gzip_command
	{
		$db->close();
		return array('msg'=>"The resolved old filepath contains single quotation mark ' which is not allowed.", 'success'=>false);
	}
	if (strpos($newfilename, "'") !== false)    // escape $newfilename for execution of SQL UPDATE
	{
		$db->close();
		return array('msg'=>"The new filename contains single quotation mark ' which is not allowed.", 'success'=>false);
	}
	if (strpos($newfilepath, "'") !== false)    // escape $newfilepath for execution of SQL UPDATE
	{
		$db->close();
		return array('msg'=>"The new filepath contains single quotation mark ' which is not allowed.", 'success'=>false);
	}
	$qf = "SELECT FilePath FROM files WHERE FilePath='".$newfilepath."'";
	$a = $db->query($qf);
	$row = $a->fetch_assoc();
	if ($row['FilePath'] == $newfilepath)
	{
		$db->close();
		return array('msg'=>"File already exists.", 'success'=>false);
	}

	$gzip_command = $gzip_or_gunzip . " '" . $resolved_oldfilepath . "'";
	$gzip_exitstatus = system($gzip_command);        
	if ($gzip_exitstatus !== false)
	{
		$q = "UPDATE files SET filename='".$newfilename."',FilePath='".$newfilepath."' WHERE ID=".$obj->fileID . $permQuery;
		$a = $db->query($q);
	}
	else
	{
		$db->close();
		return array('msg'=>'Sorry, gzip failed.', 'success'=>false);
	}
	$db->close();
	return true;
}